IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentContactCopy')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentContactCopy'
		DROP  Procedure  adfDocumentContactCopy
	END

GO

PRINT 'Creating Procedure adfDocumentContactCopy'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentContactCopy
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentContactCopy
	@DocumentClass TClass,
	@SourceDocumentID TIdentifier,
	@DestDocumentID TIdentifier
AS
	SET NOCOUNT ON
	INSERT INTO [DocumentContact] ([DocumentClass], [DocumentID], [BusinessCardClass], [BusinessCardID])
	SELECT
		@DocumentClass,
		@DestDocumentID,
		[DocumentContact].[BusinessCardClass],
		[DocumentContact].[BusinessCardID]
	FROM
		[DocumentContact]
	WHERE
		[DocumentContact].[DocumentClass] = @DocumentClass AND
		[DocumentContact].[DocumentID] = @SourceDocumentID
		
	IF @@error != 0
		RETURN 1
		
	RETURN 0
GO

GRANT EXEC ON adfDocumentContactCopy TO PUBLIC
GO
