IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyBrowse'
		DROP  Procedure  adfPropertyBrowse
	END

GO

/******************************************************************************
**		File: 
**		Name: adfPropertyBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
PRINT 'Creating Procedure adfPropertyBrowse'
GO
CREATE Procedure adfPropertyBrowse
	@Class TClass
AS
	SET NOCOUNT ON
	
	SELECT
		[Property].[ID],
		ISNULL([PropertyGlobal].[Name], [Property].[Name]) as [Name],
		[Property].[Type],
		ISNULL([PropertyGlobal].[Format], [Property].[Format]) as [Format],
		[Property].[BuiltIn],
		ISNULL([PropertyGlobal].[Description], [Property].[Description]) as [Description]
	FROM
		[Property] LEFT OUTER JOIN [PropertyGlobal]
			ON ([Property].[ID] = [PropertyGlobal].[ID] AND [PropertyGlobal].[Language] = dbo.adfGetLanguage())
	WHERE
		[Class] = @Class
	RETURN 0	
GO

GRANT EXEC ON adfPropertyBrowse TO PUBLIC
GO
