IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyChangeState'
		DROP PROCEDURE [dbo].[adfCompanyChangeState]
	END
GO

PRINT 'Creating procedure adfCompanyChangeState'
GO

/******************************************************************************
**		File: adfCompanyChangeState.sql
**		Name: adfCompanyChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 21:04:59
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    14.05.10		SYV				  pjm6DismissEventsOnObjec  
**									pjm5AllUserReminderDismiss   
**    24.08.10		SYV				  pjm6DismissEventsOnObject .. 
**									     
*******************************************************************************/
CREATE PROCEDURE adfCompanyChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Company].[Class],
		@FromState = [Company].[State]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	
	UPDATE
		[Company]
	SET
		[Company].[State] = @ToState,
		[Company].[Modified] = GETDATE(),
		[Company].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Company].[ID] = @ID
	AND
		[Company].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	UPDATE 
		[BusinessCard]
	SET
		[State] = @ToState,
		[Modified] = GETDATE(),
		[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ID] = @ID AND [Class] = @Class
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @ToState = 2
	BEGIN
		--EXEC pjm6DismissEventsOnObject @Class, @ID
		
		DECLARE @ReminderID TIdentifier
		SELECT 
			@ReminderID = [ID]
		FROM 
			[Reminder]
		WHERE 
			[DocumentClass] = @Class
			AND [DocumentID] = @ID 
			
		IF @ReminderID IS NOT NULL
		BEGIN
			EXEC pjm5AllUserReminderDismiss @ReminderID
		END
			
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyChangeState TO PUBLIC
GO
 