IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyCreate'
		DROP PROCEDURE [dbo].[adfCompanyCreate]
	END
GO

PRINT 'Creating procedure adfCompanyCreate'
GO

/******************************************************************************
**		File: adfCompanyCreate.sql
**		Name: adfCompanyCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 12:32:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17.02.10		PAM				    LegalCode
**
**		6.05.10		KOV				   @ApplyVAT
** 
**		21.05.10		KOV				  @ExchangeBanned, @ExportFinanceOnce 
**  
**		23.06.11		MAN			  [Company].[Number]
*******************************************************************************/
CREATE PROCEDURE [adfCompanyCreate]
	@Xml XML,
	@ExtendedProperties XML
AS
	DECLARE @doc INT,
			@result INT,
			@XPathRoot nvarchar(256),
			@State TState,
			@ID TIdentifier,
			@FileAs TName,
			@FoundationDate TDate,
			@LegalName TName,
			@KPP TCode,
			@LegalCode TCode,
			@BankAccountID TIdentifier,
			@ExecutiveEmployeeID TIdentifier,
			@AccountantEmployeeID TIdentifier,
			@Own TBool,
			@ManagerEmployeeID TIdentifier,
			@Comments TNotes,
			@Class TClass,
			@CurrentEmployeeID TIdentifier,
			@ExternalID TExternalIdentifier,
			@Flag TFlag,
			@LastContact TDate,
			@NextContact TDate,
			@Private TBool,
			@CompanyStatusID TIdentifier,
			@value TVariant,
			@ApplyVAT TBool,
			@PaymentCurrencyPoint TBool,
			@ExchangeBanned TBool,
			@ExportFinanceOnce TBool,
			@Number TCode

	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet @Name='ApplyVAT', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @ApplyVAT = ISNULL(CAST(@value as bit),	1)
	
	EXEC adfParameterGet @Name='PaymentCurrencyPoint', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @PaymentCurrencyPoint = ISNULL(CAST(@value as bit),1)
	
	EXEC adfParameterGet @Name='ExportFinanceOnce', @Group='Pjm6', @Value = @value OUTPUT
		SET @ExportFinanceOnce = ISNULL(CAST(@value as bit),0)	
	
	EXEC adfParameterGet @Name='ExchangeBanned', @Group='Pjm6', @Value = @value OUTPUT
		SET @ExchangeBanned = ISNULL(CAST(@value as bit),1)	

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@FileAs = [FileAs],
		@FoundationDate = CONVERT(datetime, [FoundationDate], 126),
		@LegalName = [LegalName],
		@KPP = [KPP],
		@LegalCode = CASE WHEN [LegalCode] = '' THEN NULL ELSE [LegalCode] END,
		@BankAccountID = [BankAccountID],
		@ExecutiveEmployeeID = [ExecutiveEmployeeID],
		@AccountantEmployeeID = [AccountantEmployeeID],
		@Own = (CASE [Own] WHEN 'false' THEN 0 ELSE 1 END),
		@ManagerEmployeeID = [ManagerEmployeeID],
		@Comments = [Comments],
		@ExternalID = [ExternalID],
		@Flag = [Flag],
		@LastContact = CONVERT(datetime, [LastContact], 126),
		@NextContact = CONVERT(datetime, [NextContact], 126),
		@CompanyStatusID = [CompanyStatusID],
		@Number = [Number],
		@Private = CASE WHEN [Private]='f' THEN 0 ELSE 1 END
		--@PaymentCurrencyPoint = (CASE [PaymentCurrencyPoint] WHEN 'false' THEN 0 ELSE 1 END),
		--@ExchangeBanned = (CASE [ExchangeBanned] WHEN 'false' THEN 0 ELSE 1 END)
		
		

	FROM
		OPENXML(@doc, '/adfCompanyGet/Company', 2)
			WITH (
				[FileAs] nvarchar(256),
				[FoundationDate] varchar(19),
				[LegalName] nvarchar(256),
				[KPP] varchar(32),
				[LegalCode] varchar(32),
				[BankAccountID] INT,
				[ExecutiveEmployeeID] INT,
				[AccountantEmployeeID] INT,
				[Own] varchar(5),
				[ManagerEmployeeID] INT,
				[Comments] nvarchar(max),
				[ExternalID] varchar(256),
				[Flag] int,
				[LastContact] varchar(19),
				[NextContact] varchar(19),
				[CompanyStatusID] INT,
				[Private]			varchar(1),
				[Number] varchar(32)
				--[PaymentCurrencyPoint] varchar (5),
				--[ExchangeBanned] varchar (5)
				)
		
	BEGIN TRANSACTION
	
	IF @ManagerEmployeeID IS NULL
	BEGIN
		SET @ManagerEmployeeID = dbo.adfGetCurrentEmployeeID()
	END
	
	IF @Flag IS NULL
	BEGIN
		SET @Flag = 0
	END


	
	INSERT INTO [Company]
		([Flag], [State], [FileAs], [FoundationDate], [LegalName], [KPP], [LegalCode], 
		 [BankAccountID], [ExecutiveEmployeeID], [AccountantEmployeeID], [Own],
		 [ManagerEmployeeID], [Comments], [LastContact], [NextContact], [CompanyStatusID],[ApplyVAT],
		 [PaymentCurrencyPoint],[ExchangeBanned], [ExportFinanceOnce],[Number])
	VALUES
		(@Flag, @State, @FileAs, @FoundationDate, @LegalName, @KPP, @LegalCode, 
		@BankAccountID, @ExecutiveEmployeeID, @AccountantEmployeeID, @Own,
		@ManagerEmployeeID, @Comments, @LastContact, @NextContact, @CompanyStatusID, @ApplyVAT,
		@PaymentCurrencyPoint, @ExchangeBanned, @ExportFinanceOnce,@Number)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	SELECT @Class = [Class] FROM [Company] WHERE [Company].[ID] = @ID

	INSERT INTO [ExtendedProperties] ([ID], [Class], [ExtendedProperties])
	VALUES(@ID, @Class, @ExtendedProperties)	

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @XPathRoot = N'/adfCompanyGet'
		
	EXEC @result = adfBusinessCardCreate @doc = @doc, @XPathRoot = @XPathRoot, @ID = @ID, 
		@Class = @Class, @State = @State, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @ID, @PositionID = NULL, @ExternalID = @ExternalID, @LastContact = @LastContact,
		@NextContact = @NextContact
		
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	IF @Private = 1
	BEGIN
		INSERT INTO UserContact ([UserID], [BusinessCardClass], [BusinessCardID])
			VALUES(dbo.adfGetCurrentUserID(), @Class, @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END

	INSERT INTO [CompanyIndustryBranch] ([CompanyID], [IndustryBranchID])
	SELECT 
		@ID, [IndustryBranchID] 
	FROM
		OPENXML(@doc, '/adfCompanyGet/CompanyIndustryBranch', 2)
			WITH (
				[IndustryBranchID] INT
				)
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	EXEC @result = adfCompanyCalendarCreate @ID, @Own
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	COMMIT TRANSACTION	
	
	EXEC sp_xml_removedocument @doc
	
	EXEC adfCompanyGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyCreate TO PUBLIC
GO
