IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyInfo'
		DROP PROCEDURE [dbo].[adfCompanyInfo]
	END
GO

PRINT 'Creating procedure adfCompanyInfo'
GO

/******************************************************************************
**		File: adfCompanyInfo.sql
**		Name: adfCompanyInfo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 12:32:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		6.05.10		KOV				  ApplyVAT    
**		31.05.10	SPV				     
**									[PaymentCurrencyPoint]  [ApplyVAT]
*******************************************************************************/
CREATE PROCEDURE [adfCompanyInfo]
	@ID TIdentifier
AS
	DECLARE @Class TClass, @UserID TIdentifier, @Private BIT
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Company')
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @UserID AND [BusinessCardClass]=@Class AND [BusinessCardID]=@ID)
		SET @Private = 1
	ELSE
		SET @Private = 0
		
		
	SELECT
		[Company].[ID],
		[Company].[Class],
		[Company].[State],
		[Company].[Flag],
		[Company].[FileAs],
		[Company].[FoundationDate],
		[Company].[LegalName],
		[Company].[KPP],
		[Company].[LegalCode],
		[Company].[BankAccountID],
		[Company].[ExecutiveEmployeeID],
		[Company].[AccountantEmployeeID],
		[Company].[Own],
		[Company].[ManagerEmployeeID],
		[Company].[LastContact],
		[Company].[NextContact],
		[Company].[CompanySizeID],
		[Company].[CompanyTurnoverID],
		[Company].[CompanyStatusID],
		[Company].[Comments],
		[Company].[Created],
		[Company].[CreatedBy],
		[Company].[Modified],
		[Company].[ModifiedBy],
		ISNULL([Company].[ApplyVAT], 0),
		ISNULL([Company].[PaymentCurrencyPoint], 0),
		ISNULL([Company].[ExportFinanceOnce],0),
		ISNULL([Company].[ExchangeBanned],0),
		[Company].[Timestamp],
		[ExtendedProperties].[ExtendedProperties],
		@Private as [Private],
		[Folder].[ID] AS [FolderID]
	FROM
		[Company] INNER JOIN [ExtendedProperties]
			ON ([ExtendedProperties].[Class]=@Class AND [ExtendedProperties].[ID]=@ID)
		LEFT OUTER JOIN [Folder]
			ON [Folder].[FolderID] IS NULL AND [Folder].[CompanyID] = [Company].[ID]
	WHERE
		[Company].[ID] = @ID

	
	RETURN 0
GO

GRANT EXECUTE ON [adfCompanyInfo] TO PUBLIC
GO

