IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeDelete'
		DROP PROCEDURE [dbo].[adfEmployeeDelete]
	END
GO

PRINT 'Creating procedure adfEmployeeDelete'
GO

/******************************************************************************
**		File: adfEmployeeDelete.sql
**		Name: adfEmployeeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.05.10	SYV				  FolderNotificationSettings
**		28.06.10	KOV				    
**		16.03.10	PAM				  		
*******************************************************************************/
CREATE PROCEDURE adfEmployeeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@UserID		TIdentifier,
		@Own		TBool,
		@result		int
	
	SELECT 
		@UserID = [Employee].[UserID],
		@Own = [Company].[Own]
	FROM 
		[Employee]
		INNER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID] 
	WHERE 
		[Employee].[ID] = @ID

	IF @Own = 1 AND dbo.adfHasAccessRightByName('ManageEmployees') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @Own = 0 AND dbo.adfHasAccessRightByName('ManageContacts') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Adf.Employee') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	
	EXEC @result = adfUserDeleteByID @UserID, 0
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END

	DELETE [DocumentContact] WHERE [BusinessCardClass] = dbo.adfGetClassByName('Adf.Employee') AND [BusinessCardID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [Employee] WHERE [Employee].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [BusinessCard] WHERE [ID] = @ID AND [Class] = dbo.adfGetClassByName('Adf.Employee')
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [FolderNotificationSettings] WHERE [TrusteeID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON adfEmployeeDelete TO PUBLIC
GO
 