IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeUpdate'
		DROP PROCEDURE [dbo].[adfEmployeeUpdate]
	END
GO

PRINT 'Creating procedure adfEmployeeUpdate'
GO

/******************************************************************************
**		File: adfEmployeeUpdate.sql
**		Name: adfEmployeeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		16.03.12	PAM				 /  
**    
*******************************************************************************/
CREATE PROCEDURE adfEmployeeUpdate
	@Xml XML,
	@ExtendedProperties XML
AS
	SET NOCOUNT ON
	DECLARE @doc INT,
			@result INT,
			@ID TIdentifier,
			@FileAs TName,
			@CompanyID TIdentifier,
			@PositionID TIdentifier,
			@DivisionID TIdentifier,
			@HireDate TDate,
			@FireDate TDate,
			@UserID TIdentifier,
			@Comments TNotes,
			@Title TCode,
			@FirstName TPersonName,
			@MiddleName TPersonName,
			@LastName TPersonName,
			@Suffix TCode,
			@BirthDate TDate,
			@BirthPlace TName,
			@LegalCode TCode,
			@Class TClass,
			@Initials TCode,
			@XPathRoot nvarchar(256),
			@QualificationID int,
			@LastContact TDate,
			@NextContact TDate,
			@Private TBool,
			@ReminderState TState,
			@ReminderTime TDateTime,
			@ReminderInterval TTimeSpan,
			@WindowsLogin		TSysName,
			@SqlLogin			TSysName,
			@Number				TCode,
			@CongratulateWithBirthday			TBool,
			@OwnCompany				TBool, 
			@HasAccess				TBool

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID = [ID],
		@FileAs = [FileAs],
		@Title = [Title],
		@FirstName = [FirstName],
		@MiddleName = [MiddleName],
		@LastName = [LastName],
		@Suffix = [Suffix],
		@BirthDate = CONVERT(datetime, [BirthDate], 126),
		@BirthPlace = [BirthPlace],
		@LegalCode = [LegalCode],
		@Comments = [Comments],
		@CompanyID = [CompanyID],
		@PositionID = [PositionID],
		@DivisionID = [DivisionID],
		@WindowsLogin = [WindowsLogin],
		@SqlLogin = [SqlLogin],
		@HireDate = CONVERT(datetime, [HireDate], 126),
		@FireDate = CONVERT(datetime, [FireDate], 126),
		@LastContact = CONVERT(datetime, [LastContact], 126),
		@NextContact = CONVERT(datetime, [NextContact], 126),
		@Initials = [Initials],
		@QualificationID = [QualificationID],
		@Private = CASE WHEN [Private]='f' THEN 0 ELSE 1 END,
		@ReminderState = (CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = CAST([ReminderTime] as datetime),
		@Number = [Number],
		@CongratulateWithBirthday = [CongratulateWithBirthday]
	FROM
		OPENXML(@doc, '/adfEmployeeGet/Employee', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[Title] varchar(32),
				[FirstName] nvarchar(50),
				[MiddleName] nvarchar(50),
				[LastName] nvarchar(50),
				[Suffix] nvarchar(32),
				[BirthDate] varchar(19),
				[BirthPlace] nvarchar(256),
				[LegalCode] varchar(32),
				[Comments] nvarchar(max),
				[CompanyID] int,
				[PositionID] int,
				[HireDate] varchar(19),
				[FireDate] varchar(19),
				[LastContact] varchar(19),
				[NextContact] varchar(19),
				[WindowsLogin] nvarchar(128),
				[SqlLogin] nvarchar(128),
				[Initials] varchar(32),
				[QualificationID] int,
				[DivisionID] int,
				[Private] varchar(1),
				[ReminderState] varchar(5),
				[ReminderTime] varchar(19),
				[Number] varchar(32),
				[CongratulateWithBirthday] bit
				)
	SELECT @OwnCompany = [Own] FROM [Company] WHERE [ID] = @CompanyID

	IF @OwnCompany = 1 AND dbo.adfHasAccessRightByName('ManageEmployees') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @OwnCompany = 0 AND dbo.adfHasAccessRightByName('ManageContacts') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	UPDATE [Employee]
	SET
		@UserID = [Employee].[UserID],
		@Class = [Employee].[Class],
		[Employee].[FileAs] = @FileAs,
		[Employee].[Title] = @Title,
		[Employee].[FirstName] = @FirstName,
		[Employee].[MiddleName] = @MiddleName,
		[Employee].[LastName] = @LastName,
		[Employee].[Suffix] = @Suffix,
		[Employee].[BirthDate] = @BirthDate,
		[Employee].[BirthPlace] = @BirthPlace,
		[Employee].[LegalCode] = @LegalCode,
		[Employee].[Initials] = @Initials,
		[Employee].[CompanyID] = @CompanyID,
		[Employee].[PositionID] = @PositionID,
		[Employee].[DivisionID] = @DivisionID,
		[Employee].[HireDate] = @HireDate,
		[Employee].[FireDate] = @FireDate,
		[Employee].[LastContact] = @LastContact,
		[Employee].[NextContact] = @NextContact,
		[Employee].[QualificationID] = @QualificationID,
		[Employee].[Comments] = @Comments,
		[Employee].[Modified] = DEFAULT,
		[Employee].[ModifiedBy] = DEFAULT,
		[Employee].[Number] = @Number,
		[Employee].[CongratulateWithBirthday] = @CongratulateWithBirthday
	WHERE
		[Employee].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	--/    
	SET @OwnCompany = (SELECT [Own] FROM [Company] WHERE [ID] = @CompanyID)
	IF @OwnCompany = 1
	BEGIN
		IF @UserID IS NOT NULL
		BEGIN
			EXEC @result = adfUserUpdate @UserID, @FileAs, @FileAs, @SqlLogin, @WindowsLogin, NULL
			IF @@ERROR != 0 OR @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
		ELSE
		BEGIN
			EXEC @result = adfUserCreate @FileAs, @FileAs, @SqlLogin, @WindowsLogin, @UserID OUTPUT
			IF @@ERROR != 0 OR @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END

			UPDATE [Employee] SET [UserID] = @UserID WHERE [Employee].[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		IF @UserID IS NOT NULL
		BEGIN
			EXEC @result = adfUserDeleteByID @UserID, 0
			IF @@ERROR != 0 OR @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END

	DECLARE @CurrentUserID TIdentifier
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	
	IF @Private = 1
	BEGIN
		IF NOT EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			INSERT INTO [UserContact] ([UserID], [BusinessCardClass], [BusinessCardID])
				VALUES(@CurrentUserID, @Class, @ID)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			DELETE [UserContact]
			WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END	

	UPDATE [ExtendedProperties]
	SET
		[ExtendedProperties]=@ExtendedProperties
	WHERE
		[Class] = @Class AND [ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	SET @XPathRoot = '/adfEmployeeGet'
	
	EXEC @result = adfBusinessCardUpdate @doc = @doc, @XPathRoot = @XPathRoot, 
		@ID = @ID, @Class = @Class, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @CompanyID, @PositionID = @PositionID, @LastContact = @LastContact,
		@NextContact = @NextContact
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	EXEC @result = adfPersonIdentityCardUpdate @doc = @doc, @XPathRoot = @XPathRoot, @EmployeeID = @ID	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE @EmployeeClass TClass, @rv int
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')
	SET @ReminderInterval =
		CASE WHEN @NextContact IS NOT NULL THEN
			DATEDIFF(minute, @ReminderTime, @NextContact)
			ELSE 0
		END
	EXEC @rv = pjm5ContactReminderCreate @EmployeeClass, @ID,
		@NextContact, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END

	COMMIT TRANSACTION	
	
	EXEC sp_xml_removedocument @doc

	EXEC adfEmployeeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfEmployeeUpdate TO PUBLIC
GO
 