IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfAddressTypeList')
	BEGIN
		PRINT 'Dropping Procedure adfAddressTypeList'
		DROP  Procedure  adfAddressTypeList
	END

GO

PRINT 'Creating Procedure adfAddressTypeList'
GO
/******************************************************************************
**		File: 
**		Name: adfAddressTypeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfAddressTypeList
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[AddressType].[ID],
		[DocumentGlobal].[FileAs] as [Name]
	FROM
		[AddressType] INNER JOIN [DocumentGlobal]
			ON ([AddressType].[Class] = [DocumentGlobal].[Class] AND
				[AddressType].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON adfAddressTypeList TO PUBLIC
GO
