IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCountryList')
	BEGIN
		PRINT 'Dropping Procedure adfCountryList'
		DROP  Procedure  adfCountryList
	END

GO

PRINT 'Creating Procedure adfCountryList'
GO
/******************************************************************************
**		File: 
**		Name: adfCountryList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCountryList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[Country].[ID],
		[Country].[Code]		AS [Code],
		ISNULL([CountryGlobal].[FileAs], [Country].[FileAs])		AS [Name],
		[Country].[PhoneCode]	as [PhoneCode]
	FROM
		[Country] LEFT OUTER JOIN [CountryGlobal]
			On ([Country].[Code] = [CountryGlobal].[Code] AND [CountryGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfCountryList TO PUBLIC
GO
