IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPersonIdentityCardUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfPersonIdentityCardUpdate'
		DROP  Procedure  adfPersonIdentityCardUpdate
	END

GO

PRINT 'Creating Procedure adfPersonIdentityCardUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfPersonIdentityCardUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPersonIdentityCardUpdate
	@doc INT,
	@XPathRoot nvarchar(256),
	@EmployeeID TIdentifier
AS
	DECLARE @XPath nvarchar(256)
	SET NOCOUNT ON

	SET @XPath = @XPathRoot + '/IdentityCard'
	
	DELETE [IdentityCard] WHERE [EmployeeID] = @EmployeeID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	INSERT [IdentityCard]
		([EmployeeID], [IdentityCardTypeID], [Seria], [Number], [IssueDate], [Issuer], [ExpirationDate],
		[Expired])
	SELECT
		@EmployeeID,
		[IdentityCardTypeID],
		[Seria],
		[Number],
		CONVERT(datetime, [IssueDate], 126),
		[Issuer],
		CONVERT(datetime, [ExpirationDate], 126),
		(CASE WHEN [Expired]='false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, @XPath, 2)
			WITH (
				[IdentityCardTypeID]	INT,
				[Seria]					varchar(32),
				[Number]				varchar(32),
				[IssueDate]				varchar(19),
				[Issuer]				nvarchar(256),
				[ExpirationDate]		varchar(19),
				[Expired]				nvarchar(5)
				)

	RETURN 0
GO

GRANT EXEC ON adfPersonIdentityCardUpdate TO PUBLIC
GO
