IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentDependenciesBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentDependenciesBrowse'
		DROP  Procedure  adfDocumentDependenciesBrowse
	END

GO

PRINT 'Creating Procedure adfDocumentDependenciesBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentDependenciesBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentDependenciesBrowse
	@Class TClass,
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@Language TName,
		@TableName TName
	SET @Language = dbo.adfGetLanguage()
	SELECT @TableName = [TableName] FROM [Class] WHERE [Class] = @Class
	
	SELECT
		[Document].[Class],
		[Document].[ID],
		[Document].[State],
		[Document].[FileAs],
		ISNULL([ClassGlobal].[Name], [Class].Name) AS [ClassName],
		[Document].[Created],
		[Document].[CreatedBy],
		[Document].[Modified],
		[Document].[ModifiedBy],
		[Document].[Timestamp],
		[Class].[Guid]
	FROM
		[Document]
		INNER JOIN [Attachment]
			ON [Attachment].[LinkDocumentClass] = [Document].[Class] AND
				[Attachment].[LinkDocumentid] = [Document].[ID] 
		INNER JOIN [Class]
			ON [Document].[Class] = [Class].[Class]
		LEFT OUTER JOIN [ClassGlobal] 
			ON [ClassGlobal].[Class] = [Class].[Class] AND
				[ClassGlobal].[Language] = @Language
	WHERE
		[Document].[Class] = @Class AND [Document].[ID] = @ID
	
	IF @TableName IS NOT NULL
	BEGIN
		IF EXISTS(SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_NAME = 'adf'+@TableName+'DependenciesBrowse')
		BEGIN
			DECLARE @sql varchar(max)
			SET @sql = 'EXEC adf'+@TableName+'DependenciesBrowse @ID='+CAST(@ID AS varchar(max)) 
			EXEC (@sql)
		END
	END
	RETURN 0
GO

GRANT EXEC ON adfDocumentDependenciesBrowse TO PUBLIC
GO
