IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeBrowse'
		DROP PROCEDURE [dbo].[adfActivityTypeBrowse]
	END
GO

PRINT 'Creating procedure adfActivityTypeBrowse'
GO

/******************************************************************************
**		File: adfActivityTypeBrowse.sql
**		Name: adfActivityTypeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfActivityTypeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[ActivityType].[ID],
		[ActivityType].[Class],
		[ActivityType].[State],
		[ActivityType].[Flag],
		[ActivityType].[Code],
		[ActivityType].[FileAs],
		[ActivityType].[ProjectTypeID],
		[ActivityType].[AddToNewProject],
		[ActivityType].[Billable],
		[ActivityType].[PhoneCallAccessible],
		[ActivityType].[Comments],
		[ActivityType].[Created],
		[ActivityType].[CreatedBy],
		[ActivityType].[Modified],
		[ActivityType].[ModifiedBy],
		[ActivityType].[Timestamp]
	FROM
		[ActivityType]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [ActivityType].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfActivityTypeBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeGet'
		DROP PROCEDURE [dbo].[adfActivityTypeGet]
	END
GO

PRINT 'Creating procedure adfActivityTypeGet'
GO

/******************************************************************************
**		File: adfActivityTypeGet.sql
**		Name: adfActivityTypeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfActivityTypeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ActivityType].[ID],
		[ActivityType].[Class],
		[ActivityType].[State],
		[ActivityType].[Flag],
		[ActivityType].[Code],
		[ActivityType].[FileAs],
		[ActivityType].[ProjectTypeID],
		[ActivityType].[AddToNewProject],
		[ActivityType].[Billable],
		[ActivityType].[PhoneCallAccessible],
		[ActivityType].[Comments],
		[ActivityType].[Created],
		[ActivityType].[CreatedBy],
		[ActivityType].[Modified],
		[ActivityType].[ModifiedBy],
		[ActivityType].[Timestamp]
	FROM
		[ActivityType]
	WHERE
		[ActivityType].[ID] = @ID

	SELECT
		[LanguageCode].[Code] AS [LanguageCode],
		[LanguageCode].[FileAs] AS [LanguageName],
		[ActivityTypeDefaults].[Subject],
		[ActivityTypeDefaults].[Comments]
	FROM
		[ActivityTypeDefaults]
		INNER JOIN [LanguageCode]
			ON [LanguageCode].[Code] = [ActivityTypeDefaults].[LanguageCode]
	WHERE
		[ActivityTypeDefaults].[ActivityTypeID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [adfActivityTypeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeCreate'
		DROP PROCEDURE [dbo].[adfActivityTypeCreate]
	END
GO

PRINT 'Creating procedure adfActivityTypeCreate'
GO

/******************************************************************************
**		File: adfActivityTypeCreate.sql
**		Name: adfActivityTypeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfActivityTypeCreate]
	@Code TCode,
	@FileAs TName,
	@ProjectTypeID TIdentifier,
	@AddToNewProject TBool,
	@Billable TBool,
	@PhoneCallAccessible TBool,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('efe70cde-a81b-41b9-b01d-2b3f1b1c821a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ActivityType]
		([Flag], [State], [Code], [FileAs], [ProjectTypeID], [AddToNewProject], [Billable], [PhoneCallAccessible], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @ProjectTypeID, @AddToNewProject, @Billable, @PhoneCallAccessible, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfActivityTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeUpdate'
		DROP PROCEDURE [dbo].[adfActivityTypeUpdate]
	END
GO

PRINT 'Creating procedure adfActivityTypeUpdate'
GO

/******************************************************************************
**		File: adfActivityTypeUpdate.sql
**		Name: adfActivityTypeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@ProjectTypeID TIdentifier,
	@AddToNewProject TBool,
	@Billable TBool,
	@PhoneCallAccessible TBool,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ActivityType]
	SET
		[ActivityType].[Code] = @Code,
		[ActivityType].[FileAs] = @FileAs,
		[ActivityType].[ProjectTypeID] = @ProjectTypeID,
		[ActivityType].[AddToNewProject] = @AddToNewProject,
		[ActivityType].[Billable] = @Billable,
		[ActivityType].[PhoneCallAccessible] = @PhoneCallAccessible,
		[ActivityType].[Comments] = @Comments,
		[ActivityType].[Modified] = GETDATE(),
		[ActivityType].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ActivityType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfActivityTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeDelete'
		DROP PROCEDURE [dbo].[adfActivityTypeDelete]
	END
GO

PRINT 'Creating procedure adfActivityTypeDelete'
GO

/******************************************************************************
**		File: adfActivityTypeDelete.sql
**		Name: adfActivityTypeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION
	DELETE FROM [ActivityTypeDefaults] WHERE [ActivityTypeID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [ActivityType] WHERE [ActivityType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeChangeState'
		DROP PROCEDURE [dbo].[adfActivityTypeChangeState]
	END
GO

PRINT 'Creating procedure adfActivityTypeChangeState'
GO

/******************************************************************************
**		File: adfActivityTypeChangeState.sql
**		Name: adfActivityTypeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ActivityType].[Class],
		@FromState = [ActivityType].[State]
	FROM
		[ActivityType]
	WHERE
		[ActivityType].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[ActivityType]
	SET
		[ActivityType].[State] = @ToState,
		[ActivityType].[Modified] = GETDATE(),
		[ActivityType].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ActivityType].[ID] = @ID
	AND
		[ActivityType].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeChangeState TO PUBLIC
GO

-------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeDefaultsCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeDefaultsCreate'
		DROP PROCEDURE [dbo].[adfActivityTypeDefaultsCreate]
	END
GO

PRINT 'Creating procedure adfActivityTypeDefaultsCreate'
GO

/******************************************************************************
**		File: adfActivityTypeDefaultsCreate.sql
**		Name: adfActivityTypeDefaultsCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeDefaultsCreate
	@ID TIdentifier,
	@LanguageCode TCode,
	@Subject TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	INSERT INTO [ActivityTypeDefaults] ([ActivityTypeID], [LanguageCode], [Subject], [Comments])
	VALUES (@ID, @LanguageCode, @Subject, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeDefaultsCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeDefaultsUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeDefaultsUpdate'
		DROP PROCEDURE [dbo].[adfActivityTypeDefaultsUpdate]
	END
GO

PRINT 'Creating procedure adfActivityTypeDefaultsUpdate'
GO

/******************************************************************************
**		File: adfActivityTypeDefaultsUpdate.sql
**		Name: adfActivityTypeDefaultsUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeDefaultsUpdate
	@ID TIdentifier,
	@LanguageCode TCode,
	@Subject TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ActivityTypeDefaults]
	SET
		[ActivityTypeDefaults].[Subject] = @Subject,
		[ActivityTypeDefaults].[Comments] = @Comments
	WHERE
		[ActivityTypeDefaults].[ActivityTypeID] = @ID AND
		[ActivityTypeDefaults].[LanguageCode] = @LanguageCode
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeDefaultsUpdate TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfActivityTypeDefaultsDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfActivityTypeDefaultsDelete'
		DROP PROCEDURE [dbo].[adfActivityTypeDefaultsDelete]
	END
GO

PRINT 'Creating procedure adfActivityTypeDefaultsDelete'
GO

/******************************************************************************
**		File: adfActivityTypeDefaultsDelete.sql
**		Name: adfActivityTypeDefaultsDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 10/16/2004 15:00:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfActivityTypeDefaultsDelete
	@ID TIdentifier,
	@LanguageCode TCode
AS
	
	SET NOCOUNT ON
	
	DELETE FROM
		[ActivityTypeDefaults]
	WHERE
		[ActivityTypeID] = @ID AND
		[LanguageCode] = @LanguageCode
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON adfActivityTypeDefaultsDelete TO PUBLIC
GO
