IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeBrowse'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeBrowse]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeBrowse'
GO

/******************************************************************************
**		File: adfIdentityCardTypeBrowse.sql
**		Name: adfIdentityCardTypeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 16:51:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIdentityCardTypeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[IdentityCardType].[ID],
		[IdentityCardType].[Class],
		[IdentityCardType].[State],
		[IdentityCardType].[Flag],
		[IdentityCardType].[Code],
		[IdentityCardType].[FileAs],
		[IdentityCardType].[Comments],
		[IdentityCardType].[Created],
		[IdentityCardType].[CreatedBy],
		[IdentityCardType].[Modified],
		[IdentityCardType].[ModifiedBy],
		[IdentityCardType].[Timestamp]
	FROM
		[IdentityCardType]
	WHERE
		((@StateSelector = 0) 
		 OR (@StateSelector = 1 AND [IdentityCardType].[State] IN (1, 100))
		 OR (@StateSelector = 2 AND [IdentityCardType].[State] = 2))

	RETURN 0
GO

GRANT EXECUTE ON [adfIdentityCardTypeBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeGet'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeGet]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeGet'
GO

/******************************************************************************
**		File: adfIdentityCardTypeGet.sql
**		Name: adfIdentityCardTypeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 16:51:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIdentityCardTypeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[IdentityCardType].[ID],
		[IdentityCardType].[Class],
		[IdentityCardType].[State],
		[IdentityCardType].[Flag],
		[IdentityCardType].[Code],
		[IdentityCardType].[FileAs],
		[IdentityCardType].[Comments],
		[IdentityCardType].[Created],
		[IdentityCardType].[CreatedBy],
		[IdentityCardType].[Modified],
		[IdentityCardType].[ModifiedBy],
		[IdentityCardType].[Timestamp]
	FROM
		[IdentityCardType]
	WHERE
		[IdentityCardType].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfIdentityCardTypeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeCreate'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeCreate]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeCreate'
GO

/******************************************************************************
**		File: adfIdentityCardTypeCreate.sql
**		Name: adfIdentityCardTypeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:06:51
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfIdentityCardTypeCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('069ba1d9-05e7-4ae2-8cb6-400c76da38c9')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [IdentityCardType]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfIdentityCardTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfIdentityCardTypeCreate TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeUpdate'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeUpdate]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeUpdate'
GO

/******************************************************************************
**		File: adfIdentityCardTypeUpdate.sql
**		Name: adfIdentityCardTypeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:06:51
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIdentityCardTypeUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[IdentityCardType]
	SET
		[IdentityCardType].[Code] = @Code,
		[IdentityCardType].[FileAs] = @FileAs,
		[IdentityCardType].[Comments] = @Comments,
		[IdentityCardType].[Modified] = GETDATE(),
		[IdentityCardType].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[IdentityCardType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfIdentityCardTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfIdentityCardTypeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeDelete'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeDelete]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeDelete'
GO

/******************************************************************************
**		File: adfIdentityCardTypeDelete.sql
**		Name: adfIdentityCardTypeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 17:06:51
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIdentityCardTypeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [IdentityCardType] WHERE [IdentityCardType].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfIdentityCardTypeDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIdentityCardTypeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfIdentityCardTypeChangeState'
		DROP PROCEDURE [dbo].[adfIdentityCardTypeChangeState]
	END
GO

PRINT 'Creating procedure adfIdentityCardTypeChangeState'
GO
/******************************************************************************
**		File: adfIdentityCardTypeChangeState.sql
**		Name: adfIdentityCardTypeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/08/2004 10:24:30
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfIdentityCardTypeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [IdentityCardType].[Class],
		@FromState = [IdentityCardType].[State]
	FROM
		[IdentityCardType]
	WHERE
		[IdentityCardType].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[IdentityCardType]
	SET
		[IdentityCardType].[State] = @ToState,
		[IdentityCardType].[Modified] = GETDATE(),
		[IdentityCardType].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[IdentityCardType].[ID] = @ID
	AND
		[IdentityCardType].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfIdentityCardTypeChangeState TO PUBLIC
GO
