IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSecurityExport')
	BEGIN
		PRINT 'Dropping Procedure adfSecurityExport'
		DROP  Procedure  adfSecurityExport
	END

GO

PRINT 'Creating Procedure adfSecurityExport'
GO
/******************************************************************************
**		File: 
**		Name: adfSecurityExport
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSecurityExport
AS
	SET NOCOUNT ON
	
	SELECT 
		[Right].[ID],
		[Right].[Name],
		[Right].[DisplayName],
		[Right].[Comments],
		[Right].[Group]
	FROM
		[Right]
	WHERE
		[Right].[Name] != 'CreateRights'
		
	SELECT
		[Right].[Name],
		[RightGlobal].[Language],
		[RightGlobal].[DisplayName],
		[RightGlobal].[Comments]
	FROM
		[Right] INNER JOIN [RightGlobal]
			ON ([Right].[ID] = [RightGlobal].[ID])
	WHERE
		[Right].[Name] != 'CreateRights'
	
		
	SELECT
		[Action].[ID],
		[Action].[Name],
		[Action].[Comments],
		[Action].[Image]
	FROM
		[Action]
		
	SELECT
		[ActionGlobal].[ID],
		[ActionGlobal].[Language],
		[ActionGlobal].[Name],
		[ActionGlobal].[Comments]
	FROM
		[ActionGlobal]
		
	SELECT
		[Trustee].[ID],
		[Trustee].[Name],
		[Trustee].[DisplayName],
		[Trustee].[Comments]
	FROM
		[Trustee] INNER JOIN [Role]
			ON ([Trustee].[ID] = [Role].[ID] AND [Role].[IsGroup] = 0)
	WHERE
		[Trustee].[Builtin] = 0
	
	SELECT
		[Trustee].[Name],
		[TrusteeGlobal].[Language],
		[TrusteeGlobal].[DisplayName],
		[TrusteeGlobal].[Comments]
	FROM
		[Trustee] INNER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID])
		INNER JOIN [Role]
			ON ([Trustee].[ID] = [Role].[ID] AND [Role].[IsGroup] = 0)
	WHERE
		[Trustee].[Builtin] = 0
	
	SELECT
		[Right].[Name] as [Right],
		[Trustee].[Name] as [Role]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
		INNER JOIN [Trustee] 
			ON ([AccessRight].[TrusteeID] = [Trustee].[ID])
		INNER JOIN [Role]
			ON ([Trustee].[ID] = [Role].[ID])
	
	SELECT
		[Class].[Class],
		[Class].[Code],
		[Class].[Name],
		[Class].[Guid],
		[Class].[Comments],
		[Class].[CodeIsUnique],
		[Class].[CodeIsNullable],
		[Class].[TableName],
		[Class].[SmallImage],
		[Class].[LargeImage],
		[Class].[SPBrowse],
		[Class].[SPGet],
		[Class].[SPCreate],
		[Class].[SPUpdate],
		[Class].[SPChangeState],
		[Class].[SPDelete],
		[Class].[SPList],
		[Class].[SPPrint]
	FROM
		[Class]
		
	SELECT
		[Class].[Code],
		[ClassGlobal].[Language],
		[ClassGlobal].[Name],
		[ClassGlobal].[Comments]
	FROM
		[Class] INNER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class])
		
	SELECT
		[Class].[Guid],
		[State].[State],
		[State].[Name],
		[State].[Comments],
		[State].[UIText],
		[State].[Image]
	FROM
		[State] INNER JOIN [Class]
			ON ([State].[Class] = [Class].[Class])
			
	SELECT
		[Class].[Code],
		[StateGlobal].[State],
		[StateGlobal].[Language],
		[StateGlobal].[Name],
		[StateGlobal].[Comments],
		[StateGlobal].[UIText]
	FROM
		[StateGlobal] INNER JOIN [Class]
			ON ([StateGlobal].[Class] = [Class].[Class])
			
	SELECT 
		[UICommand].[ID],
		[UICommand].[ActionID],
		[Class].[Guid],
		[UICommand].[Name],
		[UICommand].[Text],
		[UICommand].[AlternateText],
		[UICommand].[Shortcut],
		[UICommand].[Comments],
		[UICommand].[Picture],
		[UICommand].[Position],
		[UICommand].[BeginGroup]
	FROM
		[UICommand] INNER JOIN [Class]
			ON ([UICommand].[Class] = [Class].[Class])

	SELECT 
		[UICommand].[Name],
		[UICommandGlobal].[Language],
		[UICommandGlobal].[Text],
		[UICommandGlobal].[AlternateText],
		[UICommandGlobal].[Comments]
	FROM
		[UICommandGlobal] INNER JOIN [UICommand] 
			ON ([UICommandGlobal].[ID] = [UICommand].[ID])
		
	SELECT 
		[TransitionTemplate].[ID],
		[Right].[Name] as [Right],
		[Class].[Guid],
		[TransitionTemplate].[FromState],
		[TransitionTemplate].[ToState],
		[TransitionTemplate].[ActionID],
		[TransitionTemplate].[Name],
		[TransitionTemplate].[Comments],
		[UICommand].[Name] as [UICommandName],
		[TransitionTemplate].[SPValidate],
		[TransitionTemplate].[SPBefore],
		[TransitionTemplate].[SPAfter],
		[TransitionTemplate].[ConfirmationMessage]
	FROM
		[TransitionTemplate] INNER JOIN [Class]
			ON ([TransitionTemplate].[Class] = [Class].[Class])
		INNER JOIN [Right] 
			ON ([TransitionTemplate].[RightID] = [Right].[ID])
		LEFT OUTER JOIN [UICommand]
			ON ([TransitionTemplate].[UICommandID] = [UICommand].[ID])
			
	SELECT
		[Class].[Guid],
		[TT].[FromState],
		[TT].[ToState],
		[TTG].[Language],
		[TTG].[Name],
		[TTG].[Comments],
		[TTG].[ConfirmationMessage]
	FROM
		[TransitionTemplate] as [TT] INNER JOIN [TransitionTemplateGlobal] as [TTG]
			ON ([TT].[ID] = [TTG].[ID])
		INNER JOIN [Class]
			ON ([TT].[Class] = [Class].[Class])
		

	RETURN 0
GO

GRANT EXEC ON adfSecurityExport TO PUBLIC
GO
