IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCheckTransitionRights]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfCheckTransitionRights'
		DROP FUNCTION [dbo].[adfCheckTransitionRights]
	END

GO

PRINT 'Creating function adfCheckTransitionRights'
GO
/******************************************************************************
**		File: 
**		Name: adfCheckTransitionRights
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfCheckTransitionRights
	(@TransitionID TIdentifier, @RightID TIdentifier, @UserID TIdentifier)
RETURNS INT
AS
BEGIN
	IF is_member('db_owner') = 1
		RETURN @TransitionID

	IF NOT EXISTS(
		SELECT 
			*
		FROM
			[AccessRight] a INNER JOIN
			(SELECT 
				[UserRole].[RoleID]
			FROM
				[UserRole]
			WHERE
				[UserRole].[UserID] = @UserID) p 
			ON (a.[RightID] = @RightID AND a.[TrusteeID] = [p].[RoleID] AND [a].[Allow] = 1))
	BEGIN
		IF NOT EXISTS(
			SELECT 
				*
			FROM
				[AccessRight] a
			WHERE
				[a].[RightID]=@RightID AND [a].[TrusteeID]=@UserID AND [a].[Allow] = 1)
		BEGIN
			RETURN NULL
		END
	END

	RETURN @TransitionID
END
GO

