IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRightCreate')
	BEGIN
		PRINT 'Dropping Procedure adfRightCreate'
		DROP  Procedure  adfRightCreate
	END

GO

PRINT 'Creating Procedure adfRightCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfRightCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRightCreate
	@Name TSysname,
	@DisplayName TName,
	@Group TSysname,
	@Comments TNotes
AS
	DECLARE @ID TIdentifier,
			@result INT
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'CreateRights'
	IF @result != 0
		RETURN @result

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION

	INSERT INTO [Right] 
		([Name], [DisplayName], [Group], [Comments])
	VALUES
		(@Name, @DisplayName, @Group, @Comments)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [RightGlobal]
		([ID], [Language], [DisplayName], [Comments])
	VALUES
		(@ID, @Lang, @DisplayName, @Comments)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	EXEC adfRightGet @Name

	RETURN 0
GO

GRANT EXEC ON adfRightCreate TO PUBLIC
GO
