IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfStateBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfStateBrowse'
		DROP  Procedure  adfStateBrowse
	END

GO

PRINT 'Creating Procedure adfStateBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfStateBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfStateBrowse
	@Class TClass = NULL
AS
	DECLARE @C TClass, @Lang TLanguage
	
	SET NOCOUNT ON

	SET @Lang = dbo.adfGetLanguage()
		
	SET @C = dbo.adfGetClassByName('Adf.State')
	
	SELECT
		[State].[Class] as [ClassID],
		[State].[State] as [ClassState],
		@C as [Class],		
		ISNULL([StateGlobal].[Name], [State].[Name]) as [Name],
		ISNULL([StateGlobal].[Comments], [State].[Comments]) as [Comments],
		ISNULL([StateGlobal].[UIText], [State].[UIText]) as [UIText],
		[State].[Image],
		CAST(1 as INT) as [State]
	FROM
		[State] LEFT OUTER JOIN [StateGlobal]
			ON ([State].[Class] = [StateGlobal].[Class] AND [State].[State]=[StateGlobal].[State] AND
				[StateGlobal].[Language] = @Lang)
	WHERE
		(@Class IS NULL) OR (@Class IS NOT NULL AND [State].[Class] = @Class)

	RETURN 0
GO

GRANT EXEC ON adfStateBrowse TO PUBLIC
GO
