IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserCreate')
	BEGIN
		PRINT 'Dropping Procedure adfUserCreate'
		DROP  Procedure  adfUserCreate
	END

GO

PRINT 'Creating Procedure adfUserCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfUserCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserCreate
	@Name TSysname,
	@DisplayName TName,
	@SQLLogin TSysname,
	@NTLogin TSysname,
	@ID TIdentifier OUTPUT
AS
	DECLARE @result INT
			
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result

	IF EXISTS(SELECT * FROM [Trustee] WHERE [Name] = @Name OR [DisplayName] = @DisplayName)
	BEGIN
		RAISERROR('#UserNameMustBeUnique', 16, -1)
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [User] WHERE ([SQLLogin] = @SQLLogin OR [NTLogin]=@NTLogin) AND [Locked] = 0)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		RETURN 1
	END
	
	INSERT INTO [Trustee] ([Name], [DisplayName]) VALUES(@Name, @DisplayName)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [User] 
		([ID], [SQLLogin], [NTLogin], [Locked])
	VALUES
		(@ID, @SQLLogin, @NTLogin, 0)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

