IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiCommandCreate')
	BEGIN
		PRINT 'Dropping Procedure adfuiCommandCreate'
		DROP  Procedure  adfuiCommandCreate
	END

GO

PRINT 'Creating Procedure adfuiCommandCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfuiCommandCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiCommandCreate
	@Class TClass,
	@ActionID TIdentifier,
	@Name TSysname,
	@Text TName,
	@AlternateText TName,
	@Shortcut TName,
	@Picture TBlob,
	@Comments TNotes,
	@Position TIdentifier,
	@BeginGroup TBool
AS
	DECLARE @ID TIdentifier
	
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION

	INSERT INTO [UICommand] 
		([Class], [ActionID], [Name], [Text], [AlternateText], [Picture], [Shortcut], [Comments],
		[Position], [BeginGroup])
	VALUES
		(@Class, @ActionID, @Name, @Text, @AlternateText, @Picture, @Shortcut, @Comments,
		@Position, @BeginGroup)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [UICommandGlobal]
		([ID], [Language], [Text], [AlternateText], [Comments])
	VALUES		
		(@ID, @Lang, @Text, @AlternateText, @Comments)
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION

	EXEC adfuiCommandGet @ID
	
	RETURN 0
GO

GRANT EXEC ON adfuiCommandCreate TO PUBLIC
GO
