IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiStateTransitionBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfuiStateTransitionBrowse'
		DROP  Procedure  adfuiStateTransitionBrowse
	END

GO

PRINT 'Creating Procedure adfuiStateTransitionBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfuiStateTransitionBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfuiStateTransitionBrowse
	@Guid TGuid
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[State].[Class],
		[State].[State],
		[State].[Name] as [Name],
		[State].[UIText] as [UIText],
		[State].[Image]
	FROM
		[adfvwState] as [State] INNER JOIN [Class]
			ON ([State].[Class] = [Class].[Class])
	WHERE
		[Class].[Guid] = @Guid

	SELECT 
		[TransitionTemplate].[Class],
		[TransitionTemplate].[ID],
		[TransitionTemplate].[FromState],
		[TransitionTemplate].[ToState],
		[UICommand].[Name] as [Command],
		[TransitionTemplate].[ActionID],
		[Right].[Name] as [Right],
		[TransitionTemplate].[ConfirmationMessage]
	FROM 
		[adfvwTransitionTemplate] as [TransitionTemplate] INNER JOIN [Class]
			ON ([TransitionTemplate].[Class] = [Class].[Class])
		LEFT OUTER JOIN [adfvwUICommand] as [UICommand]
			ON ([TransitionTemplate].[UICommandID] = [UICommand].[ID])
		INNER JOIN [adfvwRight] as [Right]
			ON ([TransitionTemplate].[RightID] = [Right].[ID])
		INNER JOIN dbo.adfGetCurrentUserRights() C
			ON ([Right].[ID] = [C].[ID])
	WHERE
		[Class].[Guid] = @Guid
		
	RETURN 0
GO

GRANT EXEC ON adfuiStateTransitionBrowse TO PUBLIC
GO
 