IF EXISTS (SELECT * FROM sysobjects WHERE type = 'V' AND name = 'adfvwClass')
	BEGIN
		PRINT 'Dropping View adfvwClass'
		DROP  View adfvwClass
	END
GO

/******************************************************************************
**		File: 
**		Name: adfvwClass
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating View adfvwClass'
GO
CREATE VIEW adfvwClass
AS
	SELECT
		[Class].[Class],
		[Class].[Guid],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name],
		[Class].[CodeIsNullable],
		[Class].[CodeIsUnique],
		[Class].[TableName],
		[Class].[SmallImage],
		[Class].[LargeImage],
		[Class].[SPBrowse],
		[Class].[SPGet],
		[Class].[SPCreate],
		[Class].[SPUpdate],
		[Class].[SPChangeState],
		[Class].[SPDelete],
		[Class].[SPList],
		[Class].[SPPrint],
		ISNULL([ClassGlobal].[Comments], [Class].[Comments]) as [Comments],
		[Class].[Created],
		[Class].[CreatedBy],
		[Class].[Modified],
		[Class].[ModifiedBy]
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class]=[ClassGlobal].[Class] AND [ClassGlobal].[Language] = dbo.adfGetLanguage())

GO
 