IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'PaymentPeriod') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND
	EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'AssistantRecurrencePattern') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DECLARE @pp int, @ar int
	SELECT @pp = COUNT(*) FROM [PaymentPeriod] WHERE COALESCE([CalculationPeriodType], [StatementPeriodType], [InvoicePeriodType]) IS NOT NULL
	SELECT @ar = COUNT(*) FROM [AssistantRecurrencePattern]
	
	IF @pp != 0 AND @ar = 0
	BEGIN
		DECLARE 
			@ID TIdentifier,
			@StartDate TDate
		SET @StartDate = '20080101'
		
		DECLARE
			@ProjectID TIdentifier,
			@CalculationPeriodType varchar(32),
			@StatementPeriodType varchar(32),
			@InvoicePeriodType varchar(32),
			@CalculationDayType varchar(32),
			@StatementDayType varchar(32),
			@InvoiceDayType varchar(32),
			@RecurrenceType int, 
			@Interval int, 
			@DayOfWeekMask int,
			@Instance int,
			@MonthOfYear int, 
			@DayTransferRule int,
			@WorkingDays int,
			@Weekend int
		SET @WorkingDays = POWER(2, 1)| POWER(2, 2) | POWER(2, 3) | POWER(2, 4) | POWER(2, 5)
		SET @Weekend = POWER(2, 0) | POWER(2, 6)

			
		DECLARE periods CURSOR FOR 
			SELECT 
				[PaymentPeriod].[ProjectID],
				[PaymentPeriod].[CalculationPeriodType],
				[PaymentPeriod].[StatementPeriodType],
				[PaymentPeriod].[InvoicePeriodType],
				[PaymentPeriod].[CalculationDayType],
				[PaymentPeriod].[StatementDayType],
				[PaymentPeriod].[InvoiceDayType]
			FROM
				[PaymentPeriod]
			WHERE
				COALESCE([PaymentPeriod].[CalculationPeriodType], [PaymentPeriod].[StatementPeriodType], [PaymentPeriod].[InvoicePeriodType]) IS NOT NULL
		OPEN periods
		FETCH NEXT FROM periods INTO
						@ProjectID,
						@CalculationPeriodType,
						@StatementPeriodType,
						@InvoicePeriodType,
						@CalculationDayType,
						@StatementDayType,
						@InvoiceDayType

		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF @CalculationPeriodType IS NOT NULL
			BEGIN
				IF @CalculationPeriodType = '10'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 8) | POWER(2, 9)
					SET @Interval = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @CalculationPeriodType = '15'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 9)
					SET @Interval = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @CalculationPeriodType = '30' OR 
						@CalculationPeriodType = '90' OR 
						@CalculationPeriodType = '180'
				BEGIN
					SET @RecurrenceType = 3
					SET @DayTransferRule = 0
					SET @Interval = CASE @CalculationPeriodType
						WHEN '90' THEN 3
						WHEN '180' THEN 6
						ELSE 1
					END
					SET @Instance = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @MonthOfYear = 0
				END
				ELSE IF @CalculationPeriodType = '360'
				BEGIN
					SET @RecurrenceType = 5
					SET @DayTransferRule = 0
					SET @MonthOfYear = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN 12
						WHEN 'LAST_CALENDAR' THEN 12
						ELSE 1
					END
					SET @Instance = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @CalculationDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @Interval = 0
				END
				INSERT INTO [AssistantRecurrencePattern](
					[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
					[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
				)
				VALUES(
					@StartDate, NULL, NULL, @RecurrenceType, @Interval, @DayOfWeekMask,
					@Instance, @MonthOfYear, 0, @DayTransferRule	
				)
				SET @ID = SCOPE_IDENTITY()
				UPDATE 
					[Project] 
				SET 
					[Project].[CalculationRecurrencePatternID] = @ID
				WHERE 
					[Project].[ID] = @ProjectID
			END
			
			IF @StatementPeriodType IS NOT NULL
			BEGIN
				IF @StatementPeriodType = '10'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 8) | POWER(2, 9)
					SET @Interval = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @StatementPeriodType = '15'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 9)
					SET @Interval = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @StatementPeriodType = '30' OR 
						@StatementPeriodType = '90' OR 
						@StatementPeriodType = '180'
				BEGIN
					SET @RecurrenceType = 3
					SET @DayTransferRule = 0
					SET @Interval = CASE @StatementPeriodType
						WHEN '90' THEN 3
						WHEN '180' THEN 6
						ELSE 1
					END
					SET @Instance = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @MonthOfYear = 0
				END
				ELSE IF @StatementPeriodType = '360'
				BEGIN
					SET @RecurrenceType = 5
					SET @DayTransferRule = 0
					SET @MonthOfYear = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN 12
						WHEN 'LAST_CALENDAR' THEN 12
						ELSE 1
					END
					SET @Instance = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @StatementDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @Interval = 0
				END
				INSERT INTO [AssistantRecurrencePattern](
					[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
					[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
				)
				VALUES(
					@StartDate, NULL, NULL, @RecurrenceType, @Interval, @DayOfWeekMask,
					@Instance, @MonthOfYear, 0, @DayTransferRule	
				)
				SET @ID = SCOPE_IDENTITY()
				UPDATE 
					[Project] 
				SET 
					[Project].[StatementRecurrencePatternID] = @ID
				WHERE 
					[Project].[ID] = @ProjectID
			END

			IF @InvoicePeriodType IS NOT NULL
			BEGIN
				IF @InvoicePeriodType = '10'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 8) | POWER(2, 9)
					SET @Interval = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @InvoicePeriodType = '15'
				BEGIN
					SET @RecurrenceType = 1
					SET @DayTransferRule = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN -1
						WHEN 'FIRST_WORKING' THEN 1
						ELSE 0
					END
					SET @DayOfWeekMask = POWER(2, 7) | POWER(2, 9)
					SET @Interval = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @Instance = 0
					SET @MonthOfYear = 0
				END
				ELSE IF @InvoicePeriodType = '30' OR 
						@InvoicePeriodType = '90' OR 
						@InvoicePeriodType = '180'
				BEGIN
					SET @RecurrenceType = 3
					SET @DayTransferRule = 0
					SET @Interval = CASE @InvoicePeriodType
						WHEN '90' THEN 3
						WHEN '180' THEN 6
						ELSE 1
					END
					SET @Instance = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @MonthOfYear = 0
				END
				ELSE IF @InvoicePeriodType = '360'
				BEGIN
					SET @RecurrenceType = 5
					SET @DayTransferRule = 0
					SET @MonthOfYear = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN 12
						WHEN 'LAST_CALENDAR' THEN 12
						ELSE 1
					END
					SET @Instance = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN 5
						WHEN 'LAST_CALENDAR' THEN 5
						ELSE 1
					END
					SET @DayOfWeekMask = CASE @InvoiceDayType
						WHEN 'LAST_WORKING' THEN @WorkingDays
						WHEN 'FIRST_WORKING' THEN @WorkingDays
						ELSE @Weekend | @WorkingDays
					END 
					SET @Interval = 0
				END
				INSERT INTO [AssistantRecurrencePattern](
					[StartDate], [EndDate], [Occurrences], [RecurrenceType], [Interval], [DayOfWeekMask],
					[Instance], [MonthOfYear], [DayOfMonth], [DayTransferRule]
				)
				VALUES(
					@StartDate, NULL, NULL, @RecurrenceType, @Interval, @DayOfWeekMask,
					@Instance, @MonthOfYear, 0, @DayTransferRule	
				)
				SET @ID = SCOPE_IDENTITY()
				UPDATE 
					[Project] 
				SET 
					[Project].[InvoiceRecurrencePatternID] = @ID
				WHERE 
					[Project].[ID] = @ProjectID
			END
			FETCH NEXT FROM periods INTO
						@ProjectID,
						@CalculationPeriodType,
						@StatementPeriodType,
						@InvoicePeriodType,
						@CalculationDayType,
						@StatementDayType,
						@InvoiceDayType
		END
		
		CLOSE periods
		DEALLOCATE periods
	END
END
 