alter table AccessRight
   add constraint RightTrusteesFK foreign key (RightID)
      references [Right] (ID)
	  on delete cascade
go

alter table AccessRight
   add constraint TrusteeRightsFK foreign key (TrusteeID)
      references Trustee (ID)
	  on delete cascade
go

alter table ActionGlobal
   add constraint ActionGlobalActionFK foreign key (ID)
      references Action (ID)
      on delete cascade
go

alter table ActionGlobal
   add constraint ActionGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table ActivityType
   add constraint ProjectTypeActivityFK foreign key (ProjectTypeID)
      references ProjectType (ID)
go

alter table ActivityTypeDefaults
   add constraint ActivityTypeDefaultsLanguageFK foreign key (LanguageCode)
      references LanguageCode (Code)
go

alter table ActivityTypeDefaults
   add constraint DefaultsOfActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table Address
   add constraint AddressOfTypeFK foreign key (AddressTypeID)
      references AddressType (ID)
go

alter table Address
   add constraint BusinessCardAddressesFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
      on delete cascade
go

alter table AdvanceInvoice
   add constraint AdvanceInvoicesFK foreign key (InvoiceID)
      references Invoice (ID)
      on delete cascade
go

alter table AdvanceInvoice
   add constraint IsAdvanceInvoiceFK foreign key (AdvanceInvoiceID)
      references Invoice (ID)
go

alter table AlternateName
   add constraint DocumentAlternateNameFK foreign key (Class, ID)
      references Document (Class, ID)
go

alter table Announcement
   add constraint AnnouncementProjectFK foreign key (ProjectID)
      references Project (ID)
go

alter table Assignment
   add constraint AssignmentTitleFK foreign key (QualificationID)
      references Qualification (ID)
go

alter table Assignment
   add constraint MsResourceAssignmentFK foreign key (MsResourceID)
      references MsResource (ID)
go

alter table Assignment
   add constraint ProjectAssignmentsFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table AssignmentEntry
   add constraint AssignmentHistoryFK foreign key (AssignmentID)
      references Assignment (ID)
      on delete cascade
go

alter table AssignmentEntry
   add constraint EmployeeAssignmentFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table Attachment
   add constraint AttachmentDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Attachment
   add constraint AttachmentTypeAttachmentFK foreign key (AttachmentTypeID)
      references AttachmentType (ID)
go

alter table Attachment
   add constraint LinkDocumentFK foreign key (LinkDocumentClass, LinkDocumentID)
      references Document (Class, ID)
go

alter table Attachment
   add constraint UserAttachmentFK foreign key (CreatedBy)
      references [User] (ID)
go

alter table AttendanceEntry
   add constraint AttendanceEntryAttendanceEntryTypeFK foreign key (AttendanceEntryTypeID)
      references AttendanceEntryType (ID)
go

alter table Attendee
   add constraint EmployeeAttendeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table Attendee
   add constraint MeetingAttendeeFK foreign key (MeetingRequestID)
      references MeetingRequest (ID)
go

alter table AttendeeResponse
   add constraint AttendeeAttandeeResponseFK foreign key (MeetingRequestID, EmployeeID)
      references Attendee (MeetingRequestID, EmployeeID)
go

alter table BankAccount
   add constraint CompanyBankAccountsFK foreign key (CompanyID)
      references Company (ID)
go

alter table BankAccount
   add constraint CurrencyOfBankAccountFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table BusinessCard
   add constraint BusinessCardCompanyFK foreign key (CompanyID)
      references Company (ID)
go

alter table BusinessCard
   add constraint BusinessCardPositionFK foreign key (PositionID)
      references Position (ID)
go

alter table BusyEntry
   add constraint AssignmentBusyEntryFK foreign key (AssignmentID)
      references Assignment (ID)
go

alter table BusyEntry
   add constraint BusyEntryActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table BusyEntry
   add constraint EmployeeBusyEntryFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table BusyEntry
   add constraint ProjectBusyEntryFK foreign key (ProjectID)
      references Project (ID)
go

alter table BusyEntry
   add constraint TaskBusyEntryFK foreign key (TaskID)
      references Task (ID)
      on delete cascade
go

alter table Calculation
   add constraint CalculationClassFK foreign key (DocumentClass)
      references Class (Class)
go

alter table Calculation
   add constraint CalculationCurrrencyCodeFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Calculation
   add constraint CalculationProjectFK foreign key (ProjectID)
      references Project (ID)
go

alter table Calculation
   add constraint CalculationServiceTypeFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table CalculationAdvance
   add constraint AdvanceCalculationCalculationFK foreign key (AdvanceCalculationID)
      references Calculation (ID)
go

alter table CalculationAdvance
   add constraint CalculationAdvanceCalculationFK foreign key (CalculationID)
      references Calculation (ID)
      on delete cascade
go

alter table CalculationLine
   add constraint CalculationLineDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
go

alter table CalculationLine
   add constraint CalculationLinesFK foreign key (CalculationID)
      references Calculation (ID)
      on delete cascade
go

alter table CalendarEmployee
   add constraint CalendarEmployeeEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
      on delete cascade
go

alter table CalendarEmployee
   add constraint CalendarEmployeeUserFK foreign key (UserID)
      references [User] (ID)
go

alter table CalendarProject
   add constraint CalendarProjectProjectFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table CalendarProject
   add constraint CalendarProjectUserFK foreign key (UserID)
      references [User] (ID)
go

alter table CalendarResource
   add constraint ResourceCalendarResourceFK foreign key (ResourceID)
      references Resource (ID)
go

alter table CalendarResource
   add constraint UserCalendarResourceFK foreign key (UserID)
      references [User] (ID)
go

alter table CaseOfFolder
   add constraint CaseFolderAccessFK foreign key (CaseID)
      references [Case] (ID)
go

alter table CaseOfFolder
   add constraint FolderCasesFK foreign key (FolderID)
      references Folder (ID)
go

alter table Category
   add constraint ClassCategoriesFK foreign key (DocumentClass)
      references Class (Class)
go

alter table ClassGlobal
   add constraint ClassGlobalClassFK foreign key (Class)
      references Class (Class)
      on delete cascade
go

alter table ClassGlobal
   add constraint ClassGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table Company
   add constraint CompanyAccountantFK foreign key (AccountantEmployeeID)
      references Employee (ID)
go

alter table Company
   add constraint CompanyDefaultBankAccountFK foreign key (BankAccountID)
      references BankAccount (ID)
go

alter table Company
   add constraint CompanyExecutiveFK foreign key (ExecutiveEmployeeID)
      references Employee (ID)
go

alter table Company
   add constraint CompanyManagerFK foreign key (ManagerEmployeeID)
      references Employee (ID)
go

alter table Company
   add constraint SizeOfCompanyFK foreign key (CompanySizeID)
      references CompanySize (ID)
go

alter table Company
   add constraint StatusOfCompanyFK foreign key (CompanyStatusID)
      references CompanyStatus (ID)
go

alter table Company
   add constraint TurnoverOfCompanyFK foreign key (CompanyTurnoverID)
      references CompanyTurnover (ID)
go

alter table CompanyCalendar
   add constraint CalendarOfCompanyFK foreign key (CompanyID)
      references Company (ID)
go

alter table CompanyIndustryBranch
   add constraint CompanyIndustryBranchesFK foreign key (CompanyID)
      references Company (ID)
go

alter table CompanyIndustryBranch
   add constraint IdustryBranchOfCompanyFK foreign key (IndustryBranchID)
      references IndustryBranch (ID)
go

alter table ContractAddendum
   add constraint AddendumOfContractFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table CountryCurrency
   add constraint CountryCurrenciesFK foreign key (CountryCode)
      references Country (Code)
	  on delete cascade

go

alter table CountryCurrency
   add constraint CurrencyOfCountryFK foreign key (CurrencyCode)
      references Currency (Code)
	  on delete cascade
go

alter table CountryGlobal
   add constraint CountryGlobalCountryFK foreign key (Code)
      references Country (Code)
go

alter table CountryGlobal
   add constraint CountryGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table CreditMemo
   add constraint CreditMemoBankAccountFK foreign key (PayeeBankAccountID)
      references BankAccount (ID)
go

alter table CreditMemo
   add constraint CreditMemoContractFK foreign key (ProjectID)
      references Project (ID)
go

alter table CreditMemo
   add constraint CreditMemoCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table CreditMemo
   add constraint CreditMemoPayeeFK foreign key (PayeeCompanyID)
      references Company (ID)
go

alter table CreditMemo
   add constraint CreditMemoPayerFK foreign key (PayerCompanyID)
      references Company (ID)
go

alter table CreditMemo
   add constraint CreditMemoPaymentTypeFK foreign key (PaymentTypeID)
      references PaymentType (ID)
go

alter table CurrencyGlobal
   add constraint CurrencyGlobalCurrencyFK foreign key (Code)
      references Currency (Code)
go

alter table CurrencyGlobal
   add constraint CurrencyGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table CurrencyRate
   add constraint FromCurrencyFK foreign key (FromCurrencyCode)
      references Currency (Code)
go

alter table CurrencyRate
   add constraint ToCurrencyFK foreign key (ToCurrencyCode)
      references Currency (Code)
go

alter table Division
   add constraint CompanyDivisionsFK foreign key (CompanyID)
      references Company (ID)
go

alter table Document
   add constraint DocumentClassFK foreign key (Class)
      references Class (Class)
go

alter table Document
   add constraint DocumentRecurrencePatternFK foreign key (RecurrencePatternID)
      references RecurrencePattern (ID)
go

alter table Document
   add constraint DocumentStateFK foreign key (Class, State)
      references State (Class, State)
go

alter table DocumentCard
   add constraint ClassOfDocumentCardFK foreign key (DocumentCardClassID)
      references DocumentCardClass (ID)
go

alter table DocumentCard
   add constraint DivisionDocumentsFK foreign key (DivisionID)
      references Division (ID)
go

alter table DocumentCard
   add constraint DocumentCardCaseFK foreign key (CaseID)
      references [Case] (ID)
go

alter table DocumentCard
   add constraint DocumentCardCompanyCorrespondentFK foreign key (CorrespondentCompanyID)
      references Company (ID)
go

alter table DocumentCard
   add constraint DocumentCardCompanyOwnerFK foreign key (CompanyID)
      references Company (ID)
go

alter table DocumentCard
   add constraint DocumentCardContactFK foreign key (ContactID)
      references Employee (ID)
go

alter table DocumentCard
   add constraint DocumentCardCorrespondentContactFK foreign key (CorrespondentContactID)
      references Employee (ID)
go

alter table DocumentCard
   add constraint DocumentCardOwnerFK foreign key (CardOwnerID)
      references Employee (ID)
go

alter table DocumentCard
   add constraint DocumentCardReferenceFK foreign key (DocumentCardID)
      references DocumentCard (ID)
go

alter table DocumentCard
   add constraint DocumentSentBackTypeFK foreign key (DocumentSendBackTypeID)
      references DocumentSendType (ID)
go

alter table DocumentCard
   add constraint DocumentSentByTypeFK foreign key (DocumentSendTypeID)
      references DocumentSendType (ID)
go

alter table DocumentCard
   add constraint FolderDocumentCardsFK foreign key (FolderID)
      references Folder (ID)
go

alter table DocumentCard
   add constraint PlaceOfCustodyFK foreign key (CustodyPlaceID)
      references CustodyPlace (ID)
go

alter table DocumentCategory
   add constraint CategoryDocumentsFK foreign key (CategoryID)
      references Category (ID)
go

alter table DocumentCategory
   add constraint DocumentCategoriesFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table DocumentContact
   add constraint ContactDocumentFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
go

alter table DocumentContact
   add constraint DocumentContactsFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table DocumentFlowEntry
   add constraint EmployeeOfDocumentFlowFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table DocumentFlowEntry
   add constraint FlowOfDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
go

alter table DocumentGlobal
   add constraint DocumentGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table DocumentIndex
   add constraint ProjectDocumentIndexFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table DocumentItem
   add constraint DocumentCardItemFK foreign key (DocumentCardID)
      references DocumentCard (ID)
go

alter table DocumentItem
   add constraint FolderItemsFK foreign key (FolderID)
      references Folder (ID)
go

alter table DocumentItem
   add constraint UserCheckedOutDocumentItemFK foreign key (CheckedOutBy)
      references [User] (ID)
go

alter table DocumentItemReadProtocol
   add constraint DocumentItemReadProtocolDocumentFK foreign key (ID)
      references DocumentItem (ID)
      on delete cascade
go

alter table DocumentItemReadProtocol
   add constraint DocumentItemReadProtocolUserFK foreign key (UserID)
      references [User] (ID)
      on delete cascade
go

alter table DocumentLabel
   add constraint ClassDocumentLabelFK foreign key (Class)
      references Class (Class)
go

alter table DocumentSubscriptionRule
   add constraint SubscriptionRuleDocumentInstanceFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table DocumentSubscriptionRule
   add constraint SubscriptionRuleDocumentsFK foreign key (SubscriptionRuleID)
      references SubscriptionRule (ID)
      on delete cascade
go

alter table DocumentUserState
   add constraint DocumentDocumentUserStateFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table DocumentUserState
   add constraint UserDocumentUserStateFK foreign key (UserID)
      references [User] (ID)
go

alter table DocumentVersion
   add constraint ItemDocumentsFK foreign key (DocumentItemID)
      references DocumentItem (ID)
go

alter table DocumentVersion
   add constraint UserDocumentItemFK foreign key (CreatedBy)
      references [User] (ID)
go

alter table Email
   add constraint BusinessCardInternetLinksFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
      on delete cascade
go

alter table Email
   add constraint EmailOfTypeFK foreign key (EmailTypeID)
      references EmailType (ID)
go

alter table Employee
   add constraint CompanyEmployeesFK foreign key (CompanyID)
      references Company (ID)
go

alter table Employee
   add constraint EmployeeDivisionFK foreign key (DivisionID)
      references Division (ID)
go

alter table Employee
   add constraint EmployeePositionFK foreign key (PositionID)
      references Position (ID)
go

alter table Employee
   add constraint EmployeeQualificationFK foreign key (QualificationID)
      references Qualification (ID)
go

alter table Employee
   add constraint EmployeeUserFK foreign key (UserID)
      references [User] (ID)
go

alter table EmployeeCalendar
   add constraint CalendarOfEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
      on delete cascade
go

alter table EntryAmount
   add constraint TimeEntryAmountFK foreign key (ID)
      references TimeEntry (ID)
      on delete cascade
go

alter table Event
   add constraint EventContainerInstanceFK foreign key (ContainerClass, ContainerID)
      references Document (Class, ID)
go

alter table Event
   add constraint EventDocumentInstanceFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Event
   add constraint EventNotificationWayFK foreign key (NotificationWayID)
      references NotificationWay (ID)
go

alter table Event
   add constraint SubscriptionRuleEventsFK foreign key (SubscriptionRuleID)
      references SubscriptionRule (ID)
      on delete cascade
go

alter table Event
   add constraint SubscriptionTypeEventFK foreign key (SubscriptionTypeID)
      references SubscriptionType (ID)
go

alter table ExchangeSync
   add constraint ExchangeSyncDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table ExchangeSync
   add constraint ExchangeSyncUserFK foreign key (UserID)
      references [User] (ID)
      on delete cascade
go

alter table ExchangeSync
   add constraint ExchangeSyncUserContactFK foreign key (UserID, DocumentClass, DocumentID)
      references UserContact (UserID, BusinessCardClass, BusinessCardID)
	  on delete cascade
go

alter table Expense
   add constraint CodeOfExpenseFK foreign key (ExpenseCodeID)
      references ExpenseCode (ID)
go

alter table Expense
   add constraint DivisionExpenseFK foreign key (DivisionID)
      references Division (ID)
go

alter table Expense
   add constraint EmployeeExpenseFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table Expense
   add constraint ExpenceCurrencyFK foreign key (FromCurrencyCode)
      references Currency (Code)
go

alter table Expense
   add constraint ExpenseProjectCurrencyFK foreign key (ToCurrencyCode)
      references Currency (Code)
go

alter table Expense
   add constraint ExpenseUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table Expense
   add constraint ProjectExpenseFK foreign key (ProjectID)
      references Project (ID)
go

alter table Expense
   add constraint ReportContainsExpenseFK foreign key (ExpenseReportID)
      references ExpenseReport (ID)
go

alter table Expense
   add constraint TaskExpenseFK foreign key (TaskID)
      references Task (ID)
go

alter table ExpenseCode
   add constraint ProjectTypeExpenseCodeFK foreign key (ProjectTypeID)
      references ProjectType (ID)
go

alter table ExpenseCodeDefaults
   add constraint DefaultsOfExpenseCodeFK foreign key (ExpenseCodeID)
      references ExpenseCode (ID)
go

alter table ExpenseCodeDefaults
   add constraint ExpenseCodeDefaultsLanguageFK foreign key (LanguageCode)
      references LanguageCode (Code)
go

alter table ExpenseReport
   add constraint ExpenseReportOfEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table ExtendedProperties
   add constraint DocumentExtendedPropertiesFK foreign key (Class, ID)
      references Document (Class, ID)
      on delete cascade
go

alter table Facture
   add constraint FactureCurrencyCodeFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Facture
   add constraint FactureCustomerFK foreign key (CustomerCompanyID)
      references Company (ID)
go

alter table Facture
   add constraint FactureProjectFK foreign key (ProjectID)
      references Project (ID)
go

alter table Facture
   add constraint FactureSupplierFK foreign key (SupplierCompanyID)
      references Company (ID)
go

alter table FactureLine
   add constraint FactureLineDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
go

alter table FactureLine
   add constraint FactureLineUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table FactureLine
   add constraint FactureLinesFK foreign key (FactureID)
      references Facture (ID)
go

alter table FacturePayment
   add constraint PaymentsFactureFK foreign key (PaymentID)
      references Payment (ID)
go

alter table FacturePayment
   add constraint PaymentsOfFactureFK foreign key (FactureID)
      references Facture (ID)
go

alter table Folder
   add constraint FolderCompanyFK foreign key (CompanyID)
      references Company (ID)
go

alter table Folder
   add constraint SubfoldersFK foreign key (FolderID)
      references Folder (ID)
go

alter table FolderAccessControl
   add constraint FolderAccessFolderFK foreign key (FolderID)
      references Folder (ID)
      on delete cascade
go

alter table FolderAccessControl
   add constraint FolderAccessTrusteeFK foreign key (TrusteeID)
      references Trustee (ID)
      on delete cascade
go

alter table FolderNotificationSettings
   add constraint FolderNotificationTrusteeFK foreign key (TrusteeID)
      references Trustee (ID)
      on delete cascade
go

alter table FolderNotificationSettings
   add constraint NotificationOfFolderFK foreign key (FolderID)
      references Folder (ID)
      on delete cascade
go

alter table IdentityCard
   add constraint EmployeeIdentityCardsFK foreign key (EmployeeID)
      references Employee (ID)
      on delete cascade
go

alter table IdentityCard
   add constraint TypeOfIdentityCardFK foreign key (IdentityCardTypeID)
      references IdentityCardType (ID)
go

alter table Invoice
   add constraint InvoiceCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Invoice
   add constraint InvoiceCustomerCompanyFK foreign key (CustomerCompanyID)
      references Company (ID)
go

alter table Invoice
   add constraint InvoiceSupplierCompanyFK foreign key (SupplierCompanyID)
      references Company (ID)
go

alter table Invoice
   add constraint ProjectInvoiceFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table Invoice
   add constraint SupplierBankAccountFK foreign key (SupplierBankAccountID)
      references BankAccount (ID)
go

alter table InvoiceLine
   add constraint BillLinesFK foreign key (InvoiceID)
      references Invoice (ID)
      on delete cascade
go

alter table InvoiceLine
   add constraint InvoiceLineDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
go

alter table InvoiceLine
   add constraint InvoiceLineServiceTypeFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table InvoiceLine
   add constraint InvoiceLineUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table Issue
   add constraint IssueAssignedToFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table Issue
   add constraint IssueIsDuplicateOfFK foreign key (DuplicateOfIssueID)
      references Issue (ID)
go

alter table Issue
   add constraint IssuePriorityFK foreign key (PriorityID)
      references Priority (ID)
go

alter table Issue
   add constraint IssueResolutionFK foreign key (ResolutionID)
      references Resolution (ID)
go

alter table Issue
   add constraint IssueSeverityFK foreign key (SeverityID)
      references Severity (ID)
go

alter table Issue
   add constraint ProjectIssuesFK foreign key (ProjectID)
      references Project (ID)
go

alter table IssueProject
   add constraint IssueProjectProjectFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table IssueProject
   add constraint IssueProjectUserFK foreign key (UserID)
      references [User] (ID)
go

alter table MailItemEventTypeGlobal
   add constraint LanguageMailItemEventTypeGlobalFK foreign key (Language)
      references Language (Language)
go

alter table MailItemEventTypeGlobal
   add constraint MailItemEventTypeMailItemEventTypeGlobalFK foreign key (EventType)
      references MailItemEventType (EventType)
go

alter table MeetingRequest
   add constraint MeetingRequestActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table MeetingRequest
   add constraint OriginatorEmployeeMeetingRequestFK foreign key (OriginatorEmployeeID)
      references Employee (ID)
go

alter table MeetingRequest
   add constraint PriorityMeetingRequestFK foreign key (PriorityID)
      references Priority (ID)
go

alter table MeetingRequest
   add constraint ProjectMeetingRequestFK foreign key (ProjectID)
      references Project (ID)
go

alter table MeetingResource
   add constraint MeetingRequestMeetingResourceFK foreign key (MeetingRequestID)
      references MeetingRequest (ID)
go

alter table MeetingResource
   add constraint ResourceMeetingResourceFK foreign key (ResourceID)
      references Resource (ID)
go

alter table MsAssignment
   add constraint MsResourceMsAssignmentFK foreign key (ProjectID, ResourceID)
      references MsResource (ProjectID, ID)
go

alter table MsAssignment
   add constraint MsTaskMsAssignmentFK foreign key (ProjectID, TaskID)
      references MsTask (ProjectID, ID)
      on delete cascade
go

alter table MsProject
   add constraint CurrencyMsProjectFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table MsProject
   add constraint MsProjectDocumentItemFK foreign key (DocumentItemID)
      references DocumentItem (ID)
go

alter table MsProject
   add constraint PriorityMsProjectFK foreign key (PriorityID)
      references Priority (ID)
go

alter table MsResource
   add constraint MsProjectMsResourceFK foreign key (ProjectID)
      references MsProject (ID)
      on delete cascade
go

alter table MsTask
   add constraint MsProjectMsTaskFK foreign key (ProjectID)
      references MsProject (ID)
      on delete cascade
go

alter table MsTask
   add constraint MsSubprojectFK foreign key (SubprojectID)
      references MsProject (ID)
go

alter table MsTask
   add constraint MsTaskMsTaskFK foreign key (ProjectID, ParentID)
      references MsTask (ProjectID, ID)
go

alter table MsTask
   add constraint PriorityMsTaskFK foreign key (PriorityID)
      references Priority (ID)
go

alter table MsTimephasedData
   add constraint MsAssignmentMsTimephasedDataFK foreign key (TaskID, ProjectID, ResourceID, AssignmentID)
      references MsAssignment (TaskID, ProjectID, ResourceID, ID)
      on delete cascade
go

alter table NamedList
   add constraint ProjectNamedListsFK foreign key (ProjectID)
      references Project (ID)
go

alter table NamedListBinding
   add constraint NamedListBindingsFK foreign key (NamedListID)
      references NamedList (ID)
      on delete cascade
go

alter table NamedListEntry
   add constraint NamedListEntriesFK foreign key (NamedListID)
      references NamedList (ID)
      on delete cascade
go

alter table Note
   add constraint DocumentNoteFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Note
   add constraint NoteCreatedByFK foreign key (CreatedBy)
      references [User] (ID)
go

alter table NotificationMessageTemplate
   add constraint SubscriptionTypeTemplateFK foreign key (SubscriptionTypeID)
      references SubscriptionType (ID)
go

alter table NotificationMessageTemplate
   add constraint TemplateDocumentInstanceFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table NotificationMessageTemplate
   add constraint TemplateNotificationWayFK foreign key (NotificationWayID)
      references NotificationWay (ID)
go

alter table NotificationMessageTemplateGlobal
   add constraint NotificationMessageTemplateGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table NotificationMessageTemplateGlobal
   add constraint NotificationMessageTemplateGlobalNotificationMessageTemplateFK foreign key (ID)
      references NotificationMessageTemplate (ID)
      on delete cascade
go

alter table NotificationMessageTemplateTokenGlobal
   add constraint NotificationMessageTemplateTokenGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table NotificationMessageTemplateTokenGlobal
   add constraint NotificationMessageTemplateTokenGlobalNotificationMessageTemplateTokenFK foreign key (ID)
      references NotificationMessageTemplateToken (ID)
      on delete cascade
go

alter table NotificationWayGlobal
   add constraint NotificationWayGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table NotificationWayGlobal
   add constraint NotificationWayGlobalNotificationWayFK foreign key (ID)
      references NotificationWay (ID)
      on delete cascade
go

alter table NumberAssignment
   add constraint NumberAssignmentDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table NumberTemplate
   add constraint NumberTemplateCompanyFK foreign key (CompanyID)
      references Company (ID)
      on delete cascade
go

alter table Payment
   add constraint PayeeBankAccountFK foreign key (PayeeBankAccountID)
      references BankAccount (ID)
go

alter table Payment
   add constraint PayeeCompanyFK foreign key (PayeeCompanyID)
      references Company (ID)
go

alter table Payment
   add constraint PayerCompanyFK foreign key (PayerCompanyID)
      references Company (ID)
go

alter table Payment
   add constraint PaymentContractFK foreign key (ProjectID)
      references Project (ID)
go

alter table Payment
   add constraint PaymentCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Payment
   add constraint TypeOfPaymentFK foreign key (PaymentTypeID)
      references PaymentType (ID)
go

alter table PaymentDetail
   add constraint DetailOfPaymentFK foreign key (PaymentID)
      references Payment (ID)
      on delete cascade
go

alter table PaymentDetail
   add constraint InvoicePaymentFK foreign key (InvoiceID)
      references Invoice (ID)
go

alter table PaymentPeriod
   add constraint ContractPaymentPeriodFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table PaymentSchedule
   add constraint PaymentScheduleRecurrenceFK foreign key (RecurrenceID)
      references RecurrencePattern (ID)
go

alter table Phone
   add constraint BusinessCardPhonesFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
      on delete cascade
go

alter table Phone
   add constraint PhoneOfTypeFK foreign key (PhoneTypeID)
      references PhoneType (ID)
go

alter table PhoneCall
   add constraint CodeOfCallFK foreign key (PhoneCallCodeID)
      references PhoneCallCode (ID)
go

alter table PhoneCall
   add constraint PhoneCallExpenseFK foreign key (ExpenseID)
      references Expense (ID)
go

alter table PhoneCall
   add constraint PhoneCallTimeEntryFK foreign key (TimeEntryID)
      references TimeEntry (ID)
go

alter table PhoneCallRate
   add constraint PhoneCallRateCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table PhoneCallRate
   add constraint PhoneCallRatesFK foreign key (PhoneCallCodeID)
      references PhoneCallCode (ID)
      on delete cascade
go

alter table Presence
   add constraint UserPresenceFK foreign key (ID)
      references [User] (ID)
      on delete cascade
go

alter table Project
   add constraint CalculationRecurrencePatternFK foreign key (CalculationRecurrencePatternID)
      references AssistantRecurrencePattern (ID)
go

alter table Project
   add constraint ContractServiceLevelFK foreign key (ServiceLevelID)
      references ServiceLevel (ID)
go

alter table Project
   add constraint FinancialManagerFK foreign key (CustomerFinanceManagerID)
      references Employee (ID)
go

alter table Project
   add constraint InvoiceRecurrencePatternFK foreign key (InvoiceRecurrencePatternID)
      references AssistantRecurrencePattern (ID)
go

alter table Project
   add constraint MsProjectProjectFK foreign key (MsProjectID)
      references MsProject (ID)
      on delete cascade
go

alter table Project
   add constraint ProjectCostCenterFK foreign key (CostCenterID)
      references CostCenter (ID)
go

alter table Project
   add constraint ProjectCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Project
   add constraint ProjectCustomerFK foreign key (CustomerCompanyID)
      references Company (ID)
go

alter table Project
   add constraint ProjectFolderFK foreign key (FolderID)
      references Folder (ID)
go

alter table Project
   add constraint ProjectLanguageCodeFK foreign key (ProjectLanguageCode)
      references LanguageCode (Code)
go

alter table Project
   add constraint ProjectManagerFK foreign key (ProjectManagerEmployeeID)
      references Employee (ID)
go

alter table Project
   add constraint ProjectPriorityFK foreign key (PriorityID)
      references Priority (ID)
go

alter table Project
   add constraint ProjectSupplierFK foreign key (SupplierCompanyID)
      references Company (ID)
go

alter table Project
   add constraint ResponsiblePersonFK foreign key (ResponsiblePersonEmployeeID)
      references Employee (ID)
go

alter table Project
   add constraint StatementRecurrencePatternFK foreign key (StatementRecurrencePatternID)
      references AssistantRecurrencePattern (ID)
go

alter table Project
   add constraint TypeOfProjectFK foreign key (ProjectTypeID)
      references ProjectType (ID)
go

alter table ProjectActivityType
   add constraint ActivitiesOfProjectFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table ProjectActivityType
   add constraint AvailableActivityTypeFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table ProjectDetail
   add constraint ProjectDetailsFK foreign key (ID)
      references Project (ID)
      on delete cascade
go

alter table ProjectExpenseCode
   add constraint AvailableExpenseCodeFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table ProjectExpenseCode
   add constraint ExpenseCodesOfProjectFK foreign key (ExpenseCodeID)
      references ExpenseCode (ID)
go

alter table ProjectTemplate
   add constraint ProjectIsTemplateFK foreign key (ID)
      references Project (ID)
      on delete cascade
go

alter table Property
   add constraint DocumentClassPropertyFK foreign key (Class)
      references Class (Class)
go

alter table PropertyGlobal
   add constraint PropertyGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table PropertyGlobal
   add constraint PropertyGlobalPropertyFK foreign key (ID)
      references Property (ID)
go

alter table PropertyValue
   add constraint DocumentPropertyValueFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table PropertyValue
   add constraint PropertyValueFK foreign key (PropertyID)
      references Property (ID)
      on delete cascade
go

alter table Qualification
   add constraint QualificationActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table QualificationRate
   add constraint QualificationRateCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table QualificationRate
   add constraint RateOfQualificationFK foreign key (QualificationID)
      references Qualification (ID)
      on delete cascade
go

alter table Reminder
   add constraint ReminderDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Reminder
   add constraint ReminderReminderTypeFK foreign key (DocumentClass, Subtype)
      references ReminderType (Class, Subtype)
go

alter table ReminderSetting
   add constraint ReminderTypeReminderSettingFK foreign key (Class, Subtype)
      references ReminderType (Class, Subtype)
go

alter table ReminderSetting
   add constraint UserReminderSettingFK foreign key (UserID)
      references [User] (ID)
go

alter table ReminderType
   add constraint ClassReminderTypeFK foreign key (Class)
      references Class (Class)
go

alter table Resource
   add constraint EmployeeResourceFK foreign key (ResponsibleEmployeeID)
      references Employee (ID)
go

alter table Resource
   add constraint ResourceTypeResourceFK foreign key (ResourceTypeID)
      references ResourceType (ID)
go

alter table ResourceAvailability
   add constraint ResourceResourceAvailabilityFK foreign key (ResourceID)
      references Resource (ID)
go

alter table ResourceRequest
   add constraint EmployeeResourceRequestFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table ResourceRequest
   add constraint MeetingRequestResourceRequestFK foreign key (MeetingRequestID)
      references MeetingRequest (ID)
go

alter table ResourceRequest
   add constraint PriorityResourceRequestFK foreign key (PriorityID)
      references Priority (ID)
go

alter table ResourceRequest
   add constraint ProjectResourceRequestFK foreign key (ProjectID)
      references Project (ID)
go

alter table ResourceRequest
   add constraint ResourceResourceRequestFK foreign key (ResourceID)
      references Resource (ID)
go

alter table RightGlobal
   add constraint RightGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table RightGlobal
   add constraint RightGlobalRightFK foreign key (ID)
      references [Right] (ID)
      on delete cascade
go

alter table Role
   add constraint RoleTrusteeFK foreign key (ID)
      references Trustee (ID)
      on delete cascade
go

alter table SearchFolder
   add constraint SearchFolderUserFK foreign key (UserID)
      references [User] (ID)
go

alter table Service
   add constraint ServicePaymentTermFK foreign key (PaymentTermID)
      references PaymentTerm (ID)
go

alter table Service
   add constraint ServiceTypeServiceFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table Service
   add constraint ServiceUnitOfMeasureFK foreign key (UOMID)
      references UOM (ID)
go

alter table ServiceAssignment
   add constraint AddendumServiceAssignmentsFK foreign key (ContractAddendumID)
      references ContractAddendum (ID)
go

alter table ServiceAssignment
   add constraint ServiceAssignmentPaymentTermFK foreign key (PaymentTermID)
      references PaymentTerm (ID)
go

alter table ServiceAssignment
   add constraint ServiceAssignmentProjectFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table ServiceAssignment
   add constraint ServiceAssignmentServiceTypeFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table ServiceAssignment
   add constraint ServiceAssignmentsFK foreign key (ServiceID)
      references Service (ID)
go

alter table ServicePrice
   add constraint CurrencyOfServicePriceFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table ServicePrice
   add constraint PriceOfServiceFK foreign key (ServiceID)
      references Service (ID)
      on delete cascade
go

alter table ServiceRequest
   add constraint DivisionServiceRequestFK foreign key (DivisionID)
      references Division (ID)
go

alter table ServiceRequest
   add constraint ServiceRequestEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table ServiceRequest
   add constraint ServiceRequestPriorityFK foreign key (PriorityID)
      references Priority (ID)
go

alter table ServiceRequest
   add constraint ServiceRequestProjectFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table ServiceRequest
   add constraint ServiceRequestServiceTypeFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table ServiceRequestLine
   add constraint ServiceRequestLineAssignmentFK foreign key (ServiceAssignmentID)
      references ServiceAssignment (ID)
go

alter table ServiceRequestLine
   add constraint ServiceRequestLinesFK foreign key (ServiceRequestID)
      references ServiceRequest (ID)
      on delete cascade
go

alter table Snapshot
   add constraint OwnerUserSnapshotFK foreign key (OwnerUserID)
      references [User] (ID)
go

alter table Snapshot
   add constraint SnapshotContainerInstanceFK foreign key (ContainerClass, ContainerID)
      references Document (Class, ID)
go

alter table Snapshot
   add constraint SnapshotDocumentInstanceFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Snapshot
   add constraint SnapshotSubscriptionTypeFK foreign key (SubscriptionTypeID)
      references SubscriptionType (ID)
go

alter table Snapshot
   add constraint UserSnapshotFK foreign key (UserID)
      references [User] (ID)
go

alter table State
   add constraint ClassStatesFK foreign key (Class)
      references Class (Class)
go

alter table StateGlobal
   add constraint StateGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table StateGlobal
   add constraint StateGlobalStateFK foreign key (Class, State)
      references State (Class, State)
      on delete cascade
go

alter table Statement
   add constraint ProjectStatementFK foreign key (ProjectID)
      references Project (ID)
go

alter table Statement
   add constraint StatementCurrencyCodeFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Statement
   add constraint StatementCustomerCompanyFK foreign key (CustomerCompanyID)
      references Company (ID)
go

alter table Statement
   add constraint StatementSupplierCompanyFK foreign key (SupplierCompanyID)
      references Company (ID)
go

alter table StatementAdvanceInvoice
   add constraint IsStatementAdvanceInvoiceFK foreign key (AdvanceInvoiceID)
      references Invoice (ID)
      on delete cascade
go

alter table StatementAdvanceInvoice
   add constraint StatementAdvanceInvoicesFK foreign key (StatementID)
      references Statement (ID)
      on delete cascade
go

alter table StatementLine
   add constraint StatementDetailsFK foreign key (StatementID)
      references Statement (ID)
      on delete cascade
go

alter table StatementLine
   add constraint StatementLineDocumentFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
go

alter table StatementLine
   add constraint StatementLineServiceTypeFK foreign key (ServiceTypeID)
      references ServiceType (ID)
go

alter table StatementLine
   add constraint StatementLineUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table Sticker
   add constraint StickerUserFK foreign key (RecipientUserID)
      references [User] (ID)
go

alter table Subscription
   add constraint RuleSubscriptionTypeFK foreign key (SubscriptionTypeID)
      references SubscriptionType (ID)
go

alter table Subscription
   add constraint SubscriptionRuleSubscriptionFK foreign key (SubscriptionRuleID)
      references SubscriptionRule (ID)
      on delete cascade
go

alter table SubscriptionRule
   add constraint UserRulesFK foreign key (UserID)
      references [User] (ID)
go

alter table SubscriptionRuleNotificationWay
   add constraint NotificationWaySubscriptionRuleFK foreign key (NotificationWayID)
      references NotificationWay (ID)
go

alter table SubscriptionRuleNotificationWay
   add constraint SubscriptionRuleNotificationWaysFK foreign key (SubscriptionRuleID)
      references SubscriptionRule (ID)
      on delete cascade
go

alter table SubscriptionRuleNotificationWay
   add constraint SubscriptionRuleRecurrencePatternFK foreign key (SubscriptionRecurrencePatternID)
      references SubscriptionRecurrencePattern (ID)
go

alter table SubscriptionType
   add constraint SubscriptionTypeDocumentClassFK foreign key (DocumentClass)
      references Class (Class)
go

alter table SubscriptionTypeGlobal
   add constraint SubscriptionTypeGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table SubscriptionTypeGlobal
   add constraint SubscriptionTypeGlobalSubscriptionTypeFK foreign key (ID)
      references SubscriptionType (ID)
      on delete cascade
go

alter table SubscriptionTypeRight
   add constraint SubscriptionTypeRightRightFK foreign key (RightID)
      references [Right] (ID)
go

alter table SubscriptionTypeRight
   add constraint SubscriptionTypeRoleFK foreign key (SubscriptionTypeID)
      references SubscriptionType (ID)
go

alter table SuperTimer
   add constraint ActivityTypeSuperTimerFK foreign key (ActivityTypeID)
      references ActivityType (ID)
      on delete cascade
go

alter table SuperTimer
   add constraint BusinessCardSuperTimerFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
      on delete cascade
go

alter table SuperTimer
   add constraint DocumentSuperTimerFK foreign key (DocumentClass, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table SuperTimer
   add constraint UserSuperTimerFK foreign key (CreatedBy)
      references [User] (ID)
      on delete cascade
go

alter table SuperTimerHistory
   add constraint SuperTimerSuperTimerHistoryFK foreign key (SuperTimerID)
      references SuperTimer (ID)
      on delete cascade
go

alter table Task
   add constraint MsTaskTaskFK foreign key (MsTaskID)
      references MsTask (ID)
go

alter table Task
   add constraint ParentTaskFK foreign key (ParentID)
      references Task (ID)
go

alter table Task
   add constraint ProjectTaskFK foreign key (ProjectID)
      references Project (ID)
      on delete cascade
go

alter table Task
   add constraint SubprojectFK foreign key (SubprojectID)
      references Project (ID)
go

alter table Task
   add constraint TaskPriorityFK foreign key (PriorityID)
      references Priority (ID)
go

alter table TaskAssignment
   add constraint AssignmentsOfTaskFK foreign key (TaskID)
      references Task (ID)
      on delete cascade
go

alter table TaskAssignment
   add constraint TasksOfAssignmentFK foreign key (AssignmentID)
      references Assignment (ID)
go

alter table TaskRequest
   add constraint RequestsOfDocumentCardFK foreign key (DocumentCardID)
      references DocumentCard (ID)
go

alter table TaskRequest
   add constraint StatusOfTaskRequestFK foreign key (TaskRequestStatusID)
      references TaskRequestStatus (ID)
go

alter table TaskRequest
   add constraint TaskRequestOwnerFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table TaskRequest
   add constraint TaskRequestPriorityFK foreign key (PriorityID)
      references Priority (ID)
go

alter table TaskRequest
   add constraint TaskRequestProjectFK foreign key (ProjectID)
      references Project (ID)
go

alter table TaskRequest
   add constraint TaskRequestSupervisorFK foreign key (SupervisorEmployeeID)
      references Employee (ID)
go

alter table TaskRequestAssignment
   add constraint AssignmentsToTaskRequestFK foreign key (TaskRequestID)
      references TaskRequest (ID)
      on delete cascade
go

alter table TaskRequestAssignment
   add constraint TaskRequestAssignmentEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table TaskWbs
   add constraint WbsOfTaskFK foreign key (TaskID)
      references Task (ID)
      on delete cascade
go

alter table TimeEntry
   add constraint DivisionTimeEntryFK foreign key (DivisionID)
      references Division (ID)
go

alter table TimeEntry
   add constraint EmployeeTimeEntryFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table TimeEntry
   add constraint MeetingRequestTimeEntryFK foreign key (MeetingRequestID)
      references MeetingRequest (ID)
go

alter table TimeEntry
   add constraint ProjectTimeEntryFK foreign key (ProjectID)
      references Project (ID)
go

alter table TimeEntry
   add constraint SuperTimerTimeEntryFK foreign key (SuperTimerID)
      references SuperTimer (ID)
go

alter table TimeEntry
   add constraint TaskTimeEntryFK foreign key (TaskID)
      references Task (ID)
go

alter table TimeEntry
   add constraint TimeEntryActivityFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table TimeEntry
   add constraint TimeEntryAssignmentFK foreign key (AssignmentID)
      references Assignment (ID)
go

alter table TimeEntry
   add constraint TimeEntryCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table Timer
   add constraint ProjectTimerFK foreign key (ProjectID)
      references Project (ID)
go

alter table Timer
   add constraint TimerActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table Timer
   add constraint TimerTaskFK foreign key (TaskID)
      references Task (ID)
go

alter table Transition
   add constraint DocumentTransitionsFK foreign key (Class, DocumentID)
      references Document (Class, ID)
      on delete cascade
go

alter table Transition
   add constraint TransitionPerformedByFK foreign key (UserID)
      references [User] (ID)
go

alter table Transition
   add constraint TransitionTemplateFK foreign key (TransitionTemplateID)
      references TransitionTemplate (ID)
go

alter table TransitionTemplate
   add constraint ActionTransitionsFK foreign key (ActionID)
      references Action (ID)
go

alter table TransitionTemplate
   add constraint RightTransitionsFK foreign key (RightID)
      references [Right] (ID)
go

alter table TransitionTemplate
   add constraint TransitionFromStateFK foreign key (Class, FromState)
      references State (Class, State)
go

alter table TransitionTemplate
   add constraint TransitionToStateFK foreign key (Class, ToState)
      references State (Class, State)
go

alter table TransitionTemplate
   add constraint UICommandTransitionTemplateFK foreign key (UICommandID)
      references UICommand (ID)
go

alter table TransitionTemplateGlobal
   add constraint TransitionTemplateGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table TransitionTemplateGlobal
   add constraint TransitionTemplateGlobalTransitionTemplateFK foreign key (ID)
      references TransitionTemplate (ID)
      on delete cascade
go

alter table TrusteeGlobal
   add constraint TrusteeGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table TrusteeGlobal
   add constraint TrusteeGlobalTrusteeFK foreign key (ID)
      references Trustee (ID)
      on delete cascade
go

alter table UICommand
   add constraint UICommandActionFK foreign key (ActionID)
      references Action (ID)
go

alter table UICommand
   add constraint UICommandClassFK foreign key (Class)
      references Class (Class)
go

alter table UICommandGlobal
   add constraint UICommandGlobalLanguageFK foreign key (Language)
      references Language (Language)
go

alter table UICommandGlobal
   add constraint UICommandGlobalUICommandFK foreign key (ID)
      references UICommand (ID)
      on delete cascade
go

alter table UserContact
   add constraint BusinessCardUserContactFK foreign key (BusinessCardClass, BusinessCardID)
      references BusinessCard (Class, ID)
      on delete cascade
go

alter table UserContact
   add constraint UserUserContactFK foreign key (UserID)
      references [User] (ID)
go

alter table UserFavoriteFolder
   add constraint FolderFavoritByUserFK foreign key (FolderID)
      references Folder (ID)
      on delete cascade
go

alter table UserFavoriteFolder
   add constraint UsersFavoritFolderFK foreign key (UserID)
      references [User] (ID)
      on delete cascade
go

alter table UserNTLoginMapping
   add constraint UserOfNTLoginFK foreign key (UserID)
      references [User] (ID)
go

alter table UserParameter
   add constraint UserParametersFK foreign key (UserID)
      references [User] (ID)
go

alter table UserReminder
   add constraint ReminderUserReminderFK foreign key (ReminderID)
      references Reminder (ID)
      on delete cascade
go

alter table UserReminder
   add constraint UserUserReminderFK foreign key (UserID)
      references [User] (ID)
go

alter table UserRole
   add constraint RoleMembersFK foreign key (RoleID)
      references Role (ID)
go

alter table UserRole
   add constraint UserRolesFK foreign key (UserID)
      references [User] (ID)
      on delete cascade
go

alter table UserWebConfiguration
   add constraint WebConfigurationofUserFK foreign key (ID)
      references [User] (ID)
go

alter table [Case]
   add constraint CaseCompanyFK foreign key (CompanyID)
      references Company (ID)
go

alter table [Case]
   add constraint CaseEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table [Case]
   add constraint WordTemplatesFolderFK foreign key (WordTemplatesFolderID)
      references Folder (ID)
go

alter table [User]
   add constraint UserTrusteeFK foreign key (ID)
      references Trustee (ID)
      on delete cascade
go

alter table [Project]
   add constraint ProjectBankAccountFK foreign key (BankAccountID)
      references BankAccount (ID)
go

alter table ExportItem
   add constraint ExportItemCompanyFK foreign key (CompanyID)
      references Company (ID)
go

alter table ExportItem
   add constraint ExportItemEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table ExportItem
   add constraint ExportItemExportTypeFK foreign key (ExportTypeID)
      references ExportType (ID)
go

alter table Facture
   add constraint FactureExportItemFK foreign key (ExportItemID)
      references ExportItem (ID)
         on delete set null
go

alter table Invoice
   add constraint InvoiceExportItemFK foreign key (ExportItemID)
      references ExportItem (ID)
		on delete set null
go

alter table Statement
   add constraint StatementExportItemFK foreign key (ExportItemID)
      references ExportItem (ID)
		on delete set null
go

alter table TaskRequestAssignmentResponse
   add constraint AssignmentsResponseToTaskRequestFK foreign key (TaskRequestID)
      references TaskRequest (ID)
      on delete cascade
go

alter table TaskRequestAssignmentResponse
   add constraint TaskRequestAssignmentResponseEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table ExpenseCode
   add constraint ExpenseCodeUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table ExpenseCodePrice
   add constraint CurrencyOfExpenseCodePriceFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table ExpenseCodePrice
   add constraint PriceOfExpenseCodeFK foreign key (ID)
      references ExpenseCode (ID)
go
-----------------------------------------------------------------------------------------------------
alter table Budget
   add constraint BudgetSupervisorFK foreign key (SupervisorEmployeeID)
      references Employee (ID)
go

alter table Budget
   add constraint BudgetTypeFK foreign key (BudgetTypeID)
      references BudgetType (ID)
go

alter table Budget
   add constraint BudgetWarningFlagFK foreign key (WarningFlagID)
      references BudgetWarningFlag (ID)
go

alter table Budget
   add constraint CalculateBudgetPatternFK foreign key (CalculateBudgetPatternID)
      references AssistantRecurrencePattern (ID)
go

alter table Budget
   add constraint CalculatedEmployeeFK foreign key (CalculatedEmployeeID)
      references Employee (ID)
go

alter table Budget
   add constraint CurrencyCodeFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table BudgetLineExpense
   add constraint BudgelLineExpenseCodeFK foreign key (ExpenseCodeID)
      references ExpenseCode (ID)
go

alter table BudgetLineExpense
   add constraint BudgetExpenseLineCurrencyFK foreign key (CurrencyCode)
      references Currency (Code)
go

alter table BudgetLineExpense
   add constraint BudgetLineEmployeeExpenseFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table BudgetLineExpense
   add constraint BudgetLineExpenseFK foreign key (ExpenseID)
      references Expense (ID)
go

alter table BudgetLineExpense
   add constraint BudgetLineGroupExpenseFK foreign key (BudgetLineGroupID)
      references BudgetLineGroup (ID)
go

alter table BudgetLineExpense
   add constraint BudgetLineUOMFK foreign key (UOMID)
      references UOM (ID)
go

alter table BudgetLineExpense
   add constraint BudgetLinesExpenseFK foreign key (BudgetID)
      references Budget (ID)
	  on delete cascade
go

alter table BudgetLineGroup
   add constraint BudgetGroupsFK foreign key (BudgetID)
      references Budget (ID)
	  on delete cascade
go

alter table BudgetLineWork
   add constraint BudgetLineActivityTypeFK foreign key (ActivityTypeID)
      references ActivityType (ID)
go

alter table BudgetLineWork
   add constraint BudgetLineEmployeeFK foreign key (EmployeeID)
      references Employee (ID)
go

alter table BudgetLineWork
   add constraint BudgetLineGroupWorkFK foreign key (BudgetLineGroupID)
      references BudgetLineGroup (ID)
go

alter table BudgetLineWork
   add constraint BudgetLineQualificationFK foreign key (QualificationID)
      references Qualification (ID)
go

alter table BudgetLineWork
   add constraint BudgetLinesWorkFK foreign key (BudgetID)
      references Budget (ID)
	  on delete cascade
go

alter table BudgetTypeGlobal
   add constraint BudgetGroupLanguageFK foreign key (Language)
      references Language (Language)
go

alter table BudgetLineGroup
   add constraint BudgetGroupTypeFK foreign key (GroupTypeID)
      references BudgetLineGroupType (ID)
go

alter table BudgetLineGroupTypeGlobal
   add constraint BudgetGroupTypeLanguageFK foreign key (Language)
      references Language (Language)
go

alter table BudgetLineGroupGlobal
   add constraint BudgetLineGroupLanguageFK foreign key (Language)
      references Language (Language)
go

alter table BudgetWarningFlagGlobal
   add constraint BudgetWarningFlagLanguageFK foreign key (Language)
      references Language (Language)
go

alter table ProjectTemplate
   add constraint BudgetTemplateFK foreign key (BudgetTemplateID)
      references Budget (ID)
go

alter table BudgetLineExpenseEntries
   add constraint BudgeLineExpenseEntriesFK foreign key (EntryID)
      references Expense (ID)
	  on delete cascade
go

alter table BudgetLineExpenseEntries
   add constraint BudgeLineExpenseBudgetFK foreign key (BudgetID)
      references Budget (ID)
go

alter table BudgetLineExpenseEntries
   add constraint BudgetLineExpenseEntryFK foreign key (BudgetLineID)
      references BudgetLineExpense (ID)
	  on delete cascade
go

alter table BudgetLineWorkEntries
   add constraint BudgeLineTimeEntriesFK foreign key (EntryID)
      references TimeEntry (ID)
	  on delete cascade
go

alter table BudgetLineWorkEntries
   add constraint BudgeLineWorkBudgetFK foreign key (BudgetID)
      references Budget (ID)
go

alter table BudgetLineWorkEntries
   add constraint BudgetLineWorkEntryFK foreign key (BudgetLineID)
      references BudgetLineWork (ID)
	  on delete cascade
go

alter table Invoice
   add constraint InvoiceWarningFlagFK foreign key (WarningFlagID)
      references WarningFlag (ID)
go

alter table Statement
   add constraint StatementWarningFlagFK foreign key (WarningFlagID)
      references WarningFlag (ID)
go

alter table WarningFlagGlobal
   add constraint WarningFlagLanguageFK foreign key (Language)
      references Language (Language)
go

alter table Country
   add constraint CountryNationLanguageCodeFK foreign key (NationalLanguageCode)
      references LanguageCode (Code)
	  on delete set null
	  on update cascade
go