IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetTaskListByAssignment]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetTaskListByAssignment'
		DROP FUNCTION [dbo].[fnPjm5GetTaskListByAssignment]
	END

GO

PRINT 'Creating function fnPjm5GetTaskListByAssignment'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetTaskListByAssignment(@AssignmentID TIdentifier)
RETURNS TName
AS
BEGIN
	DECLARE @TaskName   nvarchar(4000),
			@tmp        TName
		DECLARE task CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[Task].[FileAs]
		FROM
			[Task]
		INNER JOIN [TaskAssignment]
			ON [Task].[ID]=[TaskAssignment].[TaskID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID]=[Assignment].[ID]
		WHERE
			[Assignment].[ID] = @AssignmentID	
			
		OPEN task
		FETCH NEXT FROM task INTO @tmp
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--------------
			SELECT @TaskName = ISNULL(@TaskName + ', ', '') + @tmp
			--------------
			FETCH NEXT FROM task INTO @tmp
		END
		CLOSE task
		DEALLOCATE task
	RETURN(@TaskName)
END
GO

GRANT EXEC ON fnPjm5GetTaskListByAssignment TO PUBLIC
GO
