IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5HasFinansDataAccess]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5HasFinansDataAccess'
		DROP FUNCTION [dbo].[fnPjm5HasFinansDataAccess]
	END

GO

PRINT 'Creating function fnPjm5HasFinansDataAccess'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5HasFinansDataAccess
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5HasFinansDataAccess(
	@ProjectID	TIdentifier,
	@EmployeeID TIdentifier,
	@Class		TClass,
	@Parameter	TVariant
	)
RETURNS TBool
AS
BEGIN
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) = 1 
		RETURN 1

	DECLARE @CurrentEmployeeID TIdentifier
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance')) = 1 
	BEGIN
		IF EXISTS(SELECT * FROM [vwAssignment]  WHERE [ProjectID] = @ProjectID AND 	[EmployeeID] = @CurrentEmployeeID AND [State] = 1)
			RETURN 1
	END
	
	IF EXISTS (
		SELECT [ID] FROM [Project] 
		WHERE 
			[ID] = @ProjectID AND 
			[ProjectManagerEmployeeID] = @CurrentEmployeeID
			)
		RETURN 1

	IF @Class = dbo.adfGetClassByName('Pjm5.Expense')
	BEGIN
		IF @CurrentEmployeeID = @EmployeeID OR
			EXISTS(
				SELECT * FROM [vwAssignment] 
				WHERE 
					[ProjectID] = @ProjectID AND 
					[EmployeeID] = @CurrentEmployeeID AND 
					([Approver] = 1 OR [Administrator] = 1) AND
					[State] = 1
					)
			RETURN 1
		IF CAST(@Parameter AS int) = dbo.adfGetCurrentUserID() -- CreatedBy
			RETURN 1
	END

	IF @Class = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN
		IF EXISTS(
			SELECT * FROM [vwAssignment] 
			WHERE 
				[ProjectID] = @ProjectID AND 
				[EmployeeID] = @CurrentEmployeeID AND 
				([Approver] = 1 OR [Administrator] = 1) AND
				[State] = 1
				)
			RETURN 1
		IF @CurrentEmployeeID = @EmployeeID AND 
			CAST(@Parameter AS int) = 1 -- ShowRates
			RETURN 1
	END

	RETURN 0
END
GO
GRANT EXEC ON fnPjm5HasFinansDataAccess TO PUBLIC
GO
  