IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetExperience') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetExperience'
		DROP FUNCTION [dbo].fnPjm6GetExperience
	END

GO

PRINT 'Creating function fnPjm6GetExperience'
GO
/******************************************************************************
**		File:	Pjm6GetExperience.sql
**		Name: 	Pjm6GetExperience
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetExperience(@HireDate datetime,
	@FireDate datetime)
RETURNS int
BEGIN
	DECLARE
		@MonthDif int,
		@YearDif int


	IF(@FireDate IS NULL)
	BEGIN
		SET @FireDate = GetDate()
	END

	SET @MonthDif = DATEDIFF(month, @HireDate,@FireDate)
	
	IF(@MonthDif > 0)
	BEGIN
		DECLARE @DayStart int,
				@DayEnd int

		SET @DayStart = DATEPART(day, @HireDate)
		SET @DayEnd = DATEPART(day, @FireDate)

		IF(@DayEnd < @DayStart - 1) 
		BEGIN
			SET @MonthDif = @MonthDif - 1
		END 
	END
	
	RETURN @MonthDif
END
GO

GRANT EXEC ON fnPjm6GetExperience TO PUBLIC
GO