IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6CheckAssignmentsAppendtoProjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6CheckAssignmentsAppendtoProjects'
		DROP PROCEDURE [dbo].[pjm6CheckAssignmentsAppendtoProjects]
	END
GO

PRINT 'Creating procedure pjm6CheckAssignmentsAppendtoProjects'
GO

/******************************************************************************
**		File: pjm6CheckAssignmentsAppendtoProjects.sql
**		Name: pjm6CheckAssignmentsAppendtoProjects
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Yuriy.Soldatkin
**		Date: 11/3/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    15.04.10		SYV				 ,    
*******************************************************************************/
CREATE PROCEDURE [pjm6CheckAssignmentsAppendtoProjects]
	@Xml XML,
	@EmployeeID TIdentifier
AS
SET NOCOUNT ON
	DECLARE @State TState,			
			@IsMember TBool,
			@IsAssistant TBool,
			@IsAssignmentEditor TBool,
			@MsProjectID TIdentifier,
			@IsLocalError TBool,
			@doc INT,
			@Number TCode
	
	DECLARE @for_append TABLE ([ID] INT null, [Description] nvarchar(256) null, [Number] varchar(32) null)
	
	SET @State = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	IF @State IS NULL
	BEGIN
		INSERT INTO @for_append VALUES(NULL, 'accessdenied_all', NULL)
		SELECT * FROM @for_append
		RETURN 1
	END
	
	DECLARE @CurrentEmployeeID int, 
			@ProjectState TState,
			@IsPM TBool

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[Employee]
		WHERE
			[ID]  = @EmployeeID AND
			[State] = 2
		) 
	BEGIN
		INSERT INTO @for_append VALUES(NULL, 'EmployeeFire', NULL)
		SELECT * FROM @for_append
		RETURN 1
	END

	DECLARE @AddProjectID TIdentifier
	DECLARE For_Add CURSOR LOCAL FAST_FORWARD FOR 
		SELECT 
			[ID] 
		FROM
		OPENXML(@doc, '/Employee/Project', 2)
			WITH (
				[ID] int
				)
	OPEN For_Add
	FETCH NEXT FROM For_Add INTO @AddProjectID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @IsLocalError = 0
		SELECT
			@Number = [Number]
		FROM
			[Project]
		WHERE
			[ID] = @AddProjectID
		SELECT @MsProjectID = [MsProjectID] FROM [Project] WHERE [ID] = @AddProjectID
		IF @MsProjectID IS NOT NULL
		BEGIN
			INSERT INTO @for_append VALUES(@AddProjectID, 'documentfrommsproject', @Number)
			SET @IsLocalError = 1
		END
		
		IF @IsLocalError = 0
		BEGIN
			IF dbo.fnPjm5IsProjectManager(@AddProjectID, @CurrentEmployeeID) = 0
			BEGIN
				SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
				SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @AddProjectID
				
				SET @IsMember = dbo.fnPjm5IsProjectMember(@AddProjectID, @CurrentEmployeeID)
				SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
				SET @IsAssignmentEditor = (@IsAssistant | @IsMember) & dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment'))
				IF (NOT (
					(@ProjectState IN (5, 6) AND @IsPM = 1) OR
					(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
					))
				BEGIN
					INSERT INTO @for_append VALUES(@AddProjectID, 'accessdenied', @Number)
					SET @IsLocalError = 1
				END
			END
		END		

		IF @IsLocalError = 0
		BEGIN

			IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @AddProjectID)
			BEGIN
				SET @State = 3
			END

			IF @EmployeeID IS NOT NULL AND
				EXISTS (
				SELECT 
					*
				FROM
					[vwAssignment] AS [Assignment]
				WHERE
					[Assignment].[ProjectID]  = @AddProjectID AND
					[Assignment].[EmployeeID]  = @EmployeeID AND
					[Assignment].[State] = @State
				) 
			BEGIN
				INSERT INTO @for_append VALUES(@AddProjectID, 'AssignmentAlreadyExist', @Number) 
				SET @IsLocalError = 1
			END
		END

		IF @IsLocalError = 0
		BEGIN
			INSERT INTO @for_append VALUES(@AddProjectID, NULL, NULL)
		END
		FETCH NEXT FROM For_Add INTO @AddProjectID
	END
	CLOSE For_Add
	DEALLOCATE For_Add
	EXEC sp_xml_removedocument @doc
	
	SELECT * FROM @for_append
	RETURN 0

GO

GRANT EXECUTE ON [pjm6CheckAssignmentsAppendtoProjects] TO PUBLIC
GO
