IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6RateAssignmentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6RateAssignmentUpdate'
		DROP PROCEDURE [dbo].[pjm6RateAssignmentUpdate]
	END
GO

PRINT 'Creating procedure pjm6RateAssignmentUpdate'
GO

/******************************************************************************
**		File: pjm6RateAssignmentUpdate.sql
**		Name: pjm6RateAssignmentUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 03.03.10
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE pjm6RateAssignmentUpdate
	@ID TIdentifier,
	@prevStandardRate TMoney,
	@prevOvertimeRate TMoney,
	@prevAlwaysUseRate TBool
AS
	SET NOCOUNT ON

	DECLARE @IsDeactivate TBool,
			@IsOvertime TBool,
			@Rate TMoney,
			@ServiceAssignmentClass TClass,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@AlwaysUseRate TBool,
			@EmployeeID TIdentifier,
			@ProjectID TIdentifier,
			@State TState

	SELECT
		@StandardRate = [StandardRate],
		@OvertimeRate = [OvertimeRate],
		@AlwaysUseRate = [AlwaysUseRate],
		@EmployeeID = [EmployeeID],
		@ProjectID = [ProjectID],
		@State = [State]
	FROM
		[vwAssignment]
	WHERE
		[ID] = @ID
		
	SET @IsDeactivate = CASE WHEN @State = 1 THEN 0 ELSE 1 END
	SET @ServiceAssignmentClass = dbo.adfGetClassByName('Pjm5.ServiceAssignment')
		
	IF (@StandardRate != @prevStandardRate AND @OvertimeRate != @prevOvertimeRate)
	BEGIN
		--  ServiceAssignment
		UPDATE [TimeEntry]
		SET
			[TimeEntry].[Rate] = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, [TimeEntry].[Overtime], [ServiceAssignment].[ID], @IsDeactivate)
		FROM
			[TimeEntry]
			INNER JOIN [ServiceAssignment]
				ON [TimeEntry].[DocumentID] = [ServiceAssignment].[ID]			
		WHERE
			[TimeEntry].[DocumentClass] = @ServiceAssignmentClass
			AND			
			[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
			AND
			[TimeEntry].[State] IN (1, 2, 5)
			AND
			NOT (
				@prevAlwaysUseRate = @AlwaysUseRate
				AND
				@AlwaysUseRate = 0
				AND
				[ServiceAssignment].[PaymentTermID] = 3
				AND
				[ServiceAssignment].[Price] IS NOT NULL
			)
		
		--   ServiceAssignment
		UPDATE [TimeEntry]
		SET
			[TimeEntry].[Rate] = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, [TimeEntry].[Overtime], NULL, @IsDeactivate)
		FROM
			[TimeEntry]
		WHERE
			ISNULL([TimeEntry].[DocumentClass], -1) != @ServiceAssignmentClass
			AND
			[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
			AND
			[TimeEntry].[State] IN (1, 2, 5)
				
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	--     (/)  AlwaysUseRate
	BEGIN						
		SET @IsOvertime = CASE WHEN @StandardRate != @prevStandardRate THEN 0 ELSE
								CASE WHEN @OvertimeRate != @prevOvertimeRate THEN 1 ELSE NULL END
						  END
		
		--  ServiceAssignment
		UPDATE [TimeEntry]
		SET
			[Rate] = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, [Overtime], [ServiceAssignment].[ID], @IsDeactivate)
		FROM
			[TimeEntry]
			INNER JOIN [ServiceAssignment]
				ON [TimeEntry].[DocumentID] = [ServiceAssignment].[ID]			
		WHERE
			[TimeEntry].[DocumentClass] = @ServiceAssignmentClass
			AND			
			[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
			AND
			[TimeEntry].[State] IN (1, 2, 5)
			AND
			NOT (
				@prevAlwaysUseRate = @AlwaysUseRate
				AND
				@AlwaysUseRate = 0
				AND
				[ServiceAssignment].[PaymentTermID] = 3
				AND
				[ServiceAssignment].[Price] IS NOT NULL
			)
			AND
			(
				[TimeEntry].[Overtime] = @IsOvertime
				OR
				(
					@prevAlwaysUseRate != @AlwaysUseRate
					AND
					[ServiceAssignment].[PaymentTermID] = 3
					AND
					[ServiceAssignment].[Price] IS NOT NULL
				)
			)
			
		--   ServiceAssignment
		UPDATE [TimeEntry]
		SET
			[Rate] = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, [Overtime], NULL, @IsDeactivate)
		FROM
			[TimeEntry]
		WHERE
			ISNULL([TimeEntry].[DocumentClass], -1) != @ServiceAssignmentClass
			AND
			[TimeEntry].[ProjectID] = @ProjectID AND [TimeEntry].[EmployeeID] = @EmployeeID
			AND
			[TimeEntry].[State] IN (1, 2, 5)
			AND
			[TimeEntry].[Overtime] = @IsOvertime
			
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6RateAssignmentUpdate TO PUBLIC
GO