﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetCalculateAllBudgets]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetCalculateAllBudgets'
		DROP PROCEDURE [dbo].[pjm6BudgetCalculateAllBudgets]
	END
GO

PRINT 'Creating procedure pjm6BudgetCalculateAllBudgets'
GO

/******************************************************************************
**		File: BudgetCalculateAllBudgets.sql
**		Name: pjm6BudgetCalculateAllBudgets
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 23.09.2011 16:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetCalculateAllBudgets]
	@AutoExecute TBool = 0								--Признак автоматического вызова процедуры
AS
	DECLARE @Projects TABLE 
	(
		ID				TIdentifier NOT NULL,
		ParentProjectID TIdentifier NULL,
		BudgetID		TIdentifier	NULL
	)
	--Построение дерева проектов
	INSERT INTO @Projects ([ID], [ParentProjectID], [BudgetID])
	SELECT
		[Project].[ID],
		[Projects].[ParentProjectID],
		[BudgetID] = (SELECT [Budget].[ID]
						FROM 
							[Budget]
						INNER JOIN [Document]
							ON [Document].[Class] = [Budget].[Class] AND [Document].[ID] = [Budget].[ID]
						WHERE 
							[Budget].[DocumentID] = [Project].[ID] AND [Budget].[State] = 2 
							AND ([RecurrencePatternID] IS NOT NULL AND [NextCalculationDate] IS NOT NULL AND [NextCalculationDate] <= GETDATE()))
						
	FROM
		[Project]
		INNER JOIN pjm6GetAvailableProjectsForBrowse (
			NULL,
			2
		) AS [Projects]
			ON [Project].[ID] = [Projects].[ID]
	--Приведение дерева к виду, в котором в корневых вершинах находятся проекты с бюджетами, которые необходимо
	--расчитать(корневые бюджеты)
	WHILE EXISTS(SELECT *FROM @Projects WHERE [ParentProjectID] IS NULL AND [BudgetID] IS NULL)
	BEGIN
		DELETE FROM @Projects
		WHERE [ID] IN (SELECT [ID] FROM @Projects WHERE [ParentProjectID] IS NULL AND [BudgetID] IS NULL)
	
		
		UPDATE @Projects
		SET ParentProjectID = NULL WHERE ParentProjectID NOT IN (SELECT [ID] FROM @Projects)
	END
	--Вызов для каждого бюджета процедуры расчета
	
	BEGIN TRANSACTION

	DECLARE 
		@BudgetID	TIdentifier,
		@rv			int

	DECLARE Budgets CURSOR FOR
		SELECT [BudgetID] FROM @Projects WHERE [BudgetID] IS NOT NULL AND [ParentProjectID] IS NULL
	OPEN Budgets
	FETCH NEXT FROM Budgets INTO @BudgetID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC @rv = pjm6BudgetCalculateActualTotals @BudgetID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
		FETCH NEXT FROM Budgets INTO @BudgetID
	END

	COMMIT TRANSACTION
	RETURN 0
GO
GRANT EXECUTE ON [pjm6BudgetCalculateAllBudgets] TO PUBLIC
GO