﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals'
		DROP PROCEDURE [dbo].[pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals]
	END
GO

PRINT 'Creating procedure pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals'
GO

/******************************************************************************
**		File: BudgetFindBudgetWorkLineAndUpdateActualTotals.sql
**		Name: pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 25/01/2011 11:35:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals]
	@BudgetID								TIdentifier,
	@EntryID								TIdentifier,
	@TimeEntryDocumentClass					TClass,
	@TimeEntryDocumentID					TIdentifier,
	@TimeEntryFileAs						TName,
	@TimeEntryEmployeeID					TIdentifier,
	@TimeEntryQualificationID				TIdentifier,
	@TimeEntryActivityTypeID				TIdentifier,
	@TimeEntryBillableHour					TAmount,
	@TimeEntryRate							TMoney,
	@TimeEntryProjectID						TIdentifier,
	@VATRate								TPercent,
	@VATIsIncluded							TBool,
	@BudgetLineID							TIdentifier OUTPUT
AS
	DECLARE
		
		@TimeEntryVATPCActualManHour			TMoney,
		@TimeEntryTotalPCActualManHour			TMoney,
		@TimeEntryTotalWithVATPCActualManHour	TMoney,
		@rv										int
	


	--Расчитать фактические суммы записи о времени
	SET @TimeEntryVATPCActualManHour = ROUND((@TimeEntryRate * @TimeEntryBillableHour) * @VATRate / (1 + @VATIsIncluded * @VATRate), 2)
	SET @TimeEntryTotalPCActualManHour = ROUND(@TimeEntryRate * @TimeEntryBillableHour, 2) - 
		(CASE @VATIsIncluded WHEN 0 THEN 0 ELSE @TimeEntryVATPCActualManHour END)
	SET @TimeEntryTotalWithVATPCActualManHour = ROUND(@TimeEntryRate * @TimeEntryBillableHour, 2) + 
		(CASE @VATIsIncluded WHEN 0 THEN @TimeEntryVATPCActualManHour ELSE 0 END)
	
	IF @TimeEntryDocumentClass != dbo.adfGetClassByName('Pjm5.TaskRequest')
	BEGIN
		SET @TimeEntryDocumentClass = NULL
		SET @TimeEntryDocumentID = NULL
	END
	--Определить линию бюджета для учета записи о времени, подставить фактические значения------------------------
	DECLARE
		@BudgetPlanningActivityForWork			TBool,
		@BudgetPlanningEmployeeForWork			TBool,
		@BudgetPlanningQualificationForWork		TBool,
		@BudgetPlanningRateForWork				TBool,
		@BudgetWorkLineID						TIdentifier,
		@BudgetLineGroupID						TIdentifier
		
	SELECT
		@BudgetPlanningActivityForWork			= [Budget].[PlanningActivityForWork],
		@BudgetPlanningEmployeeForWork			= [Budget].[PlanningEmployeeForWork],
		@BudgetPlanningQualificationForWork		= [Budget].[PlanningQualificationForWork],
		@BudgetPlanningRateForWork				= [Budget].[PlanningRateForWork]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF @TimeEntryDocumentClass IS NOT NULL AND @TimeEntryDocumentID IS NOT NULL
	BEGIN
		SELECT TOP 1
			@BudgetWorkLineID = [BudgetLineWork].[ID],
			@BudgetLineGroupID = [BudgetLineWork].[BudgetLineGroupID]
		FROM
			[BudgetLineWork]
		WHERE
			([BudgetLineWork].[BudgetID] = @BudgetID) AND
			([BudgetLineWork].[DocumentID] IS NOT NULL AND [BudgetLineWork].[DocumentClass] = @TimeEntryDocumentClass AND [BudgetLineWork].[DocumentID] = @TimeEntryDocumentID) AND
			(@BudgetPlanningActivityForWork = 0 OR 
				(@BudgetPlanningActivityForWork = 1 AND ((@TimeEntryActivityTypeID IS NOT NULL AND [BudgetLineWork].[ActivityTypeID] = @TimeEntryActivityTypeID) OR 
				(@TimeEntryActivityTypeID IS NULL AND [BudgetLineWork].[ActivityTypeID] IS NULL)))) AND
			(@BudgetPlanningEmployeeForWork = 0 OR (@BudgetPlanningEmployeeForWork = 1 AND [BudgetLineWork].[EmployeeID] = @TimeEntryEmployeeID)) AND
			(@BudgetPlanningQualificationForWork = 0 OR (@BudgetPlanningQualificationForWork = 1 AND ((@TimeEntryQualificationID IS NOT NULL AND [BudgetLineWork].[QualificationID] = @TimeEntryQualificationID) OR 
				(@TimeEntryQualificationID IS NULL AND [BudgetLineWork].[QualificationID] IS NULL)))) AND
/*TODO RATE*/(@BudgetPlanningRateForWork = 0 OR (@BudgetPlanningRateForWork = 1 AND [BudgetLineWork].[Rate] = @TimeEntryRate))
	END

	--Есть ли хотя бы одна линия, отнесенная на работу, по которой занесена запись о затрате	
		DECLARE
			@BudgetWorkLineWithDocument	Tidentifier
		IF @BudgetWorkLineID IS NULL
		BEGIN
			SELECT TOP 1
				@BudgetLineGroupID = [BudgetLineWork].[BudgetLineGroupID],
				@BudgetWorkLineWithDocument = [BudgetLineWork].[ID]
			FROM
				[BudgetLineWork]
			WHERE
				([BudgetLineWork].[BudgetID] = @BudgetID) AND
				([BudgetLineWork].[DocumentID] IS NOT NULL AND [BudgetLineWork].[DocumentClass] = @TimeEntryDocumentClass AND [BudgetLineWork].[DocumentID] = @TimeEntryDocumentID)
		END
	--Если нет линии с ассоциируемой работой, удовлетворяющей параметрам планирования, то искать линию бюджета
	--среди линий, которые не имеют ассоциаций
	IF @BudgetWorkLineID IS NULL AND @BudgetWorkLineWithDocument IS NULL
	BEGIN
		SELECT TOP 1
			@BudgetWorkLineID = [BudgetLineWork].[ID]
		FROM
			[BudgetLineWork]
		WHERE
			([BudgetLineWork].[BudgetID] = @BudgetID) AND
			([BudgetLineWork].[DocumentID] IS NULL) AND
			(@BudgetPlanningActivityForWork = 0 OR 
				(@BudgetPlanningActivityForWork = 1 AND ((@TimeEntryActivityTypeID IS NOT NULL AND [BudgetLineWork].[ActivityTypeID] = @TimeEntryActivityTypeID) OR 
				(@TimeEntryActivityTypeID IS NULL AND [BudgetLineWork].[ActivityTypeID] IS NULL)))) AND
			(@BudgetPlanningEmployeeForWork = 0 OR (@BudgetPlanningEmployeeForWork = 1 AND [BudgetLineWork].[EmployeeID] = @TimeEntryEmployeeID)) AND
			(@BudgetPlanningQualificationForWork = 0 OR (@BudgetPlanningQualificationForWork = 1 AND ((@TimeEntryQualificationID IS NOT NULL AND [BudgetLineWork].[QualificationID] = @TimeEntryQualificationID) OR 
				(@TimeEntryQualificationID IS NULL AND [BudgetLineWork].[QualificationID] IS NULL)))) AND
/*TODO RATE*/(@BudgetPlanningRateForWork = 0 OR (@BudgetPlanningRateForWork = 1 AND [BudgetLineWork].[Rate] = @TimeEntryRate))
	END
		
	--Если подходящая линия найдена, то подставить в нее фактические данные для записи, иначе создать внеплановую 
	--линию
	IF @BudgetWorkLineID IS NOT NULL
	BEGIN
		UPDATE [BudgetLineWork]
		SET
			[BudgetLineWork].[ActualManHour] = [BudgetLineWork].[ActualManHour] + @TimeEntryBillableHour,
			[BudgetLineWork].[TotalPCActualManHour] = [BudgetLineWork].[TotalPCActualManHour] + @TimeEntryTotalPCActualManHour,
			[BudgetLineWork].[TotalWithVATPCActualManHour] = [BudgetLineWork].[TotalWithVATPCActualManHour] + @TimeEntryTotalWithVATPCActualManHour
		WHERE
			[BudgetLineWork].[ID] = @BudgetWorkLineID
		IF @@ERROR != 0
			RETURN 2
	END
	ELSE
	BEGIN			
		IF @BudgetLineGroupID IS NULL AND @TimeEntryDocumentID IS NOT NULL AND @TimeEntryDocumentClass IS NOT NULL
			SET @BudgetLineGroupID = (SELECT [BudgetLineGroupID] FROM [BudgetLineWork] WHERE [BudgetLineWork].[BudgetID] = @BudgetID AND
				[BudgetLineWork].[DocumentClass] = @TimeEntryDocumentClass AND [BudgetLineWork].[DocumentID] = @TimeEntryDocumentID)
			
		--Вызов создания внеплановой линии
		EXEC @rv = pjm6BudgetLineWorkCreateUnplanned	@BudgetID, 
														@BudgetLineGroupID,
														@BudgetPlanningRateForWork,
														@TimeEntryDocumentClass,
														@TimeEntryDocumentID,
														@TimeEntryEmployeeID,
														@TimeEntryActivityTypeID,
														@TimeEntryQualificationID,
														@TimeEntryBillableHour,
														@TimeEntryTotalPCActualManHour,
														@TimeEntryTotalWithVATPCActualManHour,
														@TimeEntryRate,
														@BudgetPlanningEmployeeForWork,
														@BudgetPlanningActivityForWork,
														@BudgetPlanningQualificationForWork,
														@BudgetWorkLineID = @BudgetWorkLineID OUTPUT
		IF @rv != 0
			return @rv
	END

	SET @BudgetLineID = @BudgetWorkLineID
	RETURN 0
GRANT EXECUTE ON [pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals] TO PUBLIC
GO

