IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseCreate'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseCreate.sql
**		Name: pjm6BudgetLineExpenseCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				   PlannedAmount  ActualAmount c TCount  TAmount
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseCreate
	@Xml	XML
	
AS
	DECLARE
		@State							TState,
		@Class							TClass,
		@ID								TIdentifier,
		@FileAs							TName,
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@LineParrentClass				TName,
		@StartDate						TDate,
		@EndDate						TDate,
		@Order							TCount,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@BudgetLineGroupID				TIdentifier,
		@EmployeeID						TIdentifier,
		@ExpenseCodeID        			TIdentifier,
		@ExpenseID						TIdentifier,
		@FromCurrencyCode				TCode3,
		@ToCurrencyCode					TCode3,
		@UOMID							TIdentifier,
		@Price							TMoney,
		@PlannedAmount					TAmount,  
		@ActualAmount					TAmount,  
		@Comments             			TNotes,  
		@VATIsIncluded        			TBool,   
		@CurrencyRate         			TMoney,  
		@VATRate              			TPercent,
		@VATPlannedExpense    			TMoney,  
		@VATPCPlannedExpense  			TMoney,  
		@TotalPCPlannedExpense			TMoney,
		@TotalWithVATPCPlannedExpense	TMoney,
		@PlanningExpenseTypeForExpense	TBool,
		@PlanningEmployeeForExpense		TBool,
		@PlanningPriceForExpense		TBool,
		@PlanningDateForExpense			TBool,
		@value							TVariant,
		@doc							int
	
	SET NOCOUNT ON

	SET @State = dbo.adfwfGetInitialState('b8fd335f-1232-4a5a-a823-92225e38f361')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @Class = dbo.adfGetClassByName('Pjm6.BudgetLineExpense')

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT												
		@FileAs =						[XmlTable].[FileAs],				
		@BudgetID =						[XmlTable].[BudgetID],			
		@StartDate =					CAST([XmlTable].[StartDate] as datetime),  			
		@EndDate =						CAST([XmlTable].[EndDate] as datetime),			 				
		@DocumentClass =				dbo.adfGetClassByName([XmlTable].[DocumentClass]),		
		@DocumentID =					[XmlTable].[DocumentID],
		@LineParrentClass =				[XmlTable].[BudgetClass], 			
		@BudgetLineGroupID =			[XmlTable].[BudgetLineGroupID], 	
		@EmployeeID =					[XmlTable].[EmployeeID],					
		@ExpenseCodeID =				[XmlTable].[ExpenseCodeID],        		
		@ExpenseID =					[XmlTable].[ExpenseID],					
		@FromCurrencyCode =				[XmlTable].[FromCurrencyCode],
		@ToCurrencyCode =				[Budget].[CurrencyCode],				
		@UOMID =						[XmlTable].[UOMID],
		@Price =						[XmlTable].[Price],						
		@PlannedAmount =				[XmlTable].[PlannedAmount],						          		
		@VATIsIncluded =				[XmlTable].[VATIsIncluded],     		
		@CurrencyRate =					[XmlTable].[CurrencyRate],        		
		@VATRate =						[XmlTable].[VATRate],             		
		@VATPlannedExpense =			[XmlTable].[VATPlannedExpense],    		
		@VATPCPlannedExpense =			[XmlTable].[VATPCPlannedExpense],	
		@TotalPCPlannedExpense =		[XmlTable].[TotalPCPlannedExpense],	
		@TotalWithVATPCPlannedExpense =	[XmlTable].[TotalWithVATPCPlannedExpense],		
		@Comments =						[XmlTable].[Comments] 						
	FROM
		OPENXML(@doc, '/pjm6BudgetLineExpenseGet/BudgetLineExpense', 2)
			WITH (
				[FileAs] nvarchar(256),
				[BudgetID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[BudgetClass] int,
				[BudgetLineGroupID] int,
				[EmployeeID] int,					
				[ExpenseCodeID] int,        		
				[ExpenseID] int,					
				[FromCurrencyCode] char(3),
				[ToCurrencyCode] char(3),				
				[UOMID] int,
				[Price] decimal(18,4),						
				[PlannedAmount] decimal(18,4),					      
				[VATIsIncluded] bit,     		
				[CurrencyRate] decimal(18,4),        		
				[VATRate] decimal(18,4),             		
				[VATPlannedExpense] decimal(18,4),    		
				[VATPCPlannedExpense] decimal(18,4),	
				[TotalPCPlannedExpense] decimal(18,4),	
				[TotalWithVATPCPlannedExpense] decimal(18,4),
				[Comments] nvarchar(max)
				) AS [XmlTable]
		INNER JOIN [Budget]
			ON [Budget].[ID] = [XmlTable].[BudgetID]
	
	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT		
		@PlanningExpenseTypeForExpense	= [Budget].[PlanningExpenseTypeForExpense],
		@PlanningEmployeeForExpense		= [Budget].[PlanningEmployeeForExpense],
		@PlanningPriceForExpense		= [Budget].[PlanningPriceForExpense],
		@PlanningDateForExpense			= [Budget].[PlanningDateForExpense],
		@BudgetState					= [Budget].[State]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF @BudgetState <> 1 AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF ((@PlanningExpenseTypeForExpense = 1 AND @ExpenseCodeID IS NULL) OR 
		(@PlanningEmployeeForExpense = 1 AND @EmployeeID IS NULL) OR
		(@PlanningDateForExpense = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
	BEGIN
		RAISERROR('#budgetplanningparameterisnull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @CurrencyRate = 0 OR @CurrencyRate IS NULL
	BEGIN
		RAISERROR('#CurrencyRateCannotBeNull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF EXISTS(SELECT TOP 1 * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND
						[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[DocumentClass] = @DocumentClass AND
						[BudgetLineExpense].[DocumentID] = @DocumentID) OR
		EXISTS(SELECT * FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[State] = 1 AND
						[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[ExpenseID] = @ExpenseID)
	BEGIN
		RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL
	
	DECLARE @nationalCurrency TCode3
	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT
	SET @nationalCurrency = CAST(@value as varchar(3))

	DECLARE @TotalWithVATPC TMoney, @TotalPC TMoney
	IF @VATIsIncluded = 1
	BEGIN
		SET @TotalPC = @PlannedAmount * @Price - @VATPlannedExpense
		SET @TotalWithVATPC = @PlannedAmount * @Price
	END
	ELSE
	BEGIN
		SET @TotalPC = @PlannedAmount * @Price
		SET @TotalWithVATPC = @PlannedAmount * @Price + @VATPlannedExpense
	END
	
	IF @FromCurrencyCode != @ToCurrencyCode
	BEGIN
		IF @FromCurrencyCode = @nationalCurrency
		BEGIN
			SET @TotalPC = ROUND(@TotalPC / @CurrencyRate, 2)
			SET @TotalWithVATPC = ROUND(@TotalWithVATPC / @CurrencyRate, 2)
		END
		ELSE
		BEGIN
			SET @TotalPC = ROUND(@TotalPC * @CurrencyRate, 2)
			SET @TotalWithVATPC = ROUND(@TotalWithVATPC * @CurrencyRate, 2)
		END
		 
		IF @PlannedAmount != 0
		BEGIN
			IF @VATIsIncluded = 1
			BEGIN
				SET @TotalWithVATPC = ROUND(@TotalWithVATPC / @PlannedAmount, 2) * @PlannedAmount
				SET @TotalPC = ROUND(@TotalWithVATPC / (1.0 + @VATRate), 2)
			END
			ELSE
			BEGIN
				SET @TotalPC = ROUND(@TotalPC / @PlannedAmount, 2) * @PlannedAmount
				SET @TotalWithVATPC = ROUND(@TotalPC * (1.0 + @VATRate), 2)
			END
		END
	END
	
	INSERT INTO [BudgetLineExpense]
		([Class], [State], [FileAs], [BudgetID], [DocumentClass], [DocumentID],
		[BudgetLineGroupID], [StartDate], [EndDate], 
		[Order], 
		[Price],
		[EmployeeID], [ExpenseCodeID], [ExpenseID], [CurrencyCode],
		[UOMID], [PlannedAmount], [VATIsIncluded],[CurrencyRate],
		[VATRate], [VATPlannedExpense], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense],
		[Comments]
		)
	VALUES
		(@Class, @State, @FileAs, @BudgetID, @DocumentClass, @DocumentID,
		@BudgetLineGroupID, @StartDate, @EndDate, 
		dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'ExpenseLine', 'Planned', NULL, @BudgetLineGroupID),  
		@Price,
		@EmployeeID, @ExpenseCodeID, @ExpenseID, @FromCurrencyCode,
		@UOMID, @PlannedAmount, @VATIsIncluded, @CurrencyRate,
		@VATRate, @VATPlannedExpense, @TotalPC, @TotalWithVATPC,
		@Comments
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm6BudgetLineExpenseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseCreate TO PUBLIC
GO