IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseSetOrder]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseSetOrder'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseSetOrder]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseSetOrder'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseSetOrder.sql
**		Name: pjm6BudgetLineExpenseSetOrder
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		02.12.11	PAM				    
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseSetOrder
	@ID	TIdentifier,
	@Order TCount	
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentOrder TCount,
		@Count	TCount,
		@BudgetID TIdentifier,
		@GroupID	TIdentifier,
		@MaxOrderNumber	TCount
		
	SELECT 
		@CurrentOrder = [Order],
		@BudgetID = [BudgetID],
		@GroupID = [BudgetLineGroupID] 
	FROM 
		[BudgetLineExpense] 
	WHERE 
		[ID] = @ID
	
	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	--            
	SET @MaxOrderNumber =  (SELECT COUNT(*) FROM [BudgetLineExpense] WHERE [BudgetID] = @BudgetID AND ISNULL([BudgetLineGroupID], 0) = ISNULL(@GroupID, 0))
	IF (@Order > @MaxOrderNumber)
		SET @Order = @MaxOrderNumber
	ELSE IF (@Order <= 0)
		SET @Order = 1

	--          
	IF (@CurrentOrder > @Order)
		SET @Count = 1
	ELSE
		SET @Count = -1

	BEGIN TRANSACTION

	IF EXISTS(SELECT *FROM [BudgetLineExpense] 
				WHERE	[BudgetID] = @BudgetID AND 
						ISNULL([BudgetLineGroupID], 0) = ISNULL(@GroupID, 0) AND
						[Order] = @Order)
	BEGIN
		UPDATE [BudgetLineExpense] SET [Order] = 0 WHERE ID = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		UPDATE 
			[BudgetLineExpense] 
		SET 
			[Order] = [Order] + @Count 
		WHERE 
			((@Count = 1 AND [Order] >= @Order AND [Order] < @CurrentOrder) OR 
			(@Count = -1 AND [Order] > @CurrentOrder AND [Order] <= @Order)) AND
			[BudgetID] = @BudgetID AND ISNULL([BudgetLineGroupID], 0) = ISNULL(@GroupID, 0)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	UPDATE [BudgetLineExpense] SET [Order] = @Order WHERE ID = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseSetOrder TO PUBLIC
GO