IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetGroupSetOrder]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetGroupSetOrder'
		DROP PROCEDURE [dbo].[pjm6BudgetGroupSetOrder]
	END
GO

PRINT 'Creating procedure pjm6BudgetGroupSetOrder'
GO

/******************************************************************************
**		File: pjm6BudgetGroupSetOrder.sql
**		Name: pjm6BudgetGroupSetOrder
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		02.12.11	PAM				    
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetGroupSetOrder
	@ID	TIdentifier,
	@Order TCount
	
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentOrder TCount,
		@Count	TCount,
		@BudgetID TIdentifier,
		@GroupType	TIdentifier,
		@MaxOrderNumber	TCount
		
	SELECT 
		@CurrentOrder = [Order],
		@BudgetID = [BudgetID],
		@GroupType = [GroupTypeID]
	FROM 
		[BudgetLineGroup] 
	WHERE 
		[ID] = @ID

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	--          
	SET @MaxOrderNumber =  (SELECT COUNT(*) FROM [BudgetLineGroup] WHERE [BudgetID] = @BudgetID AND [GroupTypeID] = @GroupType AND [State] = 1)
	IF (@Order > @MaxOrderNumber)
		SET @Order = @MaxOrderNumber
	ELSE IF (@Order <= 0)
		SET @Order = 1

	--          
	IF (@CurrentOrder > @Order)
		SET @Count = 1
	ELSE
		SET @Count = -1

	BEGIN TRANSACTION

	IF EXISTS(SELECT *FROM [BudgetLineGroup] 
				WHERE	[BudgetID] = @BudgetID AND 
						[GroupTypeID] = @GroupType AND 
						[State] = 1 AND 
						[Order] = @Order)
	BEGIN
		UPDATE [BudgetLineGroup] SET [Order] = 0 WHERE ID = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE 
			[BudgetLineGroup] 
		SET 
			[Order] = [Order] + @Count 
		WHERE 
			((@Count = 1 AND [Order] >= @Order AND [Order] < @CurrentOrder) OR 
			(@Count = -1 AND [Order] > @CurrentOrder AND [Order] <= @Order)) AND
			[BudgetID] = @BudgetID AND [GroupTypeID] = @GroupType
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE [BudgetLineGroup] SET [Order] = @Order WHERE ID = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE [BudgetLineGroup] 
	SET [Order] = @MaxOrderNumber + 1
	WHERE 
		[BudgetID] = @BudgetID AND 
		[GroupTypeID] = @GroupType AND 
		[State] = 2

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetGroupSetOrder TO PUBLIC
GO