IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkBrowse'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkBrowse.sql
**		Name: pjm6BudgetLineWorkBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkBrowse
	@BudgetID			TIdentifier,
	@LineType			TIdentifier = 0,
	@EmployeeID			TIdentifier,
	@ActivityID			TIdentifier,
	@QualificationID	TIdentifier
	
AS
	DECLARE
		@DocumentClass			TClass,
		@PlanningEmployee		TBool,
		@PlanningActivity		TBool,
		@PlanningQualification	TBool,
		@VATRate				TPercent,
		@VATIsIncluded			TBool,
		@MaxOrder				TCount,
		@Lang					TLanguage

	SET @Lang = dbo.adfGetLanguage()

	SET @MaxOrder = (SELECT MAX([Order]) FROM [BudgetLineGroup] WHERE [BudgetID] = @BudgetID AND
		[GroupTypeID] = 1)

	SELECT
		@VATRate = [Budget].[VATRate],
		@VATIsIncluded = [Budget].[VATIsIncluded],
		@PlanningEmployee = [Budget].[PlanningEmployeeForWork],
		@PlanningActivity = [Budget].[PlanningActivityForWork],
		@PlanningQualification = [Budget].[PlanningQualificationForWork]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SELECT
		[BudgetLineWork].[ID],
		[BudgetLineWork].[Class],
		[BudgetLineWork].[State],
		[BudgetLineWork].[Flag],
		[BudgetLineWork].[FileAs],
		[BudgetLineWork].[BudgetID],
		[BudgetLineWork].[DocumentClass],
		[BudgetLineWork].[DocumentID],
		CASE WHEN [BudgetLineWork].[DocumentID] IS NOT NULL 
			THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([BudgetLineWork].[DocumentID], [BudgetLineWork].[DocumentClass])) ELSE
			NULL END  AS [DocumentName],
		[BudgetLineWork].[BudgetLineGroupID],
		[BudgetLineWork].[Order],
		dbo.fnPjm6GetSortedBudgetGroup(ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]), 
			[BudgetLineGroup].[Order], LEN(CAST(@MaxOrder AS nvarchar(max)))) AS [SortedGroupName],
		[BudgetLineWork].[StartDate],
		[BudgetLineWork].[EndDate],
		[BudgetLineWork].[Rate],
		[BudgetLineWork].[EmployeeID],
		[BudgetLineWork].[ActivityTypeID],
		[BudgetLineWork].[QualificationID],
		[BudgetLineWork].[PlannedManHour],
		[BudgetLineWork].[ActualManHour],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCPlannedManHour] ELSE
		[BudgetLineWork].[TotalPCPlannedManHour] END) AS [TotalPlanned],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCActualManHour] ELSE
		[BudgetLineWork].[TotalPCActualManHour] END) AS [TotalActual],
		[BudgetLineWork].[Comments],
		[BudgetLineWork].[Created],
		[BudgetLineWork].[CreatedBy],
		[BudgetLineWork].[Modified],
		[BudgetLineWork].[ModifiedBy],
		[BudgetLineWork].[Timestamp]
	FROM
		[BudgetLineWork]
		LEFT OUTER JOIN [BudgetLineGroup]
			ON [BudgetLineGroup].[ID] = [BudgetLineWork].[BudgetLineGroupID]
		LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
	WHERE
		[BudgetLineWork].[BudgetID] = @BudgetID AND
		((@LineType = 0) OR
		(@LineType = 1 AND [BudgetLineWork].[State] = 1 AND [TotalWithVATPCPlannedManHour] < [TotalWithVATPCActualManHour]) OR
		(@LineType = 2 AND [BudgetLineWork].[State] = 2)) AND
		((@PlanningEmployee = 0) OR (@PlanningEmployee = 1 AND (@EmployeeID IS NULL OR (@EmployeeID IS NOT NULL AND [BudgetLineWork].[EmployeeID] = @EmployeeID)))) AND
		((@PlanningActivity = 0) OR (@PlanningActivity = 1 AND (@ActivityID IS NULL OR [BudgetLineWork].[ActivityTypeID] = @ActivityID))) AND
		((@PlanningQualification = 0) OR (@PlanningQualification = 1 AND (@QualificationID IS NULL OR [BudgetLineWork].[QualificationID] = @QualificationID))) AND
		(dbo.fnPjm6CanEditBudget(@BudgetID) = 1 OR dbo.fnPjm6CanViewBudget(@BudgetID) = 1)
		

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkBrowse TO PUBLIC
GO