﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkByGroupBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkByGroupBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkByGroupBrowse'
GO

/******************************************************************************
**		File: BudgetLineWorkByGroupBrowse.sql
**		Name: pjm6BudgetLineWorkByGroupBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 05/04/2011 11:40:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkByGroupBrowse
	@BudgetID			TIdentifier,
	@GroupID			TIdentifier
	
AS
	DECLARE
		@DocumentClass			TClass,
		@PlanningEmployee		TBool,
		@PlanningActivity		TBool,
		@PlanningQualification	TBool,
		@VATRate				TPercent,
		@VATIsIncluded			TBool

	SELECT
		@VATRate = [Budget].[VATRate],
		@VATIsIncluded = [Budget].[VATIsIncluded]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SELECT
		[BudgetLineWork].[ID],
		[BudgetLineWork].[Class],
		[BudgetLineWork].[State],
		[BudgetLineWork].[Flag],
		[BudgetLineWork].[FileAs],
		[BudgetLineWork].[BudgetID],
		[BudgetLineWork].[DocumentClass],
		[BudgetLineWork].[DocumentID],
		CASE WHEN [BudgetLineWork].[DocumentID] IS NOT NULL 
			THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([BudgetLineWork].[DocumentID], [BudgetLineWork].[DocumentClass])) ELSE
			NULL END  AS [DocumentName],
		[BudgetLineWork].[BudgetLineGroupID],
		[BudgetLineWork].[Order],
		[BudgetLineWork].[StartDate],
		[BudgetLineWork].[EndDate],
		[BudgetLineWork].[Rate],
		[BudgetLineWork].[EmployeeID],
		[BudgetLineWork].[ActivityTypeID],
		[BudgetLineWork].[QualificationID],
		[BudgetLineWork].[PlannedManHour],
		[BudgetLineWork].[ActualManHour],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCPlannedManHour] ELSE
		[BudgetLineWork].[TotalPCPlannedManHour] END) AS [TotalPlanned],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCActualManHour] ELSE
		[BudgetLineWork].[TotalPCActualManHour] END) AS [TotalActual],
		[BudgetLineWork].[Comments],
		[BudgetLineWork].[Created],
		[BudgetLineWork].[CreatedBy],
		[BudgetLineWork].[Modified],
		[BudgetLineWork].[ModifiedBy],
		[BudgetLineWork].[Timestamp]
	FROM
		[BudgetLineWork]
	WHERE
		[BudgetLineWork].[BudgetLineGroupID] = @GroupID AND
		(dbo.fnPjm6CanEditBudget(@BudgetID) = 1 OR dbo.fnPjm6CanViewBudget(@BudgetID) = 1)
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkByGroupBrowse TO PUBLIC
GO

