IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineWorkUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineWorkUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineWorkUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineWorkUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkUpdate.sql
**		Name: pjm6BudgetLineWorkUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 01/11/2010 14:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineWorkUpdate
	@Xml	XML
	
AS
DECLARE
		@BudgetState				    TState,
		@ID								TIdentifier,
		@FileAs							TName,
		@State							TState,
		@BudgetID						TIdentifier,
		@StartDate						TDate,
		@EndDate						TDate,
		@DocumentClass					TIdentifier,
		@DocumentID						TIdentifier,
		@LineParrentClass				TName,
		@BudgetLineGroupID				TIdentifier,
		@Order							TCount,
		@Rate							TMoney,
		@EmployeeID						TIdentifier,
		@ActivityTypeID					TIdentifier,
		@QualificationID				TIdentifier,
		@PlannedManHour					TAmount,
		@VATPCPlannedManHour			TMoney,
		@TotalPCPlannedManHour			TMoney,
		@TotalWithVATPCPlannedManHour	TMoney,
		@Comments						TNotes,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@doc							int

	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID								= [ID],
		@FileAs							= [FileAs],
		@State							= [State],
		@BudgetID						= [BudgetID],					
		@StartDate						= CAST([StartDate] as datetime), 			
		@EndDate						= CAST([EndDate] as datetime),			 				
		@DocumentClass					= dbo.adfGetClassByName([DocumentClass]),		
		@DocumentID						= [DocumentID],
		@LineParrentClass				= [BudgetClass], 			
		@BudgetLineGroupID				= [BudgetLineGroupID],
		@Order							= [Order], 	
		@Rate							= [Rate],				
		@EmployeeID						= [EmployeeID],			
		@ActivityTypeID					= [ActivityTypeID],	
		@QualificationID				= [QualificationID],
		@PlannedManHour					= [PlannedManHour],
		@VATPCPlannedManHour			= [VATPCPlannedManHour],		
		@TotalPCPlannedManHour			= [TotalPCPlannedManHour],			
		@TotalWithVATPCPlannedManHour	= [TotalWithVATPCPlannedManHour],	 		
		@Comments						= [Comments] 						
	FROM
		OPENXML(@doc, '/pjm6BudgetLineWorkGet/BudgetLineWork', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[State] int,
				[BudgetID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[BudgetClass] int,
				[BudgetLineGroupID] int,
				[Order] int,
				[Rate] decimal(18,4),
				[EmployeeID] int,
				[ActivityTypeID] int,
				[QualificationID] int,
				[PlannedManHour] decimal(18,4),
				[VATPCPlannedManHour] decimal(18,4),
				[TotalPCPlannedManHour] decimal(18,4),
				[TotalWithVATPCPlannedManHour] decimal(18,4),
				[Comments] nvarchar(max)
				)

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @State = 1
	BEGIN
		SELECT		
			@PlanningActivityForWork		= [Budget].[PlanningActivityForWork],
			@PlanningEmployeeForWork		= [Budget].[PlanningEmployeeForWork],
			@PlanningQualificationForWork	= [Budget].[PlanningQualificationForWork],
			@PlanningRateForWork			= [Budget].[PlanningRateForWork],
			@PlanningDateForWork			= [Budget].[PlanningDateForWork],
			@BudgetState					= [Budget].[State]
		FROM
			[Budget]
		WHERE
			[Budget].[ID] = @BudgetID

		IF @BudgetState <> 1 AND @LineParrentClass = dbo.adfGetClassByName('Pjm6.Budget')
		BEGIN
			RAISERROR('#budgetIsOpenOrClosed', 18, -1)
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		IF ((@PlanningActivityForWork = 1 AND @ActivityTypeID IS NULL) OR 
			(@PlanningEmployeeForWork = 1 AND @EmployeeID IS NULL) OR
			(@PlanningQualificationForWork = 1 AND @QualificationID IS NULL) OR
			(@PlanningDateForWork = 1 AND (@StartDate IS NULL OR @EndDate IS NULL)))
		BEGIN
			RAISERROR('#budgetplanningparameterisnull', 18, -1)
			RETURN 1
		END

		IF EXISTS(SELECT TOP 1 *FROM [BudgetLineWork] WHERE [BudgetLineWork].[State] = 1 AND [BudgetLineWork].[ID] != @ID AND
					[BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[DocumentClass] = @DocumentClass AND
					[BudgetLineWork].[DocumentID] = @DocumentID)
		BEGIN
			RAISERROR('#BudgetLineAssociatedWithThisDocument', 18, -1)
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		--       
		DECLARE
			@OldLineGroup	TIdentifier
		SET @OldLineGroup = (SELECT [BudgetLineGroupID] FROM [BudgetLineWork] WHERE [ID] = @ID)
	END

	BEGIN TRANSACTION

	IF @DocumentID IS NULL
		SET @DocumentClass = NULL
	
	IF @State = 1
	BEGIN
		UPDATE
			[BudgetLineWork]
		SET
			[FileAs] = @FileAs,
			[StartDate] = @StartDate,
			[EndDate] = @EndDate,
			[DocumentClass] = @DocumentClass,
			[DocumentID] = @DocumentID,
			[BudgetLineGroupID] = @BudgetLineGroupID,
			[Order] = (CASE 
						WHEN (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
							(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL) THEN 
							dbo.fnPjm6GetBudgetObjectsOrder(@BudgetID, 'WorkLine', 'Planned', NULL, @BudgetLineGroupID)
						ELSE
							[Order]
						END),
			[Rate] = @Rate,
			[EmployeeID] = @EmployeeID,
			[ActivityTypeID] = @ActivityTypeID,
			[QualificationID] = @QualificationID,
			[PlannedManHour] = @PlannedManHour,
			[TotalPCPlannedManHour] = @TotalPCPlannedManHour,
			[TotalWithVATPCPlannedManHour] = @TotalWithVATPCPlannedManHour,
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		IF (@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NOT NULL AND @OldLineGroup != @BudgetLineGroupID) OR
		(@OldLineGroup IS NOT NULL AND @BudgetLineGroupID IS NULL) OR (@OldLineGroup IS NULL AND @BudgetLineGroupID IS NOT NULL)
		BEGIN
			UPDATE 
				[BudgetLineWork] 
			SET 
				[Order] = [Order] - 1
			WHERE 
				[Order] > @Order AND
				[BudgetID] = @BudgetID AND ((@OldLineGroup IS NULL AND [BudgetLineGroupID] IS NULL) OR (@OldLineGroup IS NOT NULL AND [BudgetLineGroupID] IS NOT NULL AND [BudgetLineGroupID] = @OldLineGroup))
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE IF @State = 2
	BEGIN
		UPDATE
			[BudgetLineWork]
		SET
			[FileAs] = @FileAs,
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm6BudgetLineWorkGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineWorkUpdate TO PUBLIC
GO