﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetMyControlWithoutOverdraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetMyControlWithoutOverdraftBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetMyControlWithoutOverdraftBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetMyControlWithoutOverdraftBrowse'
GO

/******************************************************************************
**		File: BudgetMyControlWithoutOverdraftBrowse.sql
**		Name: pjm6BudgetMyControlWithoutOverdraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 11/01/2011 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetMyControlWithoutOverdraftBrowse]
	@BudgetTypeSelector					TIdentifier,
	@ProjectManagerEmployeeID			TIdentifier,
	@StateSelector						TIdentifier,
	@WithoutOverdraftSelector			TIdentifier,
	@WithoutOverdraftLineTypeSelector	TIdentifier,
	@DateSelector						TIdentifier,
	@PeriodStart						TDate,
	@PeriodEnd							TDate,
	@CostCenterSelector					TIdentifier,
	@CostCenterID						TIdentifier
AS
	DECLARE
		@Lang			TLanguage,
		@Now			TDate

	SET @Now = GETDATE()
	IF @DateSelector = 1
		SET @PeriodStart = CAST(CAST(YEAR(@Now) AS varchar(4)) + '0101' AS datetime)
	ELSE IF @DateSelector = 2
		SET @PeriodStart = CAST(CAST(YEAR(@Now)-1 AS varchar(4)) + '0101' AS datetime)
	ELSE IF @DateSelector = 3
		SET @PeriodStart = DATEADD(day, 1-DATEPART(dayofyear, @PeriodStart), @PeriodStart)
	SET @PeriodStart = CONVERT(datetime, CONVERT(varchar(8), @PeriodStart, 112), 112)
	SET @PeriodEnd = DATEADD(year, 1, @PeriodStart)

	SET @Lang = dbo.adfGetLanguage()

		SELECT
		[Budget].[Class],
		[Budget].[ID],
		[Budget].[State],
		[Budget].[Flag],
			CASE @Lang
			WHEN 'en' THEN 'Budget for project ''' + [Project].[Number] + '''' ELSE
			'Бюджет по проекту ''' + [Project].[Number] + '''' END as [FileAs],
		[Budget].[WarningFlagID],
		[BudgetWarningFlag].[WarningType],
		[Project].[Number] AS [ProjectCode],
		[Project].[FileAs] AS [ProjectFileAs],
		[Project].[ProjectManagerEmployeeID],
		[Budget].[BudgetTypeID],
		dbo.fnPjm6GetBudgetPeriodName([Budget].[StartDate], [Budget].[EndDate], [BudgetTypeID], @Lang, 1) AS [Period],
		[Budget].[LastCalculationDate],
		[Budget].[NextCalculationDate],
		[Budget].[CurrencyCode],		
		[Budget].[WorkBudgetBottom],
		[Budget].[WorkBudgetHigh],
		[Budget].[ExpenseBudgetBottom],
		[Budget].[ExpenseBudgetHigh],
		[Budget].[PlannedManHour],
		[Budget].[ActualManHour],
		[Budget].[PlannedManHourWithSub],
		[Budget].[ActualManHourWithSub],

		[Budget].[TotalPCPlannedManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour]) 
			AS [TotalWDPlannedManHour],--Работа без НДС с учетом скидки, план
		[Budget].[TotalPCActualManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour]) 
			AS [TotalWDActualManHour],--Работа без НДС с учетом скидки, факт
		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [TotalWithVATPCWDPlannedManHour],--Работы с НДС, план
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [TotalWithVATPCWDActualManHour],--Работа С НДС, факт

		[Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense])
			AS [TotalWDPlannedExpense],--Затраты без НДС с учетом скидки, план
		[Budget].[TotalPCActualExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense])
			AS [TotalWDActualExpense],--Затраты без НДС со скидкой, факт

		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense])
			AS [TotalWithVATPCWDPlannedExpense],--Затраты с НДС, план		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalWithVATPCActualExpense])		
			AS [TotalWithVATPCWDActualExpense],--Затраты с НДС, факт
		
		[Budget].[TotalPCWDPlannedManHourWithSub] AS [TotalWDPlannedManHourWithSub],--Работа без НДС с  учетом скидки с п/п, план
		[Budget].[TotalPCWDActualManHourWithSub]  AS [TotalWDActualManHourWithSub],--Работа без НДС с  учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedManHourWithSub] AS [TotalWithVATPCWDPlannedManHourWithSub],--Работа с НДС с п/п, план
		[Budget].[TotalWithVATPCWDActualManHourWithSub] AS [TotalWithVATPCWDActualManHourWithSub],--Работа с НДС с п/п, факт

		[Budget].[TotalPCWDPlannedExpenseWithSub] AS [TotalWDPlannedExpenseWithSub],--Затраты без НДС с п/п, план
		[Budget].[TotalPCWDActualExpenseWithSub] AS [TotalWDActualExpenseWithSub],--Затраты без НДС с учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] AS [TotalWithVATPCWDPlannedExpenseWithSub],--Затраты с НДС  с п/п, план
		[Budget].[TotalWithVATPCWDActualExpenseWithSub] AS [TotalWithVATPCWDActualExpenseWithSub],--Затраты с НДС с п/п, факт

		(CASE 
			WHEN @WithoutOverdraftLineTypeSelector = 0 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <
						dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) THEN
						dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) -
							dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
					ELSE
						0
				END)
			WHEN @WithoutOverdraftLineTypeSelector = 1 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <
						dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) THEN
						dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) -
							dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1))
							
					ELSE
						0
				END)
		END) AS [TotalBeforePlan],
		(CASE 
			WHEN @WithoutOverdraftLineTypeSelector = 0 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <
						[Budget].[WorkBudgetHigh] THEN
						[Budget].[WorkBudgetHigh]	 - 
							dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
					ELSE
						0
				END)
			WHEN @WithoutOverdraftLineTypeSelector = 1 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <
						[Budget].[ExpenseBudgetHigh] THEN
						[Budget].[ExpenseBudgetHigh] -
							dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) 

					ELSE
						0
				END)
		END) AS [TotalBeforeHigh],
		(CASE 
			WHEN @WithoutOverdraftLineTypeSelector = 0 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <
						[Budget].[WorkBudgetBottom] THEN
						[Budget].[WorkBudgetBottom]	 - 
							dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
					ELSE
						0
				END)
			WHEN @WithoutOverdraftLineTypeSelector = 1 THEN
				(CASE 
					WHEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <
						[Budget].[ExpenseBudgetBottom] THEN
						[Budget].[ExpenseBudgetBottom] -
							dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) 

					ELSE
						0
				END)
		END) AS [TotalBeforeBottom],
		ISNULL([BudgetWarningFlagGlobal].[FileAs], [BudgetWarningFlag].[FileAs]) AS [WarningText],
		[Budget].[Comments],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp],
		[Project].[CostCenterID],
		[Project].[CustomerCompanyID],
		[Project].[SupplierCompanyID]
	FROM
		[Budget]
		INNER JOIN [Project]
			ON ([Budget].[DocumentID] = [Project].[ID])
		LEFT OUTER JOIN [BudgetWarningFlag]
			ON ([Budget].[WarningFlagID] = [BudgetWarningFlag].[ID])
		LEFT OUTER JOIN [BudgetWarningFlagGlobal] 
			ON ([BudgetWarningFlag].[ID] = [BudgetWarningFlagGlobal].[ID]
				AND [BudgetWarningFlagGlobal].[Language] = @Lang)
	WHERE
		([Budget].[SupervisorEmployeeID] = dbo.adfGetCurrentEmployeeID()) AND
		((@BudgetTypeSelector = 0) OR ([Budget].[BudgetTypeID] = @BudgetTypeSelector)) AND
		(@ProjectManagerEmployeeID IS NULL OR [Project].[ProjectManagerEmployeeID] = @ProjectManagerEmployeeID) AND 
		((@StateSelector = 0) OR ([Budget].[State] = @StateSelector + 1)) AND
		((@WithoutOverdraftSelector = 0 AND 
			((@WithoutOverdraftLineTypeSelector = 0 AND dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) > 0 AND
				(dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <= 
				dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]))) 
			OR
			(@WithoutOverdraftLineTypeSelector = 1 AND dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) > 0 AND
				(dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <= 
				dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)))))
		 ) OR
		(@WithoutOverdraftSelector = 1 AND
			((@WithoutOverdraftLineTypeSelector = 0 AND [Budget].[WorkBudgetBottom] > 0 AND
				(dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <=
				[Budget].[WorkBudgetBottom]))
			OR
			(@WithoutOverdraftLineTypeSelector = 1 AND [Budget].[ExpenseBudgetBottom] > 0 AND
				(dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <=
				[Budget].[ExpenseBudgetBottom])))
		 ) OR
		(@WithoutOverdraftSelector = 2 AND 
			((@WithoutOverdraftLineTypeSelector = 0 AND [Budget].[WorkBudgetHigh] > 0 AND 
				(dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) <=
				[Budget].[WorkBudgetHigh]))
			OR
			(@WithoutOverdraftLineTypeSelector = 1 AND [Budget].[ExpenseBudgetHigh] > 0 AND
				(dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) <=
				[Budget].[ExpenseBudgetHigh])))
		 )
		) AND
		((@CostCenterSelector = 0) OR (@CostCenterSelector = 1 AND ([Project].[CostCenterID] = @CostCenterID OR (@CostCenterID IS NULL AND [Project].[CostCenterID] IS NULL)))) AND
		(
			(
				[Budget].[BudgetTypeID] = 1 
				AND
				(
					@DateSelector = 0 
					OR 
					(
						[Project].[Date] < @PeriodEnd AND ISNULL([Project].[EndDate], @Now)  > @PeriodStart
					)
				)
			)
			OR
			(
				[Budget].[BudgetTypeID] > 1 
				AND
				(
					@DateSelector = 0 
					OR 
					(
						[Budget].[StartDate] < @PeriodEnd AND ISNULL([Budget].[EndDate], @Now)  > @PeriodStart
					)
				)
			)
		)
		AND
		(dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetMyControlWithoutOverdraftBrowse] TO PUBLIC
GO

