IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetUpdate.sql
**		Name: pjm6BudgetUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 20/08/2010 17:05:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.07.11	SYV				   #crossingbudgetperiod
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetUpdate
	@Xml	XML
AS
	DECLARE
		@ID								TIdentifier,
		@State							TState,
		@BudgetType						TIdentifier,
		@StartDate						TDate,
		@EndDate						TDate,
		@ProjectID						TIdentifier,
		@UseWorkPlanning				TBool,
		@UseExpensePlanning				TBool,
		@WorkBudgetBottom				TMoney,
		@WorkBudgetHigh					TMoney,
		@WorkBudgetBottomEqualsPlan		TBool,
		@WorkBudgetHighEqualsPlan		TBool,
		@ExpenseBudgetBottom			TMoney,
		@ExpenseBudgetHigh				TMoney,
		@ExpenseBudgetBottomEqualsPlan	TBool,
		@ExpenseBudgetHighEqualsPlan	TBool,
		@NextCalculationDate			TDate,
		@ReminderState					TState,
		@ReminderInterval				TTimeSpan,
		@ReminderTime					TDateTime,
		@WorkTimeStart					TCount,
		@RecurrenceID					TIdentifier,
		@SupervisorEmployeeID			TIdentifier,
		@DiscountViewWork				TBool,
		@DiscountPercentWork			TPercent,
		@DiscountTotalWork				TMoney,
		@DiscountPercentWorkFinal		TPercent,
		@DiscountTotalWorkFinal			TMoney,
		@DiscountTypeWork				TCount,
		@DiscountViewExpense			TBool,
		@DiscountPercentExpense			TPercent,
		@DiscountTotalExpense			TMoney,
		@DiscountPercentExpenseFinal	TPercent,
		@DiscountTotalExpenseFinal		TMoney,
		@DiscountTypeExpense			TCount,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@PlanningExpenseTypeForExpense	TBool,
		@PlanningEmployeeForExpense		TBool,
		@PlanningPriceForExpense		TBool,
		@PlanningDateForExpense			TBool,
		@TimeEntryAccount				TIdentifier,
		@TimeEntrySendingForApprovalAccount TBool,
		@TimeEntryActualTotalsAccount TIdentifier,
		@ExpenseAccount					TIdentifier,
		@ExpenseSendingForApprovalAccount TBool,
		@Comments						TNotes,
		@value							TVariant,
		@doc							int,
		@rv								int
	
	DECLARE -- RECURRENCE
		@Occurrences TCount


	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [ID],
		@State = [State],
		@StartDate = CAST([StartDate] AS datetime),
		@EndDate = CAST([EndDate] AS datetime),
		@BudgetType = [BudgetTypeID],
		@ProjectID	= [DocumentID],
		@UseWorkPlanning = [UseWorkPlanning],
		@UseExpensePlanning = [UseExpensePlanning],
		@WorkBudgetBottom = [WorkBudgetBottom],
		@WorkBudgetHigh = [WorkBudgetHigh],
		@WorkBudgetBottomEqualsPlan = [WorkBudgetBottomEqualsPlan],
		@WorkBudgetHighEqualsPlan = [WorkBudgetHighEqualsPlan],
		@ExpenseBudgetBottom = [ExpenseBudgetBottom],
		@ExpenseBudgetHigh = [ExpenseBudgetHigh],
		@ExpenseBudgetBottomEqualsPlan = [ExpenseBudgetBottomEqualsPlan],
		@ExpenseBudgetHighEqualsPlan = [ExpenseBudgetHighEqualsPlan],
		@NextCalculationDate = CAST([NextCalculationDate] AS datetime),
		@ReminderState = CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END,
		@RecurrenceID = [RecurrencePatternID],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@DiscountViewWork = [DiscountViewWork],
		@DiscountPercentWork = ABS([DiscountPercentWork]),
		@DiscountTotalWork = ABS([DiscountTotalWork]),
		@DiscountTypeWork = [DiscountTypeWork],
		@DiscountViewExpense = [DiscountViewExpense],
		@DiscountPercentExpense = ABS([DiscountPercentExpense]),
		@DiscountTotalExpense = ABS([DiscountTotalExpense]),
		@DiscountTypeExpense = [DiscountTypeExpense],
		@PlanningActivityForWork = [PlanningActivityForWork],
		@PlanningEmployeeForWork = [PlanningEmployeeForWork],
		@PlanningQualificationForWork = [PlanningQualificationForWork],
		@PlanningRateForWork = [PlanningRateForWork],
		@PlanningDateForWork = [PlanningDateForWork],
		@PlanningExpenseTypeForExpense = [PlanningExpenseTypeForExpense],
		@PlanningEmployeeForExpense = [PlanningEmployeeForExpense],
		@PlanningPriceForExpense = [PlanningPriceForExpense],
		@PlanningDateForExpense = [PlanningDateForExpense],
		@TimeEntryAccount = [TimeEntryAccount],
		@TimeEntrySendingForApprovalAccount = [TimeEntrySendingForApprovalAccount],
		@TimeEntryActualTotalsAccount = [TimeEntryActualTotalsAccount],
		@ExpenseAccount = [ExpenseAccount],
		@ExpenseSendingForApprovalAccount = [ExpenseSendingForApprovalAccount],
		@Comments = [Comments]
	FROM 
		OPENXML(@doc, '/pjm6BudgetGet/Budget', 2)
			WITH (
			[ID] int,
			[State] int,
			[StartDate] varchar(19),
			[EndDate] varchar(19),
			[BudgetTypeID] int,
			[DocumentID] int,
			[UseWorkPlanning] bit,
			[UseExpensePlanning] bit,
			[WorkBudgetBottom] money,
			[WorkBudgetHigh] money,
			[WorkBudgetBottomEqualsPlan] bit,
			[WorkBudgetHighEqualsPlan] bit,
			[ExpenseBudgetBottom] money,
			[ExpenseBudgetHigh] money,
			[ExpenseBudgetBottomEqualsPlan] bit,
			[ExpenseBudgetHighEqualsPlan] bit,
			[NextCalculationDate] varchar(19),
			[ReminderState] varchar(5),
			[RecurrencePatternID] int,
			[SupervisorEmployeeID] int,
			[DiscountViewWork] bit,
			[DiscountPercentWork] decimal(18,4),
			[DiscountTotalWork] decimal,
			[DiscountTypeWork] int,
			[DiscountViewExpense] bit,
			[DiscountPercentExpense] decimal(18,4),
			[DiscountTotalExpense] decimal,
			[DiscountTypeExpense] int,
			[PlanningActivityForWork] bit,
			[PlanningEmployeeForWork] bit,
			[PlanningQualificationForWork] bit,
			[PlanningRateForWork] bit,
			[PlanningDateForWork] bit,
			[PlanningExpenseTypeForExpense] bit,
			[PlanningEmployeeForExpense] bit,
			[PlanningPriceForExpense] bit,
			[PlanningDateForExpense] bit,
			[TimeEntryAccount] int,
			[TimeEntrySendingForApprovalAccount] bit,
			[TimeEntryActualTotalsAccount] int,
			[ExpenseAccount] int,
			[ExpenseSendingForApprovalAccount] bit,
			[Comments] nvarchar(max)
			)
	
	IF dbo.fnPjm6CanEditBudget(@ID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT * FROM OPENXML(@doc, '/pjm6BudgetGet/RecurrencePattern', 2) WITH ([ID] int))
	BEGIN
		SELECT
			@Occurrences = [XmlTable].[Occurrences]
		FROM
			OPENXML(@doc, '/pjm6BudgetGet/RecurrencePattern', 2)
			WITH (
				[Occurrences] int
				) as [XmlTable] 
	END
	EXEC sp_xml_removedocument @doc

	IF(@DiscountTypeWork != 0 AND ((@DiscountViewWork = 0 AND @DiscountPercentWork IS NULL) OR (@DiscountViewWork = 1 AND @DiscountTotalWork IS NULL))) OR
		(@DiscountTypeExpense != 0 AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense IS NULL) OR (@DiscountViewExpense = 1 AND @DiscountTotalExpense IS NULL)))
	BEGIN
		RAISERROR('#DiscountIsNotDefined', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
			
	IF ((@DiscountTypeWork = 1 OR @DiscountTypeWork = 2) AND ((@DiscountViewWork = 0 AND @DiscountPercentWork = 0) OR
		(@DiscountViewWork = 1 AND @DiscountTotalWork = 0))) OR
		((@DiscountTypeExpense = 1 OR @DiscountTypeExpense = 2) AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense = 0) OR
		(@DiscountViewExpense = 1 AND @DiscountTotalExpense = 0)))
	BEGIN
		RAISERROR('#DiscountCantBeZero', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @PlanningActivityForWork = 0 AND @PlanningEmployeeForWork = 0 AND 
		@PlanningQualificationForWork = 0 AND @PlanningRateForWork = 0 
	BEGIN
		RAISERROR('#WorkPlanningParametersIsNull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @PlanningExpenseTypeForExpense = 0 AND @PlanningEmployeeForExpense = 0 AND @PlanningPriceForExpense = 0
	BEGIN
		RAISERROR('#ExpensePlanningParametersIsNull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 1 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseExpensePlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 2 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF (@BudgetType > 1 AND EXISTS(SELECT * FROM [Budget] WHERE [DocumentID] = @ProjectID AND
		@ID != [ID] AND
		((@StartDate Between [Budget].[StartDate] AND [Budget].[EndDate])
		OR (@EndDate Between [Budget].[StartDate] AND [Budget].[EndDate]) OR 
		([Budget].[StartDate] Between @StartDate AND @EndDate)
		OR ([Budget].[EndDate] Between @StartDate AND @EndDate))))
	BEGIN
		RAISERROR('#crossingbudgetperiod', 18, -1)
		RETURN 1
	END

	SET @DiscountPercentWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 0 THEN -@DiscountPercentWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 0 THEN @DiscountPercentWork ELSE NULL END
									END
	SET @DiscountTotalWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 1 THEN -@DiscountTotalWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 1 THEN @DiscountTotalWork ELSE NULL END
									END
	SET @DiscountPercentExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 0 THEN -@DiscountPercentExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 0 THEN @DiscountPercentExpense ELSE NULL END
										END
	SET @DiscountTotalExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 1 THEN -@DiscountTotalExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 1 THEN @DiscountTotalExpense ELSE NULL END
										END
	BEGIN TRANSACTION
	/*
	IF @State = 1
	BEGIN*/
		UPDATE [Budget]
		SET
			[Budget].[StartDate] = @StartDate,
			[Budget].[EndDate] = @EndDate,
			[Budget].[WarningFlagID] = NULL,
			[Budget].[UseWorkPlanning] = @UseWorkPlanning,
			[Budget].[UseExpensePlanning] = @UseExpensePlanning,
			[Budget].[WorkBudgetBottom] = (CASE @WorkBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetBottom END),
			[Budget].[WorkBudgetHigh] = (CASE @WorkBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetHigh END) ,
			[Budget].[WorkBudgetBottomEqualsPlan] = @WorkBudgetBottomEqualsPlan,
			[Budget].[WorkBudgetHighEqualsPlan] = @WorkBudgetHighEqualsPlan,
			[Budget].[ExpenseBudgetBottom] =(CASE @ExpenseBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], @DiscountViewExpense, @DiscountPercentExpenseFinal, @DiscountTotalExpenseFInal, [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) ELSE @ExpenseBudgetBottom END),
			[Budget].[ExpenseBudgetHigh] = (CASE @ExpenseBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], @DiscountViewExpense, @DiscountPercentExpenseFinal, @DiscountTotalExpenseFinal, [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) ELSE @ExpenseBudgetHigh END),
			[Budget].[ExpenseBudgetBottomEqualsPlan] = @ExpenseBudgetBottomEqualsPlan,
			[Budget].[ExpenseBudgetHighEqualsPlan] = @ExpenseBudgetHighEqualsPlan,
			[Budget].[NextCalculationDate] = @NextCalculationDate,
			[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
			[Budget].[DiscountViewWork] = @DiscountViewWork,
			[Budget].[DiscountPercentWork] = @DiscountPercentWorkFinal,
			[Budget].[DiscountTotalWork] = @DiscountTotalWorkFinal,
			[Budget].[DiscountViewExpense] = @DiscountViewExpense,
			[Budget].[DiscountPercentExpense] = @DiscountPercentExpenseFinal,
			[Budget].[DiscountTotalExpense] = @DiscountTotalExpenseFinal,
			[Budget].[PlanningActivityForWork] = @PlanningActivityForWork,
			[Budget].[PlanningEmployeeForWork] = @PlanningEmployeeForWork,
			[Budget].[PlanningQualificationForWork] = @PlanningQualificationForWork,
			[Budget].[PlanningRateForWork] = @PlanningRateForWork,
			[Budget].[PlanningDateForWork] = @PlanningDateForWork,
			[Budget].[PlanningExpenseTypeForExpense] = @PlanningExpenseTypeForExpense,
			[Budget].[PlanningEmployeeForExpense] = @PlanningEmployeeForExpense,
			[Budget].[PlanningPriceForExpense] = @PlanningPriceForExpense,
			[Budget].[PlanningDateForExpense] = @PlanningDateForExpense,
			[Budget].[TimeEntryAccount] = @TimeEntryAccount,
			[Budget].[TimeEntrySendingForApprovalAccount] = @TimeEntrySendingForApprovalAccount,
			[Budget].[TimeEntryActualTotalsAccount] = @TimeEntryActualTotalsAccount,
			[Budget].[ExpenseAccount] = @ExpenseAccount,
			[Budget].[ExpenseSendingForApprovalAccount] = @ExpenseSendingForApprovalAccount,
			[Budget].[Comments] = @Comments,
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT
		WHERE
			[Budget].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	/*END
	ELSE IF @State = 2
	BEGIN
		UPDATE [Budget]
		SET
			[Budget].[WarningFlagID] = NULL,
			[Budget].[NextCalculationDate] = @NextCalculationDate,
			[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
			[Budget].[Comments] = @Comments,
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT
		WHERE
			[Budget].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END*/

	IF @State = 1
	BEGIN
		
		UPDATE
			[RecurrencePattern]
		SET
			[Occurrences] = @Occurrences
		WHERE
			[ID] = @RecurrenceID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END


	EXEC adfParameterGet 'WorkTimeStart1', 'Pjm5', @value OUTPUT	
	SET  @WorkTimeStart = CAST(@value AS int)

	SET @ReminderInterval = -@WorkTimeStart
	EXEC @rv = pjm6BudgetReminderCreate @ID,
		@NextCalculationDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	COMMIT TRANSACTION	
	
	EXEC pjm6BudgetGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetUpdate TO PUBLIC
GO
