 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumBrowse'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumBrowse]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumBrowse'
GO

/******************************************************************************
**		File: pjm5ContractAddendumBrowse.sql
**		Name: pjm5ContractAddendumBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ContractAddendumBrowse]
	@ProjectID TIdentifier,
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[ContractAddendum].[Class],
		[ContractAddendum].[ID],
		[ContractAddendum].[State],
		[ContractAddendum].[Flag],
		[ContractAddendum].[Date],
		[ContractAddendum].[Number],
		[ContractAddendum].[FileAs],
		[ContractAddendum].[ProjectID],
		[ContractAddendum].[Comments],
		[ContractAddendum].[Created],
		[ContractAddendum].[CreatedBy],
		[ContractAddendum].[Modified],
		[ContractAddendum].[ModifiedBy],
		[ContractAddendum].[Timestamp]
	FROM
		[ContractAddendum]
	WHERE
		[ContractAddendum].[ProjectID] = @ProjectID AND
		((@StateSelector = 0) OR (@StateSelector != 0 AND [ContractAddendum].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ContractAddendumBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumGet'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumGet]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumGet'
GO

/******************************************************************************
**		File: pjm5ContractAddendumGet.sql
**		Name: pjm5ContractAddendumGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ContractAddendumGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ContractAddendum].[Class],
		[ContractAddendum].[ID],
		[ContractAddendum].[State],
		[ContractAddendum].[Flag],
		[ContractAddendum].[Date],
		[ContractAddendum].[Number],
		[ContractAddendum].[FileAs],
		[ContractAddendum].[ProjectID],
		[ContractAddendum].[Comments],
		[ContractAddendum].[Created],
		[ContractAddendum].[CreatedBy],
		[ContractAddendum].[Modified],
		[ContractAddendum].[ModifiedBy],
		[ContractAddendum].[Timestamp]
	FROM
		[ContractAddendum]
	WHERE
		[ContractAddendum].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ContractAddendumGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumCreate'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumCreate]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumCreate'
GO

/******************************************************************************
**		File: pjm5ContractAddendumCreate.sql
**		Name: pjm5ContractAddendumCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ContractAddendumCreate]
	@Date TDate,
	@Number TCode,
	@FileAs TName,
	@ProjectID TIdentifier,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('3f7b8261-9e01-4486-be0f-f66ff7833f37')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ContractAddendum]
		([Flag], [State], [Date], [Number], [FileAs], [ProjectID], [Comments])
	VALUES
		(0, @State, @Date, @Number, @FileAs, @ProjectID, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5ContractAddendumGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ContractAddendumCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumUpdate'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumUpdate]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumUpdate'
GO

/******************************************************************************
**		File: pjm5ContractAddendumUpdate.sql
**		Name: pjm5ContractAddendumUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ContractAddendumUpdate
	@ID TIdentifier,
	@Date TDate,
	@Number TCode,
	@FileAs TName,
	--@ProjectID TIdentifier,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ContractAddendum]
	SET
		[ContractAddendum].[Date] = @Date,
		[ContractAddendum].[Number] = @Number,
		[ContractAddendum].[FileAs] = @FileAs,
		--[ContractAddendum].[ProjectID] = @ProjectID,
		[ContractAddendum].[Comments] = @Comments,
		[ContractAddendum].[Modified] = GETDATE(),
		[ContractAddendum].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ContractAddendum].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ContractAddendumGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ContractAddendumUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumDelete'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumDelete]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumDelete'
GO

/******************************************************************************
**		File: pjm5ContractAddendumDelete.sql
**		Name: pjm5ContractAddendumDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ContractAddendumDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ContractAddendum] WHERE [ContractAddendum].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ContractAddendumDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractAddendumChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractAddendumChangeState'
		DROP PROCEDURE [dbo].[pjm5ContractAddendumChangeState]
	END
GO

PRINT 'Creating procedure pjm5ContractAddendumChangeState'
GO

/******************************************************************************
**		File: pjm5ContractAddendumChangeState.sql
**		Name: pjm5ContractAddendumChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/09/2005 16:10:35
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ContractAddendumChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ContractAddendum].[Class],
		@FromState = [ContractAddendum].[State],
		@ProjectID = [ProjectID]
	FROM
		[ContractAddendum]
	WHERE
		[ContractAddendum].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @FromState = 1 AND @ToState = 2 AND
		(SELECT [State] FROM [Project] WHERE [ID] = @ProjectID) = 1
	BEGIN
		RAISERROR('#CannotApproveContractAddendumProjectIsDraft', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	UPDATE
		[ContractAddendum]
	SET
		[ContractAddendum].[State] = @ToState,
		[ContractAddendum].[Modified] = GETDATE(),
		[ContractAddendum].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ContractAddendum].[ID] = @ID
	AND
		[ContractAddendum].[State] = @FromState
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[ServiceAssignment]
	SET
		[State] = 2
	WHERE
		[ContractAddendumID] = @ID AND
		[State] = 1
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5ContractAddendumChangeState TO PUBLIC
GO
