 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoCreate'
		DROP PROCEDURE [dbo].[pjm5CreditMemoCreate]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoCreate'
GO

/******************************************************************************
**		File: pjm5CreditMemoCreate.sql
**		Name: pjm5CreditMemoCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CreditMemoCreate]
	@Xml XML
AS
	DECLARE 
		@State TState,
		@ID TIdentifier,
		@FileAs TName,
		@Date TDate,
		@Number TCode,
		@VAT TMoney,
		@PaymentTypeID TIdentifier,
		@PayeeCompanyID TIdentifier,
		@PayeeBankAccountID TIdentifier,
		@PayerCompanyID TIdentifier,
		@ProjectID TIdentifier,
		@Value TMoney,
		@CurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BaseCurrencyRate TMoney,
		@CurrencyRate TMoney,
		@Reason TName,
		@Payer TName,
		@Comments TNotes,
		@doc int,
		@val TVariant,
		@TotalPC TMoney,
		@TotalWithVATPC TMoney,
		@TotalBC TMoney,
		@TotalWithVATBC TMoney
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('cac22366-ee83-4e23-9c88-8ee437b068ca')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT 
		@Date = CONVERT(datetime, [XmlTable].[Date]),
		@FileAs = [XmlTable].[FileAs],
		@Number = [XmlTable].[Number],
		@PaymentTypeID = [XmlTable].[PaymentTypeID],
		@CurrencyCode = ISNULL([BankAccount].[CurrencyCode], [XmlTable].[CurrencyCode]),
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@PayeeCompanyID = [XmlTable].[SupplierCompanyID],
		@PayeeBankAccountID = [XmlTable].[PayeeBankAccountID],
		@PayerCompanyID = [XmlTable].[CustomerCompanyID],
		@ProjectID = [XmlTable].[ProjectID],
		@Value = [XmlTable].[Value],
		@VAT = [XmlTable].[VAT],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@BaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@Comments = [XmlTable].[Comments],
		@Reason = [XmlTable].[Reason],
		@Payer = [XmlTable].[Payer]
	FROM
		OPENXML(@doc, '/pjm5CreditMemoGet/CreditMemo', 2)
			WITH (
				[FileAs] nvarchar(512),
				[Date] nvarchar(19),
				[Number] varchar(32),
				[PaymentTypeID] int,
				[CurrencyCode] char(3),
				[SupplierCompanyID] int,
				[PayeeBankAccountID] int,
				[CustomerCompanyID] int,
				[Reason] nvarchar(256),
				[Payer] nvarchar(256),
				[ProjectID] int,
				[Value] money,
				[VAT] money,
				[CurrencyRate] money,
				[BaseCurrencyRate] money,
				[Comments] nvarchar(max)
				) AS [XmlTable]
		LEFT JOIN [BankAccount]
			ON [BankAccount].[ID] = [XmlTable].[PayeeBankAccountID]
		LEFT JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
	
	EXEC sp_xml_removedocument @doc
	
	DECLARE 
		@BaseCurrencyCode TCode3,
		@NationalCurrency TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @val OUTPUT
	SET @BaseCurrencyCode = CAST(@val as varchar(3))

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrency = CAST(@val AS varchar(8))
	
	IF @BaseCurrencyCode = @CurrencyCode
	BEGIN
		SET @BaseCurrencyRate = 1.0
	END
	
	IF @ProjectCurrencyCode = @CurrencyCode
	BEGIN
		SET @CurrencyRate = 1.0
	END
		
	IF @BaseCurrencyRate IS NULL
	BEGIN
		SELECT 
			@BaseCurrencyRate = [Rate]
		FROM
			[CurrencyRate]
		WHERE
			[FromCurrencyCode] = @BaseCurrencyCode AND
			[ToCurrencyCode] = @CurrencyCode AND
			(@Date BETWEEN [ValidFrom] AND [ValidTo])
	END
	
	SET	@TotalPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency THEN (@Value - @VAT) / @CurrencyRate
						ELSE (@Value - @VAT) * @CurrencyRate
					END, 2)
	SET	@TotalWithVATPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @CurrencyRate
						ELSE @Value * @CurrencyRate
					END, 2)

	SET	@TotalBC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN (@Value - @VAT) / @BaseCurrencyRate
						ELSE (@Value - @VAT) * @BaseCurrencyRate
					END, 2)
	SET	@TotalWithVATBC= ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @BaseCurrencyRate
						ELSE @Value * @BaseCurrencyRate
					END, 2)

	BEGIN TRANSACTION
	
	INSERT INTO [CreditMemo]
		([Flag], [State],
		 [FileAs], [Date], [Number],
		 [VAT], [PaymentTypeID], [PayeeCompanyID],
		 [PayeeBankAccountID], [PayerCompanyID], [ProjectID],
		 [Value], [CurrencyCode], [CurrencyRate], [BaseCurrencyRate], 
		 [Comments], [Reason], [Payer],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC])
	VALUES
		(0, @State,
		 @FileAs, @Date, @Number,
		 @VAT, @PaymentTypeID, @PayeeCompanyID,
		 @PayeeBankAccountID, @PayerCompanyID, @ProjectID,
		 @Value, @CurrencyCode, @CurrencyRate, @BaseCurrencyRate, 
		 @Comments, @Reason, @Payer,
		 @TotalPC, @TotalWithVATPC, @TotalBC, @TotalWithVATBC)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	
	COMMIT TRANSACTION
	
	EXEC pjm5CreditMemoGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CreditMemoCreate TO PUBLIC
GO
