 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoGet'
		DROP PROCEDURE [dbo].[pjm5CreditMemoGet]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoGet'
GO

/******************************************************************************
**		File: pjm5CreditMemoGet.sql
**		Name: pjm5CreditMemoGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CreditMemoGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ProjectID TIdentifier,
		@Class	TClass
	SELECT
		@ProjectID = [CreditMemo].[ProjectID],
		@Class = [CreditMemo].[Class]
	FROM 
		[CreditMemo]
	WHERE
		[CreditMemo].[ID] = @ID
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, @Class, NULL) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		[CreditMemo].[Class],
		[CreditMemo].[ID],
		[CreditMemo].[State],
		[CreditMemo].[Flag],
		[CreditMemo].[FileAs],
		[CreditMemo].[Date],
		[CreditMemo].[Number],
		[CreditMemo].[VAT],
		[CreditMemo].[PaymentTypeID],
		[CreditMemo].[PayeeCompanyID],
		[CreditMemo].[PayeeBankAccountID],
		[CreditMemo].[PayerCompanyID],
		[CreditMemo].[Reason],
		[CreditMemo].[Payer],
		[CreditMemo].[ProjectID],
		[Project].[ContractNumber],
		[CreditMemo].[Value],
		[CreditMemo].[CurrencyCode],
		[CreditMemo].[CurrencyRate],
		[CreditMemo].[BaseCurrencyRate],
		[CreditMemo].[Comments],
		[CreditMemo].[Created],
		[CreditMemo].[CreatedBy],
		[CreditMemo].[Modified],
		[CreditMemo].[ModifiedBy],
		[CreditMemo].[Timestamp],
		[CreditMemo].[PayerCompanyID] AS [CustomerCompanyID],
		[CreditMemo].[PayeeCompanyID] AS [SupplierCompanyID]
	FROM
		[CreditMemo]
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [CreditMemo].[ProjectID]
	WHERE
		[CreditMemo].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CreditMemoGet] TO PUBLIC
GO

