IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trCreditMemoUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm5trCreditMemoUpdate'
		DROP  Trigger pjm5trCreditMemoUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trCreditMemoUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trCreditMemoUpdate'
GO
CREATE Trigger pjm5trCreditMemoUpdate 
ON [CreditMemo] FOR INSERT, UPDATE
AS
BEGIN
	IF @@ROWCOUNT = 0
		RETURN
	
    IF EXISTS (
		SELECT *
		FROM [inserted]
		WHERE 
			[inserted].[Value] < [inserted].[VAT]
	)
	BEGIN
		RAISERROR('#wrongvatvalue', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END

	IF EXISTS(
		SELECT * 
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID]
		WHERE
			[deleted].[State] = 1 AND
			[inserted].[State] = 2 AND
			[inserted].[ProjectID] IS NOT NULL AND
			[inserted].[CurrencyRate] IS NULL 
	)
	BEGIN
		RAISERROR('#CurrencyRateCannotBeNull', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END

	IF EXISTS(
		SELECT * 
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID]
		WHERE
			[deleted].[State] = 1 AND
			[inserted].[State] = 2 AND
			[inserted].[BaseCurrencyRate] IS NULL 
	)
	BEGIN
		RAISERROR('#BaseCurrencyRateCannotBeNull', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
END

GO
 