IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceBrowse'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceBrowse]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceBrowse'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceBrowse.sql
**		Name: pjm5CustodyPlaceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CustodyPlaceBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[CustodyPlace].[Class],
		[CustodyPlace].[ID],
		[CustodyPlace].[State],
		[CustodyPlace].[Flag],
		[CustodyPlace].[Code],
		[CustodyPlace].[FileAs],
		[CustodyPlace].[Comments],
		[CustodyPlace].[Created],
		[CustodyPlace].[CreatedBy],
		[CustodyPlace].[Modified],
		[CustodyPlace].[ModifiedBy],
		[CustodyPlace].[Timestamp]
	FROM
		[CustodyPlace]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [CustodyPlace].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [CustodyPlace].[State] = 2)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CustodyPlaceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceGet'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceGet]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceGet'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceGet.sql
**		Name: pjm5CustodyPlaceGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CustodyPlaceGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[CustodyPlace].[Class],
		[CustodyPlace].[ID],
		[CustodyPlace].[State],
		[CustodyPlace].[Flag],
		[CustodyPlace].[Code],
		[CustodyPlace].[FileAs],
		[CustodyPlace].[Comments],
		[CustodyPlace].[Created],
		[CustodyPlace].[CreatedBy],
		[CustodyPlace].[Modified],
		[CustodyPlace].[ModifiedBy],
		[CustodyPlace].[Timestamp]
	FROM
		[CustodyPlace]
	WHERE
		[CustodyPlace].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CustodyPlaceGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceCreate'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceCreate]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceCreate'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceCreate.sql
**		Name: pjm5CustodyPlaceCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CustodyPlaceCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('73d450d8-acfd-4005-b2a1-4471e6053b5e')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [CustodyPlace]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5CustodyPlaceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CustodyPlaceCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceUpdate'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceUpdate]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceUpdate'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceUpdate.sql
**		Name: pjm5CustodyPlaceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CustodyPlaceUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[CustodyPlace]
	SET
		[CustodyPlace].[Code] = @Code,
		[CustodyPlace].[FileAs] = @FileAs,
		[CustodyPlace].[Comments] = @Comments,
		[CustodyPlace].[Modified] = DEFAULT,
		[CustodyPlace].[ModifiedBy] = DEFAULT
	WHERE
		[CustodyPlace].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5CustodyPlaceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CustodyPlaceUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceDelete'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceDelete]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceDelete'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceDelete.sql
**		Name: pjm5CustodyPlaceDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CustodyPlaceDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [CustodyPlace] WHERE [CustodyPlace].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5CustodyPlaceDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CustodyPlaceChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CustodyPlaceChangeState'
		DROP PROCEDURE [dbo].[pjm5CustodyPlaceChangeState]
	END
GO

PRINT 'Creating procedure pjm5CustodyPlaceChangeState'
GO

/******************************************************************************
**		File: pjm5CustodyPlaceChangeState.sql
**		Name: pjm5CustodyPlaceChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CustodyPlaceChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [CustodyPlace].[Class],
		@FromState = [CustodyPlace].[State]
	FROM
		[CustodyPlace]
	WHERE
		[CustodyPlace].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CustodyPlace]
	SET
		[CustodyPlace].[State] = @ToState,
		[CustodyPlace].[Modified] = DEFAULT,
		[CustodyPlace].[ModifiedBy] = DEFAULT
	WHERE
		[CustodyPlace].[ID] = @ID
	AND
		[CustodyPlace].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5CustodyPlaceChangeState TO PUBLIC
GO
