 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentCardDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardDelete'
GO

/******************************************************************************
**		File: pjm5DocumentCardDelete.sql
**		Name: pjm5DocumentCardDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF NOT EXISTS(SELECT * FROM [DocumentCard] WHERE [ID] = @ID)
		RETURN 0

	DECLARE 
		@ItemID TIdentifier,
		@FolderID TIdentifier,
		@CreatedBy TIdentifier,
		@ModifiedBy TIdentifier,
		@UserID TIdentifier
		
	SELECT 
		@ItemID = [DocumentItem].[ID],
		@FolderID = [DocumentCard].[FolderID],
		@CreatedBy = [DocumentCard].[CreatedBy],
		@ModifiedBy = [DocumentCard].[ModifiedBy]
	FROM 
		[DocumentCard]
		LEFT OUTER JOIN [DocumentItem] 
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
	WHERE 
		[DocumentCard].[ID] = @ID
	IF @ItemID IS NOT NULL
	BEGIN
		SET @UserID = dbo.adfGetCurrentUserID()
		IF NOT (@FolderID = -1 AND @UserID = @ModifiedBy)
		BEGIN
			IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'DeleteAll') = 0
			BEGIN
				IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'DeleteOwn') = 0
				BEGIN
					RAISERROR('#accessdenied', 18, -1)
					RETURN 1
				END
				IF @UserID != @CreatedBy
				BEGIN
					RAISERROR('#accessdenied', 18, -1)
					RETURN 1
				END
			END
		END
	END
	
	BEGIN TRANSACTION
	IF @FolderID = -1
	BEGIN
		IF @ItemID IS NOT NULL
		BEGIN
			DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @itemID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			DELETE FROM [DocumentItem] WHERE [ID] = @ItemID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		
		DELETE FROM [DocumentFlowEntry] 
		FROM
			[DocumentFlowEntry]
			INNER JOIN [DocumentCard]
				ON [DocumentFlowEntry].[DocumentClass] = [DocumentCard].[Class] AND 
					[DocumentFlowEntry].[DocumentID] = [DocumentCard].[ID]
		WHERE 
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE FROM [DocumentCard] WHERE [DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF @ItemID IS NOT NULL
		BEGIN
			UPDATE 
				[DocumentItem] 
			SET 
				[State] = 100,
				[FolderID] = -1,
				[Modified] = DEFAULT,
				[ModifiedBy] = DEFAULT
			WHERE 
				[ID] = @ItemID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		UPDATE 
			[DocumentCard] 
		SET 
			[State] = 100,
			[FolderID] = -1,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE 
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		IF @ItemID IS NOT NULL
		BEGIN
			EXEC pjm5DocumentItemDeleteNotification @ItemID
		END
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentDelete'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentDelete]
	END
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentDelete'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentDelete]
	END
GO

