IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentCardUpdate.sql
**		Name: pjm5DocumentCardUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardUpdate
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@doc int
	
	DECLARE 
		@FileAs TName,
		@FileName TName,
		@DocumentCardClassID TIdentifier,
		@DocumentCardID TIdentifier,
		@Number TCode,
		@Date TDate,
		@NumberIn TCode,
		@DateIn TDate,
		@NumberOut TCode,
		@DateOut TDate,
		@CompanyID TIdentifier,
		@ContactID TIdentifier,
		@CorrespondentCompanyID TIdentifier,
		@CorrespondentContactID TIdentifier,
		@DivisionID TIdentifier,
		@CaseID TIdentifier,
		@SentTime TDateTime,
		@DocumentSendTypeID TIdentifier,
		@Comments TNotes,
		@Package TCode,
		@Copy TBool,
		@AppendixCount TCount,
		@PageCount TCount,
		@StorePeriod TCount,
		@CardOwnerID TIdentifier,
		@CustodyPlaceID TIdentifier,
		
		@HasToBeSentBack TBool,
		@SentBackTime TDateTime,
		@DocumentSendBackTypeID TIdentifier,

		@DocumentItemID TIdentifier,
		@DocumentItemFileName TName,
		@Extension TName

		
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [XmlTable].[ID],
		@FileAs = [XmlTable].[FileAs],
		@FileName = [XmlTable].[FileName],

		@DocumentItemID = [DocumentItem].[ID],
		@DocumentItemFileName = [DocumentItem].[FileName],
		@Extension = [DocumentItem].[Extension],

		@DocumentCardClassID = [XmlTable].[DocumentCardClassID],
		@DocumentCardID = [XmlTable].[DocumentCardID],
		@Number = [XmlTable].[Number],
		@Date = CAST([XmlTable].[Date] AS datetime),
		@NumberIn = [XmlTable].[NumberIn],
		@DateIn = CAST([XmlTable].[DateIn] AS datetime),
		@NumberOut = [XmlTable].[NumberOut],
		@DateOut = CAST([XmlTable].[DateOut] AS datetime),
		@CompanyID = [XmlTable].[CompanyID],
		@ContactID = [XmlTable].[ContactID],
		@CorrespondentCompanyID = [XmlTable].[CorrespondentCompanyID],
		@CorrespondentContactID = [XmlTable].[CorrespondentContactID],
		@DivisionID = [XmlTable].[DivisionID],
		@CaseID = [XmlTable].[CaseID],
		@SentTime = CAST([XmlTable].[SentTime] AS datetime),
		@DocumentSendTypeID = [XmlTable].[DocumentSendTypeID],
		@Comments = [XmlTable].[Comments],

		@Package = [XmlTable].[Package],
		@Copy = CASE [XmlTable].[Copy] WHEN 'true' THEN 1 WHEN 'false' THEN 0 ELSE NULL END,
		@AppendixCount = [XmlTable].[AppendixCount],
		@PageCount = [XmlTable].[PageCount],
		@StorePeriod = [XmlTable].[StorePeriod], 
		@CardOwnerID = [XmlTable].[CardOwnerID],
		@HasToBeSentBack = CASE WHEN [XmlTable].[HasToBeSentBack] = 'false' THEN 0 ELSE 1 END,
		@SentBackTime = CAST([XmlTable].[SentBackTime] AS datetime),
		@DocumentSendBackTypeID = [XmlTable].[DocumentSendBackTypeID],
		@CustodyPlaceID = [XmlTable].[CustodyPlaceID]
	FROM 
		OPENXML(@doc, '/pjm5DocumentCardGet/DocumentCard', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(512),
				[FileName] nvarchar(512),
				[DocumentItemID] int,
				[DocumentCardClassID] int,
				[DocumentCardID] int,
				[Number] varchar(32),
				[Date] nvarchar(19),
				[NumberIn] varchar(32),
				[DateIn] nvarchar(19),
				[NumberOut] varchar(32),
				[DateOut] nvarchar(19),
				[CompanyID] int,
				[ContactID] int,
				[CorrespondentCompanyID] int,
				[CorrespondentContactID] int,
				[DivisionID] int,
				[CaseID] int,
				[DocumentSendTypeID] int,
				[SentTime] nvarchar(19),
				[Comments] nvarchar(max),
				[Package] varchar(32),
				[Copy] varchar(5),
				[AppendixCount] int,
				[PageCount] int,
				[StorePeriod] int, 
				[CardOwnerID] int,
				[HasToBeSentBack] varchar(5),
				[SentBackTime] nvarchar(19),
				[DocumentSendBackTypeID] int,
				[CustodyPlaceID] int
				) AS [XmlTable]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [XmlTable].[ID]
			
	EXEC sp_xml_removedocument @doc
	
	IF @DocumentItemID IS NOT NULL
	BEGIN
		IF UPPER(@Extension) != UPPER(RIGHT(@FileName, LEN(@Extension)))
		BEGIN
			RAISERROR('#wrongfileextension', 18, -1)
			RETURN 1
		END	
	END
	
	BEGIN TRANSACTION
	IF @DocumentItemID IS NOT NULL AND
		UPPER(@DocumentItemFileName) != UPPER(@FileName)
	BEGIN
		UPDATE
			[DocumentItem]
		SET
			[FileAs] = @FileAs,
			[FileName] = @FileName
		WHERE
			[DocumentCardID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE 
		[DocumentCard]
	SET
		[FileAs] = @FileAs, 
		[DocumentCardClassID] = @DocumentCardClassID,
		[DocumentCardID] = @DocumentCardID,
		[Number] = @Number,
		[Date] = @Date,
		[NumberIn] = @NumberIn,
		[DateIn] = @DateIn,
		[NumberOut] = @NumberOut,
		[DateOut] = @DateOut,
		[CompanyID] = @CompanyID,
		[ContactID] = @ContactID,
		[CorrespondentCompanyID] = @CorrespondentCompanyID,
		[CorrespondentContactID] = @CorrespondentContactID,
		[DivisionID] = @DivisionID,
		[CaseID] = @CaseID,
		[DocumentSendTypeID] = @DocumentSendTypeID,
		[SentTime] = @SentTime,
		[Comments] = @Comments,
		[Package] = @Package,
		[Copy] = @Copy,
		[AppendixCount] = @AppendixCount,
		[PageCount] = @PageCount,
		[StorePeriod] = @StorePeriod, 
		[CardOwnerID] = @CardOwnerID,
		[CustodyPlaceID] = @CustodyPlaceID,
		[HasToBeSentBack] = @HasToBeSentBack,
		[SentBackTime] = @SentBackTime,
		[DocumentSendBackTypeID] = @DocumentSendBackTypeID,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	
	COMMIT TRANSACTION
	EXEC pjm5DocumentCardGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentUpdate'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentUpdate]
	END
GO

 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentUpdate'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentUpdate]
	END
GO

