IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentFlowEntryBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentFlowEntryBrowse'
		DROP PROCEDURE [dbo].[pjm5DocumentFlowEntryBrowse]
	END
GO

PRINT 'Creating procedure pjm5DocumentFlowEntryBrowse'
GO

/******************************************************************************
**		File: pjm5DocumentFlowEntryBrowse.sql
**		Name: pjm5DocumentFlowEntryBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentFlowEntryBrowse]
	@Class	TClass,
	@ID		TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[DocumentFlowEntry].[ID],
		[DocumentFlowEntry].[DocumentClass],
		[DocumentFlowEntry].[DocumentID],
		[DocumentFlowEntry].[EmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[DocumentFlowEntry].[ChargeDate],
		[DocumentFlowEntry].[ReturnDate],
		[DocumentFlowEntry].[Comments]
	FROM
		[DocumentFlowEntry]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [DocumentFlowEntry].[EmployeeID]
	WHERE
		[DocumentFlowEntry].[DocumentClass] = @Class AND
		[DocumentFlowEntry].[DocumentID] = @ID
	RETURN 0 
GO

GRANT EXECUTE ON pjm5DocumentFlowEntryBrowse TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentFlowEntryUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentFlowEntryUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentFlowEntryUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentFlowEntryUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentFlowEntryUpdate.sql
**		Name: pjm5DocumentFlowEntryUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentFlowEntryUpdate]
	@ID TIdentifier,
	@DocumentClass	TClass,
	@DocumentID	TIdentifier,
	@EmployeeID	TIdentifier,
	@ChargeDate	TDate,
	@ReturnDate	TDate,
	@Comments	TNotes
AS
	SET NOCOUNT ON
	IF @ID IS NULL
	BEGIN
		INSERT INTO [DocumentFlowEntry] 
			([DocumentClass], [DocumentID], [EmployeeID], [ChargeDate], [ReturnDate], [Comments])
		VALUES
			(@DocumentClass, @DocumentID, @EmployeeID, @ChargeDate, @ReturnDate, @Comments)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE
			[DocumentFlowEntry]
		SET
			[EmployeeID] = @EmployeeID, 
			[ChargeDate] = @ChargeDate, 
			[ReturnDate] = @ReturnDate, 
			[Comments] = @Comments
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentFlowEntryUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentFlowEntryDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentFlowEntryDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentFlowEntryDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentFlowEntryDelete'
GO

/******************************************************************************
**		File: pjm5DocumentFlowEntryDelete.sql
**		Name: pjm5DocumentFlowEntryDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentFlowEntryDelete]
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	DELETE [DocumentFlowEntry] WHERE [ID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentFlowEntryDelete TO PUBLIC
GO
