 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentItemInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentItemInfo'
		DROP PROCEDURE [dbo].[pjm6DocumentItemInfo]
	END
GO

PRINT 'Creating procedure pjm6DocumentItemInfo'
GO

/******************************************************************************
**		File: pjm6DocumentItemInfo.sql
**		Name: pjm6DocumentItemInfo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentItemInfo]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		[DocumentItem].[State],
		[DocumentItem].[Flag],
		[DocumentItem].[FolderID],

		[DocumentCard].[Class] AS [DocumentCardClass],
		[DocumentCard].[ID] AS [DocumentCardID],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[FileAs],

		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentVersion].[DataLength],
		[DocumentItem].[CheckedOutBy],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		CAST([DocumentCard].[Timestamp] as bigint) AS [Timestamp],
		CAST('acb865ab-ae3c-429e-af10-d14d6a46363b' as uniqueidentifier) AS [Guid]
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion]
	WHERE
		[DocumentItem].[ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentItemInfo] TO PUBLIC
GO

