/******************************************************************************
**		Name: pjm6ExchangeSyncGetContacts
**		Auth: pavel.svintsov
**		Date: 27.01.2011 16:00:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		
**    
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncGetContacts]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncGetContacts'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncGetContacts]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncGetContacts'
GO

SET QUOTED_IDENTIFIER ON
GO
-------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncGetContacts]
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeClass TClass
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')
	SELECT
	(SELECT
		[Employee].[ID] as '@EmployeeID',
		[ExchangeSync].[ExchangeID] as '@ExchangeID',
		[Employee].[FirstName] as '@FirstName',
		[Employee].[MiddleName] as '@MiddleName',
		[Employee].[LastName] as '@LastName',
		[Employee].[FileAs] as '@FileAs',
		[Employee].[BirthDate] as '@BirthDate',
		[Employee].[Initials] as '@ShortName',
		[Employee].[Suffix] as '@Suffix',
		[Employee].[Title] as '@Title',
		
		[Employee].[Modified] as '@Modified',
		[ExchangeSync].[Date] as '@LastSync',
		[Employee].[NextContact] as '@NextContact',
		[Position].[FileAs] as '@Position',
		[Division].[FileAs] as '@Division',
		[Company].[FileAs] as '@Company',
		[Employee].[Comments] as '@Comment',
		--addresses
		[LegalAddress].[Street]		as '@LegalStreet',
		[LegalAddress].[City]		as '@LegalCity',
		[LegalAddress].[Region]		as '@LegalRegion',
		[LegalAddress].[PostalCode] as '@LegalPostalCode',
		[LegalAddress].[Country]	as '@LegalCountry',
		[LegalAddress].[Mail]		as '@LegalMail',
		[HomeAddress].[Street]		as '@HomeStreet',
		[HomeAddress].[City]		as '@HomeCity',
		[HomeAddress].[Region]		as '@HomeRegion',
		[HomeAddress].[PostalCode]	as '@HomePostalCode',
		[HomeAddress].[Country]		as '@HomeCountry',
		[HomeAddress].[Mail]		as '@HomeMail',
		[OtherAddress].[Street]		as '@OtherStreet',
		[OtherAddress].[City]		as '@OtherCity',
		[OtherAddress].[Region]		as '@OtherRegion',
		[OtherAddress].[PostalCode] as '@OtherPostalCode',
		[OtherAddress].[Country]	as '@OtherCountry',
		[OtherAddress].[Mail]		as '@OtherMail',
		--emails
		(SELECT [Email] FROM [Email] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [EmailTypeID] = 1) as '@Email',
		(SELECT [Email] FROM [Email] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [EmailTypeID] = 2) as '@Email2',
		(SELECT [Email] FROM [Email] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [EmailTypeID] = 3) as '@Email3',
		(SELECT [Email] FROM [Email] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [EmailTypeID] = 4) as '@WebPage',
		-- phone numbers
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 1) as '@WorkPhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 2) as '@HomePhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 3) as '@MobilePhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 4) as '@OtherPhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 5) as '@HelperPhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 6) as '@Work2Phone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 7) as '@CompanyPhone',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 8) as '@WorkFax',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 9) as '@HomeFax',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 10) as '@AddFax',
		(SELECT [Phone] FROM [Phone] WHERE [BusinessCardClass] = @EmployeeClass AND [BusinessCardID] = [Employee].[ID]
			AND [PhoneTypeID] = 11) as '@BasePhone',
		CASE WHEN
			[ExtendedProperties].exist('/ExtendedProperties/Values/PictureHash') = 0 THEN [ExtendedProperties]
			ELSE
				(
				SELECT
					[ExtendedProperties].value('(/ExtendedProperties/Values/PhoneSelector1)[1]', 'varchar(2)') as 'Values/PhoneSelector1',
					[ExtendedProperties].value('(/ExtendedProperties/Values/PhoneSelector2)[1]', 'varchar(2)') as 'Values/PhoneSelector2',
					[ExtendedProperties].value('(/ExtendedProperties/Values/PhoneSelector3)[1]', 'varchar(2)') as 'Values/PhoneSelector3',
					[ExtendedProperties].value('(/ExtendedProperties/Values/PhoneSelector4)[1]', 'varchar(2)') as 'Values/PhoneSelector4',
					[ExtendedProperties].value('(/ExtendedProperties/Values/AddressSelector)[1]', 'varchar(2)') as 'Values/AddressSelector',
					[ExtendedProperties].value('(/ExtendedProperties/Values/EmailSelector)[1]', 'varchar(2)') as 'Values/EmailSelector',
					[ExtendedProperties].value('(/ExtendedProperties/Values/WebPageSelector)[1]', 'varchar(2)') as 'Values/WebPageSelector',
					[ExtendedProperties].value('(/ExtendedProperties/Values/IdentityCardType)[1]', 'varchar(2)') as 'Values/IdentityCardType',
					[ExtendedProperties].value('(/ExtendedProperties/Values/Gender)[1]', 'varchar(2)') as 'Values/Gender',
					[ExtendedProperties].value('(/ExtendedProperties/Values/PictureHash)[1]', 'varchar(24)') as 'Values/PictureHash'
				FOR XML PATH('ExtendedProperties'), TYPE
				)
		END as [ExtendedProperties]
	FROM
		[UserContact]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [UserContact].[BusinessCardID] AND [userContact].BusinessCardClass = @EmployeeClass
		LEFT OUTER JOIN [Position]
			ON [Position].[ID] = [Employee].[PositionID]
		LEFT OUTER JOIN [Division]
			ON [Division].[ID] = [Employee].[DivisionID]
		LEFT OUTER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
		LEFT OUTER JOIN [Address] as [LegalAddress]
			ON [LegalAddress].[BusinessCardClass] = @EmployeeClass AND [LegalAddress].[BusinessCardID] = [Employee].[ID] AND [LegalAddress].[AddressTypeID] = 1
		LEFT OUTER JOIN [Address] as [HomeAddress]
			ON [HomeAddress].[BusinessCardClass] = @EmployeeClass AND [HomeAddress].[BusinessCardID] = [Employee].[ID] AND [HomeAddress].[AddressTypeID] = 3
		LEFT OUTER JOIN [Address] as [OtherAddress]
			ON [OtherAddress].[BusinessCardClass] = @EmployeeClass AND [OtherAddress].[BusinessCardID] = [Employee].[ID] AND [OtherAddress].[AddressTypeID] = 4
		LEFT OUTER JOIN [ExchangeSync]
			ON [ExchangeSync].[DocumentClass] = [Employee].[Class] AND [ExchangeSync].[DocumentID] = [Employee].[ID] AND [ExchangeSync].[UserID] = @UserID
		LEFT OUTER JOIN [ExtendedProperties]
			ON [Employee].[ID] = [ExtendedProperties].[ID] AND [Employee].[Class] = [ExtendedProperties].[Class]
		
	WHERE
		[UserContact].[UserID] = @UserID
	FOR XML PATH('Contact'), TYPE)
	FOR XML PATH('Contacts'), TYPE
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6ExchangeSyncGetContacts TO PUBLIC
GO

