IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseUpdate'
		DROP PROCEDURE [dbo].[pjm5ExpenseUpdate]
	END
GO

PRINT 'Creating procedure pjm5ExpenseUpdate'
GO

/******************************************************************************
**		File: pjm5ExpenseUpdate.sql
**		Name: pjm5ExpenseUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      30.09.10    BVY                ,     .
**		13.09.12	MAB				   Amount c TCount  TAmount
*******************************************************************************/
CREATE PROCEDURE pjm5ExpenseUpdate
	@Xml XML
AS
	DECLARE
		@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@ExpenseCodeID TIdentifier,
		@Date TDateTime,
		@Amount TAmount,
		@Billable TBool,
		@Price TMoney,
		@FromCurrencyCode TCode3,
		@ToCurrencyCode TCode3,
		@CurrencyRate TMoney,
		@VATRate TPercent,
		@VAT TMoney,
		@VATIsIncluded TBool,
		@Comments TNotes,
		@EmployeeID TIdentifier,
		@Doc int,
		@rv int,
		@MyEmployeeID int,
		@PhoneCallCodeID TIdentifier,
		@State TState,
		@OldAssignmentID TIdentifier,
		@UOMID TIdentifier
		
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID = [XmlTable].[ID],
		@FileAs = [XmlTable].[FileAs],
		@ProjectID = [XmlTable].[ProjectID],
		@DocumentClass = dbo.adfGetClassByName([XmlTable].[DocumentClass]),
		@DocumentID = [XmlTable].[DocumentID],
		@TaskID = [XmlTable].[TaskID],
		@ExpenseCodeID = [XmlTable].[ExpenseCodeID],
		@Date = CAST([XmlTable].[Date] as datetime),
		@Amount = [XmlTable].[Amount],
		@Billable = (CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END),
		@Price = [XmlTable].[Price],
		@FromCurrencyCode = [XmlTable].[FromCurrencyCode],
		@ToCurrencyCode = [Project].[CurrencyCode],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@VATIsIncluded = CASE WHEN [VATIsIncluded] = 'false' THEN 0 ELSE 1 END,
		@VATRate = [XmlTable].[VATRate],
		@VAT = [XmlTable].[VAT],
		@Comments = [XmlTable].[Comments],
		@EmployeeID = [XmlTable].[EmployeeID],
		@PhoneCallCodeID = [XmlTable].[PhoneCallCodeID],
		@UOMID = [XmlTable].[UOMID]
	FROM
		OPENXML(@Doc, '/pjm5ExpenseGet/Expense', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[ExpenseCodeID] int,
				[EmployeeID] int,
				[ProjectID] int,
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[TaskID] int,
				[Date] varchar(19),
				[Amount] decimal(18,4),
				[Billable] varchar(5),
				[Price] money,
				[VATIsIncluded] varchar(5),
				[VATRate] decimal(18,4),
				[VAT] decimal(18,4),
				[FromCurrencyCode] char(3),
				[CurrencyRate] decimal(18,4),
				[Comments] nvarchar(max),
				[PhoneCallCodeID] int,
				[UOMID] int
			) as [XmlTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]

	EXEC sp_xml_removedocument @doc



	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NULL
	BEGIN
		RAISERROR('#PhoneCallCodeIsNotDefined', 18, -1)
		RETURN 1
	END
	

IF @DocumentID IS NULL AND @DocumentClass IS NOT NULL
BEGIN
	SET @DocumentClass = NULL 
END
	
	SELECT 
		@State = [State]
	FROM 
		[Expense] 
	WHERE 
		[ID] = @ID
	

	BEGIN TRANSACTION
	IF @State = 5
	BEGIN
		EXEC @rv = pjm5ExpenseChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	EXEC @rv = pjm5ExpenseUpdateInternal
		@ID,
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@ExpenseCodeID,
		@Date,
		@UOMID,
		@Amount,
		@Billable,
		@Price,
		@FromCurrencyCode,
		@ToCurrencyCode,
		@CurrencyRate,
		@VATRate,
		@VATIsIncluded,
		@Vat,
		@Comments

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NOT NULL
	BEGIN
		UPDATE 
			[PhoneCall]
		SET
			[PhoneCallCodeID] = @PhoneCallCodeID
		WHERE
			[ExpenseID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION

	EXEC pjm5ExpenseGet @ID

	RETURN 0
GO



GRANT EXECUTE ON pjm5ExpenseUpdate TO PUBLIC
GO
 