IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureDraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureBrowse'
		DROP PROCEDURE [dbo].[pjm5FactureDraftBrowse]
	END
GO

PRINT 'Creating procedure pjm5FactureBrowse'
GO

/******************************************************************************
**		File: pjm5FactureBrowse.sql
**		Name: pjm5FactureBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureDraftBrowse]
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool

	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Flag],
		[Facture].[FileAs],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[ProjectID],
		[Facture].[SupplierCompanyID],
		[Facture].[SupplierAddress],
		[Facture].[SupplierINN],
		[Facture].[SupplierKPP],
		[Facture].[CustomerCompanyID],
		[Facture].[CustomerAddress],
		[Facture].[CustomerINN],
		[Facture].[CustomerKPP],
		[Facture].[Sender],
		[Facture].[Recipient],
		[Facture].[DocumentNumber],
		[Facture].[DocumentDate],
		[Facture].[Chief],
		[Facture].[Accountant],
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy],
		[Facture].[Comments],
		[Facture].[Timestamp],
		[Facture].[Advance],
		[Facture].[CurrencyCode],
		[Facture].[Total],
		[Facture].[VAT],
		[Facture].[TotalWithVAT],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Facture].[ExchangeBanned]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Project].[ID] = [Facture].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		[Facture].[State] = 1 AND
		(@ViewAllProjects = 1 OR dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FactureDraftBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureBrowse'
		DROP PROCEDURE [dbo].[pjm5FactureBrowse]
	END
GO

PRINT 'Creating procedure pjm5FactureBrowse'
GO

/******************************************************************************
**		File: pjm5FactureBrowse.sql
**		Name: pjm5FactureBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureBrowse]
	@StateSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool

	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
		
	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Flag],
		[Facture].[FileAs],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[ProjectID],
		[Facture].[SupplierCompanyID],
		[Facture].[SupplierAddress],
		[Facture].[SupplierINN],
		[Facture].[SupplierKPP],
		[Facture].[CustomerCompanyID],
		[Facture].[CustomerAddress],
		[Facture].[CustomerINN],
		[Facture].[CustomerKPP],
		[Facture].[Sender],
		[Facture].[Recipient],
		[Facture].[DocumentNumber],
		[Facture].[DocumentDate],
		[Facture].[Chief],
		[Facture].[Accountant],
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy],
		[Facture].[Comments],
		[Facture].[Timestamp],
		[Facture].[Advance],
		[Facture].[CurrencyCode],
		[Facture].[Total],
		[Facture].[VAT],
		[Facture].[TotalWithVAT],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Facture].[ExchangeBanned]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Project].[ID] = [Facture].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		(@DateSelector = 0 OR [Facture].[Date] BETWEEN @PeriodStart AND @PeriodEnd) AND
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 4 AND [Facture].[State] != 3) OR
			(@StateSelector != 0 AND [Facture].[State] = @StateSelector)
		) AND
		(@ViewAllProjects = 1 OR dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FactureBrowse] TO PUBLIC
GO
