IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureCreate'
		DROP PROCEDURE [dbo].[pjm5FactureCreate]
	END
GO

PRINT 'Creating procedure pjm5FactureCreate'
GO

/******************************************************************************
**		File: pjm5FactureCreate.sql
**		Name: pjm5FactureCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureCreate]
	@Xml XML
AS
	SET NOCOUNT ON

	DECLARE
		@FileAs TName,
		@Date TDate,
		@Number TCode,

		@ProjectID TIdentifier,
		@CurrencyCode TCode,
		@CurrencyRate TAmount,
		@Scale TCount,

		@SupplierCompanyID TIdentifier,
		@SupplierAddress TNotes,
		@SupplierINN TName,
		@SupplierKPP TCode,
		@CustomerCompanyID TIdentifier,
		@CustomerAddress TNotes,
		@CustomerINN TName,
		@CustomerKPP TCode,
		@Sender TNotes,
		@Recipient TNotes,
		@DocumentNumber TName,
		@DocumentDate TDate,
		@Chief TName,
		@Accountant TName,
		@Comments TNotes,
		@Advance TBool,
		@ExchangeBanned TBool,
		
		@value TVariant,			
		@doc int

	DECLARE @State TState,
			@ID TIdentifier
	
	SET @State = dbo.adfwfGetInitialState('55bf9030-b268-4094-8610-0408eef8a713')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT 
		@FileAs = ISNULL([XMLTable].[FileAs], '  '),
		@Date = CONVERT(datetime, [XMLTable].[Date]),
		@Number = ISNULL([XMLTable].[Number], ''),

		@ProjectID = [XMLTable].[ProjectID],
		@CurrencyCode = [XMLTable].[CurrencyCode],
		@CurrencyRate = [XMLTable].[CurrencyRate],
		@Scale = [Project].[Scale],

		@SupplierCompanyID = [XMLTable].[SupplierCompanyID],
		@SupplierAddress = [XMLTable].[SupplierAddress],
		@SupplierINN = [XMLTable].[SupplierINN],
		@SupplierKPP = [XMLTable].[SupplierKPP],
		@CustomerCompanyID = [XMLTable].[CustomerCompanyID],
		@CustomerAddress = [XMLTable].[CustomerAddress],
		@CustomerINN = [XMLTable].[CustomerINN],
		@CustomerKPP = [XMLTable].[CustomerKPP],
		@Sender = [XMLTable].[Sender],
		@Recipient = [XMLTable].[Recipient],
		@DocumentNumber = [XMLTable].[DocumentNumber],
		@DocumentDate = [XMLTable].[DocumentDate],
		@Comments = [XMLTable].[Comments],
		@Advance = CASE [XMLTable].[Advance] WHEN 'false' THEN 0 ELSE 1 END,
		@ExchangeBanned = CASE [XMLTable].[ExchangeBanned] WHEN 'false' THEN 0 ELSE 1 END
	FROM
		OPENXML(@doc, '/pjm5FactureGet/Facture', 2)
			WITH (
				[FileAs] varchar(512),
				[Date] varchar(19),
				[Number] varchar(32),
				[ProjectID] int,
				[CurrencyCode] varchar(3),
				[CurrencyRate] decimal(18,4),
				[Scale] int,
				[SupplierCompanyID] int,
				[SupplierAddress] varchar(512),
				[SupplierINN] varchar(512),
				[SupplierKPP] varchar(512),
				[CustomerCompanyID] int,
				[CustomerAddress] varchar(512),
				[CustomerINN] varchar(512),
				[CustomerKPP] varchar(512),
				[Sender] varchar(512),
				[Recipient] varchar(512),
				[DocumentNumber] varchar(512),
				[DocumentDate] varchar(19),
				[Comments] nvarchar(max),
				[Advance] varchar(5),
				[ExchangeBanned] varchar(5)
			) [XMLTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]

	DECLARE @payments TABLE([PaymentID] int)
	INSERT INTO @payments SELECT [PaymentID] FROM OPENXML(@doc, '/pjm5FactureGet/Payment', 2)	WITH ([PaymentID] INT)
	
	EXEC sp_xml_removedocument @doc
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	SELECT
		@Chief = COALESCE(
			dbo.adfPropertyValueGetText([Chief].[Class], [Chief].[ID], '00000002-0000-0000-0000-000000000000'),
			[Chief].[LastName] + ISNULL(' ' + [Chief].[FirstName], '') + ISNULL(' ' + [Chief].[MiddleName], ''), 
			[Chief].[FileAs]), 
		@Accountant = COALESCE(
			dbo.adfPropertyValueGetText([Accountant].[Class], [Accountant].[ID], '00000002-0000-0000-0000-000000000000'), 
			[Accountant].[LastName] + ISNULL(' ' + [Accountant].[FirstName], '') + ISNULL(' ' + [Accountant].[MiddleName], ''), 
			[Accountant].[FileAs])
	FROM
		[Company]
		LEFT OUTER JOIN [Employee] AS [Chief]
			ON [Chief].[ID] = [Company].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [Accountant]
			ON [Accountant].[ID] = [Company].[AccountantEmployeeID]
	WHERE		
		[Company].[ID] = @SupplierCompanyID
	
	DECLARE @PaymentClass TClass, @FactureClass TClass
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	
	BEGIN TRANSACTION
	INSERT INTO [Facture]
		([Flag], [State], [FileAs], [Date], [Number], [SupplierCompanyID], [SupplierAddress], [SupplierINN], [SupplierKPP], [CustomerCompanyID], [CustomerAddress], [CustomerINN], [CustomerKPP], [Sender], [Recipient], [DocumentNumber], [DocumentDate], [Chief], [Accountant], [Comments],
		[ProjectID], [CurrencyCode], [CurrencyRate], [Scale],
		[Total], [TotalWithVAT], [TotalPC], [TotalWithVATPC],[Advance], [ExchangeBanned])
	VALUES
		(0, @State, @FileAs, @Date, @Number, @SupplierCompanyID, @SupplierAddress, @SupplierINN, @SupplierKPP, @CustomerCompanyID, @CustomerAddress, @CustomerINN, @CustomerKPP, @Sender, @Recipient, @DocumentNumber, @DocumentDate, @Chief, @Accountant, @Comments,
		@ProjectID, @CurrencyCode, @CurrencyRate, @Scale,
		0,0,0,0,
		@Advance, @ExchangeBanned)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [FacturePayment]([FactureID], [PaymentID]) SELECT @ID, [PaymentID] FROM @payments
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	SELECT
		@PaymentClass, [PaymentID], '-',
		@FactureClass, [FactureID], 3	
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	EXEC pjm5FactureGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureCreate TO PUBLIC
GO
 