IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureGet'
		DROP PROCEDURE [dbo].[pjm5FactureGet]
	END
GO

PRINT 'Creating procedure pjm5FactureGet'
GO

/******************************************************************************
**		File: pjm5FactureGet.sql
**		Name: pjm5FactureGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE
		@ProjectID TIdentifier,
		@Class	TClass
	SELECT
		@ProjectID = [Facture].[ProjectID],
		@Class = [Facture].[Class]
	FROM 
		[Facture]
	WHERE
		[Facture].[ID] = @ID
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, @Class, NULL) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Flag],
		[Facture].[FileAs],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[ProjectID],
		[Facture].[CurrencyCode],
		[Facture].[CurrencyRate],
		[Facture].[Scale],
		[Facture].[SupplierCompanyID],
		[Facture].[SupplierAddress],
		[Facture].[SupplierINN],
		[Facture].[SupplierKPP],
		[Facture].[CustomerCompanyID],
		[Facture].[CustomerAddress],
		[Facture].[CustomerINN],
		[Facture].[CustomerKPP],
		[Facture].[Sender],
		[Facture].[Recipient],
		[Facture].[DocumentNumber],
		[Facture].[DocumentDate],
		[Facture].[Chief],
		[Facture].[Accountant],
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy],
		[Facture].[Comments],
		[Facture].[Timestamp],
		[Facture].[Advance],
		[Facture].[Total],
		[Facture].[VAT],
		[Facture].[TotalWithVAT],
		[Facture].[TotalPC],
		[Facture].[VATPC],
		[Facture].[TotalWithVATPC],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Facture].[ExchangeBanned],
		[ExportItem].[Date] as [Exported],
		[ExportItem].[EmployeeID] as [ExportedBy]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [ExportItem]
			ON [ExportItem].[ID] = [Facture].[ExportItemID]
	WHERE
		[Facture].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	
	SELECT
		[FactureLine].[ID],
		[FactureLine].[FactureID],
		[FactureLine].[DocumentClass],
		[FactureLine].[DocumentID],
		[FactureLine].[UOMID],
		[FactureLine].[Amount],
		[FactureLine].[VATIsIncluded], 
		[FactureLine].[VATRate], 
		[FactureLine].[OriginalPrice],
		[FactureLine].[Price],
		[FactureLine].[Total],
		[FactureLine].[Excise],
		[FactureLine].[VAT],
		[FactureLine].[TotalWithVAT],
		[FactureLine].[OriginalPricePC],
		[FactureLine].[PricePC],
		[FactureLine].[TotalPC],
		[FactureLine].[ExcisePC],
		[FactureLine].[VATPC],
		[FactureLine].[TotalWithVATPC],
		[FactureLine].[Country],
		[FactureLine].[CustomDeclaration],
		[FactureLine].[Description],
		[UOM].[Code] AS [UOM],
		[FactureLine].[BasePrice],
		[FactureLine].[SortKey]
	FROM
		[FactureLine]
		LEFT OUTER JOIN [UOM]
			ON [UOM].[ID] = [FactureLine].[UOMID]
	WHERE
		[FactureLine].[FactureID] = @ID
	ORDER BY 
		[FactureLine].[Description]
	
	SELECT
		[FactureID],
		[PaymentID]
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @ID
	

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FactureGet] TO PUBLIC
GO

 