 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueFind'
		DROP PROCEDURE [dbo].[pjm5IssueFind]
	END
GO

PRINT 'Creating procedure pjm5IssueFind'
GO

/******************************************************************************
**		File: pjm5IssueFind.sql
**		Name: pjm5IssueFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Issue].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		[Issue].[Class],
		[Issue].[ID],
		[Issue].[State],
		[Issue].[DueDate],
		[Issue].[Number],
		[Issue].[FileAs],
		[Issue].[Comments],
		[Issue].[ProjectID],
		[Issue].[Flag],
		[Issue].[Created],
		[Issue].[CreatedBy],
		[Issue].[Modified],
		[Issue].[ModifiedBy]
	FROM
		[Issue] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Issue].[ProjectID] = [P].[ID])
	WHERE
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Issue].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Issue].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Issue].[FileAs] LIKE '%' + @Text + '%' OR [Issue].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Issue].[Number] LIKE '%' + @Text + '%' OR [Issue].[FileAs] LIKE '%' + @Text + '%' OR [Issue].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Issue].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Issue].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND [EmployeeID] = @EmployeeID)
			OR
			(@UserOption = 1 AND ([CreatedBy] = @UserID OR [ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Issue].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Issue].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Issue].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5IssueFind] TO PUBLIC
GO 