IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderCaseUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderCaseUpdate'
		DROP PROCEDURE [dbo].[pjm5FolderCaseUpdate]
	END
GO

PRINT 'Creating procedure pjm5FolderCaseUpdate'
GO

/******************************************************************************
**		File: pjm5FolderCaseUpdate.sql
**		Name: pjm5FolderCaseUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5FolderCaseUpdate
	@FolderID TIdentifier,
	@CaseID TIdentifier,
	@Allowed TBool
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION
	UPDATE 
		[CaseOfFolder]
	SET
		[Allowed] = @Allowed
	WHERE
		[FolderID] = @FolderID AND
		[CaseID] = @CaseID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5FolderCaseUpdate TO PUBLIC
GO
