IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FreeBusyBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FreeBusyBrowse'
		DROP PROCEDURE [dbo].[pjm5FreeBusyBrowse]
	END
GO

PRINT 'Creating procedure pjm5FreeBusyBrowse'
GO

/******************************************************************************
**		File: pjm5FreeBusyBrowse.sql
**		Name: pjm5FreeBusyBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 09/06/2006 19:34:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FreeBusyBrowse]
	@ItemType TName,
	@ID TIdentifier,
	@Date TDate
AS
	SET NOCOUNT ON
	
	
	SET @Date = CONVERT(datetime, CONVERT(nvarchar(8), @Date, 112), 112)
	
	IF @ItemType = 'Employee'
	BEGIN
		SELECT
			[Class],
			[ID],
			(CASE WHEN [State] = 1 THEN 'Tentative' ELSE 'Busy' END) as [State],
			[StartTime],
			[Duration]
		FROM
			[TimeEntry]
		WHERE
			CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112) = @Date
		AND
			[EmployeeID] = @ID
		AND
			[State] IN (1, 2, 3, 5, 6)
		
		SELECT
			[Class],
			[ID],
			(CASE WHEN [State] = 1 THEN 'Tentative' ELSE (CASE WHEN [ResponseType]='Accept' THEN 'Busy' ELSE 'Tentative' END) END) as [State],
			[StartTime],
			[Duration]
		FROM
			(
			SELECT
				[MeetingRequest].[Class],
				[MeetingRequest].[ID],
				[MeetingRequest].[OriginatorEmployeeID] as [EmployeeID],
				[MeetingRequest].[State],
				[MeetingRequest].[StartTime],
				[MeetingRequest].[Duration],
				CAST('Accept' as varchar(32)) as [ResponseType]
			FROM
				[MeetingRequest]
			WHERE
				CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112) = @Date
			AND
				[OriginatorEmployeeID] = @ID
			AND
				(
					[State] = 2
				OR
					([State] = 1 AND [OriginatorEmployeeID] = dbo.adfGetCurrentEmployeeID())
				)
			UNION ALL
			SELECT
				[MeetingRequest].[Class],
				[MeetingRequest].[ID],
				[Attendee].[EmployeeID] as [EmployeeID],
				[MeetingRequest].[State],
				[MeetingRequest].[StartTime],
				[MeetingRequest].[Duration],
				ISNULL([Attendee].[ResponseType], 'Tentative') as [ResponseType]
			FROM
				[MeetingRequest] INNER JOIN [Attendee]
					ON ([MeetingRequest].[ID] = [Attendee].[MeetingRequestID])
			WHERE
				CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112) = @Date
			AND
				[Attendee].[EmployeeID] = @ID
			AND
				(
					[State] = 2	
				OR
					([State] = 1 AND [MeetingRequest].[OriginatorEmployeeID] = dbo.adfGetCurrentEmployeeID())
				)
			) as [S]
		WHERE
			[EmployeeID] = @ID AND [ResponseType] != 'Decline'
		
	END
	ELSE IF @ItemType = 'Resource'
	BEGIN
		SELECT
			[Class],
			ISNULL([MeetingRequestID], 0) as [ID],
			(CASE WHEN [State] IN (1, 2) THEN 'Tentative' ELSE 'Busy' END) as [State],
			[StartTime],
			[Duration]
		FROM
			[ResourceRequest]
		WHERE
			[ResourceID] = @ID
		AND
			CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112) = @Date
		AND
		(
			[State] IN (2, 3)
		OR
			([State]=1 AND [EmployeeID] = dbo.adfGetCurrentEmployeeID())
		)
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FreeBusyBrowse] TO PUBLIC
GO
 