 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceSuspicious]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceSuspicious'
		DROP PROCEDURE [dbo].[pjm5InvoiceSuspicious]
	END
GO

PRINT 'Creating procedure pjm5InvoiceSuspicious'
GO

/******************************************************************************
**		File: pjm5InvoiceSuspicious.sql
**		Name: pjm5InvoiceSuspicious
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm5InvoiceSuspicious
	@ID TIdentifier
AS
BEGIN
	DECLARE
		@TotalWithVAT TMoney,
		@TotalWithVATPC TMoney,
		@TotalWithVATBC TMoney,
		@CurrencyRate TAmount,
		@BaseCurrencyRate TAmount
		
	SELECT
		@TotalWithVAT = [TotalWithVAT],
		@TotalWithVATPC = [TotalWithVATPC],
		@TotalWithVATBC = [TotalWithVATBC],
		@CurrencyRate = [CurrencyRate],
		@BaseCurrencyRate = [BaseCurrencyRate]
	FROM
		[Invoice]
	WHERE
		[ID] = @ID
		
	IF NOT(
		(
		@TotalWithVAT * @CurrencyRate > @TotalWithVATPC * 0.9 AND @TotalWithVAT * @CurrencyRate < @TotalWithVATPC * 1.1 
		OR
		@TotalWithVAT / @CurrencyRate > @TotalWithVATPC * 0.9 AND @TotalWithVAT / @CurrencyRate < @TotalWithVATPC * 1.1
		) 
		AND
		(
		@TotalWithVATPC * @BaseCurrencyRate > @TotalWithVATBC * 0.9 AND @TotalWithVATPC * @BaseCurrencyRate < @TotalWithVATBC * 1.1 
		OR
		@TotalWithVATPC / @BaseCurrencyRate > @TotalWithVATBC * 0.9 AND @TotalWithVATPC / @BaseCurrencyRate < @TotalWithVATBC * 1.1
		)
	)
	BEGIN
		RETURN 1
	END
	
	RETURN 0
END
GO

GRANT EXECUTE ON pjm5InvoiceSuspicious TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceChangeState'
		DROP PROCEDURE [dbo].[pjm5InvoiceChangeState]
	END
GO

PRINT 'Creating procedure pjm5InvoiceChangeState'
GO

/******************************************************************************
**		File: pjm5InvoiceChangeState.sql
**		Name: pjm5InvoiceChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    14.05.10		SYV				  pjm6DismissEventsOnObjec  
**									pjm5AllUserReminderDismiss    
**    24.08.10		SYV				  pjm6DismissEventsOnObject .. 
**									        
*******************************************************************************/
CREATE PROCEDURE pjm5InvoiceChangeState
	@ID TIdentifier,
	@ToState TState,
	@Forced TBool
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@rv int,
			@Date TDate

	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Invoice].[Class],
		@FromState = [Invoice].[State],
		@ProjectID = [Invoice].[ProjectID],
		@Date = [Invoice].[Date]
	FROM
		[Invoice]
	WHERE
		[Invoice].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @Forced = 0 AND @FromState = 1 AND @ToState = 2
	BEGIN
		EXEC @rv = pjm5InvoiceSuspicious @ID
		IF @rv != 0
		BEGIN
			RAISERROR('?SuspiciousData', 18, -1)
			RETURN 1
		END
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	IF @FromState IN (1, 6) AND @ToState = 2
	BEGIN
		EXEC @rv = pjm5InvoiceCreateRecurrence @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		UPDATE [Document]
		SET [RecurrencePatternID] = NULL
		WHERE [Class] = @Class AND [ID] = @ID
	END
		
	UPDATE
		[Invoice]
	SET
		[Invoice].[State] = @ToState,
		[Invoice].[Modified] = DEFAULT,
		[Invoice].[ModifiedBy] = DEFAULT
	WHERE
		[Invoice].[ID] = @ID
	AND
		[Invoice].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF (@ToState = 3 OR @ToState = 5)
	BEGIN
		--EXEC pjm6DismissEventsOnObject @Class, @ID
		
		DECLARE @ReminderID TIdentifier
		SELECT 
			@ReminderID = [ID]
		FROM 
			[Reminder]
		WHERE 
			[DocumentClass] = @Class
			AND [DocumentID] = @ID 
			
		IF @ReminderID IS NOT NULL
		BEGIN
			EXEC pjm5AllUserReminderDismiss @ReminderID
		END	
	END	

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5InvoiceChangeState TO PUBLIC
GO
