IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueBrowseByCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueBrowseByCategory'
		DROP PROCEDURE [dbo].[pjm5IssueBrowseByCategory]
	END
GO

PRINT 'Creating procedure pjm5IssueBrowseByCategory'
GO

/******************************************************************************
**		File: pjm5IssueBrowseByCategory.sql
**		Name: pjm5IssueBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueBrowseByCategory]
	@StateSelector INT,
	@EmployeeOnly BIT,
	@ProjectID INT
AS

	/*
	@StateSelector description:
		0 - all, 1 - active, 2 - closed, 3 - resolved, 4 - postponed, 5 - submited
	*/

	SET NOCOUNT ON
	
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	DECLARE	@userID int
	SET	@userID = dbo.adfGetCurrentUserID()
	
	DECLARE @IssueClass TClass
	SET @IssueClass = dbo.adfGetClassByName('Pjm5.Issue')

	DECLARE @none nvarchar(6)
	IF dbo.adfGetLanguage() = 'ru'
		SET @none = '()'
	ELSE
		SET @none = '(none)'
		
	SELECT
		[Issue].[Class],
		[Issue].[ID],
		[Issue].[State],
		[Issue].[Flag],
		[Issue].[Number],
		[Issue].[FileAs],
		[Issue].[DuplicateOfIssueID],
		[Issue].[ProjectID],
		[Issue].[EmployeeID],
		[Issue].[SeverityID],
		[Issue].[PriorityID],
		[Issue].[DueDate],
		[Issue].[EndTime],
		[Issue].[ResolutionID],
		[Issue].[Resolution],
		[Issue].[SendStatusReport],
		[Issue].[WSSDocumentURL],
		[Issue].[UDF1],
		[Issue].[UDF2],
		[Issue].[UDF3],
		[Issue].[UDF4],
		[Issue].[Comments],
		[Issue].[Created],
		[Issue].[CreatedBy],
		[Issue].[Modified],
		[Issue].[ModifiedBy],
		[Issue].[Timestamp],
		ISNULL([Category].[FileAs],@none) as [Category],
		CAST(ISNULL([DocumentUserState].[Read], 0) as bit) as [Read],
		[DocumentUserState].[ReadTime],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[ActualBudget]
			ELSE -1
		END AS [ActualBudget],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[Budget]
			ELSE -1
		END AS [Budget],
		[Issue].[ActualManHour],
		[Issue].[ManHour]
	FROM
		[Issue]
		INNER JOIN [Project] ON [Project].[ID] = [Issue].[ProjectID]
		LEFT OUTER JOIN [DocumentUserState]
			ON ([DocumentUserState].[UserID] = @UserID AND 
				[DocumentUserState].[DocumentClass] = @IssueClass AND 
				[DocumentUserState].[DocumentID] = [Issue].[ID])
		LEFT OUTER JOIN [DocumentCategory]
			ON ([Issue].[Class] = [DocumentCategory].[DocumentClass] AND [Issue].[ID] = [DocumentCategory].[DocumentID])
		LEFT OUTER JOIN [Category]
			ON ([DocumentCategory].[CategoryID] = [Category].[ID])
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [Issue].[State] = 3) OR
			(@StateSelector = 2 AND [Issue].[State] = 5) OR
			(@StateSelector = 3 AND [Issue].[State] = 4) OR
			(@StateSelector = 4 AND [Issue].[State] = 6) OR
			(@StateSelector = 5 AND [Issue].[State] = 2) 
		)
		AND
		(
				@EmployeeOnly = 0 
			OR 
				(@EmployeeOnly != 0 AND [Issue].[EmployeeID] = @EmployeeID)
		)
		AND 
		(
			(@ProjectID > 0 AND [Issue].[ProjectID] = @ProjectID)
			OR 
			(@ProjectID = -1 AND [Issue].[ProjectID] IN (SELECT [ProjectID] FROM [IssueProject] WHERE [UserID] = @userId))
			OR
			(@ProjectID = -2 AND [Issue].[ProjectID] IN (SELECT [ID] FROM [Project]	WHERE
				[State] = 2 AND [Project].[SupportsRequestManagement] != 0
				AND
				([ProjectManagerEmployeeID] = @EmployeeID OR  
				dbo.fnPjm5IsProjectMember([Project].[ID], @EmployeeID) = 1 OR
				dbo.fnPjm5IsAssistant() = 1)))
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5IssueBrowseByCategory] TO PUBLIC
GO
 