IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trIssueUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm5trIssueUpdate'
		DROP  Trigger pjm5trIssueUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trIssueUpdate
**		Desc: 
**
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    11.02.10		SYV					      
**										  UserParameters  
*******************************************************************************/

PRINT 'Creating Trigger pjm5trIssueUpdate'
GO
CREATE TRIGGER pjm5trIssueUpdate ON [Issue] FOR UPDATE
AS
	SET NOCOUNT ON
	/*
		State = 3 ()        AssignmentID
	*/
	IF EXISTS(SELECT * FROM [inserted] WHERE [State] = 3 AND [EmployeeID] IS NULL)
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#issueassignmentnotspecified', 18, -1)
		RETURN
	END
	
	DECLARE @ToState TState,
			@FromState TState,
			@value TVariant,
			@Approve bit,
			@UserID int
	
	SET @value = NULL
	SET @UserID = dbo.adfGetCurrentUserID()		
	
	SELECT
		@FromState = [State]
	FROM
		[deleted]
	
	SELECT
		@ToState = [State]
	FROM
		[inserted]
	
	SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'TimeEntryApproveForDocumentInFinalState' AND [UserID] = @UserID
	SET @Approve = ISNULL(CAST(@value as bit), 0)
	
	IF @ToState = 5 AND @FromState IN (4, 6) AND @Approve = 1
	BEGIN
		DECLARE @DocumentClass TClass,
				@DocumentID TIdentifier
		SELECT
				@DocumentClass = [Class],
				@DocumentID = [ID]
		FROM
			[inserted]		
		EXEC pjm6TimeEntryAutoApproveForDocumentInFinalState @DocumentClass, @DocumentID
	END
	
	RETURN
GO

