IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmInvoiceLineType')
	BEGIN
		PRINT 'Dropping Procedure lmInvoiceLineType'
		DROP  Procedure  lmInvoiceLineType
	END

GO

PRINT 'Creating Procedure lmInvoiceLineType'
GO
/******************************************************************************
**		File: 
**		Name: lmInvoiceLineType
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmInvoiceLineType
AS
	SET NOCOUNT ON
	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @language = 'en'
	BEGIN
		SELECT 1 AS [ID], 'Custom' AS [Name], 1 AS [State]
		UNION
		SELECT 2, 'Calculation', 1
		UNION
		SELECT 3, 'Price-list', 1
		UNION
		SELECT 4, 'Order', 1
		UNION
		SELECT 5, 'Time', 1
		UNION
		SELECT 6, 'Expense', 1
	END
	ELSE
	BEGIN
		SELECT 1 AS [ID], '' AS [Name], 1 AS [State]
		UNION
		SELECT 2, '', 1
		UNION
		SELECT 3, '-', 1
		UNION
		SELECT 4, '', 1
		UNION
		SELECT 5, '', 1
		UNION
		SELECT 6, '', 1
	END	
	RETURN 0
GO

GRANT EXEC ON lmInvoiceLineType TO PUBLIC
GO
