 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmManagerAccessible')
	BEGIN
		PRINT 'Dropping Procedure lmManagerAccessible'
		DROP  Procedure  lmManagerAccessible
	END

GO

PRINT 'Creating Procedure lmManagerAccessible'
GO
/******************************************************************************
**		File: 
**		Name: lmManagerAccessible
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmManagerAccessible
AS
	SET NOCOUNT ON

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 1 OR dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllEmployees')) = 1
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Employee].[State]
		FROM
			[Employee]
			INNER JOIN [Project]
				ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
			INNER JOIN [Company]
				ON [Employee].[CompanyID] = [Company].[ID]	
		WHERE
			[Company].[Own] = 1
		GROUP BY 
			[Employee].[ID],
			[Employee].[FileAs],
			[Employee].[State]	
	
	RETURN 0
GO

GRANT EXEC ON lmManagerAccessible TO PUBLIC
GO
