IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[lmTask]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure lmTask'
		DROP PROCEDURE [dbo].[lmTask]
	END
GO

PRINT 'Creating procedure lmTask'
GO

/******************************************************************************
**		File: lmTask.sql
**		Name: lmTask
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [lmTask]
AS
	SET NOCOUNT ON
		
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()	
	
	SELECT
		[Task].[ID],
		[Task].[State],
		[Task].[FileAs] AS [Name],
		[Task].[ProjectID],
		[Task].[ParentID],
		[Task].[SubProjectID],
		CASE 
			WHEN
			 [Task].[ID] IN 
			 (
				SELECT 
					[TaskAssignment].[TaskID]
				FROM
					[TaskAssignment]
				WHERE
					[TaskAssignment].[State] = 1
					AND
					[TaskAssignment].[AssignmentID] IN
					(
						SELECT
							[vwAssignment].[ID]
						FROM
							[vwAssignment]
						WHERE
							[vwAssignment].[EmployeeID] = @EmployeeID
					)
			 )
			 THEN 1
			ELSE 0
		END AS [OWN]
	FROM
		[Task]
	WHERE
		[Task].[ProjectID] IN (SELECT [ID] FROM dbo.fnPjm5GetAvailableProjects()) OR
		[Task].[State] = 7
	
	RETURN 0
GO

GRANT EXECUTE ON [lmTask] TO PUBLIC
GO
 