 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AttendeeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AttendeeBrowse'
		DROP PROCEDURE [dbo].[pjm5AttendeeBrowse]
	END
GO

PRINT 'Creating procedure pjm5AttendeeBrowse'
GO

/******************************************************************************
**		File: pjm5AttendeeBrowse.sql
**		Name: pjm5AttendeeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5AttendeeBrowse]
	@NodeType nvarchar(128),
	@Id TIdentifier
AS
	SET NOCOUNT ON

	IF @NodeType = 'AllEmployeesNode'
	BEGIN
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Qualification].[FileAs] as [Qualification],
			[Company].[FileAs] as [Organization],
			(SELECT TOP 1 [Phone] FROM [Phone] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] ORDER BY [PhoneTypeID]) as [Phone],
			(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] < 4 ORDER BY [EmailTypeID]) as [Email]
		FROM
			[Employee] INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[Own]=1)
			LEFT OUTER JOIN [Qualification]
				ON ([Employee].[QualificationID] = [Qualification].[ID])
		WHERE
			[Employee].[State] = 1
	END	
	ELSE IF @NodeType = 'CompanyEmployeesNode'
	BEGIN
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Qualification].[FileAs] as [Qualification],
			[Company].[FileAs] as [Organization],
			(SELECT TOP 1 [Phone] FROM [Phone] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] ORDER BY [PhoneTypeID]) as [Phone],
			(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] < 4 ORDER BY [EmailTypeID]) as [Email]
		FROM
			[Employee] INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[Own]=1 AND [Company].[ID] = @ID)
			LEFT OUTER JOIN [Qualification]
				ON ([Employee].[QualificationID] = [Qualification].[ID])
		WHERE
			[Employee].[State] = 1
	END
	ELSE IF @NodeType = 'DivisionEmployeesNode'
	BEGIN
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Qualification].[FileAs] as [Qualification],
			[Company].[FileAs] as [Organization],
			(SELECT TOP 1 [Phone] FROM [Phone] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] ORDER BY [PhoneTypeID]) as [Phone],
			(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] < 4 ORDER BY [EmailTypeID]) as [Email]
		FROM
			[Employee] INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[Own]=1)
			LEFT OUTER JOIN [Qualification]
				ON ([Employee].[QualificationID] = [Qualification].[ID])
		WHERE
			[Employee].[State] = 1 AND [Employee].[DivisionID] = @ID
	END
	ELSE IF @NodeType = 'ProjectEmployeesNode'
	BEGIN
		SELECT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Qualification].[FileAs] as [Qualification],
			[Company].[FileAs] as [Organization],
			(SELECT TOP 1 [Phone] FROM [Phone] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] ORDER BY [PhoneTypeID]) as [Phone],
			(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] < 4 ORDER BY [EmailTypeID]) as [Email]
		FROM
			[vwAssignment] INNER JOIN [Employee] 
				ON ([vwAssignment].[EmployeeID] = [Employee].[ID])
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID])
			LEFT OUTER JOIN [Qualification]
				ON ([Employee].[QualificationID] = [Qualification].[ID])
		WHERE
			[vwAssignment].[ProjectID] = @ID
		AND
			[Employee].[State] = 1
		AND
			[vwAssignment].[State] = 1
	END
	
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5AttendeeBrowse] TO PUBLIC
GO
 