IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5MeetingRequestOwnCalendarBrowse')
	BEGIN
		PRINT 'Dropping Procedure pjm5MeetingRequestOwnCalendarBrowse'
		DROP  Procedure  pjm5MeetingRequestOwnCalendarBrowse
	END

GO

PRINT 'Creating Procedure pjm5MeetingRequestOwnCalendarBrowse'
GO
/******************************************************************************
**		File: 
**		Name: pjm5MeetingRequestOwnCalendarBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm5MeetingRequestOwnCalendarBrowse
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	DECLARE @employeeID int

	SET NOCOUNT ON
	
	SET @employeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[MeetingRequest].[Class],
		[MeetingRequest].[ID],
		[MeetingRequest].[State],
		[MeetingRequest].[FileAs],
		[MeetingRequest].[StartTime],
		DATEADD(minute, [MeetingRequest].[Duration], [MeetingRequest].[StartTime]) as [EndTime],
		[MeetingRequest].[ActivityTypeID],
		[MeetingRequest].[ProjectID],
		[Project].[Number] as [ProjectCode],
		NULL,
		[MeetingRequest].[Location] as [TaskName],
		[MeetingRequest].[OriginatorEmployeeID] as [EmployeeID],
		0 as [Billable],
		[MeetingRequest].[Color],
		[MeetingRequest].[Comments],
		[MeetingRequest].[Created],
		[MeetingRequest].[Modified],
		[MeetingRequest].[CreatedBy],
		[MeetingRequest].[ModifiedBy],
		[MeetingRequest].[Timestamp],
		[Class].[Guid]
	FROM
		[MeetingRequest] INNER JOIN [Class]
			ON ([MeetingRequest].[Class] = [Class].[Class])
		LEFT OUTER JOIN [Project]
			ON [MeetingRequest].[ProjectID] = [Project].[ID]
	WHERE
		(
			[MeetingRequest].[OriginatorEmployeeID] = @employeeID
		OR
			(EXISTS(SELECT * FROM [Attendee] WHERE [MeetingRequestID] = [MeetingRequest].[ID] AND [EmployeeID] = @employeeID AND ([ResponseType] IS NULL OR [ResponseType] IN ('Accept', 'Tentative'))) AND [MeetingRequest].[State] IN (2, 3))
		)
	AND
		[MeetingRequest].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd
	
	RETURN 0
GO

GRANT EXEC ON pjm5MeetingRequestOwnCalendarBrowse TO PUBLIC
GO
  