IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestReminderCreate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestReminderCreate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestReminderCreate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestReminderCreate.sql
**		Name: pjm5MeetingRequestReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@DocumentClass TClass,
		@rv int
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.MeetingRequest')

	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		'MS',
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	IF @ReminderEventTime > GETDATE()
	BEGIN
		EXEC @rv = dbo.pjm5MeetingDocumentUserReminderCreate @DocumentClass,
			@DocumentID,
			@ReminderEventTime,
			@ReminderState,
			@ReminderInterval
		IF @rv != 0
		BEGIN
			RETURN @rv
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MeetingRequestReminderCreate] TO PUBLIC
GO  