IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5NotificationTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5NotificationTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm5NotificationTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm5NotificationTemplateUpdate'
GO

/******************************************************************************
**		File: pjm5NotificationTemplateUpdate.sql
**		Name: pjm5NotificationTemplateUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5NotificationTemplateUpdate]
	@ID TIdentifier,
	@SimpleMessageTheme TName,
	@SimpleMessageBody TNotes,
	@AggregatedMessageTheme TName,
	@AggregatedMessageBody TNotes
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	IF NOT EXISTS (
		SELECT *
		FROM [NotificationMessageTemplateGlobal]
		WHERE [ID] = @ID AND [Language] = @Lang
 	) AND @Lang != 'ru'
 	BEGIN
 		INSERT INTO [NotificationMessageTemplateGlobal] 
 		([ID], [Language], [SimpleMessageTheme], [SimpleMessageBody],
 		[AggregatedMessageTheme], [AggregatedMessageBody])
 		VALUES (@ID, @Lang, @SimpleMessageTheme, @SimpleMessageBody,
 		@AggregatedMessageTheme, @AggregatedMessageBody)
 		IF @@error != 0
		RETURN 1
 	END
 	ELSE
	BEGIN
		IF @Lang = 'ru'
		BEGIN
			UPDATE [NotificationMessageTemplate]
			SET
				[SimpleMessageTheme] = @SimpleMessageTheme,
				[SimpleMessageBody] = @SimpleMessageBody,
				[AggregatedMessageTheme] = @AggregatedMessageTheme,
				[AggregatedMessageBody] = @AggregatedMessageBody
			WHERE
				[ID] = @ID
			IF @@error != 0
				RETURN 1
		END
		ELSE
		BEGIN
			UPDATE [NotificationMessageTemplateGlobal]
			SET
				[SimpleMessageTheme] = @SimpleMessageTheme,
				[SimpleMessageBody] = @SimpleMessageBody,
				[AggregatedMessageTheme] = @AggregatedMessageTheme,
				[AggregatedMessageBody] = @AggregatedMessageBody
			WHERE
				[ID] = @ID AND [Language] = @Lang
			IF @@error != 0
				RETURN 1
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5NotificationTemplateUpdate] TO PUBLIC
GO  