IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderStatusGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderStatusGet'
		DROP PROCEDURE [dbo].[pjm5ReminderStatusGet]
	END
GO

PRINT 'Creating procedure pjm5ReminderStatusGet'
GO

/******************************************************************************
**		File: pjm5ReminderStatusGet.sql
**		Name: pjm5ReminderStatusGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderStatusGet]
	@ReminderID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	IF @UserID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		[Reminder].[EventTime],
		[UserReminder].[NextInterval]
	FROM
		[Reminder]
		INNER JOIN [UserReminder]
			ON [Reminder].[ID] = [UserReminder].[ReminderID]
	WHERE
		[Reminder].[ID] = @ReminderID AND
		[UserReminder].[UserID] = @UserID AND
		[UserReminder].[State] = 1 AND
		([Reminder].[EventTime] IS NOT NULL) AND 
		(DATEADD(minute, -[UserReminder].[NextInterval], [Reminder].[EventTime]) <= GETDATE())
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderStatusGet] TO PUBLIC
GO
   