 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderUpdate'
		DROP PROCEDURE [dbo].[pjm5ReminderUpdate]
	END
GO

PRINT 'Creating procedure pjm5ReminderUpdate'
GO

/******************************************************************************
**		File: pjm5ReminderUpdate.sql
**		Name: pjm5ReminderUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderUpdate]
	@DocumentClass TClass,
	@ReminderSubtype TCode2,
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime
AS
	SET NOCOUNT ON
	
	IF @DocumentClass IS NULL OR @DocumentID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @@TRANCOUNT = 0
	BEGIN
		RAISERROR('#NotTransactionEnvironment', 18, -1)
		RETURN 1
	END
	
	DECLARE
		@ReminderID TIdentifier
		
	SELECT @ReminderID = [ID]
	FROM [Reminder]
	WHERE [DocumentClass] = @DocumentClass AND
		[Subtype] = @ReminderSubtype AND
		[DocumentID] = @DocumentID
		
	IF @ReminderID IS NULL
	BEGIN
		RAISERROR('#ReminderIsNotExists', 18, -1)
		RETURN 1
	END
	
	UPDATE [Reminder] SET [EventTime] = @ReminderEventTime WHERE [ID] = @ReminderID
	IF @@error != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO