IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestReminderCreate'
		DROP PROCEDURE [dbo].[pjm5TaskRequestReminderCreate]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestReminderCreate'
GO

/******************************************************************************
**		File: pjm5TaskRequestReminderCreate.sql
**		Name: pjm5TaskRequestReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@DocumentClass TClass,
		@rv int
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
		
	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		'RD',
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END

	EXEC @rv = dbo.pjm5DocumentUserReminderCreate @DocumentClass,
		@DocumentID,
		@ReminderEventTime
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	--adding SUPERVISOR to reminder
	EXEC @rv = dbo.pjm6DocumentSupervisorReminderCreate @DocumentClass,
		@DocumentID,
		@ReminderEventTime
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestReminderCreate] TO PUBLIC
GO  