/*===========================================================*/
/* Database View:          */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderContact]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderContact]
go

create view pjm5vwReminderContact
as
	SELECT
		[BusinessCard].[Class] as [DocumentClass],
		[BusinessCard].[ID] as [DocumentID],
		CASE
			WHEN [BusinessCard].[Class] = dbo.adfGetClassByName('Adf.Employee') THEN
				CASE WHEN [UserContact].[BusinessCardID] IS NULL THEN 
					[Company].[ManagerEmployeeID]
					ELSE [UserContact].[UserID]
				END
			WHEN [BusinessCard].[Class] = dbo.adfGetClassByName('Adf.Company') THEN
				CASE WHEN [UserContact].[BusinessCardID] IS NULL THEN 
					[Company].[ManagerEmployeeID]
					ELSE [UserContact].[UserID]
				END
			ELSE NULL
		END as [RecipientUserID],
		[BusinessCard].[NextContact] as [EventTime]
	FROM
		[BusinessCard]
		LEFT JOIN [Employee]
			ON ([Employee].[ID] = [BusinessCard].[ID] AND
				[Employee].[Class] = [BusinessCard].[Class])
		LEFT JOIN [Company]
			ON ([Company].[ID] = [BusinessCard].[ID] AND
				[Company].[Class] = [BusinessCard].[Class])
		LEFT OUTER JOIN [UserContact]
			ON ([BusinessCard].[ID] = [UserContact].[BusinessCardID] AND
				[UserContact].[BusinessCardClass] = [BusinessCard].[Class])
go

grant select on [dbo].[pjm5vwReminderContact] to [public]
go 