IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPaymentGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPaymentGet'
		DROP PROCEDURE [dbo].[adfPaymentGet]
	END
GO

PRINT 'Creating procedure adfPaymentGet'
GO

/******************************************************************************
**		File: adfPaymentGet.sql
**		Name: adfPaymentGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfPaymentGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		[Payment].[Class],
		[Payment].[ID],
		[Payment].[State],
		[Payment].[Flag],
		[Payment].[FileAs],
		[Payment].[Date],
		[Payment].[Number],
		[Payment].[PaymentTypeID],
		[Payment].[CurrencyCode],
		[Payment].[PayeeCompanyID],
		[Payment].[PayeeBankAccountID],
		[Payment].[PayerCompanyID],
		[Payment].[Reason],
		[Payment].[Payer],
		[Payment].[Value],
		[Payment].[VAT],
		[Payment].[BaseCurrencyRate],
		[Payment].[Comments],
		[Payment].[Created],
		[Payment].[CreatedBy],
		[Payment].[Modified],
		[Payment].[ModifiedBy],
		[Payment].[Timestamp],
		[Payment].[PayerCompanyID] AS [CustomerCompanyID],
		[Payment].[PayeeCompanyID] AS [SupplierCompanyID]
	FROM
		[Payment]
	WHERE
		[Payment].[ID] = @ID
		
	IF @@ROWCOUNT = 0
		RETURN 1
		
	SELECT
		[PaymentDetail].[ID],
		[PaymentDetail].[InvoiceID],
		[Invoice].[Number],
		[Invoice].[Date],
		[Invoice].[TotalWithVAT] AS [Sum],
		[Invoice].[VAT] AS [VATSum],
		[Invoice].[CurrencyCode],
		[PaymentDetail].[CurrencyRate],
		[PaymentDetail].[Value],
		[PaymentDetail].[VAT],
		[PaymentDetail].[PaymentValue],
		[PaymentDetail].[PaymentVAT],
		[PaymentDetail].[Description]
	FROM
		[PaymentDetail]
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [PaymentDetail].[InvoiceID]
	WHERE
		([PaymentDetail].[PaymentID] = @ID)

	RETURN 0
GO

GRANT EXECUTE ON [adfPaymentGet] TO PUBLIC
GO

 