IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallBrowse'
		DROP PROCEDURE [dbo].[pjm5PhoneCallBrowse]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallBrowse'
GO

/******************************************************************************
**		File: pjm5PhoneCallBrowse.sql
**		Name: pjm5PhoneCallBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[PhoneCall].[Class],
		[PhoneCall].[ID],
		[PhoneCall].[State],
		[PhoneCall].[Flag],
		[PhoneCall].[FileAs],

		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[Billable] as [Billable],
		[TimeEntry].[Overtime],
		[Expense].[Billable] as [ExpenseBillable],

		[PhoneCall].[ExpenseID],
		[PhoneCall].[PhoneCallCodeID],
		[PhoneCall].[Comments],
		[PhoneCall].[Created],
		[PhoneCall].[CreatedBy],
		[PhoneCall].[Modified],
		[PhoneCall].[ModifiedBy],
		[PhoneCall].[Timestamp]
	FROM
		[PhoneCall]
		INNER JOIN [TimeEntry]
			ON [TimeEntry].[ID] = [PhoneCall].[TimeEntryID]
		INNER JOIN [Expense]
			ON [Expense].[ID] = [PhoneCall].[ExpenseID]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [PhoneCall].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PhoneCallBrowse] TO PUBLIC
GO
 