IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ProjectCalculationAssistantBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ProjectCalculationAssistantBrowse'
		DROP PROCEDURE [dbo].[pjm6ProjectCalculationAssistantBrowse]
	END
GO

PRINT 'Creating procedure pjm6ProjectCalculationAssistantBrowse'
GO

/******************************************************************************
**		File: pjm6ProjectCalculationAssistantBrowse.sql
**		Name: pjm6ProjectCalculationAssistantBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    11/11/2009	SYV				 @PeriodEnd = NULL    
**									      
**	  16.09.10		SYV				      
**									    
**	  27.09.10		SYV				 ,     
**	  27.10.10		SYV				 ,     
**	  07.02.11		SYV				        
*******************************************************************************/
CREATE PROCEDURE [pjm6ProjectCalculationAssistantBrowse]
      @DateSelector     INT,
      @PeriodEnd        datetime,
      @EmployeeID       TIdentifier,
      @CostCenterSelector int,
      @CostCenterID TIdentifier,
      @DocumentSelector int,
      @StateSelector int
AS
      SET NOCOUNT ON
      DECLARE 
            @date datetime,
            @ViewAllProjects TBool,
            @ViewAllFinance TBool,
            @ViewFinance TBool,
            @Assistant TBool,
            @CurrentEmployeeID TIdentifier,
            @Class TClass,
            
            @TimeEntryClass TClass,
            @ExpenseClass TClass,
            @PhoneCallClass TClass,
            @ServiceRequestClass TClass
            
            
      SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()     
      SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
      SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
      SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
      SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
      SET @Class = dbo.adfGetClassByName('Pjm5.Calculation')
      
      SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
      SET @ExpenseClass = dbo.adfGetClassByName('Pjm5.Expense')
      SET @PhoneCallClass = dbo.adfGetClassByName('Pjm5.PhoneCall')
      SET @ServiceRequestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
            
      SET @date = DATEADD(day, 1, CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime))
      
      IF @DateSelector = 0
			SET @PeriodEnd = NULL
      IF @DateSelector = 1
            SET @PeriodEnd = @date
      IF @DateSelector = 2
            SET @PeriodEnd = DATEADD(day, 7, @date)
      IF @DateSelector = 3
            SET @PeriodEnd = DATEADD(month, 1, DATEADD(day, 1-DAY(DATEADD(day, -1, @date)), DATEADD(day, -1, @date)))
      IF @DateSelector = 4
            SET @PeriodEnd = DATEADD(month, 2, DATEADD(day, 1-DAY(DATEADD(day, -1, @date)), DATEADD(day, -1, @date)))
      IF @DateSelector = 5
            SET @PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))
      
      DECLARE @ActiveProject TABLE ([ProjectID] TIdentifier NOT NULL, [TimeBill] TAmount NULL, [MoneyBill] TMoney NULL)

      --
      IF (@DocumentSelector = 0 OR @DocumentSelector = 1)
      BEGIN
		INSERT INTO @ActiveProject ([ProjectID], [TimeBill], [MoneyBill])
		(
			SELECT
				[TimeEntry].[ProjectID],
				SUM(ISNULL([EntryAmount].[Amount], 0)),
				SUM(ISNULL([EntryAmount].[Amount] * [EntryAmount].[Price], 0))
			FROM
				[TimeEntry]
				INNER JOIN [EntryAmount]
					ON [EntryAmount].[ID] = [TimeEntry].[ID]
					AND [EntryAmount].[Price] > 0
			WHERE
				(
					@StateSelector = 0 AND [State] IN (2,3) 
					OR [State] = 3
				) AND
				[Billable] = 1 AND
				(
					[StartTime] < @PeriodEnd
					OR
					@DateSelector = 0
				) AND
				[StartTime] >= ISNULL(
						(
							SELECT 
								MAX([PeriodEnd]) + 1 
							FROM 
								[Calculation]
								LEFT OUTER JOIN [PaymentPeriod]
									ON [PaymentPeriod].[ProjectID] = [Calculation].[ProjectID]
							WHERE 
								[Calculation].[ProjectID] = [TimeEntry].[ProjectID] 
								AND 
								[Calculation].[State] != 4
								AND
								[Calculation].[DocumentClass] = @TimeEntryClass
								AND
								(
									[Calculation].[PeriodEnd] < [PaymentPeriod].[CalculationNextPaymentDate]
									OR
									[PaymentPeriod].[CalculationNextPaymentDate] IS NULL
								)
						), 0) 
			GROUP BY
				[TimeEntry].[ProjectID]
		)
      END
      
      --   
      IF (@DocumentSelector = 0 OR @DocumentSelector = 2 OR @DocumentSelector = 3)
      BEGIN
		INSERT INTO @ActiveProject ([ProjectID], [TimeBill], [MoneyBill])
		(
			SELECT
				[Expense].[ProjectID],
				NULL,
				SUM(ISNULL([TotalWithVATPC], 0)) 
			FROM 
				[Expense] 
			WHERE 
				(
					@StateSelector = 0 AND [State] IN (2,3) 
					OR [State] = 3
				) AND
				[Billable] = 1 AND
				[Price] > 0 AND
				( 
					[Expense].[Date] < @PeriodEnd
					OR
					@DateSelector = 0
				) AND
				[Expense].[Date] >= ISNULL(
					(
						SELECT 
							MAX([PeriodEnd]) + 1 
						FROM 
							[Calculation]
							LEFT OUTER JOIN [PaymentPeriod]
								ON [PaymentPeriod].[ProjectID] = [Calculation].[ProjectID]
						WHERE 
							[Calculation].[ProjectID] = [Expense].[ProjectID] 
							AND 
							[Calculation].[State] != 4
							AND 
							(
								([Calculation].[DocumentClass] = @ExpenseClass AND @DocumentSelector = 2)
								OR
								([Calculation].[DocumentClass] = @PhoneCallClass AND @DocumentSelector = 3)
								OR
								@DocumentSelector = 0
							)
							AND
							(
								[Calculation].[PeriodEnd] < [PaymentPeriod].[CalculationNextPaymentDate]
								OR
								[PaymentPeriod].[CalculationNextPaymentDate] IS NULL
							)
					), 0)
				AND
				(
					(@DocumentSelector = 3 AND [Expense].[ExpenseCodeID] = 1)
					OR
					(
						@DocumentSelector = 2 
						AND 
						([Expense].[ExpenseCodeID] IS NULL OR [Expense].[ExpenseCodeID] != 1)
					)
					OR
					@DocumentSelector = 0
				)
			GROUP BY
				[Expense].[ProjectID]
		)
      END
      
      --
      IF (@DocumentSelector = 0 OR @DocumentSelector = 4)
      BEGIN
		INSERT INTO @ActiveProject ([ProjectID], [TimeBill], [MoneyBill])
		(
            SELECT 
				[ServiceRequest].[ProjectID],
				NULL,
				SUM(ISNULL([TotalWithVAT], 0))
			FROM 
				[ServiceRequest] 
			WHERE 
				(
					@StateSelector = 0 AND [State] IN (3,4) 
					OR [State] = 4
				) AND
				[Billable] = 1 AND
				[Total] > 0 AND 
				(
					[ServiceRequest].[Date] < @PeriodEnd
					OR
					@DateSelector = 0
				) AND
					[ServiceRequest].[Date] >= ISNULL(
						(
							SELECT 
								MAX([PeriodEnd]) + 1 
							FROM 
								[Calculation]
								LEFT OUTER JOIN [PaymentPeriod]
									ON [PaymentPeriod].[ProjectID] = [Calculation].[ProjectID]
							WHERE 
								[Calculation].[ProjectID] = [ServiceRequest].[ProjectID] 
								AND 
								[Calculation].[State] != 4
								AND
								[Calculation].[DocumentClass] = @ServiceRequestClass
								AND
								(
									[Calculation].[PeriodEnd] < [PaymentPeriod].[CalculationNextPaymentDate]
									OR
									[PaymentPeriod].[CalculationNextPaymentDate] IS NULL
								)
						), 0)
			GROUP BY
				[ServiceRequest].[ProjectID]
		)
	  END
      
      ;
      WITH [ActiveProject] ([ProjectID], [TimeBill], [MoneyBill]) AS
      (
			SELECT
				[ProjectID], 
				SUM(ISNULL([TimeBill], 0)), 
				SUM(ISNULL([MoneyBill], 0))
			FROM
				@ActiveProject
			GROUP BY
				[ProjectID]
	  )
      SELECT
            [Project].[Class],
            [Project].[ID],
            --[Project].[State],
            -1 AS [State],
            [Project].[Flag],
            [Project].[Date],
            [Project].[Number],
            [Project].[FileAs],
            [Project].[ProjectTypeID],
            [Project].[SupplierCompanyID],
            [Project].[ProjectManagerEmployeeID],
            [Project].[CustomerCompanyID],
            [Project].[CustomerFinanceManagerID],
            [Project].[ResponsiblePersonEmployeeID],
            [Project].[PriorityID],
            [Project].[EndDate],
            [Project].[CurrencyCode],
            [Project].[CostCenterID],
            [Project].[ContractNumber],
            [Project].[ContractDate],
            [Project].[ContractEndDate],
            [Project].[ContractSubject],
            [Project].[ServiceLevelID],
            
            dbo.fnPjm6PeriodTypeNameGet([AssistantRecurrencePattern].[RecurrenceType]) AS [PeriodType],
            --dbo.fnPjm6DayTypeNameGet([PaymentPeriod].[CalculationDayType]) AS [DayType],
            [PaymentPeriod].[CalculationNextPaymentDate] AS [NextPaymentDate],
            @Class AS [DocumentClass], 
            [Calculation].[ID] AS [DocumentID],
            [Calculation].[State] AS [DocumentState],
            dbo.adfGetStateName(@Class, [Calculation].[State]) AS [DocumentStateName],
            [Calculation].[FileAs] AS [DocumentFileAs],
            
            [Project].[PaymentCurrencyPoint],
            [Project].[Comments],
            [Project].[Created],
            [Project].[CreatedBy],
            [Project].[Modified],
            [Project].[ModifiedBy],
            [Project].[Timestamp],
            [PaymentPeriod].[InvoiceNextPaymentDate],
            [PaymentPeriod].[StatementNextPaymentDate],
            [PaymentPeriod].[CalculationNextPaymentDate],
            [Project].[ContractComments], 
			ISNULL([ActiveProject].[TimeBill], 0) AS [TimeBill],
			ISNULL([ActiveProject].[MoneyBill], 0) AS [MoneyBill]
      FROM
            [Project]
            INNER JOIN [PaymentPeriod]
                  ON [PaymentPeriod].[ProjectID] = [Project].[ID]
            LEFT OUTER JOIN [ActiveProject]
                  ON [ActiveProject].[ProjectID] = [Project].[ID]
            LEFT OUTER JOIN [AssistantRecurrencePattern]
                  ON [AssistantRecurrencePattern].[ID] = [Project].[CalculationRecurrencePatternID]
            LEFT OUTER JOIN [Calculation]
                  ON [Project].[ID] = [Calculation].[ProjectID] AND
                        (
							[Calculation].[Date] = [PaymentPeriod].[CalculationNextPaymentDate]
							OR 
							@PeriodEnd IS NULL
                        )
                         AND
                        [Calculation].[State] != 4
                        AND
						(
							@DocumentSelector = 0
							OR
							(@DocumentSelector = 1 AND [Calculation].[DocumentClass] = @TimeEntryClass)
							OR
							(@DocumentSelector = 2 AND [Calculation].[DocumentClass] = @ExpenseClass)
							OR
							(@DocumentSelector = 3 AND [Calculation].[DocumentClass] = @PhoneCallClass)
							OR
							(@DocumentSelector = 4 AND [Calculation].[DocumentClass] = @ServiceRequestClass)
						)
      WHERE
            [Project].[State] IN (2, 3) AND
            (
                  @CostCenterSelector = 0 OR
                  ISNULL([Project].[CostCenterID], -1) = ISNULL(@CostCenterID, -1)
            ) AND
            (
                  ([PaymentPeriod].[CalculationNextPaymentDate] IS NOT NULL AND [PaymentPeriod].[CalculationNextPaymentDate] < @PeriodEnd)
                  OR
                  ([PaymentPeriod].[CalculationNextPaymentDate] IS NULL AND @PeriodEnd IS NULL)
            ) AND
            (
                  @ViewAllFinance = 1 OR 
                  (@Assistant = 1 AND @ViewAllProjects = 1) OR
                  dbo.fnPjm5IsProjectManager([Project].[ID], @CurrentEmployeeID) = 1 OR
                  (
                        @ViewFinance = 1 AND
                        dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1
                  )
            )  AND
            (
                  @EmployeeID IS NULL OR
                  [Project].[ProjectManagerEmployeeID] = @EmployeeID
            )
      
      RETURN 0
GO

GRANT EXECUTE ON [pjm6ProjectCalculationAssistantBrowse] TO PUBLIC
GO