IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ProjectInvoiceAssistantBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ProjectInvoiceAssistantBrowse'
		DROP PROCEDURE [dbo].[pjm6ProjectInvoiceAssistantBrowse]
	END
GO

PRINT 'Creating procedure pjm6ProjectInvoiceAssistantBrowse'
GO

/******************************************************************************
**		File: pjm6ProjectInvoiceAssistantBrowse.sql
**		Name: pjm6ProjectInvoiceAssistantBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    11/11/2009	SYV				 @PeriodEnd = NULL    
**									         
*******************************************************************************/
CREATE PROCEDURE [pjm6ProjectInvoiceAssistantBrowse]
	@DateSelector	INT,
	@PeriodEnd		datetime,
	@EmployeeID		TIdentifier,
	@CostCenterSelector int,
	@CostCenterID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllProjects TBool,
		@ViewAllFinance TBool,
		@ViewFinance TBool,
		@Assistant TBool,
		@CurrentEmployeeID TIdentifier,
		@Class TClass
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()	
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @Assistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	SET @Class = dbo.adfGetClassByName('Pjm5.Invoice')
	SET @date = DATEADD(day, 1, CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime))
	
	IF @DateSelector = 0
		SET @PeriodEnd = NULL
	IF @DateSelector = 1
		SET @PeriodEnd = @date
	IF @DateSelector = 2
		SET @PeriodEnd = DATEADD(day, 7, @date)
	IF @DateSelector = 3
		SET @PeriodEnd = DATEADD(month, 1, DATEADD(day, 1-DAY(@date), @date))
	IF @DateSelector = 4
		SET @PeriodEnd = DATEADD(month, 2, DATEADD(day, 1-DAY(@date), @date))
	IF @DateSelector = 5
		SET @PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))
		
	;
	WITH [ActiveProject] ([ProjectID], [PeriodType], --[DayType], 
		[NextPaymentDate], [DocumentClass], 
		[DocumentID], [DocumentState], [Date], [DocumentFileAs],
		[InvoiceNextPaymentDate], [StatementNextPaymentDate], [CalculationNextPaymentDate]) AS
	(
		SELECT
		[Project].[ID],
		dbo.fnPjm6PeriodTypeNameGet([AssistantRecurrencePattern].[RecurrenceType]),
		--dbo.fnPjm6DayTypeNameGet([PaymentPeriod].[InvoiceDayType]),
		[PaymentPeriod].[InvoiceNextPaymentDate],
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[FileAs],
		[PaymentPeriod].[InvoiceNextPaymentDate],
		[PaymentPeriod].[StatementNextPaymentDate],
		[PaymentPeriod].[CalculationNextPaymentDate]
	FROM
		[Project]
		INNER JOIN [PaymentPeriod]
			ON [PaymentPeriod].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [AssistantRecurrencePattern]
			ON [AssistantRecurrencePattern].[ID] = [Project].[InvoiceRecurrencePatternID]
		LEFT OUTER JOIN [Invoice]
			ON [Project].[ID] = [Invoice].[ProjectID] AND
			(
				[Invoice].[Date] = [PaymentPeriod].[InvoiceNextPaymentDate]
				OR
				(
				@PeriodEnd IS NULL
				AND
				NOT EXISTS (
					SELECT * 
					FROM 
						[PaymentPeriod]
					WHERE 
						[PaymentPeriod].[ProjectID] = [Invoice].[ProjectID] AND
						[PaymentPeriod].[InvoiceNextPaymentDate] IS NOT NULL
					) 
				)
			)
			 AND
				[Invoice].[State] != 3
	WHERE
		(
			@ViewAllFinance = 1 OR 
			(@Assistant = 1 AND @ViewAllProjects = 1) OR
			dbo.fnPjm5IsProjectManager([Project].[ID], @CurrentEmployeeID) = 1 OR
			(
				@ViewFinance = 1 AND
				dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1
			)
		) AND
		(
			@EmployeeID IS NULL OR
			[Project].[ProjectManagerEmployeeID] = @EmployeeID
		)
	),
	[PlannedInvoice] ([ProjectID], [DocumentClass], [DocumentID], [DocumentState], [Date], [DocumentFileAs]) AS 
	(
	SELECT
		[Invoice].[ProjectID],
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Date],
		[Invoice].[FileAs]
	FROM
		[Invoice]
		INNER JOIN [ActiveProject] p
			ON p.[ProjectID] = [Invoice].[ProjectID]
	WHERE
		[Invoice].[State] = 6 AND
		(
			(
			@PeriodEnd IS NULL
			AND
			NOT EXISTS (
				SELECT * 
				FROM 
					[PaymentPeriod]
				WHERE 
					[PaymentPeriod].[ProjectID] = [Invoice].[ProjectID] AND
					[PaymentPeriod].[InvoiceNextPaymentDate] IS NOT NULL
				) 
			)
			OR
			(@DateSelector = 1 OR [Invoice].[Date] < @PeriodEnd) 
		)
	)
	SELECT
		[Project].[Class],
		[Project].[ID],
		--[Project].[State],
		-1 AS [State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		
		[ActiveProject].[PeriodType],
		--[ActiveProject].[DayType],
		[PlannedInvoice].[Date] AS [NextPaymentDate],
		@Class AS [DocumentClass],
		[PlannedInvoice].[DocumentID],
		[PlannedInvoice].[DocumentState],
		dbo.adfGetStateName(@Class, [PlannedInvoice].[DocumentState]) AS [DocumentStateName],
		[PlannedInvoice].[DocumentFileAs],
		
		[Project].[PaymentCurrencyPoint],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[ActiveProject].[InvoiceNextPaymentDate],
		[ActiveProject].[StatementNextPaymentDate],
		[ActiveProject].[CalculationNextPaymentDate],
		[Project].[ContractComments]
	FROM
		[Project]
		INNER JOIN [PlannedInvoice]
			ON [PlannedInvoice].[ProjectID] = [Project].[ID]
		INNER JOIN [ActiveProject]
			ON [ActiveProject].[ProjectID] = [Project].[ID]
	WHERE
		[Project].[State] IN (2, 3) AND
		(
			@CostCenterSelector = 0 OR
			ISNULL([Project].[CostCenterID], -1) = ISNULL(@CostCenterID, -1)
		)

	UNION
			
	SELECT
		[Project].[Class],
		[Project].[ID],
		--[Project].[State],
		-1 AS [State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		
		[ActiveProject].[PeriodType],
		--[ActiveProject].[DayType],
		[ActiveProject].[NextPaymentDate],
		@Class AS [DocumentClass],
		[ActiveProject].[DocumentID],
		[ActiveProject].[DocumentState],
		dbo.adfGetStateName(@Class, [ActiveProject].[DocumentState]) AS [DocumentStateName],
		[ActiveProject].[DocumentFileAs],
		
		[Project].[PaymentCurrencyPoint],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[ActiveProject].[InvoiceNextPaymentDate],
		[ActiveProject].[StatementNextPaymentDate],
		[ActiveProject].[CalculationNextPaymentDate],
		[Project].[ContractComments]
	FROM
		[Project]
		INNER JOIN [ActiveProject]
			ON [ActiveProject].[ProjectID] = [Project].[ID]
	WHERE
		[Project].[State] IN (2, 3) AND
		(
			@CostCenterSelector = 0 OR
			ISNULL([Project].[CostCenterID], -1) = ISNULL(@CostCenterID, -1)
		) AND
		(
			([ActiveProject].[NextPaymentDate] IS NOT NULL AND [ActiveProject].[NextPaymentDate] < @PeriodEnd)
			OR
			([ActiveProject].[NextPaymentDate] IS NULL AND @PeriodEnd IS NULL)
		) AND
		(
			[ActiveProject].[DocumentID] IS NOT NULL
			OR
			[ActiveProject].[DocumentID] IS NULL AND
			NOT EXISTS (
				SELECT * 
				FROM 
					[PlannedInvoice]
				WHERE 
					[PlannedInvoice].[ProjectID] = [ActiveProject].[ProjectID] AND
					[PlannedInvoice].[Date] = [ActiveProject].[NextPaymentDate]
				)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ProjectInvoiceAssistantBrowse] TO PUBLIC
GO