IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateUpdate'
GO

/******************************************************************************
**		File: ProjectTemplateUpdate.sql
**		Name: pjm5ProjectTemplateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.05.10	SYV		          [ExchangeSystemName]  
**		15.06.10	KOV				  [FolderID]
**		22.04.11	SYV				  GroupCalculationLines, ShowActivityTypes
**									GroupingAdvanceCalculations  
**		14.07.11	SYV				 UseSubProjects
*******************************************************************************/
CREATE PROCEDURE pjm5ProjectTemplateUpdate
	@Xml	XML
AS
	DECLARE
		@ID TIdentifier,
		@ManagerID int,
		@AssignmentState TState,
		@CurrencyCode TCode3,
		@doc int,
		
		@AssignmentID TIdentifier,
		@EmployeeName TName,
		@QualificationID TIdentifier,
		@StandardRate TMoney,
		@OvertimeRate TMoney,
		@rv int,
		@InvoicePeriodType TCode,
		@InvoiceDayType TCode,
		@InvoiceNextPaymentDate TDate,
		@StatementPeriodType TCode,
		@StatementDayType TCode,
		@StatementNextPaymentDate TDate,
		@CalculationPeriodType TCode,
		@CalculationDayType TCode,
		@CalculationNextPaymentDate TDate,
		@BudgetTemplateID Tidentifier,
		@UseBudgetPlanning TBool,
		@value TVariant,

		@DiscountTypeByTime					TIdentifier,
		@DiscountViewByTime					TBool,
		@DiscountByTime						TMoney,
		
		@DiscountTypeByExpense				TIdentifier,
		@DiscountViewByExpense				TBool,
		@DiscountByExpense					TMoney,
		
		@DiscountTypeByPhone				TIdentifier,
		@DiscountViewByPhone				TBool,
		@DiscountByPhone					TMoney,
		
		@DiscountTypeByServiceRequest		TIdentifier,
		@DiscountViewByServiceRequest		TBool,
		@DiscountByServiceRequest			TMoney
		
	SET NOCOUNT ON
	
	EXEC adfParameterGet @Name='UseBudgetPlanning', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseBudgetPlanning = CAST(@value as bit)

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@ID = [ID],
		@InvoicePeriodType = [InvoicePeriodType],
		@InvoiceDayType = [InvoiceDayType],
		@InvoiceNextPaymentDate = CAST([InvoiceNextPaymentDate] AS datetime),
		@StatementPeriodType = [StatementPeriodType],
		@StatementDayType = [StatementDayType],
		@StatementNextPaymentDate = CAST([StatementNextPaymentDate] AS datetime),
		@CalculationPeriodType = [CalculationPeriodType],
		@CalculationDayType = [CalculationDayType],
		@CalculationNextPaymentDate = CAST([CalculationNextPaymentDate] AS datetime),
		@BudgetTemplateID = [BudgetTemplateID],

		@DiscountTypeByTime	= [DiscountTypeByTime],
		@DiscountViewByTime	= [DiscountViewByTime],
		@DiscountByTime	= [DiscountByTime],
		
		@DiscountTypeByExpense = [DiscountTypeByExpense],
		@DiscountViewByExpense = [DiscountViewByExpense],
		@DiscountByExpense = [DiscountByExpense],
		
		@DiscountTypeByPhone = [DiscountTypeByPhone],
		@DiscountViewByPhone = [DiscountViewByPhone],
		@DiscountByPhone = [DiscountByPhone],
		
		@DiscountTypeByServiceRequest = [DiscountTypeByServiceRequest],
		@DiscountViewByServiceRequest = [DiscountViewByServiceRequest],
		@DiscountByServiceRequest = [DiscountByServiceRequest]
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
			WITH (
				[ID] int,
				[InvoicePeriodType] varchar(32),
				[InvoiceDayType] varchar(32),
				[InvoiceNextPaymentDate] varchar(19),
				[StatementPeriodType] varchar(32),
				[StatementDayType] varchar(32),
				[StatementNextPaymentDate] varchar(19),
				[CalculationPeriodType] varchar(32),
				[CalculationDayType] varchar(32),
				[CalculationNextPaymentDate] varchar(19),
				[BudgetTemplateID] int,

				[DiscountTypeByTime] int,
				[DiscountViewByTime] bit,
				[DiscountByTime] decimal(18,4),
				
				[DiscountTypeByExpense] int,
				[DiscountViewByExpense] bit,
				[DiscountByExpense]	decimal(18,4),
				
				[DiscountTypeByPhone] int,
				[DiscountViewByPhone] bit,
				[DiscountByPhone] decimal(18,4),	
				
				[DiscountTypeByServiceRequest] int,
				[DiscountViewByServiceRequest] bit,
				[DiscountByServiceRequest] decimal(18,4)
				)

	BEGIN TRANSACTION
	UPDATE
		[PaymentPeriod]
	SET
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		[InvoiceNextPaymentDate] = @InvoiceNextPaymentDate,
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		[StatementNextPaymentDate] = @StatementNextPaymentDate,
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType,
		[CalculationNextPaymentDate] = @CalculationNextPaymentDate
	WHERE
		[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	UPDATE 
		[Project]
	SET
		@ID = [XmlTable].[ID],
		@ManagerID = [XmlTable].[ProjectManagerEmployeeID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		[Project].[Date] = [XmlTable].[Date],
		[Project].[Number] = [XmlTable].[Number],
		[Project].[FileAs] = [XmlTable].[FileAs],
		[Project].[ProjectTypeID] = [XmlTable].[ProjectTypeID],
		[Project].[SupplierCompanyID] = [XmlTable].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID] = [XmlTable].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID] = [XmlTable].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID] = [XmlTable].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID] = [XmlTable].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID] = [XmlTable].[PriorityID],
		[Project].[ProjectLanguageCode] = [XmlTable].[ProjectLanguageCode],
		[Project].[CurrencyCode] = [XmlTable].[CurrencyCode],
		[Project].[CostCenterID] = [XmlTable].[CostCenterID],
		[Project].[Budget] = [XmlTable].[Budget],
		[Project].[ContractNumber] = [XmlTable].[ContractNumber],
		[Project].[ContractDate] = [XmlTable].[ContractDate],
		[Project].[ContractEndDate] = [XmlTable].[ContractEndDate],
		[Project].[ContractSubject] = [XmlTable].[ContractSubject],
		[Project].[ApplyVAT] = [XmlTable].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod] = [XmlTable].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType] = [XmlTable].[InvoiceExpirationPeriodType],
		[Project].[Comments] = [XmlTable].[Comments],
		[Project].[ContractComments] = [XmlTable].[ContractComments],
		[Project].[RoundingMode] = [XmlTable].[RoundingMode],
		[Project].[RoundingInterval] = [XmlTable].[RoundingInterval],
		[Project].[Billable] = [XmlTable].[Billable],
		[Project].[Modified] = GETDATE(),
		[Project].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Project].[SupportsRequestManagement] = [XmlTable].[SupportsRequestManagement],
		[Project].[RatesWithVAT] = CASE [XmlTable].[ApplyVAT]
				WHEN 1 THEN [XmlTable].[RatesWithVAT]
				ELSE 0
			END,
		[Project].[PaymentCurrencyPoint] = [XmlTable].[PaymentCurrencyPoint],
		[Project].[InitialBalance] = [XmlTable].[InitialBalance],
		[Project].[BaseInitialBalance] = [XmlTable].[BaseInitialBalance],
		[Project].[InvoiceCurrency] = [XmlTable].[InvoiceCurrency],
		[Project].[StatementCurrency] = [XmlTable].[StatementCurrency],
		[Project].[FactureCurrency] = [XmlTable].[FactureCurrency],
		[Project].[Scale] = [XmlTable].[Scale],
		[Project].[FolderID] = [XmlTable].[FolderID],
		[Project].[ExchangeSystemName] = [XmlTable].[ExchangeSystemName],
		[Project].[GroupingAdvanceCalculations] = [XmlTable].[GroupingAdvanceCalculations],
		[Project].[ShowActivityTypes] = [XmlTable].[ShowActivityTypes],
		[Project].[GroupCalculationLines] = [XmlTable].[GroupCalculationLines],
		[Project].[ShowPrice] = [XmlTable].[ShowPrice],
		[Project].[UseSubProjects] = [XmlTable].[UseSubProjects]
	FROM
		[Project] INNER JOIN
	(
		SELECT
			[ID],
			CAST([Date] as datetime) as [Date],
			[Number],
			[FileAs],
			[ProjectTypeID],
			[SupplierCompanyID],
			[ProjectManagerEmployeeID],
			[CustomerCompanyID],
			[CustomerFinanceManagerID],
			[ResponsiblePersonEmployeeID],
			[PriorityID],
			[ProjectLanguageCode],
			[CurrencyCode],
			[CostCenterID],
			[ManHour],
			[Budget],
			[ContractNumber],
			CAST([ContractDate] as datetime) as [ContractDate],
			CAST([ContractEndDate] as datetime) as [ContractEndDate],
			[ContractSubject],
			(CASE [ApplyVAT] WHEN 'false' THEN 0 ELSE 1 END) as [ApplyVAT],
			[InvoiceExpirationPeriod],
			[InvoiceExpirationPeriodType],
			[WSSDocumentsURL],
			[Comments],
			[ContractComments],
			[RoundingInterval],
			[RoundingMode],
			(CASE [ProjectTypeID] WHEN 1 THEN 1 ELSE 0 END) as [Billable],
			(CASE [SupportsRequestManagement] WHEN 'false' THEN 0 ELSE 1 END) as [SupportsRequestManagement],
			(CASE [RatesWithVAT] WHEN 'false' THEN 0 ELSE 1 END) as [RatesWithVAT],
			[PaymentCurrencyPoint],
			[InitialBalance],
			[BaseInitialBalance],
			[InvoiceCurrency],
			[StatementCurrency],
			[FactureCurrency],
			[Scale],
			[FolderID],
			[ExchangeSystemName],
			[GroupingAdvanceCalculations],
			(CASE [ShowActivityTypes] WHEN 'false' THEN 0 ELSE 1 END) AS [ShowActivityTypes],
			(CASE [GroupCalculationLines] WHEN 'false' THEN 0 ELSE 1 END) AS [GroupCalculationLines],
			(CASE [ShowPrice] WHEN 'false' THEN 0 ELSE 1 END) AS [ShowPrice],
			[UseSubProjects]
		FROM
			OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
				WITH (
					[ID] int,
					[Date] varchar(19),
					[Number] varchar(32),
					[FileAs] nvarchar(256),
					[ProjectTypeID] int,
					[SupplierCompanyID] int,
					[ProjectManagerEmployeeID] int,
					[CustomerCompanyID] int,
					[CustomerFinanceManagerID] int,
					[ResponsiblePersonEmployeeID] int,
					[PriorityID] int,
					[ProjectLanguageCode] varchar(32),
					[CurrencyCode] char(3),
					[CostCenterID] int,
					[ManHour] int,
					[Budget] money,
					[ContractNumber] varchar(32),
					[ContractDate] varchar(19),
					[ContractEndDate] varchar(19),
					[ContractSubject] nvarchar(256),
					[ApplyVAT] varchar(5),
					[InvoiceExpirationPeriod] int,
					[InvoiceExpirationPeriodType] int,
					[WSSDocumentsURL] varchar(512),
					[Comments] nvarchar(max),
					[ContractComments] nvarchar (max),
					[RoundingInterval] int,
					[RoundingMode] int,
					[Billable] varchar(5),
					[SupportsRequestManagement] varchar(5),
					[RatesWithVAT] varchar(5),
					[PaymentCurrencyPoint] int,
					[InitialBalance] money,
					[BaseInitialBalance] money,
					[InvoiceCurrency] int,
					[StatementCurrency] int,
					[FactureCurrency] int,
					[Scale] int,
					[FolderID] int,
					[ExchangeSystemName] nvarchar(256),
					[GroupingAdvanceCalculations] int,
					[ShowActivityTypes] varchar(5),
					[GroupCalculationLines] varchar(5),
					[ShowPrice] varchar(5),
					[UseSubProjects] bit
					)
				) as [XmlTable] ON
			([Project].[ID] = [XmlTable].[ID])
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	UPDATE [ProjectDetail]
	SET
		[DiscountTypeByTime] = @DiscountTypeByTime,
		[DiscountViewByTime] = @DiscountViewByTime,
		[DiscountByTime] = @DiscountByTime,
		
		[DiscountTypeByExpense] = @DiscountTypeByExpense,
		[DiscountViewByExpense] = @DiscountViewByExpense,
		[DiscountByExpense] = @DiscountByExpense,
		
		[DiscountTypeByPhone] = @DiscountTypeByPhone,
		[DiscountViewByPhone] = @DiscountViewByPhone,
		[DiscountByPhone] = @DiscountByPhone,
		
		[DiscountTypeByServiceRequest] = @DiscountTypeByServiceRequest,
		[DiscountViewByServiceRequest] = @DiscountViewByServiceRequest,
		[DiscountByServiceRequest] = @DiscountByServiceRequest
	FROM
		[ProjectDetail]
		INNER JOIN
		(
		SELECT
			[ID]
		FROM
			OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
				WITH (
					[ID] int
					)
		) AS [XmlTable] ON
			[ProjectDetail].[ID] = [XmlTable].[ID]
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DELETE FROM [ProjectActivityType] WHERE [ProjectActivityType].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [ProjectActivityType]
			([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		(CASE [Billable] WHEN 'false' THEN 0 ELSE 1 END),
		(CASE [Actively] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectActivityType', 2)
			WITH (
				[ID] int 'ID',
				[Billable] varchar(5) 'Billable',
				[Actively] varchar(5) 'Actively'
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DELETE FROM [ProjectExpenseCode] WHERE [ProjectExpenseCode].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		(CASE [Billable] WHEN 'false' THEN 0 ELSE 1 END),
		(CASE [Actively] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectExpenseCode', 2)
			WITH (
				[ID] int 'ID',
				[Billable] varchar(5) 'Billable',
				[Actively] varchar(5) 'Actively'
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.ProjectTemplate')
	UPDATE 
		[Document]
	SET 
		[Flag] = [Project].[Flag], 
		[FileAs] = [Project].[FileAs], 
		[Modified] = [Project].[Modified], 
		[ModifiedBy] = [Project].[ModifiedBy]
	FROM
		[Document]
		INNER JOIN [Project]
			ON [Document].[ID] = [Project].[ID] AND
				[Document].[Class] = @TemplateClass
	WHERE
		[Project].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseBudgetPlanning = 0
		SET @BudgetTemplateID = NULL


	UPDATE
		[ProjectTemplate]
	SET
		[BudgetTemplateID] = @BudgetTemplateID
	WHERE
		[ProjectTemplate].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END


	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc
	EXEC pjm5ProjectTemplateGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5ProjectTemplateUpdate TO PUBLIC
GO
 