IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectUpdate'
		DROP PROCEDURE [dbo].[pjm5ProjectUpdate]
	END
GO

PRINT 'Creating procedure pjm5ProjectUpdate'
GO

/******************************************************************************
**		File: pjm5ProjectUpdate.sql
**		Name: pjm5ProjectUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.09.09	syv				  BankAccountID
**
**		06.04.10	KOV				      
**									 -   
**		13.11.10	SYV				  [GroupingAdvanceCalculations]
**		24.11.10	SYV				  [StatementCurrencyPoint]
**		18.04.11	SYV				    
*******************************************************************************/
CREATE PROCEDURE pjm5ProjectUpdate
	@Xml	XML
AS
	DECLARE
		@ID TIdentifier,
		@ManagerID int,
		@AssignmentState TState,
		@CurrencyCode TCode3,
		@ManHour TAmount,
		@Budget TMoney,
		@doc int,
		
		@AssignmentID TIdentifier,
		@EmployeeName TName,
		@QualificationID TIdentifier,
		@StandardRate TMoney,
		@OvertimeRate TMoney,
		@rv int,
		
		@ExternalNotificationOpenIssue bit,
		@ExternalNotificationResolveIssue bit,
		@ExternalNotificationPostponeIssue bit,
		@ExternalNotificationCloseIssue bit,
		
		@CustomerCompanyID TIdentifier,
		@InvoicePeriodType TCode,
		@InvoiceDayType TCode,
		@InvoiceNextPaymentDate TDate,
		@StatementPeriodType TCode,
		@StatementDayType TCode,
		@StatementNextPaymentDate TDate,
		@CalculationPeriodType TCode,
		@CalculationDayType TCode,
		@CalculationNextPaymentDate TDate,
		@BankAccountID TIdentifier,
		@ExchangeSystemName TName,
		@IsConsignor bit,
		@ConsignorID TIdentifier,
		@ConsignorClass TClass,
		@ConsignorContract TName,
		@BudgetNextCalculationDate	TDate,
		@BudgetID					TIdentifier,
		@ReminderState					TState,
		@DiscountTypeByTime					TIdentifier,
		@DiscountViewByTime					TBool,
		@DiscountByTime						TMoney,
		
		@DiscountTypeByExpense				TIdentifier,
		@DiscountViewByExpense				TBool,
		@DiscountByExpense					TMoney,
		
		@DiscountTypeByPhone				TIdentifier,
		@DiscountViewByPhone				TBool,
		@DiscountByPhone					TMoney,
		
		@DiscountTypeByServiceRequest		TIdentifier,
		@DiscountViewByServiceRequest		TBool,
		@DiscountByServiceRequest			TMoney
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@ID = [ID],
		@ManHour = [ManHour], 
		@Budget = [Budget],
		@CustomerCompanyID = [CustomerCompanyID],
		@ExternalNotificationOpenIssue =
			CASE [ExternalNotificationOpenIssue] WHEN 'false' THEN 0 ELSE 1 END,
		@ExternalNotificationResolveIssue =
			CASE [ExternalNotificationResolveIssue] WHEN 'false' THEN 0 ELSE 1 END,
		@ExternalNotificationPostponeIssue =
			CASE [ExternalNotificationPostponeIssue] WHEN 'false' THEN 0 ELSE 1 END,
		@ExternalNotificationCloseIssue =
			CASE [ExternalNotificationCloseIssue] WHEN 'false' THEN 0 ELSE 1 END,
		@InvoicePeriodType = [InvoicePeriodType],
		@InvoiceDayType = [InvoiceDayType],
		@InvoiceNextPaymentDate = CAST([InvoiceNextPaymentDate] AS datetime),
		@StatementPeriodType = [StatementPeriodType],
		@StatementDayType = [StatementDayType],
		@StatementNextPaymentDate = CAST([StatementNextPaymentDate] AS datetime),
		@CalculationPeriodType = [CalculationPeriodType],
		@CalculationDayType = [CalculationDayType],
		@CalculationNextPaymentDate = CAST([CalculationNextPaymentDate] AS datetime),
		@BankAccountID = [BankAccountDefault],
		@ExchangeSystemName = [ExchangeSystemName],
		@IsConsignor = CASE [IsConsignor] WHEN 'false' THEN 0 ELSE 1 END,
		@ConsignorID = [ConsignorID],
		@ConsignorClass = [ConsignorClass],
		@ConsignorContract = [ConsignorContract],
		@BudgetID = [BudgetID],
		@BudgetNextCalculationDate = CAST([NextCalculationDate] AS datetime),
		@ReminderState = CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END,
		@DiscountTypeByTime	= [DiscountTypeByTime],
		@DiscountViewByTime	= [DiscountViewByTime],
		@DiscountByTime	= [DiscountByTime],
		
		@DiscountTypeByExpense = [DiscountTypeByExpense],
		@DiscountViewByExpense = [DiscountViewByExpense],
		@DiscountByExpense = [DiscountByExpense],
		
		@DiscountTypeByPhone = [DiscountTypeByPhone],
		@DiscountViewByPhone = [DiscountViewByPhone],
		@DiscountByPhone = [DiscountByPhone],
		
		@DiscountTypeByServiceRequest = [DiscountTypeByServiceRequest],
		@DiscountViewByServiceRequest = [DiscountViewByServiceRequest],
		@DiscountByServiceRequest = [DiscountByServiceRequest]
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
			WITH (
				[ID] int,
				[ManHour] decimal(18,4),
				[Budget] money,
				[CustomerCompanyID] int,
				[ExternalNotificationOpenIssue] varchar(5),
				[ExternalNotificationResolveIssue] varchar(5),
				[ExternalNotificationPostponeIssue] varchar(5),
				[ExternalNotificationCloseIssue] varchar(5),
				[InvoicePeriodType] varchar(32),
				[InvoiceDayType] varchar(32),
				[InvoiceNextPaymentDate] varchar(19),
				[StatementPeriodType] varchar(32),
				[StatementDayType] varchar(32),
				[StatementNextPaymentDate] varchar(19),
				[CalculationPeriodType] varchar(32),
				[CalculationDayType] varchar(32),
				[CalculationNextPaymentDate] varchar(19),
				[BankAccountDefault] int,
				[ExchangeSystemName] varchar(50),
				[IsConsignor] bit,
				[ConsignorID] int,
				[ConsignorClass] smallint,
				[ConsignorContract] varchar(50),
				[BudgetID] int,
				[NextCalculationDate] varchar(19),
				[ReminderState] varchar(5),
				[DiscountTypeByTime] int,
				[DiscountViewByTime] bit,
				[DiscountByTime] decimal(18,4),
				
				[DiscountTypeByExpense] int,
				[DiscountViewByExpense] bit,
				[DiscountByExpense]	decimal(18,4),
				
				[DiscountTypeByPhone] int,
				[DiscountViewByPhone] bit,
				[DiscountByPhone] decimal(18,4),	
				
				[DiscountTypeByServiceRequest] int,
				[DiscountViewByServiceRequest] bit,
				[DiscountByServiceRequest] decimal(18,4)
				)
	IF EXISTS (SELECT * FROM [Project] WHERE [ID] = @ID AND [State] = 4)
	BEGIN
		RAISERROR('#CannotEditClosedProject', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DECLARE @CurrentEmployeeID int
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ID, @CurrentEmployeeID) = 0 AND 
		(
		dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 0 OR
		dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProject')) = 0
		)
	BEGIN
		EXEC sp_xml_removedocument @doc
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @Budget IS NOT NULL AND @Budget < 0
	BEGIN
		RAISERROR('#BudgetIsInvalid', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	--    -  
	--         
	--        ,  
	DECLARE @InvoiceCount int, @StatementCount int, @CalculationCount int, @FactureCount int
	SELECT @InvoiceCount = COUNT([ID]) FROM [Invoice] WHERE [Invoice].[ProjectID] = @ID
	SELECT @StatementCount = COUNT([ID]) FROM [Statement] WHERE [Statement].[ProjectID] = @ID
	--SELECT @CalculationCount = COUNT([ID]) FROM [Calculation] WHERE [Calculation].[ProjectID] = @ID
	SELECT @FactureCount = COUNT([ID]) FROM [Facture] WHERE [Facture].[ProjectID] = @ID
	IF (@InvoiceCount != 0 OR @StatementCount != 0 OR @FactureCount != 0) AND @CustomerCompanyID IS NULL
	BEGIN
		RAISERROR('#ProjectInvoiceOrCalcExists', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	BEGIN TRANSACTION
	UPDATE
		[PaymentPeriod]
	SET
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		[InvoiceNextPaymentDate] = @InvoiceNextPaymentDate,
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		[StatementNextPaymentDate] = @StatementNextPaymentDate,
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType,
		[CalculationNextPaymentDate] = @CalculationNextPaymentDate
	WHERE
		[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	UPDATE [Project]
	SET
		@ID = [XmlTable].[ID],
		@ManagerID = [XmlTable].[ProjectManagerEmployeeID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		[Project].[Date] = [XmlTable].[Date],
		[Project].[Number] = [XmlTable].[Number],
		[Project].[NumerationCode] = [XmlTable].[NumerationCode],
		[Project].[FileAs] = [XmlTable].[FileAs],
		[Project].[ProjectTypeID] = [XmlTable].[ProjectTypeID],
		[Project].[SupplierCompanyID] = [XmlTable].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID] = [XmlTable].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID] = [XmlTable].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID] = [XmlTable].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID] = [XmlTable].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID] = [XmlTable].[PriorityID],
		[Project].[ProjectLanguageCode] = [XmlTable].[ProjectLanguageCode],
		[Project].[CurrencyCode] = [XmlTable].[CurrencyCode],
		[Project].[CostCenterID] = [XmlTable].[CostCenterID],
		[Project].[Budget] = [XmlTable].[Budget],
		[Project].[ContractNumber] = [XmlTable].[ContractNumber],
		[Project].[ContractDate] = [XmlTable].[ContractDate],
		[Project].[ContractEndDate] = [XmlTable].[ContractEndDate],
		[Project].[ContractSubject] = [XmlTable].[ContractSubject],
		[Project].[ApplyVAT] = [XmlTable].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod] = [XmlTable].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType] = [XmlTable].[InvoiceExpirationPeriodType],
		[Project].[Comments] = [XmlTable].[Comments],
		[Project].[RoundingMode] = [XmlTable].[RoundingMode],
		[Project].[RoundingInterval] = [XmlTable].[RoundingInterval],
		[Project].[Billable] = [XmlTable].[Billable],
		[Project].[WSSDocumentsURL] = [XmlTable].[WSSDocumentsURL],
		[Project].[SupportsRequestManagement] = [XmlTable].[SupportsRequestManagement],
		[Project].[RatesWithVAT] = CASE [XmlTable].[ApplyVAT]
				WHEN 1 THEN [XmlTable].[RatesWithVAT]
				ELSE 0
			END,
		[Project].[PaymentCurrencyPoint] = [XmlTable].[PaymentCurrencyPoint],
		[Project].[InitialBalance] = [XmlTable].[InitialBalance],
		[Project].[BaseInitialBalance] = [XmlTable].[BaseInitialBalance],
		[Project].[InvoiceCurrency] = [XmlTable].[InvoiceCurrency],
		[Project].[StatementCurrency] = [XmlTable].[StatementCurrency],
		[Project].[FactureCurrency] = [XmlTable].[FactureCurrency],
		[Project].[Scale] = [XmlTable].[Scale],
		[Project].[FolderID] = [XmlTable].[FolderID],
		[Project].[Modified] = DEFAULT,
		[Project].[ModifiedBy] = DEFAULT,
		[Project].[EndDate] = [XmlTable].[EndDate],
		[Project].[GroupCalculationLines] = [XmlTable].[GroupCalculationLines],
		[Project].[CheckTaskWorkOverdraft] = [XmlTable].[CheckTaskWorkOverdraft],
		[Project].[ContractComments] = [XmlTable].[ContractComments],
		[Project].[ShowActivityTypes] = [XmlTable].[ShowActivityTypes],
		[Project].[BankAccountID] = [XmlTable].[BankAccountDefault],
		[Project].[ExchangeSystemName] = @ExchangeSystemName,
		[Project].[GroupingAdvanceCalculations] = [XmlTable].[GroupingAdvanceCalculations],
		[Project].[StatementCurrencyPoint] = [XmlTable].[StatementCurrencyPoint],
		[Project].[IsConsignor] = @IsConsignor,
		[Project].[ConsignorID] = @ConsignorID,
		[Project].[ConsignorClass] = @ConsignorClass,
		[Project].[ConsignorContract] = @ConsignorContract,
		[Project].[ShowPrice] = [XmlTable].[ShowPrice],
		[Project].[UseSubProjects] = [XmlTable].[UseSubProjects]
	FROM
		[Project] INNER JOIN
		(
		SELECT
			[ID],
			CAST([Date] as datetime) as [Date],
			[Number],
			[NumerationCode],
			[FileAs],
			[ProjectTypeID],
			[SupplierCompanyID],
			[ProjectManagerEmployeeID],
			[CustomerCompanyID],
			[CustomerFinanceManagerID],
			[ResponsiblePersonEmployeeID],
			[PriorityID],
			[ProjectLanguageCode],
			[CurrencyCode],
			[CostCenterID],
			[Budget],
			[ContractNumber],
			CAST([ContractDate] as datetime) as [ContractDate],
			CAST([ContractEndDate] as datetime) as [ContractEndDate],
			[ContractSubject],
			(CASE [ApplyVAT] WHEN 'false' THEN 0 ELSE 1 END) as [ApplyVAT],
			[InvoiceExpirationPeriod],
			[InvoiceExpirationPeriodType],
			[WSSDocumentsURL],
			[Comments],
			[RoundingInterval],
			[RoundingMode],
			(CASE  WHEN [ProjectTypeID] IN (1) THEN 1 ELSE 0 END) as [Billable],
			(CASE [SupportsRequestManagement] WHEN 'false' THEN 0 ELSE 1 END) as [SupportsRequestManagement],
			(CASE [RatesWithVAT] WHEN 'false' THEN 0 ELSE 1 END) as [RatesWithVAT],
			[PaymentCurrencyPoint],
			[InitialBalance],
			[BaseInitialBalance],
			[InvoiceCurrency],
			[StatementCurrency],
			[FactureCurrency],
			[Scale],
			[FolderID],
			CAST([EndDate] as datetime) as [EndDate],
			(CASE [GroupCalculationLines] WHEN 'false' THEN 0 ELSE 1 END) AS [GroupCalculationLines],
			(CASE [ShowActivityTypes] WHEN 'false' THEN 0 ELSE 1 END) AS [ShowActivityTypes],
			(CASE [CheckTaskWorkOverdraft] WHEN 'false' THEN 0 ELSE 1 END) AS [CheckTaskWorkOverdraft],
			[ContractComments],
			[BankAccountDefault],
			[GroupingAdvanceCalculations],
			[StatementCurrencyPoint],
			(CASE [ShowPrice] WHEN 'false' THEN 0 ELSE 1 END) AS [ShowPrice],
			[UseSubProjects]
		FROM
			OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
				WITH (
					[ID] int,
					[Date] varchar(19),
					[Number] varchar(32),
					[NumerationCode] varchar(32),
					[FileAs] nvarchar(256),
					[ProjectTypeID] int,
					[SupplierCompanyID] int,
					[ProjectManagerEmployeeID] int,
					[CustomerCompanyID] int,
					[CustomerFinanceManagerID] int,
					[ResponsiblePersonEmployeeID] int,
					[PriorityID] int,
					[ProjectLanguageCode] varchar(32),
					[CurrencyCode] char(3),
					[CostCenterID] int,
					[Budget] money,
					[ContractNumber] varchar(32),
					[ContractDate] varchar(19),
					[ContractEndDate] varchar(19),
					[ContractSubject] nvarchar(256),
					[ApplyVAT] varchar(5),
					[InvoiceExpirationPeriod] int,
					[InvoiceExpirationPeriodType] int,
					[WSSDocumentsURL] varchar(512),
					[Comments] nvarchar(max),
					[RoundingInterval] int,
					[RoundingMode] int,
					[Billable] varchar(5),
					[SupportsRequestManagement] varchar(5),
					[RatesWithVAT] varchar(5),
					[PaymentCurrencyPoint] int,
					[InitialBalance] money,
					[BaseInitialBalance] money,
					[InvoiceCurrency] int,
					[StatementCurrency] int,
					[FactureCurrency] int,
					[Scale] int,
					[FolderID] int,
					[EndDate] varchar(19),
					[GroupCalculationLines] varchar(5),
					[CheckTaskWorkOverdraft] varchar(5),
					[ContractComments] nvarchar(max),
					[ShowActivityTypes] varchar(5),
					[BankAccountDefault] int,
					[GroupingAdvanceCalculations] int,
					[StatementCurrencyPoint] int,
					[ShowPrice] varchar(5),
					[UseSubProjects] bit
					)
				) as [XmlTable] ON
			([Project].[ID] = [XmlTable].[ID])
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	UPDATE [ProjectDetail]
	SET
		[DueDate] = CASE 
			WHEN [Project].[MsProjectID] IS NULL THEN [XmlTable].[DueDate]
			ELSE [ProjectDetail].[DueDate]
		END,
		[DiscountTypeByTime] = @DiscountTypeByTime,
		[DiscountViewByTime] = @DiscountViewByTime,
		[DiscountByTime] = @DiscountByTime,
		
		[DiscountTypeByExpense] = @DiscountTypeByExpense,
		[DiscountViewByExpense] = @DiscountViewByExpense,
		[DiscountByExpense] = @DiscountByExpense,
		
		[DiscountTypeByPhone] = @DiscountTypeByPhone,
		[DiscountViewByPhone] = @DiscountViewByPhone,
		[DiscountByPhone] = @DiscountByPhone,
		
		[DiscountTypeByServiceRequest] = @DiscountTypeByServiceRequest,
		[DiscountViewByServiceRequest] = @DiscountViewByServiceRequest,
		[DiscountByServiceRequest] = @DiscountByServiceRequest
	FROM
		[ProjectDetail]
		INNER JOIN [Project] 
			ON [Project].[ID] = [ProjectDetail].[ID]
		INNER JOIN
		(
		SELECT
			[ID],
			CAST([DueDate] as datetime) as [DueDate]
		FROM
			OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
				WITH (
					[ID] int,
					[DueDate] varchar(19)
					)
		) AS [XmlTable] ON
			[Project].[ID] = [XmlTable].[ID]
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DELETE FROM [ProjectActivityType] WHERE [ProjectActivityType].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [ProjectActivityType]
			([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		(CASE [Billable] WHEN 'false' THEN 0 ELSE 1 END),
		(CASE [Actively] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/ProjectActivityType', 2)
			WITH (
				[ID] int 'ID',
				[Billable] varchar(5) 'Billable',
				[Actively] varchar(5) 'Actively'
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DELETE FROM [ProjectExpenseCode] WHERE [ProjectExpenseCode].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		(CASE [Billable] WHEN 'false' THEN 0 ELSE 1 END),
		(CASE [Actively] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/ProjectExpenseCode', 2)
			WITH (
				[ID] int 'ID',
				[Billable] varchar(5) 'Billable',
				[Actively] varchar(5) 'Actively'
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE 
		@Now			TDate,
		@CurrentUserID	TIDentifier

	SET @currentUserID = dbo.adfGetCurrentUserID()
	SET @Now = GETDATE()
	IF @BudgetID IS NOT NULL AND (
		EXISTS(
			SELECT *
			FROM 
				[Budget] 
				LEFT OUTER JOIN [Reminder]
					ON ([Reminder].[DocumentClass] = [Budget].[Class] AND
						[Reminder].[DocumentID] = [Budget].[ID] AND
						[Reminder].[Subtype] = 'BC')
				LEFT OUTER JOIN [UserReminder]
					ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
						[UserReminder].[UserID] = @CurrentUserID)
			WHERE 
				[Budget].[ID] = @BudgetID 
				AND 
				(ISNULL([NextCalculationDate], @Now) <> ISNULL(@BudgetNextCalculationDate, @Now)
				OR ISNULL([UserReminder].[State], 0) <> @ReminderState)))
	BEGIN
		UPDATE [Budget]
		SET [NextCalculationDate] = @BudgetNextCalculationDate
		WHERE [ID] = @BudgetID AND [State] IN (1, 2)

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		DECLARE
			@ReminderInterval				TTimeSpan,
			@WorkTimeStart					TCount,
			@value							TVariant

		EXEC adfParameterGet 'WorkTimeStart1', 'Pjm5', @value OUTPUT	
		SET  @WorkTimeStart = CAST(@value AS int)

		SET @ReminderInterval = -@WorkTimeStart
		EXEC @rv = pjm6BudgetReminderCreate @BudgetID,
			@BudgetNextCalculationDate, @ReminderState, @ReminderInterval
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN @rv
		END
	END

	DECLARE 
			@SubscriptionRuleID TIdentifier,
			@UserID TIdentifier,
			@OpenIssueID TIdentifier,
			@ResolveIssueID TIdentifier,
			@PostponeIssueID TIdentifier,
			@CloseIssueID TIdentifier
			
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@OpenIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalOpenIssue'),
		@ResolveIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalResolveIssue'),
		@PostponeIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalPostponeIssue'),
		@CloseIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalCloseIssue')
	
	EXEC @rv = dbo.pjm5ExternalSubscriptionRuleCreate @SubscriptionRuleID OUTPUT, @ID, @UserID
	IF @rv != 0 OR @SubscriptionRuleID IS NULL
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	IF @ExternalNotificationOpenIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @OpenIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationResolveIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @ResolveIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationPostponeIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @PostponeIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationCloseIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @CloseIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN @rv
		END
	END
	
	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm5ProjectGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ProjectUpdate TO PUBLIC
GO