 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateTasksBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateTasksBrowse'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateTasksBrowse]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateTasksBrowse'
GO

/******************************************************************************
**		File: pjm5ProjectTemplateTasksBrowse.sql
**		Name: pjm5ProjectTemplateTasksBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectTemplateTasksBrowse]
	@ID TIdentifier,
	@StartDate TDate
AS
	SET NOCOUNT ON
	DECLARE 
		@BaseDate TDate,
		@ShiftDays TCount
	SELECT @BaseDate = [Date] FROM [Project] WHERE [ID] = @ID
	SELECT @ShiftDays = DATEDIFF(day, @BaseDate, @StartDate)
	
		
	SELECT
		[ID],
		[ProjectID],
		dbo.fnPjm5ShiftDate([StartDate], @ShiftDays) AS [StartDate],
		[Duration] as [Duration],
		[ManHour],
		dbo.fnPjm5AddWorkingDays(dbo.fnPjm5ShiftDate([StartDate], @ShiftDays),[Duration]) AS [DueDate]
	FROM
		[Task]
	WHERE
		[ProjectID] = @ID
		
	SELECT
		[TaskID],
		[AssignmentID],
		[Work],
		[Units]
	FROM
		[TaskAssignment]
		INNER JOIN [Task]
			ON [Task].[ID] = [TaskAssignment].[TaskID]
	WHERE
		[Task].[ProjectID] = @ID
		
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectTemplateTasksBrowse] TO PUBLIC
GO