IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6SubProjectRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6SubProjectRemove'
		DROP PROCEDURE [dbo].[pjm6SubProjectRemove]
	END
GO

PRINT 'Creating procedure pjm6SubProjectRemove'
GO

/******************************************************************************
**		File: pjm6SubProjectRemove.sql
**		Name: pjm6SubProjectRemove
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.07.11	SYV				 	
*******************************************************************************/
CREATE PROCEDURE [pjm6SubProjectRemove]
	--@ID int,
	@SubProjectID int
AS
	SET NOCOUNT ON
	DECLARE 
		@TaskID TIdentifier,
		@ProjectID TIdentifier,
		@TaskIndex TCount

	SELECT
		@TaskID = [Task].[ID],
		@ProjectID = [Task].[ProjectID],
		@TaskIndex = [TaskWbs].[TaskIndex]
	FROM 
		[Task]
		INNER JOIN [TaskWbs]
			ON [Task].[ID] = [TaskWbs].[TaskID]
	WHERE 
		[Task].[SubProjectID] = @SubProjectID 

		
	BEGIN TRANSACTION
	DELETE
		[Task]
	WHERE
		[ID] = @TaskID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END;
		
	WITH [Tasks] ([ID], [RowNumber]) AS
	(
		SELECT
			[TaskWbs].[TaskID],
			ROW_NUMBER() OVER (ORDER BY [TaskWbs].[TaskIndex] ASC)
		FROM
			[TaskWbs]
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskWbs].[TaskID]
		WHERE
			[Task].[ProjectID] = @ProjectID AND 
			[Task].[ID] != @TaskID AND 
			[TaskWbs].[TaskIndex] >= @TaskIndex
	)
	UPDATE
		[TaskWbs]
	SET
		[TaskIndex] = @TaskIndex + ([Tasks].[RowNumber] - 1)
	FROM 
		[TaskWbs]
		INNER JOIN [Tasks]
			ON [Tasks].[ID] = [TaskWbs].[TaskID]
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6SubProjectRemove TO PUBLIC
GO