IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationBrowse'
		DROP PROCEDURE [dbo].[pjm5QualificationBrowse]
	END
GO

PRINT 'Creating procedure pjm5QualificationBrowse'
GO

/******************************************************************************
**		File: pjm5QualificationBrowse.sql
**		Name: pjm5QualificationBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5QualificationBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[Qualification].[Class],
		[Qualification].[ID],
		[Qualification].[State],
		[Qualification].[Flag],
		[Qualification].[Code],
		[Qualification].[FileAs],
		[Qualification].[ActivityTypeID],
		[QualificationRate].[Standard] as [Standard],
		[QualificationRate].[Overtime] as [Overtime],
		[QualificationRate].[CurrencyCode] as [CurrencyCode],
		[Qualification].[Comments],
		[Qualification].[Created],
		[Qualification].[CreatedBy],
		[Qualification].[Modified],
		[Qualification].[ModifiedBy],
		[Qualification].[Timestamp]
	FROM
		[Qualification] LEFT OUTER JOIN [QualificationRate] ON
			([Qualification].[ID] = [QualificationRate].[QualificationID]
			AND [QualificationRate].[CurrencyCode]=dbo.fnPjm5GetAccountingCurrency())
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Qualification].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5QualificationBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationGet'
		DROP PROCEDURE [dbo].[pjm5QualificationGet]
	END
GO

PRINT 'Creating procedure pjm5QualificationGet'
GO

/******************************************************************************
**		File: pjm5QualificationGet.sql
**		Name: pjm5QualificationGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5QualificationGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Qualification].[Class],
		[Qualification].[ID],
		[Qualification].[State],
		[Qualification].[Flag],
		[Qualification].[Code],
		[Qualification].[FileAs],
		[Qualification].[ActivityTypeID],
		[Qualification].[Comments],
		[Qualification].[Created],
		[Qualification].[CreatedBy],
		[Qualification].[Modified],
		[Qualification].[ModifiedBy],
		[Qualification].[Timestamp]
	FROM
		[Qualification]
	WHERE
		[Qualification].[ID] = @ID
		
	SELECT
		[QualificationRate].[Standard],
		[QualificationRate].[Overtime],
		[QualificationRate].[CurrencyCode]
	FROM
		[QualificationRate]
	WHERE
		[QualificationRate].[QualificationID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5QualificationGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationCreate'
		DROP PROCEDURE [dbo].[pjm5QualificationCreate]
	END
GO

PRINT 'Creating procedure pjm5QualificationCreate'
GO

/******************************************************************************
**		File: pjm5QualificationCreate.sql
**		Name: pjm5QualificationCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5QualificationCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@ActivityTypeID TIdentifier,
			@Comments TNotes,
			@doc INT
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('a93253fa-ea27-48ac-9620-10ee3421b69d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@FileAs = [FileAs],
		@Code = [Code],
		@Comments = [Comments],
		@ActivityTypeID = [ActivityTypeID]
	FROM
		OPENXML(@doc, '/pjm5QualificationGet/Qualification', 2)
			WITH (
				[FileAs] nvarchar(256),
				[ActivityTypeID] int,
				[Code] varchar(32),
				[Comments] nvarchar(max)
				)
	BEGIN TRANSACTION
	
	INSERT INTO [Qualification]
		([Flag], [State], [Code], [FileAs], [Comments], [ActivityTypeID])
	VALUES
		(0, @State, @Code, @FileAs, @Comments, @ActivityTypeID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [QualificationRate]
		([QualificationID], [CurrencyCode], [Standard], [Overtime])
	SELECT
		@ID,
		[CurrencyCode],
		[Standard],
		[Overtime]
	FROM
		OPENXML(@doc, '/pjm5QualificationGet/QualificationRate', 2)
			WITH (
				[Standard] money,
				[Overtime] money,
				[CurrencyCode] varchar(3)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm5QualificationGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5QualificationCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationUpdate'
		DROP PROCEDURE [dbo].[pjm5QualificationUpdate]
	END
GO

PRINT 'Creating procedure pjm5QualificationUpdate'
GO

/******************************************************************************
**		File: pjm5QualificationUpdate.sql
**		Name: pjm5QualificationUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5QualificationUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@Comments TNotes,
			@ActivityTypeID TIdentifier,
			@doc INT
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID = [ID],
		@FileAs = [FileAs],
		@Code = [Code],
		@Comments = [Comments],
		@ActivityTypeID = [ActivityTypeID]
	FROM
		OPENXML(@doc, '/pjm5QualificationGet/Qualification', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[ActivityTypeID] int,
				[Code] varchar(32),
				[Comments] nvarchar(max)
				)
	BEGIN TRANSACTION

	UPDATE 
		[Qualification]
	SET
		[Qualification].[Code] = @Code,
		[Qualification].[FileAs] = @FileAs,
		[Qualification].[ActivityTypeID] = @ActivityTypeID,
		[Qualification].[Comments] = @Comments,
		[Qualification].[Modified] = GETDATE(),
		[Qualification].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Qualification].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DELETE [QualificationRate] WHERE [QualificationID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	INSERT INTO [QualificationRate]
		([QualificationID], [CurrencyCode], [Standard], [Overtime])
	SELECT
		@ID,
		[CurrencyCode],
		[Standard],
		[Overtime]
	FROM
		OPENXML(@doc, '/pjm5QualificationGet/QualificationRate', 2)
			WITH (
				[Standard] money,
				[Overtime] money,
				[CurrencyCode] varchar(3)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm5QualificationGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5QualificationUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationDelete'
		DROP PROCEDURE [dbo].[pjm5QualificationDelete]
	END
GO

PRINT 'Creating procedure pjm5QualificationDelete'
GO

/******************************************************************************
**		File: pjm5QualificationDelete.sql
**		Name: pjm5QualificationDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5QualificationDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Qualification] WHERE [Qualification].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5QualificationDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5QualificationChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5QualificationChangeState'
		DROP PROCEDURE [dbo].[pjm5QualificationChangeState]
	END
GO

PRINT 'Creating procedure pjm5QualificationChangeState'
GO

/******************************************************************************
**		File: pjm5QualificationChangeState.sql
**		Name: pjm5QualificationChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 16:56:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5QualificationChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Qualification].[Class],
		@FromState = [Qualification].[State]
	FROM
		[Qualification]
	WHERE
		[Qualification].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Qualification]
	SET
		[Qualification].[State] = @ToState,
		[Qualification].[Modified] = GETDATE(),
		[Qualification].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Qualification].[ID] = @ID
	AND
		[Qualification].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5QualificationChangeState TO PUBLIC
GO
 