IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportEmployeeTimeAllocationByProjectHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportEmployeeTimeAllocationByProjectHeader'
		DROP  Procedure  ReportEmployeeTimeAllocationByProjectHeader
	END

GO

PRINT 'Creating Procedure ReportEmployeeTimeAllocationByProjectHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE PROCEDURE [dbo].[ReportEmployeeTimeAllocationByProjectHeader]
        @CompanyID TIdentifier,
        @DivisionSelector int,
        @DivisionID TIdentifier,
        @DateSelector int,
        @Date TDate,
        @PeriodStart TDateTime OUTPUT,
        @PeriodEnd TDateTime OUTPUT

AS

SET NOCOUNT ON

DECLARE
          @CompanyName TName,
          @DivisionName TName,
          @WorkingDays	decimal(18,2),
          @UserName TName,
          @UserID TIdentifier

SET @CompanyName = '( )'

   SELECT 
         @CompanyName = [Company].[FileAs]
   FROM
         [Company]
   WHERE 
         [Company].[ID] = @CompanyID   

   SET @DivisionName = CASE @DivisionSelector
                            WHEN 0 THEN '()'       
                            WHEN 1 THEN '( )'
                            WHEN 2 THEN (SELECT 
               [Division].[FileAs]
         FROM
               [Division]
         WHERE 
               [Division].[ID] = @DivisionID)
                       END
                       
   IF (@DateSelector = 2 AND YEAR(@Date) = YEAR(GETDATE()) AND MONTH(@Date) = MONTH(GETDATE()))
	BEGIN
		SET @DateSelector = 0
	END
   
   Set @PeriodStart = CASE @DateSelector
                           WHEN 0 THEN CAST(CONVERT(varchar(8), DATEADD(day, 1 - DAY(GetDate()), GetDate()), 112) AS datetime)
                           WHEN 1 THEN CAST(CONVERT(varchar(8), DATEADD(day, 1 - DAY(GetDate()), DATEADD(month, - 1, GETDATE())), 112) AS datetime)
                           --WHEN 2 THEN CAST(CONVERT(varchar(8), DATEADD(day, 1 - DAY(@Date), @Date), 112) AS datetime)
                           WHEN 2 THEN @PeriodStart
                      END

   Set @PeriodEnd = CASE @DateSelector
                           WHEN 0 THEN CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
                           WHEN 1 THEN CAST(CONVERT(varchar(8), DATEADD(day, - DAY(GETDATE()), GETDATE()), 112) AS datetime)
                           --WHEN 2 THEN CAST(CONVERT(varchar(8), DATEADD(day, - DAY(@Date), DATEADD(month, 1, @Date)), 112) AS datetime)
                           WHEN 2 THEN @PeriodEnd + 1
                     END
   
  	
   SET DATEFIRST 7
   SET @WorkingDays = dbo.fnPjm5GetWorkingDays(@PeriodStart, @PeriodEnd)
   SET DATEFIRST 1
   IF @DateSelector <> 2
   BEGIN
		SET @PeriodEnd = DATEADD(day, 1, @PeriodEnd)
   END

   SET @UserID = dbo.adfGetCurrentUserID()
	
   SELECT
         @UserName = [Trustee].[DisplayName]
   FROM 
         [Trustee]
   WHERE 
         [Trustee].[ID] = @UserID

   SELECT
         @CompanyName  AS [CompanyName],
         @DivisionName AS [DivisionName],
         @WorkingDays AS [WorkingDays],
         @WorkingDays*8 as [WorkingHours],
         @UserName as [UserName],
         @DateSelector as [DateType],	--
         @PeriodStart as [StartDate],	--
         @PeriodEnd as [EndDate]		--


RETURN 0

GO

GRANT EXEC ON ReportEmployeeTimeAllocationByProjectHeader TO PUBLIC

GO
