IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportLoadOfEmployeeHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportLoadOfEmployeeHeader'
		DROP  Procedure  ReportLoadOfEmployeeHeader
	END

GO

PRINT 'Creating Procedure ReportLoadOfEmployeeHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportLoadOfEmployeeHeader
	@PeriodStart datetime,
	@PeriodEnd datetime,
	@EmployeeID int
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@EmployeeName	TName,
		@CompanyName	TName,
		@CompanyID		TIdentifier,
		@Qualification	TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
	
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00
							
	SET @UserID = dbo.adfGetCurrentUserID()
			
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@EmployeeName = [Employee].[FileAs],
		@CompanyName = [Company].[FileAs],
		@CompanyID = [Company].[ID],
		@Qualification = [Qualification].[FileAs]		
	FROM 
		[Employee]
		LEFT OUTER JOIN [Company]
			ON [Employee].[CompanyID] = [Company].[ID]
		LEFT OUTER JOIN [Qualification]
			ON [Employee].[QualificationID]	= [Qualification].[ID]
	WHERE
		[Employee].[ID] = @EmployeeID 
		
		
	SELECT
		@EmployeeName AS [EmployeeName],
		@CompanyName AS [CompanyName],
		@Qualification AS [Qualification],
		@PeriodStart AS [Date],
		@WorkTime AS [WorkTime],
		@UserName AS [UserName],	
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= @PeriodStart AND [CompanyCalendar].[Date] < DATEADD(day, 1, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= @PeriodStart AND [CompanyCalendar].[Date] < DATEADD(day, 1, @PeriodStart) AND [EmployeeCalendar].[Working] IS  NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work01],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 1, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 2, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 1, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 2, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work02],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 2, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 3, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 2, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 3, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work03],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 3, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 4, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 3, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 4, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work04],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 4, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 5, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 4, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 5, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work05],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 5, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 6, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 5, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 6, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work06],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 6, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 7, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 6, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 7, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work07],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 7, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 8, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 7, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 8, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work08],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 8, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 9, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 8, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 9, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work09],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 9, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 10, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 9, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 10, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work10],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 10, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 11, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 10, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 11, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work11],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 11, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 12, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 11, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 12, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work12],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 12, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 13, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 12, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 13, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work13],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 13, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 14, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 13, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 14, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work14],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 14, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 15, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 14, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 15, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work15],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 15, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 16, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 15, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 16, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work16],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 16, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 17, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 16, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 17, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work17],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 17, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 18, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 17, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 18, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work18],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 18, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 19, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 18, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 19, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work19],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 19, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 20, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 19, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 20, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work20],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 20, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 21, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 20, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 21, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work21],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 21, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 22, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 21, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 22, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work22],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 22, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 23, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 22, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 23, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work23],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 23, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 24, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 23, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 24, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work24],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 24, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 25, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 24, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 25, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work25],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 25, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 26, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 25, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 26, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work26],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 26, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 27, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 26, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 27, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work27],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 27, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 28, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 27, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 28, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work28],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 28, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 29, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 28, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 29, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work29],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 29, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 30, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 29, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 30, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END) AS [Work30],
		SUM(CASE
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 30, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 31, @PeriodStart) AND [EmployeeCalendar].[Working] IS NULL
			 THEN [CompanyCalendar].[Working]
			WHEN [CompanyCalendar].[Date] >= DATEADD(day, 30, @PeriodStart) AND [CompanyCalendar].[Date] < DATEADD(day, 31, @PeriodStart) AND [EmployeeCalendar].[Working] IS NOT NULL
			 THEN [EmployeeCalendar].[Working]
		END)	AS [Work31]		
	FROM
		[CompanyCalendar]
		LEFT OUTER JOIN [EmployeeCalendar]
			ON [CompanyCalendar].[Date] = [EmployeeCalendar].[Date] AND [EmployeeCalendar].[EmployeeID] = @EmployeeID
						   
	WHERE
		[CompanyCalendar].[Date] >= @PeriodStart AND [CompanyCalendar].[Date] < @PeriodEnd AND
		[CompanyCalendar].[CompanyID] = @CompanyID
	
	
RETURN 0
GO

GRANT EXEC ON ReportLoadOfEmployeeHeader TO PUBLIC

GO
