IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportProjectPlanOfOperationHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportProjectPlanOfOperationHeader'
		DROP  Procedure  ReportProjectPlanOfOperationHeader
	END

GO

PRINT 'Creating Procedure ReportProjectPlanOfOperationHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportProjectPlanOfOperationHeader
	@ProjectID		TIdentifier,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@DateSelector	int
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID

	SELECT
		[Project].[FileAs] AS [ProjectName],
		[Project].[Number] AS [ProjectCode],
		[SupplierCompany].[FileAs] AS [SupplierCompanyName],
		[CostCenter].[FileAs] AS [CostCenter],
		[Employee].[FileAs] AS [ManagerName],
		[CustomerCompany].[FileAs] AS [CustomerCompanyName],
		[Project].[Date] AS [StartDate],
		ISNULL([Project].[EndDate], [ProjectDetail].[DueDate]) AS [EndDate],
		CASE
			WHEN ISNULL([Project].[EndDate], [ProjectDetail].[DueDate]) IS NOT NULL
			THEN dbo.fnPjm5GetWorkingDays(GETDATE(), ISNULL([Project].[EndDate], [ProjectDetail].[DueDate]))
			ELSE NULL
		END AS [Remains],
		CASE
			WHEN ISNULL([Project].[EndDate], [ProjectDetail].[DueDate]) IS NOT NULL
			THEN dbo.fnPjm5GetWorkingDays(ISNULL(DATEADD(day, 1, [Project].[EndDate]), DATEADD(day, 1, [ProjectDetail].[DueDate])), GETDATE())
			ELSE NULL
		END AS [Exceed], 
		[Project].[State] AS [State],
		@UserName AS [UserName],
		@PeriodStart AS [PeriodStart],
		@PeriodEnd AS [PeriodEnd],
		@DateSelector AS [DateSelector]
	FROM 
		[Project]
		INNER JOIN [ProjectDetail]
			ON [ProjectDetail].[ID] = [Project].[ID]
		LEFT OUTER JOIN [Company] AS [CustomerCompany]
			ON [Project].[CustomerCompanyID] = [CustomerCompany].[ID]
		LEFT OUTER JOIN [Company] AS [SupplierCompany]
			ON [Project].[SupplierCompanyID] = [SupplierCompany].[ID]	
		LEFT OUTER JOIN [Employee]
			ON [Project].[ProjectManagerEmployeeID] = [Employee].[ID]
		LEFT OUTER JOIN [CostCenter]
			ON [Project].[CostCenterID] = [CostCenter].[ID]
	WHERE
		[Project].[ID] = @ProjectID

RETURN 0

GO

GRANT EXEC ON ReportProjectPlanOfOperationHeader TO PUBLIC

GO
