 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportResourceRequest]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportResourceRequest'
		DROP PROCEDURE [dbo].[ReportResourceRequest]
	END
GO

PRINT 'Creating procedure ReportResourceRequest'
GO

/******************************************************************************
**		File: ReportResourceRequest.sql
**		Name: ReportResourceRequest
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportResourceRequest]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @EmployeeID TIdentifier, @UserID TIdentifier, @UserName TName
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID();
	SET @UserID = dbo.adfGetCurrentUserID();
	SELECT @UserName = [Trustee].[DisplayName] FROM [Trustee] WHERE [Trustee].[ID] = @UserID
	
	SELECT
		[ResourceRequest].[Class],
		[ResourceRequest].[ID],
		[ResourceRequest].[State],
		[ResourceRequest].[Flag],
		[ResourceRequest].[FileAs],
		[ResourceRequest].[ProjectID],
		[Project].[Number] AS [ProjectNumber],
		[Project].[FileAs] AS [ProjectFileAs],
		[ResourceRequest].[EmployeeID],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[ResourceRequest].[PriorityID],
		[Priority].[Code] AS [PriorityCode],
		[Priority].[FileAs] AS [PriorityFileAs],
		[ResourceRequest].[StartTime],
		CAST([ResourceRequest].[Duration]/60.0 as decimal(8,2)) AS [Duration],
		DATEADD(minute,[ResourceRequest].[Duration],[ResourceRequest].[StartTime]) AS [EndTime],
		[ResourceRequest].[Comments],
		[ResourceRequest].[Created],
		[ResourceRequest].[CreatedBy],
		[ResourceRequest].[Modified],
		[ResourceRequest].[ModifiedBy],
		[Creator].[FileAs] AS [CreatorFileAs],
		@UserName AS [UserName],
		[MeetingRequest].[FileAs] AS [MeetingFileAs],
		[Resource].[FileAs] AS [ResourceFileAs],
		[ResourceType].[FileAs] AS [ResourceTypeFileAs]
	FROM
		[ResourceRequest]
		INNER JOIN [Resource]
			ON [Resource].[ID] = [ResourceRequest].[ResourceID]
		INNER JOIN [ResourceType]
			ON [ResourceType].[ID] = [Resource].[ResourceTypeID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [ResourceRequest].[EmployeeID]
		INNER JOIN [Priority]
			ON [Priority].[ID] = [ResourceRequest].[PriorityID]
		INNER JOIN [Employee] AS [Creator]
			ON [Creator].[UserID] = [ResourceRequest].[CreatedBy]
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [ResourceRequest].[ProjectID]
		LEFT OUTER JOIN [MeetingRequest]
			ON [MeetingRequest].[ID] = [ResourceRequest].[MeetingRequestID]	
	WHERE
		[ResourceRequest].[ID] = @ID
	
		
	SELECT
		[Note].[Created],
		[Note].[Text],
		[Employee].[FileAs]
	FROM
		[ResourceRequest]
		INNER JOIN [Note]
			ON [ResourceRequest].[ID] = [Note].[DocumentID] AND
			   [ResourceRequest].[Class] = [Note].[DocumentClass]
		INNER JOIN [Employee]
			ON ([Note].[CreatedBy] = [Employee].[UserID])
	WHERE
		[ResourceRequest].[ID] = @ID 
	ORDER BY
		[Note].[Created]
	RETURN 0
GO

GRANT EXECUTE ON [ReportResourceRequest] TO PUBLIC
GO

