IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportTimeSheetPresentation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportTimeSheetPresentation'
		DROP PROCEDURE [dbo].[ReportTimeSheetPresentation]
	END
GO

PRINT 'Creating procedure ReportTimeSheetPresentation'
GO

/******************************************************************************
**		File: ReportTimeSheetPresentation.sql
**		Name: ReportTimeSheetPresentation
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportTimeSheetPresentation]
	@EmployeeID		TIdentifier,
	@ProjectID		TIdentifier,
	@StateSelector	TBool,
	@PeriodStart	datetime
AS
	SET NOCOUNT ON	
	SET DATEFIRST 1	
	
	DECLARE 
		@ViewAllProjects TBool,
		@CurrentEmployeeID TIdentifier,
		@EmployeeName TName,
		@PeriodEnd	datetime,
		@FileAs TName,
		@Code TName
	SET @Code = 'Timesheet'

	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF @EmployeeID IS NULL SET @EmployeeID = @CurrentEmployeeID

	SET @PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime)
	SET @PeriodStart = DATEADD(day, 1 - DATEPART(weekday, @PeriodStart), @PeriodStart)
	SET @PeriodEnd = DATEADD(day, 7, @PeriodStart)
	
	DECLARE @l TLanguage;
	SET @l = dbo.adfGetLanguage()

	DECLARE @ProjectTable TABLE ([ID] int, [FileAs] nvarchar(max))
	INSERT INTO @ProjectTable ([ID], [FileAs])
	SELECT [ID], [FileAs]
	FROM [Project] 
	WHERE
		@ViewAllProjects = 1 OR
		dbo.fnPjm5IsProjectManager([ID], @CurrentEmployeeID) = 1 OR 
		dbo.fnPjm5IsProjectMember([ID], @CurrentEmployeeID) = 1

	DECLARE @table TABLE(
		[Class] int,
		[ID] int,
		[EmployeeID] int,
		[ProjectFileAs] nvarchar(256),
		[TaskFileAs] nvarchar(256),
		[ServiceAssignmentFileAs] nvarchar(256),
		[Billable] bit,
		[Chargeable] nvarchar(256),
		[Overtime] nvarchar(256),
		[Monday] decimal(18,4),
		[Tuesday] decimal(18,4),
		[Wednesday] decimal(18,4),
		[Thursday] decimal(18,4),
		[Friday] decimal(18,4),
		[Saturday] decimal(18,4),
		[Sunday] decimal(18,4),
		[Total] decimal(18,4)
	)
	INSERT INTO @table
	SELECT
		[Project].[Class],
		ISNULL([ProjectTable].[ID], -1),
		[TimeEntry].[EmployeeID],
		CASE @l
			WHEN 'en' THEN ISNULL([ProjectTable].[FileAs], '(others)')
			ELSE ISNULL([ProjectTable].[FileAs], '()')
		END AS [ProjectFileAs],
		[Task].[FileAs] AS [TaskFileAs],
		[ServiceAssignment].[FileAs] AS [ServiceAssignmentFileAs],
		[TimeEntry].[Billable],
		CASE 
			WHEN [TimeEntry].[Billable] = 1 AND @l = 'ru'
				THEN ''
			WHEN [TimeEntry].[Billable] = 0 AND @l = 'ru'
				THEN ' '
			WHEN [TimeEntry].[Billable] = 1 AND @l = 'en'
				THEN 'Chargeable'
			WHEN [TimeEntry].[Billable] = 0 AND @l = 'en'
				THEN 'Non Chargeable'
		END AS [Chargeable],
		CASE
			WHEN [TimeEntry].[Overtime] = 0 AND  @l = 'ru'
				THEN ''
			WHEN [TimeEntry].[Overtime] = 1 AND  @l = 'ru'
				THEN ''
			WHEN [TimeEntry].[Overtime] = 0 AND  @l = 'en'
				THEN 'No'
			WHEN [TimeEntry].[Overtime] = 1 AND  @l = 'en'
				THEN 'Yes'
		END AS [Overtime],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 1 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Monday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 2 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Tuesday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 3 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Wednesday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 4 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Thursday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 5 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Friday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 6 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Saturday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 7 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Sunday],
		ISNULL(SUM([TimeEntry].[BillableDuration]), 0.0) / 60.0 AS [Total]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
		LEFT OUTER JOIN @ProjectTable AS [ProjectTable]
			ON [ProjectTable].[ID] = [Project].[ID]
		LEFT OUTER JOIN [Task]
			ON [Task].[ID] = [TimeEntry].[TaskID] AND 
				[Task].[ProjectID] = [ProjectTable].[ID]
		LEFT OUTER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[ID] = [TimeEntry].[DocumentID] AND [ServiceAssignment].[Class] = [TimeEntry].[DocumentClass] AND 
				[ServiceAssignment].[ProjectID] = [ProjectTable].[ID]
		LEFT OUTER JOIN [ActivityType]
			ON [ActivityType].[ID] = [TimeEntry].[ActivityTypeID]
	WHERE
		[TimeEntry].[EmployeeID] = @EmployeeID AND 
		[TimeEntry].[StartTime] >= @PeriodStart AND 
		[TimeEntry].[StartTime] < @PeriodEnd AND
		(
			(@StateSelector = 0 AND [TimeEntry].[State] IN (3, 6)) OR	
			(@StateSelector = 1 AND [TimeEntry].[State] IN (2, 3, 6))
		) AND
		(
			@ProjectID IS NULL OR [Project].[ID] = @ProjectID
		)
	GROUP BY
		[Project].[Class],
		[ProjectTable].[ID],
		[TimeEntry].[EmployeeID],
		[ProjectTable].[FileAs],
		[Task].[FileAs],
		[ServiceAssignment].[FileAs],
		[TimeEntry].[Billable],
		[TimeEntry].[Overtime]
	ORDER BY
		CASE 
			WHEN [ProjectTable].[ID] IS NULL THEN 1
			ELSE 0
		END ASC,
		[ProjectTable].[FileAs]		
	DECLARE
		@BillableFlag int,
		@NotBillableFlag int
	SET @BillableFlag = 0
	SET @NotBillableFlag = 0
	IF EXISTS (SELECT * FROM @table WHERE [Billable] = 1)
		SET @BillableFlag = 1
	IF EXISTS (SELECT * FROM @table WHERE [Billable] = 0)
		SET @NotBillableFlag = 1
		
	SELECT @EmployeeName = [FileAs] FROM [Employee] WHERE [ID] = @EmployeeID
	SET @FileAs = @EmployeeName + ', ' + CONVERT(varchar(10), @PeriodStart, 105)
	SELECT
		@EmployeeID AS [EmployeeID],
		@EmployeeName AS [EmployeeName],
		@PeriodStart AS [PeriodStart],
		@PeriodEnd AS [PeriodEnd],
		@StateSelector AS [StateSelector],
		@FileAs AS [FileAs],
		@PeriodStart AS [Mon],
		DATEADD(day, 1, @PeriodStart) AS [Tue],
		DATEADD(day, 2, @PeriodStart) AS [Wed],
		DATEADD(day, 3, @PeriodStart) AS [Thu],
		DATEADD(day, 4, @PeriodStart) AS [Fri],
		DATEADD(day, 5, @PeriodStart) AS [Sat],
		DATEADD(day, 6, @PeriodStart) AS [Sun],
		(SELECT SUM([Monday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableMon],
		(SELECT SUM([Tuesday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableTue],
		(SELECT SUM([Wednesday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableWed],
		(SELECT SUM([Thursday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableThu],
		(SELECT SUM([Friday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableFri],
		(SELECT SUM([Saturday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableSat],
		(SELECT SUM([Sunday]) FROM @table WHERE [Billable] = 1) AS [TotalBillableSun],
		(SELECT SUM([Total]) FROM @table WHERE [Billable] = 1) AS [TotalBillable],
		
		(SELECT SUM([Monday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableMon],
		(SELECT SUM([Tuesday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableTue],
		(SELECT SUM([Wednesday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableWed],
		(SELECT SUM([Thursday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableThu],
		(SELECT SUM([Friday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableFri],
		(SELECT SUM([Saturday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableSat],
		(SELECT SUM([Sunday]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillableSun],
		(SELECT SUM([Total]) FROM @table WHERE [Billable] = 0) AS [TotalNotBillable],

		(SELECT SUM([Monday]) FROM @table) AS [TotalMon],
		(SELECT SUM([Tuesday]) FROM @table) AS [TotalTue],
		(SELECT SUM([Wednesday]) FROM @table) AS [TotalWed],
		(SELECT SUM([Thursday]) FROM @table) AS [TotalThu],
		(SELECT SUM([Friday]) FROM @table) AS [TotalFri],
		(SELECT SUM([Saturday]) FROM @table) AS [TotalSat],
		(SELECT SUM([Sunday]) FROM @table) AS [TotalSun],
		(SELECT SUM([Total]) FROM @table) AS [Total],
		
		@BillableFlag AS [BillableFlag],
		@NotBillableFlag AS [NotBillableFlag]

	SELECT
		[Class],
		[ID],
		[EmployeeID],
		[ProjectFileAs],
		[TaskFileAs],
		[ServiceAssignmentFileAs],
		[Billable],
		[Chargeable],
		[Overtime],
		CASE [Monday] 
		WHEN 0.00 THEN ' '
		ELSE CAST([Monday] AS varchar(40))
		END AS [Monday] ,
		CASE [Tuesday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Tuesday] AS varchar(40))
		END AS [Tuesday] ,
		CASE [Wednesday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Wednesday] AS varchar(40))
		END AS [Wednesday],
		CASE [Thursday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Thursday] AS varchar(40))
		END AS [Thursday],
		CASE [Friday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Friday] AS varchar(40))
		END AS [Friday],
		CASE [Saturday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Saturday] AS varchar(40))
		END AS [Saturday],
		CASE [Sunday]
		WHEN 0.00 THEN ' '
		ELSE CAST([Sunday] AS varchar(40))
		END AS [Sunday],
		[Total]
	FROM
		@table

	DECLARE @author TName, @employee TName
	SELECT @author = [FileAs] FROM [Employee] WHERE [ID] = dbo.adfGetCurrentEmployeeID()
	SELECT
      @EmployeeName AS [Title],
      @FileAs AS [Subject],
      @author AS [Author],
      NULL AS [Manager],
      [Company].[FileAs] AS [Company],
      NULL AS [Category],
      @Code AS [Keywords]
     FROM
		[Employee]
		LEFT OUTER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
     WHERE
		[Employee].[ID] = @EmployeeID
	RETURN 0
GO

GRANT EXECUTE ON [ReportTimeSheetPresentation] TO PUBLIC
GO
 