 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceTypeBrowse.sql
**		Name: pjm5ResourceTypeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceTypeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[ResourceType].[Class],
		[ResourceType].[ID],
		[ResourceType].[State],
		[ResourceType].[Flag],
		[ResourceType].[FileAs],
		[ResourceType].[Comments],
		[ResourceType].[Created],
		[ResourceType].[CreatedBy],
		[ResourceType].[Modified],
		[ResourceType].[ModifiedBy],
		[ResourceType].[Timestamp]
	FROM
		[ResourceType]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [ResourceType].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceTypeBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeGet'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeGet]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeGet'
GO

/******************************************************************************
**		File: pjm5ResourceTypeGet.sql
**		Name: pjm5ResourceTypeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceTypeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ResourceType].[Class],
		[ResourceType].[ID],
		[ResourceType].[State],
		[ResourceType].[Flag],
		[ResourceType].[FileAs],
		[ResourceType].[Comments],
		[ResourceType].[Created],
		[ResourceType].[CreatedBy],
		[ResourceType].[Modified],
		[ResourceType].[ModifiedBy],
		[ResourceType].[Timestamp]
	FROM
		[ResourceType]
	WHERE
		[ResourceType].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceTypeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeCreate'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeCreate]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeCreate'
GO

/******************************************************************************
**		File: pjm5ResourceTypeCreate.sql
**		Name: pjm5ResourceTypeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceTypeCreate]
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('adc53935-3890-46b3-97d4-78ca914e4b85')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ResourceType]
		([Flag], [State], [FileAs], [Comments])
	VALUES
		(0, @State, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5ResourceTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceTypeCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeUpdate'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeUpdate]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeUpdate'
GO

/******************************************************************************
**		File: pjm5ResourceTypeUpdate.sql
**		Name: pjm5ResourceTypeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceTypeUpdate
	@ID TIdentifier,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ResourceType]
	SET
		[ResourceType].[FileAs] = @FileAs,
		[ResourceType].[Comments] = @Comments,
		[ResourceType].[Modified] = DEFAULT,
		[ResourceType].[ModifiedBy] = DEFAULT
	WHERE
		[ResourceType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ResourceTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceTypeUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeDelete'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeDelete]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeDelete'
GO

/******************************************************************************
**		File: pjm5ResourceTypeDelete.sql
**		Name: pjm5ResourceTypeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceTypeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ResourceType] WHERE [ResourceType].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceTypeDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceTypeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceTypeChangeState'
		DROP PROCEDURE [dbo].[pjm5ResourceTypeChangeState]
	END
GO

PRINT 'Creating procedure pjm5ResourceTypeChangeState'
GO

/******************************************************************************
**		File: pjm5ResourceTypeChangeState.sql
**		Name: pjm5ResourceTypeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 16:40:04
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceTypeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ResourceType].[Class],
		@FromState = [ResourceType].[State]
	FROM
		[ResourceType]
	WHERE
		[ResourceType].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[ResourceType]
	SET
		[ResourceType].[State] = @ToState,
		[ResourceType].[Modified] = GETDATE(),
		[ResourceType].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ResourceType].[ID] = @ID
	AND
		[ResourceType].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceTypeChangeState TO PUBLIC
GO
