IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StartupWizardServiceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StartupWizardServiceBrowse'
		DROP PROCEDURE [dbo].[pjm5StartupWizardServiceBrowse]
	END
GO

PRINT 'Creating procedure pjm5StartupWizardServiceBrowse'
GO

/******************************************************************************
**		File: pjm5StartupWizardServiceBrowse.sql
**		Name: pjm5StartupWizardServiceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StartupWizardServiceBrowse]
AS
	SET NOCOUNT ON
	
	SELECT
		[Service].[Class],
		[Service].[ID],
		[Service].[State],
		[Service].[Flag],
		[Service].[Code],
		[Service].[FileAs],
		[Service].[PaymentTermID],
		[PaymentTerm].[FileAs] AS [PaymentTermFileAs],
		[Service].[ServiceTypeID],
		[ServiceType].[Code] AS [ServiceTypeCode],
		[ServiceType].[FileAs] AS [ServiceTypeFileAs],
		[Service].[UOMID],
		[Service].[Comments],
		[Service].[Created],
		[Service].[CreatedBy],
		[Service].[Modified],
		[Service].[ModifiedBy],
		[Service].[Timestamp]
	FROM
		[Service]
		INNER JOIN [ServiceType]
			ON [ServiceType].[ID] = [Service].[ServiceTypeID]
		INNER JOIN [PaymentTerm]
			ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
	WHERE
		[Service].[State] = 1
		
	RETURN 0
GO
GRANT EXECUTE ON [pjm5StartupWizardServiceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceBrowse.sql
**		Name: pjm5ServiceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceBrowse]
	@StateSelector INT
AS
	DECLARE @VAT TPercent
	DECLARE @CurrencyCode TCode3
	
	SET NOCOUNT ON
	
	SET @VAT = dbo.fnPjm5GetVATRate()
	SET @CurrencyCode = dbo.fnPjm5GetAccountingCurrency()
	
	SELECT
		[Service].[Class],
		[Service].[ID],
		[Service].[State],
		[Service].[Flag],
		[Service].[PaymentTermID],
		[Service].[ServiceTypeID],
		[Service].[Code],
		[Service].[FileAs],
		[Service].[VATIsIncluded],
		(CASE WHEN [Service].[VATIsIncluded] = 0 THEN [ServicePrice].[Price] 
			ELSE CAST(CAST([ServicePrice].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END) as [PriceWOVAT],
		(CASE WHEN [Service].[VATIsIncluded] = 1 THEN [ServicePrice].[Price]
			ELSE CAST(CAST([ServicePrice].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) as [PriceWithVAT],
		[ServicePrice].[CurrencyCode],
		[Service].[UOMID],
		[Service].[Comments],
		[Service].[Created],
		[Service].[CreatedBy],
		[Service].[Modified],
		[Service].[ModifiedBy],
		[Service].[Timestamp]
	FROM
		[Service] LEFT OUTER JOIN [ServicePrice]
			ON ([Service].[ID] = [ServicePrice].[ServiceID] AND
				[ServicePrice].[CurrencyCode] = @CurrencyCode)
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Service].[State] = @StateSelector))
		
	RETURN 0
GO
GRANT EXECUTE ON [pjm5ServiceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceGet'
		DROP PROCEDURE [dbo].[pjm5ServiceGet]
	END
GO

PRINT 'Creating procedure pjm5ServiceGet'
GO

/******************************************************************************
**		File: pjm5ServiceGet.sql
**		Name: pjm5ServiceGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceGet]
	@ID TIdentifier
AS
	DECLARE @VAT TPercent

	SET NOCOUNT ON
	SET @VAT = dbo.fnPjm5GetVATRate()
	
	SELECT
		[Service].[Class],
		[Service].[ID],
		[Service].[State],
		[Service].[Flag],
		[Service].[PaymentTermID],
		[Service].[ServiceTypeID],
		[Service].[Code],
		[Service].[FileAs],
		[Service].[UOMID],
		[Service].[VATIsIncluded],
		[Service].[Comments],
		[Service].[Created],
		[Service].[CreatedBy],
		[Service].[Modified],
		[Service].[ModifiedBy],
		[Service].[Timestamp]
	FROM
		[Service]
	WHERE
		[Service].[ID] = @ID
		
	SELECT
		(CASE WHEN [Service].[VATIsIncluded] = 1 THEN [ServicePrice].[Price]
			ELSE CAST(CAST([ServicePrice].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) as [PriceWithVAT],
		[ServicePrice].[CurrencyCode],
		(CASE WHEN [Service].[VATIsIncluded] = 0 THEN [ServicePrice].[Price] 
			ELSE CAST(CAST([ServicePrice].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END) as [PriceWOVAT],
		((CASE WHEN [Service].[VATIsIncluded] = 1 THEN [ServicePrice].[Price]
			ELSE CAST(CAST([ServicePrice].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) -
		(CASE WHEN [Service].[VATIsIncluded] = 0 THEN [ServicePrice].[Price] 
			ELSE CAST(CAST([ServicePrice].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END)) as [VAT]
	FROM
		[ServicePrice] INNER JOIN [Service]
			ON ([ServicePrice].[ServiceID] = [Service].[ID])
	WHERE
		[ServicePrice].[ServiceID] = @ID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceCreate'
		DROP PROCEDURE [dbo].[pjm5ServiceCreate]
	END
GO

PRINT 'Creating procedure pjm5ServiceCreate'
GO

/******************************************************************************
**		File: pjm5ServiceCreate.sql
**		Name: pjm5ServiceCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@PaymentTermID TIdentifier,
			@ServiceTypeID TIdentifier,
			@UOMID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@VATIsIncluded TBool,
			@Comments TNotes,
			@doc INT
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('7fb7b48c-b9b8-41fc-a243-fa13832d0167')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@FileAs = [FileAs],
		@Code = [Code],
		@Comments = [Comments],
		@PaymentTermID = [PaymentTermID],
		@ServiceTypeID = [ServiceTypeID],
		@UOMID = [UOMID],
		@VATIsIncluded = (CASE [VATIsIncluded] WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		OPENXML(@doc, '/pjm5ServiceGet/Service', 2)
			WITH (
				[FileAs] nvarchar(256),
				[Code] varchar(32),
				[Comments] nvarchar(max),
				[PaymentTermID] int,
				[ServiceTypeID] int,
				[UOMID] int,
				[VATIsIncluded] varchar(5)
				)
	BEGIN TRANSACTION

	INSERT INTO [Service]
		([Flag], [State], [PaymentTermID], [ServiceTypeID], [Code], [FileAs], [VATIsIncluded], [UOMID], [Comments])
	VALUES
		(0, @State, @PaymentTermID, @ServiceTypeID, @Code, @FileAs, @VATIsIncluded, @UOMID, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [ServicePrice]
		([ServiceID], [CurrencyCode], [Price])
	SELECT
		@ID,
		[CurrencyCode],
		(CASE WHEN @VATIsIncluded = 1 THEN [PriceWithVAT] ELSE [PriceWOVAT] END)
	FROM
		OPENXML(@doc, '/pjm5ServiceGet/ServicePrice', 2)
			WITH (
				[PriceWOVAT] money,
				[PriceWithVAT] money,
				[CurrencyCode] varchar(3)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm5ServiceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceUpdate'
		DROP PROCEDURE [dbo].[pjm5ServiceUpdate]
	END
GO

PRINT 'Creating procedure pjm5ServiceUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceUpdate.sql
**		Name: pjm5ServiceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@PaymentTermID TIdentifier,
			@ServiceTypeID TIdentifier,
			@UOMID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@VATIsIncluded TBool,
			@Price TMoney,
			@CurrencyCode TCode3,
			@Comments TNotes,
			@doc INT,
			@PrevTermID TIdentifier
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID = [XmlTable].[ID],
		@FileAs = [XmlTable].[FileAs],
		@Code = [XmlTable].[Code],
		@Comments = [XmlTable].[Comments],
		@PaymentTermID = [XmlTable].[PaymentTermID],
		@ServiceTypeID = [XmlTable].[ServiceTypeID],
		@UOMID = [XmlTable].[UOMID],
		@VATIsIncluded = (CASE [XmlTable].[VATIsIncluded] WHEN 'false' THEN 0 ELSE 1 END),
		@PrevTermID = [Service].[PaymentTermID]
	FROM
		OPENXML(@doc, '/pjm5ServiceGet/Service', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[Code] varchar(32),
				[Comments] nvarchar(max),
				[PaymentTermID] int,
				[ServiceTypeID] int,
				[UOMID] int,
				[VATIsIncluded] varchar(5)
				) AS [XmlTable]
		INNER JOIN [Service]
			ON [Service].[ID] = [XmlTable].[ID]

	IF @PaymentTermID != @PrevTermID AND
		EXISTS(
			SELECT *
			FROM
				[ServiceAssignment]
			WHERE
				[ServiceAssignment].[ServiceID] = @ID
		)	
	BEGIN
		RAISERROR('#CannotChangeServicePaymentTerm', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	BEGIN TRANSACTION
	
	UPDATE 
		[Service]
	SET
		[Service].[PaymentTermID] = @PaymentTermID,
		[Service].[ServiceTypeID] = @ServiceTypeID,
		[Service].[UOMID] = @UOMID,
		[Service].[Code] = @Code,
		[Service].[FileAs] = @FileAs,
		[Service].[VATIsIncluded] = @VATIsIncluded,
		[Service].[Comments] = @Comments,
		[Service].[Modified] = DEFAULT,
		[Service].[ModifiedBy] = DEFAULT
	WHERE
		[Service].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DELETE [ServicePrice] WHERE [ServiceID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	INSERT INTO [ServicePrice]
		([ServiceID], [CurrencyCode], [Price])
	SELECT
		@ID,
		[CurrencyCode],
		(CASE WHEN @VATIsIncluded = 1 THEN [PriceWithVAT] ELSE [PriceWOVAT] END)
	FROM
		OPENXML(@doc, '/pjm5ServiceGet/ServicePrice', 2)
			WITH (
				[PriceWOVAT] money,
				[PriceWithVAT] money,
				[CurrencyCode] varchar(3)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	EXEC pjm5ServiceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceDelete'
		DROP PROCEDURE [dbo].[pjm5ServiceDelete]
	END
GO

PRINT 'Creating procedure pjm5ServiceDelete'
GO

/******************************************************************************
**		File: pjm5ServiceDelete.sql
**		Name: pjm5ServiceDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Service] WHERE [Service].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceChangeState'
		DROP PROCEDURE [dbo].[pjm5ServiceChangeState]
	END
GO

PRINT 'Creating procedure pjm5ServiceChangeState'
GO

/******************************************************************************
**		File: pjm5ServiceChangeState.sql
**		Name: pjm5ServiceChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Service].[Class],
		@FromState = [Service].[State]
	FROM
		[Service]
	WHERE
		[Service].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Service]
	SET
		[Service].[State] = @ToState,
		[Service].[Modified] = DEFAULT,
		[Service].[ModifiedBy] = DEFAULT
	WHERE
		[Service].[ID] = @ID
	AND
		[Service].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceChangeState TO PUBLIC
GO
 