IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestCreateFromServiceAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestCreateFromServiceAssignment'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestCreateFromServiceAssignment]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestCreateFromServiceAssignment'
GO

/******************************************************************************
**		File: pjm5ServiceRequestCreateFromServiceAssignment.sql
**		Name: pjm5ServiceRequestCreateFromServiceAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestCreateFromServiceAssignment]
	@ServiceAssignmentID TIdentifier,
	@Number TCode,
	@FileAs TName,
	@Date TDate
AS
	DECLARE 
			@EmployeeID TIdentifier,
			@State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@Comments TNotes,
			@ServiceAssignmentPrice TMoney,
			@PaymentTermID TIdentifier,
			@ServiceTypeID TIdentifier,
			@rv int
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('47383a06-ed8c-4aec-9468-4c4e4da3be29')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		@ProjectID = [ServiceAssignment].[ProjectID],
		@ExecutorID = NULL,
		@PriorityID = 500,
		@StartDate = NULL,
		@DueDate = NULL,
		@Billable = 0,
		@VATIsIncluded = [ServiceAssignment].[VATIsIncluded],
		@Comments = NULL,
		@ServiceAssignmentPrice = [ServiceAssignment].[Price],
		@PaymentTermID = [ServiceAssignment].[PaymentTermID],
		@ServiceTypeID = [ServiceAssignment].[ServiceTypeID]
	FROM
		[ServiceAssignment]
	WHERE
		[ServiceAssignment].[ID] = @ServiceAssignmentID
	IF @PaymentTermID != 2
	BEGIN
		RAISERROR('#WrongServicePaymentTermForRequest', 18, -1)
		RETURN 1
	END
	
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0
	BEGIN
		IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
			dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	IF NOT EXISTS (SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [State] = 2)
	BEGIN
		RAISERROR('#ProjectIsNotOpen', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	INSERT INTO [ServiceRequest]
		([Flag], [State], [ProjectID], [EmployeeID], [PriorityID],
		 [Date], [Number], [FileAs], [StartDate], [DueDate], [Billable],
		 [VATIsIncluded], [Comments], [ServiceTypeID])	
	VALUES
		(0, @State,
		 @ProjectID, @ExecutorID, @PriorityID, @Date, @Number,
		 @FileAs, @StartDate, @DueDate, @Billable,
		 @VATIsIncluded, @Comments, @ServiceTypeID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	EXEC @rv = pjm5ServiceRequestLineUpdate
		NULL,
		@ID,
		@ServiceAssignmentID,
		1,
		0,
		@ServiceAssignmentPrice,
		NULL
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE
		@ReminderState TState,
		@ReminderInterval TTimeSpan,
		@CurrentUserID TIdentifier,
		@Class TClass
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@Class = dbo.adfGetClassByName('Pjm5.ServiceRequest'),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@Class, 'SD', @CurrentUserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@Class, 'SD', @CurrentUserID)
		
	EXEC @rv = pjm5ServiceRequestReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	COMMIT TRANSACTION

	EXEC pjm5ServiceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestCreateFromServiceAssignment TO PUBLIC
GO  