IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestCreateRecurrence]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestCreateRecurrence'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestCreateRecurrence]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestCreateRecurrence'
GO

/******************************************************************************
**		File: pjm5ServiceRequestCreateRecurrence.sql
**		Name: pjm5ServiceRequestCreateRecurrence
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestCreateRecurrence]
	@ID TIdentifier
AS
	DECLARE 
			@EmployeeID TIdentifier,
			@Class TClass,
			@State TState,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@Comments TNotes,
			@Description TNotes,
			@RecurrenceID TIdentifier, 
			@ServiceTypeID TIdentifier,
			@rv int
	
	SET NOCOUNT ON

	SELECT
		@Class = [Class],
		@ProjectID = [ProjectID],
		@ExecutorID = [EmployeeID],
		@PriorityID = [PriorityID],
		@Date = [Date],
		@Number = '',
		@FileAs = '',
		@StartDate = [StartDate],
		@DueDate = [DueDate],
		@Billable = [Billable],
		@VATIsIncluded = [VATIsIncluded],
		@ServiceTypeID = [ServiceTypeID],
		@Description = [Description],
		@Comments = [Comments]
	FROM
		[ServiceRequest]
	WHERE
		[ID] = @ID
	
	SELECT
		@RecurrenceID = [RecurrencePatternID]
	FROM
		[Document]
	WHERE
		[Class] = @Class AND [ID] = @ID
	IF @RecurrenceID IS NULL
		RETURN 0
	
	DECLARE 
		@NewID TIdentifier,
		@NewDate TDatetime,
		@NewDueDate TDatetime,
		@CurrentDate TDatetime

	SET @CurrentDate = GETDATE()
	SET @NewDate = dbo.fnPjm5RecurrenceGetNextDateTime(@RecurrenceID, @StartDate, @CurrentDate)
	IF @NewDate IS NULL
		RETURN 0

	SET @State = dbo.adfwfGetInitialState('47383a06-ed8c-4aec-9468-4c4e4da3be29')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0
	BEGIN
		IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
			dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	IF NOT EXISTS (SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [State] = 2)
	BEGIN
		RAISERROR('#ProjectIsNotOpen', 18, -1)
		RETURN 1
	END

	SET @NewDueDate = DATEADD(day, DATEDIFF(day, @StartDate, @NewDate), @DueDate)
	INSERT INTO [ServiceRequest]
		([Flag], [State], [ProjectID], [EmployeeID], [PriorityID],
		 [Date], [Number], [FileAs], [StartDate], [DueDate], [Billable],
		 [VATIsIncluded], [Comments], [ServiceTypeID], [Description])	
	VALUES
		(0, @State,
		 @ProjectID, @ExecutorID, @PriorityID, @NewDate, @Number,
		 @FileAs, @NewDate, @NewDueDate, @Billable,
		 @VATIsIncluded, @Comments, @ServiceTypeID, @Description)

	IF @@ERROR != 0
		RETURN 1

	SET @NewID = SCOPE_IDENTITY()

	INSERT INTO [ServiceRequestLine] 
		([ServiceRequestID], [ServiceAssignmentID], [Description],
		 [RequestAmount], [FactAmount], [Price])
	SELECT 
		@NewID, [ServiceAssignmentID], [Description],
		[RequestAmount], [RequestAmount], [Price]
	FROM
		[ServiceRequestLine]
	WHERE
		[ServiceRequestID] = @ID
	IF @@ERROR != 0
		RETURN 1

	EXEC @rv = adfDocumentCategoryCopy @Class, @ID, @NewID
	IF @rv != 0
		RETURN @rv

	EXEC @rv = adfDocumentContactCopy @Class, @ID, @NewID
	IF @rv != 0
		RETURN @rv

	UPDATE
		[Document]
	SET
		[RecurrencePatternID] = @RecurrenceID
	WHERE
		[Class] = @Class AND [ID] = @NewID
	IF @@ERROR != 0
		RETURN 1

	DECLARE @Occurrences TCount
	SELECT @Occurrences = [Occurrences] FROM [RecurrencePattern] WHERE [ID] = @RecurrenceID
	IF ISNULL(@Occurrences, 0) > 0
	BEGIN
		UPDATE
			[RecurrencePattern]
		SET
			[Occurrences] = @Occurrences - 1
		WHERE
			[ID] = @RecurrenceID
		IF @@ERROR != 0
			RETURN 1
	END
	
	DECLARE
		@ReminderState TState,
		@ReminderInterval TTimeSpan,
		@CurrentUserID TIdentifier
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@Class, 'SD', @CurrentUserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@Class, 'SD', @CurrentUserID)
		
	EXEC @rv = pjm5ServiceRequestReminderCreate @NewID,
		@NewDueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestCreateRecurrence TO PUBLIC
GO  