 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementLineUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementLineUpdate'
		DROP PROCEDURE [dbo].[pjm5StatementLineUpdate]
	END
GO

PRINT 'Creating procedure pjm5StatementLineUpdate'
GO

/******************************************************************************
**		File: pjm5StatementLineUpdate.sql
**		Name: pjm5StatementLineUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementLineUpdate]
	@ID	TIdentifier,
	@StatementID TIdentifier,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Amount TAmount,
	@UOMID TIdentifier,
	@VATIsIncluded TBool, 
	@VATRate TPercent, 
	@Price TMoney,
	@VAT TMoney,
	@PricePC TMoney,
	@VATPC TMoney,
	@Description TNotes,
	@ServiceTypeID TIdentifier,
	@BasePrice TCount,
	@SortKey TCode
AS
	SET NOCOUNT ON
	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [ProjectID] FROM [Statement] WHERE [ID] = @StatementID
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
		SET @UOMID = 1 --  Hours
	SET @Price = ISNULL(@Price, 0.0)
	SET @VAT = ISNULL(@VAT, 0.0)
	IF @ID IS NULL -- 
	BEGIN
		INSERT INTO [StatementLine] 
			([StatementID], [DocumentClass], [DocumentID], 
			[Description], [Amount], [UOMID], [Price], [VATIsIncluded], [VATRate], [VAT],
			[PricePC], [VATPC], [ServiceTypeID], 
			[BasePrice], [SortKey])
		VALUES 
			(@StatementID, @DocumentClass, @DocumentID, 
			@Description, @Amount, @UOMID, @Price, @VATIsIncluded, @VATRate, @VAT,
			@PricePC, @VATPC, @ServiceTypeID,
			@BasePrice, @SortKey)
		IF @@ERROR != 0
			RETURN 1
	END
	ELSE
	BEGIN
		UPDATE 
			[StatementLine] 
		SET
			[DocumentClass] = @DocumentClass,
			[DocumentID] = @DocumentID,
			[Description] =  @Description,
			[Amount] = @Amount,
			[UOMID] = @UOMID,
			[Price] = @Price,
			[VATIsIncluded] = @VATIsIncluded, 
			[VATRate] = @VATRate, 
			[VAT] = @VAT,
			[PricePC] = @PricePC, 
			[VATPC] = @VATPC,
			[ServiceTypeID] = @ServiceTypeID,
			[BasePrice] = @BasePrice, 
			[SortKey] = @SortKey
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
			RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementLineUpdate TO PUBLIC
GO


 