IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementUpdate'
		DROP PROCEDURE [dbo].[pjm5StatementUpdate]
	END
GO

PRINT 'Creating procedure pjm5StatementUpdate'
GO

/******************************************************************************
**		File: pjm5StatementUpdate.sql
**		Name: pjm5StatementUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.06.11	SYV				      
**		01.07.11	SYV				 WarningFlagID,   
*******************************************************************************/
CREATE PROCEDURE pjm5StatementUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@Date TDate,
			@Number TCode,
			@Class TClass,
			@State TState,
			@FileAs TName,
			@ProjectID TIdentifier,
			@Periodical TBool,
			@PeriodStart TDate,
			@PeriodEnd TDate,
			@Comments TNotes,
			@StatementCurrencyRate TAmount,
			@CurrencyRate TAmount,
			@BaseCurrencyRate TAmount,
			@PrevCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@ProjectCurrencyCode TCode3,
			@NationalCurrencyCode TCode3,
			@value TVariant,
			@doc int,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ReminderTime TDateTime,
			@ReturnDate TDate,
			@rv int,
			@RecurrenceID TIdentifier,
			@SupplierCompanyID TIdentifier, 
			@CustomerCompanyID TIdentifier,
			@ExchangeBanned TBool,
			@WarningFlagID TIdentifier,
			@StatementBaseCurrencyRate TAmount
	
	SET NOCOUNT ON

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [XmlTable].[ID],
		@Class = [XmlTable].[Class],
		@State = [XmlTable].[State],
		@Date = CONVERT(datetime, [XmlTable].[Date]),
		@Number  = [XmlTable].[Number],
		@FileAs = [XmlTable].[FileAs],
		@ProjectID = [XmlTable].[ProjectID],
		@PeriodStart = CONVERT(datetime, [XmlTable].[PeriodStart]),
		@PeriodEnd = CONVERT(datetime, [XmlTable].[PeriodEnd]),
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@BaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		@ReturnDate = CONVERT(datetime, [XmlTable].[ReturnDate]),
		@ReminderState = CASE [XmlTable].[ReminderState] WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderTime = CONVERT(datetime, [XmlTable].[ReminderTime]),

		@SupplierCompanyID = [XmlTable].[SupplierCompanyID], 
		@CustomerCompanyID = [XmlTable].[CustomerCompanyID],
		@Comments = [XmlTable].[Comments],

		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@PrevCurrencyCode = [Statement].[CurrencyCode],
		@StatementCurrencyRate = [Statement].[CurrencyRate],
		@StatementBaseCurrencyRate = [Statement].[BaseCurrencyRate],
		@ExchangeBanned = [XmlTable].[ExchangeBanned],
		@RecurrenceID = [XmlTable].[RecurrencePatternID],
		@WarningFlagID = [Statement].[WarningFlagID]
	FROM
		OPENXML(@doc, '/pjm5StatementGet/Statement', 2)
			WITH (
			[ID] int 'ID',
			[Class] int,
			[State] int,
			[Date] nvarchar(19) 'Date',
			[Number] varchar(32) 'Number',
			[FileAs] nvarchar(512) 'FileAs',
			[ProjectID] int 'ProjectID',
			[PeriodStart] nvarchar(19) 'PeriodStart',
			[PeriodEnd] nvarchar(19) 'PeriodEnd',
			[CurrencyRate] money 'CurrencyRate',
			[BaseCurrencyRate] money 'BaseCurrencyRate',
			[CurrencyCode] char(3) 'CurrencyCode',
			[Comments] nvarchar(max) 'Comments',
			[ReminderState] varchar(5) 'ReminderState',
			[ReminderTime] varchar(19) 'ReminderTime',
			[ReturnDate] varchar(19) 'ReturnDate',
			[RecurrencePatternID] int,
			[SupplierCompanyID] int,
			[CustomerCompanyID] int,
			[ExchangeBanned] bit 'ExchangeBanned'
			) AS [XmlTable] 
		INNER JOIN [Statement] 
			ON  [Statement].[ID] = [XmlTable].[ID]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
	
				
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	--     
	DECLARE @ApprovedRatesUpdated TBool
	SELECT
		@ApprovedRatesUpdated = CASE WHEN
			[State] = 2 AND
			(
				ISNULL([CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) OR
				ISNULL([CurrencyCode], -100) = ISNULL(@CurrencyCode, -100) OR
				ISNULL([BaseCurrencyRate], -100) = ISNULL(@BaseCurrencyRate, -100)
			)
		THEN 1 ELSE 0 END
	FROM
		[Statement]
	WHERE
		[ID] = @ID

	IF @ApprovedRatesUpdated = 1
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 16, -1)
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @OnlyCustomFields TBool
	SELECT
		@OnlyCustomFields = CASE WHEN
			[Statement].[ExchangeBanned] != @ExchangeBanned AND
			ISNULL([Statement].[Date], -100) = ISNULL(@Date, -100) AND
			ISNULL([Statement].[ReturnDate], -100) = ISNULL(@ReturnDate, -100) AND
			ISNULL([Statement].[Number], -100) = ISNULL(@Number, -100) AND
			ISNULL([Statement].[FileAs], -100) = ISNULL(@FileAs, -100) AND
			ISNULL([Statement].[ProjectID], -100) = ISNULL(@ProjectID, -100) AND
			ISNULL([Statement].[PeriodStart], -100) = ISNULL(@PeriodStart, -100) AND
			ISNULL([Statement].[PeriodEnd], -100) = ISNULL(@PeriodEnd, -100) AND
			ISNULL([Statement].[CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) AND
			ISNULL([Statement].[BaseCurrencyRate], -100) = ISNULL(@BaseCurrencyRate, -100) AND
			ISNULL([Statement].[CurrencyCode], -100) = ISNULL(@CurrencyCode, -100) AND
			ISNULL([Statement].[SupplierCompanyID], -100) = ISNULL(@SupplierCompanyID, -100) AND
			ISNULL([Statement].[CustomerCompanyID], -100) = ISNULL(@CustomerCompanyID, -100) AND
			ISNULL([Statement].[Comments], -100) = ISNULL(@Comments, -100)
			/*[Statement].[TotalBC]= ROUND(CASE
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ISNULL([Statement].[TotalPC], 0)  / @BaseCurrencyRate
						ELSE ISNULL([Statement].[TotalPC], 0)  * @BaseCurrencyRate
					END, 2),
		[Statement].[TotalWithVATBC] = ROUND(CASE 
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ISNULL([Statement].[TotalWithVATPC], 0)  / @BaseCurrencyRate
						ELSE ISNULL([Statement].[TotalWithVATPC],0) * @BaseCurrencyRate
					END, 2)*/
		THEN 1 ELSE 0 END
	FROM
		[Statement]
	WHERE
		[Statement].[ID] = @ID

	IF @OnlyCustomFields = 1
	BEGIN
		UPDATE
			[Statement]
		SET
			[Statement].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Statement].[ID] = @ID
		
		EXEC pjm5StatementGet @ID
		RETURN 0
	END

	----------------------------------------------rec--------------------------------------------------
	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool

	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM OPENXML(@doc, '/pjm5StatementGet/RecurrencePattern', 2) WITH ([ID] int))
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate = [XmlTable].[StartDate], 
			@REndDate = [XmlTable].[EndDate], 
			@RRecurrenceType = [XmlTable].[RecurrenceType], 
			@ROccurrences = [XmlTable].[Occurrences],
			@RInterval = [XmlTable].[Interval], 
			@RDayOfWeekMask = [XmlTable].[DayOfWeekMask], 
			@RInstance = [XmlTable].[Instance], 
			@RMonthOfYear = [XmlTable].[MonthOfYear], 
			@RDayOfMonth = [XmlTable].[DayOfMonth]
		FROM
			OPENXML(@doc, '/pjm5StatementGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19), 
				[EndDate] varchar(19), 
				[RecurrenceType] int, 
				[Occurrences] int,
				[Interval] int, 
				[DayOfWeekMask] int, 
				[Instance] int, 
				[MonthOfYear] int, 
				[DayOfMonth] int
				) as [XmlTable] 
	END

	IF @State = 1
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	---------------------------------------------------------------------------------------------------

	BEGIN TRANSACTION

	IF ISNULL(@StatementCurrencyRate, -1) != ISNULL(@CurrencyRate, -1) OR 
		--ISNULL(@StatementCurrencyRate, -1) != ISNULL(@BaseCurrencyRate, -1) OR
		@PrevCurrencyCode != @CurrencyCode
	BEGIN
		DECLARE @lines TABLE (
		   ID int,
		   DocumentID int null,
		   VATIsIncluded bit null,
		   VATRate decimal(18,4) null,
		   Amount decimal(18,4) null,
		   PricePC money null,
		   VATPC money null,
		   Price money null,
		   VAT money null,
		   BasePrice int,
		   modified bit)
		INSERT INTO @lines 
			(ID,DocumentID,VATIsIncluded,VATRate,Amount,PricePC,VATPC,Price,VAT,BasePrice,modified)
		SELECT 
			ID,DocumentID,VATIsIncluded,VATRate,Amount,PricePC,VATPC,Price,VAT,BasePrice,0 
		FROM 
			[StatementLine] 
		WHERE 
			StatementID = @ID
		
		IF @CurrencyRate = 1
		BEGIN
			UPDATE @lines
			SET 
				PricePC = Price,
				VATPC = VAT,
				modified = 1
			WHERE
				BasePrice = 2

			UPDATE @lines
			SET 
				Price = PricePC,
				VAT = VATPC,
				modified = 1
			WHERE
				BasePrice = 1
		END
		ELSE
		BEGIN
			UPDATE @lines
			SET 
				PricePC = ROUND(CASE 
							WHEN @CurrencyCode = @NationalCurrencyCode THEN Price / @CurrencyRate
							ELSE Price * @CurrencyRate
						END, 2),
				modified = 1
			WHERE
				BasePrice = 2
				
			UPDATE @lines
			SET 
				Price = ROUND(CASE 
							WHEN @CurrencyCode = @NationalCurrencyCode THEN PricePC * @CurrencyRate
							ELSE PricePC / @CurrencyRate
						END, 2),
				modified = 1
			WHERE
				BasePrice = 1
		END
		UPDATE @lines
		SET
			[VATPC] = CASE [VATIsIncluded]
					WHEN 0 THEN ROUND([Amount] * [PricePC] * [VatRate], 2)
					ELSE ROUND([Amount] * [PricePC] * [VatRate] / (1 + [VatRate]), 2)
				END
		WHERE
			BasePrice = 2
			
		UPDATE @lines
		SET
			[VAT] = CASE [VATIsIncluded]
					WHEN 0 THEN ROUND([Amount] * [Price] * [VatRate], 2)
					ELSE ROUND([Amount] * [Price] * [VatRate] / (1 + [VatRate]), 2)
				END
		WHERE
			BasePrice = 1
			
		UPDATE
			[StatementLine]
		SET
			PricePC = l.PricePC,
			VATPC = l.VATPC,
			Price = l.Price,
			VAT = l.VAT
		FROM
			[StatementLine]
			INNER JOIN @lines l
				ON l.[ID] = [StatementLine].[ID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF ISNULL(@StatementCurrencyRate, -1) != ISNULL(@CurrencyRate, -1) OR 
		ISNULL(@StatementBaseCurrencyRate, -1) != ISNULL(@BaseCurrencyRate, -1) OR
		@PrevCurrencyCode != @CurrencyCode
	BEGIN
		SET @WarningFlagID = NULL
	END

	UPDATE 
		[Statement]
	SET
		[Statement].[Date] = @Date,
		[Statement].[ReturnDate] = @ReturnDate,
		[Statement].[Number] = ISNULL(@Number, ''),
		[Statement].[FileAs] = @FileAs,
		[Statement].[ProjectID] = @ProjectID,
		[Statement].[PeriodStart] = @PeriodStart,
		[Statement].[PeriodEnd] = @PeriodEnd,
		[Statement].[CurrencyRate] = @CurrencyRate,
		[Statement].[BaseCurrencyRate] = @BaseCurrencyRate,
		[Statement].[CurrencyCode] = @CurrencyCode,
		[Statement].[SupplierCompanyID] = @SupplierCompanyID, 
		[Statement].[CustomerCompanyID] = @CustomerCompanyID,
		[Statement].[Comments] = @Comments,
		[Statement].[Modified] = DEFAULT,
		[Statement].[ModifiedBy] = DEFAULT,
		[Statement].[TotalBC]= ROUND(CASE
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ISNULL([Statement].[TotalPC], 0)  / @BaseCurrencyRate
						ELSE ISNULL([Statement].[TotalPC], 0)  * @BaseCurrencyRate
					END, 2),
		[Statement].[TotalWithVATBC] = ROUND(CASE 
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ISNULL([Statement].[TotalWithVATPC], 0)  / @BaseCurrencyRate
						ELSE ISNULL([Statement].[TotalWithVATPC],0) * @BaseCurrencyRate
					END, 2),
		[WarningFlagID] = @WarningFlagID
	FROM 
		[Statement]
	WHERE
		[Statement].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @OnlyCustomFields = 0
	BEGIN
		UPDATE
			[Statement]
		SET
			[Statement].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Statement].[ID] = @ID
	END

	SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @ReturnDate)
	EXEC @rv = pjm5StatementReminderCreate @ID,
		@ReturnDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	EXEC sp_xml_removedocument @doc
	
	EXEC pjm5StatementGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementUpdate TO PUBLIC
GO
