IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TaskBrowseSelectorDialogCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure TaskBrowseSelectorDialogCalculation'
		DROP PROCEDURE [dbo].[TaskBrowseSelectorDialogCalculation]
	END
GO

PRINT 'Creating procedure TaskBrowseSelectorDialogCalculation'
GO

/******************************************************************************
**		File: TaskBrowseSelectorDialog.sql
**		Name: TaskBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.07.10	MAN				   ViewAllTasks  [Assignment].[State]=1
*******************************************************************************/
CREATE PROCEDURE [TaskBrowseSelectorDialogCalculation]
	@EmployeeID	TIdentifier,
	@ProjectID	TIdentifier,
	@State TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ViewAllTasks TBool
	SET @ViewAllTasks = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllTasks'))
	
	
	IF @EmployeeID = 0 
		SELECT @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT DISTINCT
		[Task].[ID],
		[Task].[State],
		[Task].[ProjectID],
		[Task].[FileAs],
		[Task].[StartDate],
		[Task].[DueDate]
	FROM
		[Task]

			INNER JOIN [Project]
			ON [Project].[ID] = [Task].[ProjectID]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
			AND [TaskAssignment].[State] = 1
		LEFT OUTER JOIN [vwAssignment] AS [Assignment]
			ON [Assignment].[ID] = [TaskAssignment].[AssignmentID]


	WHERE
		[Task].[State] IN (1, 2, 3, 5) AND
		[Task].[SubprojectID] IS NULL 
		AND
		(
			(
				[Assignment].[EmployeeID] = IsNull(@EmployeeID, [Assignment].[EmployeeID]) and
				[Assignment].[State] = 1
			)
			OR
			[Project].[ProjectManagerEmployeeID] = @EmployeeID OR 
			@ViewAllTasks = 1 
			
		)
		AND
		(
			@ProjectID IN (0, -1, -2, -3, -4) OR
			[Task].[ProjectID] = @ProjectID
		) AND
		(
			[Task].[State] = @State OR	--   
			@State = 0 --   
		)
	
		
		
		
		
	RETURN 0
GO

GRANT EXECUTE ON [TaskBrowseSelectorDialogCalculation] TO PUBLIC
GO
