IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trTaskDueDateChange')
	BEGIN
		PRINT 'Dropping Trigger pjm6trTaskDueDateChange'
		DROP  Trigger pjm6trTaskDueDateChange
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trTaskDueDateChange
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

--PRINT 'Creating Trigger pjm6trTaskDueDateChange'
GO
/*CREATE TRIGGER pjm6trTaskDueDateChange ON [Task] FOR INSERT, DELETE, UPDATE
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON
	;
	WITH
	[ChangedProjectID] ([ProjectID]) AS
	(
	SELECT
		ISNULL([inserted].[ProjectID],[deleted].[ProjectID])
	FROM [inserted]
		FULL OUTER JOIN [deleted]
			ON [deleted].[ProjectID] = [inserted].[ProjectID]
	),
	[NewProjectDueDate] ([ProjectID], [DueDate], [PercentComplete], [PlannedManHour], [PlannedBudget]) AS
	(
	SELECT 
		[ChangedProjectID].[ProjectID],
		ISNULL(MAX([Task].[DueDate]), 0),
		SUM
			(
			CASE WHEN [Task].[State] IN (2, 3) AND [Task].[Duration] = 0 
					THEN [Task].[PercentComplete]
				 WHEN [Task].[State] IN (2, 3) AND [Task].[Duration] > 0
					THEN [Task].[PercentComplete] *  [Task].[Duration]
			ELSE 0
			END
			) / 
			SUM(CASE WHEN [Task].[State] IN (2, 3) AND [Task].[Duration] > 0 
					THEN [Task].[Duration] ELSE 1 END
		),
		SUM ([TaskPlanned].[ManHour]),
		SUM ([TaskPlanned].[Budget])
	FROM [ChangedProjectID]
		LEFT OUTER JOIN [Task]
			ON [Task].[ProjectID] = [ChangedProjectID].[ProjectID]
		LEFT OUTER JOIN 
			(SELECT
				[Task].[ProjectID] as [ID],
				ISNULL(CASE WHEN [Task].[SubProjectID] IS NOT NULL 
						THEN [Task].[ManHour]
						ELSE SUM(ISNULL([TaskAssignment].[Work], 0))	
						END, 0)/60.0 as [ManHour],

				ISNULL(CASE WHEN [Task].[SubProjectID] IS NOT NULL 
						THEN [Task].[Budget]
						ELSE SUM(ISNULL([TaskAssignment].[Work] * [Assignment].[StandardRate], 0)) 	
						END, 0)/60.0 as [Budget]
			 FROM [Task]
				LEFT OUTER JOIN [TaskAssignment]
					ON [TaskAssignment].[TaskID] = [Task].[ID]
				LEFT OUTER JOIN [Assignment]
					ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
			GROUP BY 
				[Task].[ProjectID],
				[Task].[SubProjectID],
				[Task].[ManHour],
				[Task].[Budget]
			) AS [TaskPlanned]
			ON [TaskPlanned].[ID] = [ChangedProjectID].[ProjectID]
	GROUP BY
		[ChangedProjectID].[ProjectID]
	)
	UPDATE [Project]
	SET 
	[Project].[DueDate] = (
		CASE WHEN [NewProjectDueDate].[DueDate] >= [Project].[Date]
			THEN [NewProjectDueDate].[DueDate] 
			ELSE [Project].[Date] END),
	[Project].[PercentComplete] = [NewProjectDueDate].[PercentComplete],
	[Project].[PlannedManHour] = [NewProjectDueDate].[PlannedManHour],
	[Project].[PlannedBudget] = [NewProjectDueDate].[PlannedBudget]
	FROM [Project] 
		INNER JOIN [NewProjectDueDate]
			ON [NewProjectDueDate].[ProjectID] = [Project].[ID]		
			
	
	RETURN */
