 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestBrowseByDocumentCard]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestBrowseByDocumentCard'
		DROP PROCEDURE [dbo].[pjm5TaskRequestBrowseByDocumentCard]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestBrowseByDocumentCard'
GO

/******************************************************************************
**		File: pjm5TaskRequestBrowseByDocumentCard.sql
**		Name: pjm5TaskRequestBrowseByDocumentCard
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestBrowseByDocumentCard]
	@DocumentCardID TIdentifier
AS
	DECLARE @CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@StartTime datetime,
		@EndTime datetime,
		@Now datetime
		
	SET NOCOUNT ON

	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[DocumentCardID],
		[TaskRequest].[ProjectID],
		[TaskRequest].[EmployeeID],
		[TaskRequest].[SupervisorEmployeeID],
		[TaskRequest].[PriorityID],
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[EndTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		[TaskRequest].[PercentComplete],
		(CAST([TaskRequest].[PercentComplete] * 100 as int) / 25) * 25 as PC,
		[TaskRequest].[Resolution],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp],
		[Employee].[FileAs] AS [EmployeeFileAs],
		[TaskRequest].[ActualBudget],
		[TaskRequest].[ActualManHour],
		[TaskRequest].[Budget],
		[TaskRequest].[ManHour]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [Employee]
			ON [TaskRequest].[EmployeeID] = [Employee].[ID]
	WHERE
		[TaskRequest].[DocumentCardID] = @DocumentCardID
			
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestBrowseByDocumentCard] TO PUBLIC
GO

