IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestCanceled]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskRequestCanceled'
		DROP PROCEDURE [dbo].[pjm6TaskRequestCanceled]
	END
GO

PRINT 'Creating procedure pjm6TaskRequestCanceled'
GO

/******************************************************************************
**		File: pjm6TaskRequestCanceled.sql
**		Name: pjm6TaskRequestCanceled
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6TaskRequestCanceled
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@SupervisorID TIdentifier,
		@AuthorID TIdentifier,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	SELECT
		@AuthorID = [TaskRequest].[CreatedBy],
		@SupervisorID = [TaskRequest].[SupervisorEmployeeID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[ID] = @ID
		
	DECLARE @users TABLE ([UserID] TIdentifier)
	IF @AuthorID != @FromID
		INSERT INTO @users ([UserID]) VALUES(@AuthorID)
	IF @SupervisorID IS NOT NULL
	BEGIN
		SELECT @SupervisorID = [UserID] FROM [Employee] WHERE [ID] = @SupervisorID
		IF ISNULL(@SupervisorID, @FromID) != @FromID AND @SupervisorID != @AuthorID
			INSERT INTO @users ([UserID]) VALUES(@SupervisorID)
	END
		
	INSERT INTO @users ([UserID])
	SELECT
		[Employee].[UserID]
	FROM 
		[TaskRequestAssignment]
		INNER JOIN [Employee] 
			ON [TaskRequestAssignment].[EmployeeID] = [Employee].[ID]
	WHERE
		[TaskRequestAssignment].[TaskRequestID] = @ID AND 
		[Employee].[UserID] IS NOT NULL AND
		[Employee].[UserID] != @FromID AND
		[Employee].[UserID] NOT IN (ISNULL(@AuthorID, -1), ISNULL(@SupervisorID, -1))
	
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @ID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		@FileAs,
		N'TaskRequestCanceled',
		@FromID,
		[Users].[UserID],
		@Class,
		@ID,
		0,
		NULL, --@FileAs,
		CASE @Language 
			WHEN 'en' THEN 'Task Request "' + @FileAs + '" has been canceled.'
			ELSE ' "' + @FileAs + '" .'
		END
	FROM 
		@users AS [Users]

	RETURN 0
GO

GRANT EXECUTE ON pjm6TaskRequestCanceled TO PUBLIC
GO
