IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestGet'
		DROP PROCEDURE [dbo].[pjm5TaskRequestGet]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestGet'
GO

/******************************************************************************
**		File: pjm5TaskRequestGet.sql
**		Name: pjm5TaskRequestGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.08.11	SYV				   ,  SupervisorEmployeeID IS NULL
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestGet]
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@ProjectID TIdentifier, 
		@SupervisorEmployeeID TIdentifier,
		@DocumentCardID TIdentifier,
		@DocumentItemID TIdentifier,
		@CaseID TIdentifier,
		@CreatedBy TIdentifier,
		@UserID Tidentifier,
		@rv int,
		@IsFinanceEnable	bit,
		@ViewAllFinance TBool,
		@ViewFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@IsPM TBool,
		@IsMember TBool
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF dbo.fnPjm5IsAssistant() = 0
	BEGIN
		SELECT 
			@ProjectID = [TaskRequest].[ProjectID],
			@SupervisorEmployeeID = [TaskRequest].[SupervisorEmployeeID],
			@CreatedBy = [TaskRequest].[CreatedBy]
		FROM 
			[TaskRequest]
		WHERE 
			[TaskRequest].[ID] = @ID
			
		IF @ProjectID IS NOT NULL AND 
			ISNULL(@SupervisorEmployeeID, -1) != @CurrentEmployeeID AND
			@CreatedBy != @UserID
		BEGIN
			IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
				dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID) = 0
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
		END
	END
	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance'))
	SET @IsPM = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @IsMember = @IsPM | dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
	
	SET @IsFinanceEnable = @IsMember & @ViewFinance
	SET @IsFinanceEnable = @IsFinanceEnable | @ViewAllFinance | @IsPM
	
	DECLARE
		@Class TClass,
		@RecurrencePatternID TIdentifier
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @RecurrencePatternID = [RecurrencePatternID] FROM [Document] WHERE [Document].[Class] = @Class AND [Document].[ID] = @ID

	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[ProjectID],
		[TaskRequest].[DocumentCardID],
		[TaskRequest].[PriorityID],
		[TaskRequest].[EmployeeID],
		[TaskRequest].[SupervisorEmployeeID],
		/*CASE 
			WHEN [DocumentCard].[ID] IS NULL THEN [TaskRequest].[SupervisorEmployeeID]
			ELSE [DocumentCard].[CardOwnerID]
		END AS [SupervisorEmployeeID],*/
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[EndTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		CAST([TaskRequest].[PercentComplete] * 100 as int) as [PercentComplete],
		[TaskRequest].[Resolution],
		[TaskRequest].[DocumentEditAccess],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp],
		@RecurrencePatternID AS [RecurrencePatternID],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([TaskRequest].[Class], 'RD', @UserID)) AS [ReminderInterval],
		[TaskRequest].[ActualManHour],
		[TaskRequest].[ManHour],
		[TaskRequest].[ActualBudget],
		[TaskRequest].[Budget],
		ISNULL([Project].[CurrencyCode], 'RUB') AS [CurrencyCode],
		[Project].[ProjectTypeID],
		CASE 
			WHEN (@IsFinanceEnable = 1 AND [Project].[ProjectTypeID] = 1) 		
				THEN 1
			ELSE 0
		END AS [HasFinanceAccess]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [DocumentCard]
			ON [TaskRequest].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [TaskRequest].[Class] AND
				[Reminder].[DocumentID] = [TaskRequest].[ID] AND
				[Reminder].[Subtype] = 'RD')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [TaskRequest].[ProjectID]
	WHERE
		[TaskRequest].[ID] = @ID
		
	SELECT
		[EmployeeID],
		[Accepted]
	FROM
		[TaskRequestAssignment]
	WHERE
		[TaskRequestID] = @ID
		

	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID
	
	SELECT
		[EmployeeID],
		[Response]
	FROM
		[TaskRequestAssignmentResponse]
	WHERE
		[TaskRequestID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestGet] TO PUBLIC
GO

 