IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryDelete'
		DROP PROCEDURE [dbo].[pjm5TimeEntryDelete]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryDelete'
GO

/******************************************************************************
**		File: pjm5TimeEntryDelete.sql
**		Name: pjm5TimeEntryDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    06.10.09		syv				  pjm6AssignmentCheckBudgetOverdraft
*******************************************************************************/
CREATE PROCEDURE pjm5TimeEntryDelete
	@ID TIdentifier,
	@Forced TBool
AS
	SET NOCOUNT ON
	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@TimeEntryClass TClass,
		@ExpenseClass TClass,
		@TaskID TIdentifier,
		@TaskAssignmentState TCode,
		@rv int
	
	SET @ExpenseClass = dbo.adfGetClassByName('Pjm5.Expense')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT 
		@TimeEntryClass = [Class],
		@EmployeeID = [EmployeeID], 
		@ProjectID = [ProjectID],
		@TaskID = [TimeEntry].[TaskID],
		@TaskAssignmentState = ISNULL([TaskAssignment].[State], 0)
	FROM 
		[TimeEntry]
			LEFT OUTER JOIN [TaskAssignment]
				ON [TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
				AND [TaskAssignment].[TaskID] = [TimeEntry].[TaskID] 
	WHERE 
		[TimeEntry].[ID] = @ID
	
	-- taskassignment
	IF @TaskAssignmentState > 1
	BEGIN
		RAISERROR('#TimeEntryTaskAssignmentStateIsDeactivated', 18, -1)
		RETURN 1
	END
	
	IF @CurrentEmployeeID != @EmployeeID AND
		dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE
		@phoneCall TBool,
		@class TClass
	IF EXISTS (SELECT * FROM [PhoneCall] WHERE [TimeEntryID] = @ID)
		SET @phoneCall = 1
	IF @Forced != 1 AND @phoneCall = 1
	BEGIN
		RAISERROR('?DeletePhoneCallTimeEntry', 18, -1)
		RETURN 1
	END
	SET @class = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN TRANSACTION
	IF @phoneCall = 1
	BEGIN
		UPDATE [PhoneCall] SET [TimeEntryID] = NULL WHERE [TimeEntryID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	DELETE FROM [Attachment] 
	WHERE 
		[Attachment].[DocumentClass] = @ExpenseClass AND
		[Attachment].[LinkDocumentClass] = @TimeEntryClass AND 
		[Attachment].[LinkDocumentID] = @ID AND
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [DocumentCategory] WHERE [DocumentClass] = @class AND [DocumentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [DocumentContact] WHERE [DocumentClass] = @class AND [DocumentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [TimeEntry] WHERE [TimeEntry].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	--ROLLBACK TRANSACTION	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
/*
	IF @TaskID IS NOT NULL 
	BEGIN
		DECLARE @AssignmentID TIdentifier
		SET @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @EmployeeID)	
		IF @AssignmentID IS NOT NULL
			EXEC pjm6AssignmentCheckBudgetOverdraft @TaskID, @AssignmentID, NULL
	END*/
	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryDelete TO PUBLIC
GO
 