IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntrySelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntrySelectorDialog'
		DROP PROCEDURE [dbo].[pjm5TimeEntrySelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5TimeEntrySelectorDialog'
GO

/******************************************************************************
**		File: pjm5TimeEntrySelectorDialog.sql
**		Name: pjm5TimeEntrySelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntrySelectorDialog]
	@ProjectID		INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@Employee		TName,
	@DocumentClass	TClass
AS
	SET NOCOUNT ON	
	DECLARE 
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()	

	DECLARE
		@invoiceClass TClass,
		@statementClass TClass
	SET @invoiceClass =dbo.adfGetClassByName('Pjm5.Invoice')
	SET @statementClass =dbo.adfGetClassByName('Pjm5.Statement')
	SET @PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime)
	SET @PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))

	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		ISNULL([TimeEntry].[FileAs], ' ') AS [FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		[TimeEntry].[BillableDuration],
		[TimeEntry].[BillableHour],
		[TimeEntry].[Overtime],
		[TimeEntry].[Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE 
			WHEN dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) != 1 AND
				dbo.fnPjm5IsProjectApprover([Project].[ID], @CurrentEmployeeID) != 1
				THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[Employee].[FileAs] AS [EmployeeName]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [TimeEntry].[EmployeeID]
	WHERE
		[Project].[ID] = @ProjectID AND
		[TimeEntry].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd AND 
		[TimeEntry].[Billable] = 1 AND
		[TimeEntry].[State] IN (3, 6) AND
		(@Employee IS NULL OR [Employee].[FileAs] LIKE @Employee) AND
		NOT EXISTS(
			SELECT * 
			FROM 
				[CalculationLine] 
				INNER JOIN [Calculation]
					ON [Calculation].[ID] = [CalculationLine].[CalculationID]
			WHERE 
				[Calculation].[State] != 4 AND
				[CalculationLine].[DocumentClass] = [TimeEntry].[Class] AND [CalculationLine].[DocumentID] = [TimeEntry].[ID]
		) AND
		(
			(@DocumentClass = @invoiceClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[InvoiceLine] 
						INNER JOIN [Invoice]
							ON [Invoice].[ID] = [InvoiceLine].[InvoiceID]
					WHERE 
						[Invoice].[State] != 3 AND
						[InvoiceLine].[DocumentClass] = [TimeEntry].[Class] AND [InvoiceLine].[DocumentID] = [TimeEntry].[ID]))
			OR
			(@DocumentClass = @statementClass AND 
				NOT EXISTS(
					SELECT * 
					FROM 
						[StatementLine] 
						INNER JOIN [Statement]
							ON [Statement].[ID] = [StatementLine].[StatementID]
					WHERE 
						[Statement].[State] != 4 AND
						[StatementLine].[DocumentClass] = [TimeEntry].[Class] AND [StatementLine].[DocumentID] = [TimeEntry].[ID])
			)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntrySelectorDialog] TO PUBLIC
GO
 