IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeSheetGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeSheetGet'
		DROP PROCEDURE [dbo].[pjm5TimeSheetGet]
	END
GO

PRINT 'Creating procedure pjm5TimeSheetGet'
GO

/******************************************************************************
**		File: pjm5TimeSheetGet.sql
**		Name: pjm5TimeSheetGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeSheetGet]
	@EmployeeID		TIdentifier,
	@ProjectID		TIdentifier,
	@StateSelector	TBool,
	@PeriodStart	datetime
AS
	SET NOCOUNT ON	
	SET DATEFIRST 1	
	
	DECLARE 
		@ViewAllProjects TBool,
		@CurrentEmployeeID TIdentifier,
		@PeriodEnd	datetime

	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF @EmployeeID IS NULL SET @EmployeeID = @CurrentEmployeeID

	SET @PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime)
	SET @PeriodStart = DATEADD(day, 1 - DATEPART(weekday, @PeriodStart), @PeriodStart)
	SET @PeriodEnd = DATEADD(day, 7, @PeriodStart)
	
	SELECT
		@EmployeeID AS [EmployeeID],
		@ProjectID AS [ProjectID],
		@PeriodStart AS [PeriodStart],
		@PeriodEnd AS [PeriodEnd],
		@StateSelector AS [StateSelector]
		
	DECLARE @l TLanguage;
	SET @l = dbo.adfGetLanguage()
	
	;WITH ProjectTable([ID], [FileAs]) AS (
		SELECT 
			[ID],
			[FileAs]
		FROM
			[Project] 
		WHERE
			@ViewAllProjects = 1 OR
			dbo.fnPjm5IsProjectManager([ID], @CurrentEmployeeID) = 1 OR 
			dbo.fnPjm5IsProjectMember([ID], @CurrentEmployeeID) = 1
	)
	SELECT
		[Project].[Class],
		ISNULL([ProjectTable].[ID], -1),
		[TimeEntry].[EmployeeID],
		CASE @l
			WHEN 'en' THEN ISNULL([ProjectTable].[FileAs], '(others)')
			ELSE ISNULL([ProjectTable].[FileAs], '()')
		END AS [ProjectFileAs],
		[Task].[FileAs] AS [TaskFileAs],
		[ServiceAssignment].[FileAs] AS [ServiceAssignmentFileAs],
		[TimeEntry].[Billable],
		CASE 
			WHEN [TimeEntry].[Billable] = 1 AND @l = 'ru'
				THEN ''
			WHEN [TimeEntry].[Billable] = 0 AND @l = 'ru'
				THEN ' '
			WHEN [TimeEntry].[Billable] = 1 AND @l = 'en'
				THEN 'Chargeable'
			WHEN [TimeEntry].[Billable] = 0 AND @l = 'en'
				THEN 'Non Chargeable'
		END AS [Chargeable],
		[TimeEntry].[Overtime],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 1 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Monday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 2 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Tuesday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 3 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Wednesday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 4 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Thursday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 5 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Friday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 6 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Saturday],
		ISNULL(SUM(
			CASE DATEPART(weekday, [TimeEntry].[StartTime])
				WHEN 7 THEN [TimeEntry].[BillableDuration]
				ELSE 0
			END), 0.0) / 60.0 AS [Sunday],
		ISNULL(SUM([TimeEntry].[BillableDuration]), 0.0) / 60.0 AS [Total]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
		LEFT OUTER JOIN [ProjectTable]
			ON [ProjectTable].[ID] = [Project].[ID]
		LEFT OUTER JOIN [Task]
			ON [Task].[ID] = [TimeEntry].[TaskID] AND 
				[Task].[ProjectID] = [ProjectTable].[ID]
		LEFT OUTER JOIN [ServiceAssignment]
			ON [ServiceAssignment].[ID] = [TimeEntry].[DocumentID] AND
				[ServiceAssignment].[Class] = [TimeEntry].[DocumentClass] AND 
				[ServiceAssignment].[ProjectID] = [ProjectTable].[ID] 
		LEFT OUTER JOIN [ActivityType]
			ON [ActivityType].[ID] = [TimeEntry].[ActivityTypeID]
	WHERE
		[TimeEntry].[EmployeeID] = @EmployeeID AND 
		[TimeEntry].[StartTime] >= @PeriodStart AND 
		[TimeEntry].[StartTime] < @PeriodEnd AND
		(
			(@StateSelector = 0 AND [TimeEntry].[State] IN (3, 6)) OR	
			(@StateSelector = 1 AND [TimeEntry].[State] IN (2, 3, 6))
		) AND
		(
			@ProjectID IS NULL OR [Project].[ID] = @ProjectID
		)
	GROUP BY
		[Project].[Class],
		[ProjectTable].[ID],
		[TimeEntry].[EmployeeID],
		[ProjectTable].[FileAs],
		[Task].[FileAs],
		[ServiceAssignment].[FileAs],
		[TimeEntry].[Billable],
		[TimeEntry].[Overtime]
	ORDER BY
		CASE 
			WHEN [ProjectTable].[ID] IS NULL THEN 1
			ELSE 0
		END ASC,
		[ProjectTable].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeSheetGet] TO PUBLIC
GO
 