IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trTimeEntryDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm5trTimeEntryDelete'
		DROP  Trigger pjm5trTimeEntryDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trTimeEntryDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trTimeEntryDelete'
GO
CREATE Trigger pjm5trTimeEntryDelete 
ON [TimeEntry] FOR DELETE
AS
BEGIN
    IF @@rowcount = 0
       RETURN
       
    SET NOCOUNT ON
	
	UPDATE 
		[EmployeeCalendar]
	SET
		[Actual] = [Actual] - [D].[Duration]
	FROM
		EmployeeCalendar INNER JOIN (
			SELECT 
				[EmployeeID], 
				CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112) as [Date],
				SUM([Duration]) as [Duration]
			FROM 
				[deleted]
			WHERE
				[deleted].[State] != 4
			GROUP BY
				[EmployeeID], 
				CONVERT(datetime, CONVERT(varchar(8), [StartTime], 112), 112)) as [D]
			ON ([EmployeeCalendar].[EmployeeID] = [D].[EmployeeID] AND
				[EmployeeCalendar].[Date] = [D].[Date])
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN
	END
	
	/*UPDATE [TaskAssignment]
	SET 
		[RemainingWork] = [RemainingWork] + [deleted].[Duration],
		[RemainingOvertimeWork] = 
			CASE 
				WHEN ([Task].[MsTaskID] IS NOT NULL AND [deleted].[Overtime] = 1)
					THEN [RemainingOvertimeWork] + [deleted].[Duration] 
				ELSE [RemainingOvertimeWork] 
			END
	FROM
		[TaskAssignment]
		INNER JOIN [deleted]
			ON [deleted].[TaskID] = [TaskAssignment].[TaskID] AND
				[TaskAssignment].[AssignmentID] = [deleted].[AssignmentID]
		INNER JOIN [Task]
			ON [Task].[ID] = [TaskAssignment].[TaskID]
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN
	END*/

END
GO

