/****** Object:  StoredProcedure [pjmams].[ProgramsActivityBrowse]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[ProgramsActivityBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[ProgramsActivityBrowse]'
	DROP PROCEDURE [pjmams].[ProgramsActivityBrowse]
END
GO

PRINT 'Creating procedure [pjmams].[ProgramsActivityBrowse]'
GO

CREATE PROCEDURE [pjmams].[ProgramsActivityBrowse] @Date datetime
AS
	SET NOCOUNT ON
	
	DECLARE @Total decimal(18, 2)

	SELECT
		@Date as [Date]
		

	SELECT TOP 1
		@Total = SUM(DATEDIFF(second, [Created], [Closed])) / 60.0
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[Process].[UserName] != '\'
	GROUP BY
		ISNULL([Module].[Description], [Module].[Name])
	ORDER BY 
		 1 DESC

	SELECT TOP 20
		ISNULL([Module].[Description], [Module].[Name]) as [Module],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(3600 as decimal(18,4)) as decimal(18,2)) as [Duration],
		CAST(SUM(DATEDIFF(second, [Created], [Closed])) / CAST(60 as decimal(18,4)) as decimal(18,2)) * 100 / @Total as [RelativeDuration]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[Process].[UserName] != '\'
	GROUP BY
		ISNULL([Module].[Description], [Module].[Name])
	ORDER BY 
		 3 DESC
	
	RETURN 0
GO

    