IF EXISTS (SELECT * FROM sysobjects WHERE type = 'V' AND name = 'vwTimeEntry')
	BEGIN
		PRINT 'Dropping View vwTimeEntry'
		DROP  View vwTimeEntry
	END
GO

/******************************************************************************
**		File: 
**		Name: vwTimeEntry
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating View vwTimeEntry'
GO
CREATE View vwTimeEntry
as
	SELECT 
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[TimeEntry].[AssignmentID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[DocumentClass],
		[TimeEntry].[DocumentID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		[EntryAmount].[Amount] * 60 AS [BillableDuration],
		[EntryAmount].[Amount] AS [BillableHour],
		[TimeEntry].[Overtime],
		[TimeEntry].[Rate] AS [OriginalRate],
		[EntryAmount].[Price] AS [Rate],
		[TimeEntry].[VATRate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[ExternalID],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[TimeEntry].[MeetingRequestID]
	FROM
		[TimeEntry] 
		INNER JOIN [EntryAmount]
			ON [TimeEntry].[ID] = [EntryAmount].[ID]
GO

